VERSION 1.0 CLASS
BEGIN
  MultiUse = 0   'False
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Application"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oDBMGUI As Object

Private lIndex As Long

Private fDBMApp As frmDBMApp

Private oDatabase As DBMLib.Database

'''

Public Property Get Title() As String
    Title = App.Title
End Property
Public Property Let Title(NewVal As String)
    App.Title = "DBMAPP - " + NewVal
End Property

Public Property Get DBMGUI() As Object
    Set DBMGUI = oDBMGUI
End Property
Public Property Set DBMGUI(NewVal As Object)
    Set oDBMGUI = NewVal
End Property

Public Property Get Index() As Long
    Index = lIndex
End Property
Public Property Let Index(ByVal NewVal As Long)
    lIndex = NewVal
End Property

Public Property Get Database() As DBMLib.Database
    If oDatabase Is Nothing Then
        Set oDatabase = New DBMLib.Database
        Set oDatabase.DBMApp = Me
    End If
    Set Database = oDatabase
End Property

Public Property Get Autorefresh() As Boolean
    Autorefresh = modAutorefresh.Enabled
End Property
Public Property Let Autorefresh(ByVal NewVal As Boolean)
    modAutorefresh.Enabled = NewVal
End Property

Public Property Get Interval() As Long
    Interval = modAutorefresh.Interval
End Property
Public Property Let Interval(ByVal NewVal As Long)
    modAutorefresh.Interval = NewVal
End Property

'''

Public Sub ShowForm()
    If fDBMApp Is Nothing Then
        Set fDBMApp = New frmDBMApp
    End If
    fDBMApp.Show
End Sub

Public Sub HideForm()
    If Not fDBMApp Is Nothing Then
        Unload fDBMApp
        Set fDBMApp = Nothing
    End If
End Sub

'''

Public Sub Refresh()
    If oDatabase Is Nothing Then Exit Sub
    oDatabase.State.Refresh True, True
End Sub

'''

Public Sub CleanUp()
    If Not oDatabase Is Nothing Then oDatabase.CleanUp
    
    Set oDatabase = Nothing
    Set oDBMGUI = Nothing
End Sub

'''

Private Sub Class_Initialize()
    Set oDBMGUI = Nothing
        
    lIndex = 0
    Set oDatabase = Nothing
    
    modAutorefresh.Initialize Me
    
    If App.StartMode = vbSModeStandalone Then
        ShowForm
    End If
End Sub

'''

Private Sub Class_Terminate()
    On Error Resume Next
    
    modAutorefresh.Terminate
    
    HideForm
    
    If Not oDBMGUI Is Nothing Then
        oDBMGUI.AppServerTerminate Me
    End If
End Sub

'''

#If DBG Then

Public Property Get DebugTrace() As Object
    Set DebugTrace = oDbgTrace
End Property
Public Property Set DebugTrace(NewVal As Object)
    Set oDbgTrace = NewVal
    If Not oDatabase Is Nothing Then
        Set oDatabase.DebugTrace = oDbgTrace
    End If
End Property

#End If


