Attribute VB_Name = "modBackup"
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oParent As Object

'''

Const DELAY = 100

'''

Private oExecObj As Object
Private sFunction As String

'''

Private lTimerID As Long
Private bRC As Boolean

'''

Public Sub Execute(Object As Object, _
                   ByVal FunctionName As String)
                        
    StopTimer
    
    Set oExecObj = Object
    sFunction = FunctionName
    
    StartTimer
End Sub

Public Sub CleanUp()
    StopTimer
    Set oExecObj = Nothing
End Sub

'''

Private Sub StartTimer()
    lTimerID = SetTimer(0, 0, DELAY, AddressOf TimerProc)
End Sub

Private Sub StopTimer()
    If lTimerID <> 0 Then
        KillTimer 0, lTimerID
        lTimerID = 0
    End If
End Sub

Private Sub TimerProc(ByVal lHwnd As Long, _
                      ByVal lMsg As Long, _
                      ByVal lTimerID As Long, _
                      ByVal lTime As Long)
    
    StopTimer
    
    If Not oExecObj Is Nothing Then
        bRC = oExecObj.Execute(sFunction)
    End If
End Sub

