Attribute VB_Name = "modBackupState"
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oExecObj As Object

'''

Private lTimerID As Long
Private bInExecute As Boolean

'''

Public Sub StartTimer(Object As Object, ByVal Interval As Long)
    Set oExecObj = Object
    lTimerID = SetTimer(0, 0, Interval, AddressOf TimerProc)
End Sub

Public Sub StopTimer()
    If lTimerID <> 0 Then
        KillTimer 0, lTimerID
        lTimerID = 0
    End If
End Sub

Public Sub ChangeInterval(ByVal Interval As Long)
    Dim lResult As Long
    If lTimerID <> 0 Then
        lResult = SetTimer(0, lTimerID, Interval, AddressOf TimerProc)
    End If
End Sub

Public Sub CleanUp()
    StopTimer
    Set oExecObj = Nothing
End Sub

'''

Private Sub TimerProc(ByVal lHwnd As Long, _
                      ByVal lMsg As Long, _
                      ByVal lTimerID As Long, _
                      ByVal lTime As Long)
    
    If Not bInExecute Then
        bInExecute = True
        If Not oExecObj Is Nothing Then oExecObj.Execute
        bInExecute = False
    End If
End Sub

