VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CommandItems"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oItems As New Collection
'
' Public
'
' Properties
'
Public Property Get Count() As Long
    Count = oItems.Count
End Property

Public Property Get Item(ByVal Key As Long) As CommandItem
Attribute Item.VB_UserMemId = 0
    Set Item = oItems("K" + CStr(Key))
End Property

Public Property Get NewEnum()
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = oItems.[_NewEnum]
End Property
'
' Methods
'
Public Function Add(ItemType As CommandItemTypeConstants, _
                    Key As Long, _
                    Optional Caption As String, _
                    Optional Image As Variant, _
                    Optional InstanceType As Long = 0, _
                    Optional VersionNumber As Long = 0) As CommandItem
    
    Dim oCommandItem As New CommandItem
    
    With oCommandItem
        .ItemType = ItemType
        .Caption = Caption
        .Image = Image
        .Key = Key
        .InstanceType = InstanceType
        .VersionNumber = VersionNumber
    End With
    
    oItems.Add oCommandItem, "K" + CStr(Key)

    Set Add = oCommandItem
    Set oCommandItem = Nothing
End Function

Public Sub Remove(Key As Long)
    oItems.Remove "K" + CStr(Key)
End Sub

Public Sub CleanUp()
    Dim i As Integer
    Dim iCount As Integer
    Dim oItem As CommandItem
    
    iCount = oItems.Count
    For i = 1 To iCount
        Set oItem = oItems.Item(i)
        oItem.CleanUp
    Next
    
    For i = 1 To iCount
        oItems.Remove 1
    Next
    
    Set oItems = Nothing
End Sub

