VERSION 5.00
Begin VB.UserControl MenuBar 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   CanGetFocus     =   0   'False
   ClientHeight    =   315
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   345
   InvisibleAtRuntime=   -1  'True
   Picture         =   "MenuBar.ctx":0000
   ScaleHeight     =   315
   ScaleWidth      =   345
   ToolboxBitmap   =   "MenuBar.ctx":0532
End
Attribute VB_Name = "MenuBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

#If DBG Then
    #Const TRACE_WM = False
#End If

Private oCommandList As CommandList

Private oImageList As Object

Private vImageChecked As Variant
Private vImageUnChecked As Variant

Private oMenuBarItems As MenuBarItems

Private oMenuItems As MenuItems

Private hMenuBar As Long

Private mi As MEASUREITEMSTRUCT
Private di As DRAWITEMSTRUCT
Private mii As MENUITEMINFO

Private wFlags As Integer
Private wID As Integer
Private wUser As Integer
Private hMenu As Long
Private hDC As Long

Private oNCM As New NonClientMetrics
Private hFontOld As Long

Private hBrushHighlight As Long
Private hBrushMenu As Long
Private hPenHighlight As Long
Private hPenMenu As Long
Private hPenBtnHighlight As Long
Private hPenBtnShadow As Long
Private hPenBtnFace As Long
Private lColorHighlightText As Long
Private lColorMenuText As Long
Private lColorGrayText As Long

Private hBrushOld As Long
Private hPenOld As Long
Private lTextColorOld As Long

Private oItem As MenuBarItem
Private oSelectedItem As MenuBarItem
Private lSelectedID As Long
Private lSelectedhMenu As Long
Private oIML As Object

Private lMenuSizeX As Long
Private lMenuSizeY As Long

Private vImage As Variant
Private lImageWidth As Long
Private lImageHeight As Long

Private r As RECT

Private lFormat As Long

Private lPosX As Long
Private lPosY As Long

Private tPoint As POINTAPI

Private bShow As Boolean
Private hPrevMenu As Long
Private hWndMenu As Long

Private bMenuLoop As Boolean

Private i As Integer

Private lRC As Long

'''

'
' Public
'
' Events
'
Public Event ItemClick(ByVal Item As MenuBarItem)
Public Event ItemSelect(ByVal Item As MenuBarItem)
'
' Properties
'
Public Property Get CommandList() As CommandList
    Set CommandList = oCommandList
End Property
Public Property Set CommandList(NewVal As CommandList)
    Set oCommandList = NewVal
    Set oImageList = oCommandList.ImageList
End Property

Public Property Get ImageList() As Object
    Set ImageList = oImageList
End Property

Public Property Get ImageChecked() As Variant
    ImageChecked = vImageChecked
End Property
Public Property Let ImageChecked(ByVal NewVal As Variant)
    vImageChecked = NewVal
End Property

Public Property Get ImageUnChecked() As Variant
    ImageUnChecked = vImageUnChecked
End Property
Public Property Let ImageUnChecked(ByVal NewVal As Variant)
    vImageUnChecked = NewVal
End Property

Public Property Get MenuBarItems() As MenuBarItems
    Set MenuBarItems = oMenuBarItems
End Property

Friend Property Get MenuHWnd() As Long
    MenuHWnd = hWndMenu
End Property
'
' Private
'
' Events UserControl
'
Private Sub UserControl_Initialize()
    Set oCommandList = Nothing
    
    vImageChecked = Empty
    vImageUnChecked = Empty
    
    Set oMenuBarItems = New MenuBarItems
    Set oMenuBarItems.MenuBar = Me
    
    Set oMenuItems = New MenuItems
    
    mii.fMask = MIIM_DATA
    mii.cbSize = Len(mii)
    
    lMenuSizeX = GetSystemMetrics(SM_CXMENUSIZE) + 2
    lMenuSizeY = GetSystemMetrics(SM_CYMENUSIZE)
    
    bShow = False
    hPrevMenu = 0
    hWndMenu = 0
    
    bMenuLoop = False
End Sub

Private Sub UserControl_Resize()
    SIZE ScaleX(20, vbPixels, vbTwips), ScaleY(20, vbPixels, vbTwips)
End Sub
'
' Methods
'
Public Sub Show(ByVal hWnd As Long)
    Dim hDC As Long
    
    If Not Ambient.UserMode Then Exit Sub
    If bShow Then Exit Sub
    
    #If DBG Then
        T ">>> Show 0x" + Hex$(hWnd)
    #End If
    
    If hWnd = 0 Then Exit Sub
    
    lMenuSizeX = GetSystemMetrics(SM_CXMENUSIZE) + 2
    lMenuSizeY = GetSystemMetrics(SM_CYMENUSIZE)
    
    hBrushHighlight = CreateSolidBrush(GetSysColor(COLOR_HIGHLIGHT))
    hBrushMenu = CreateSolidBrush(GetSysColor(COLOR_MENU))
    hPenHighlight = CreatePen(0, 1, GetSysColor(COLOR_HIGHLIGHT))
    hPenMenu = CreatePen(0, 1, GetSysColor(COLOR_MENU))
    hPenBtnHighlight = CreatePen(0, 1, GetSysColor(COLOR_BTNHIGHLIGHT))
    hPenBtnShadow = CreatePen(0, 1, GetSysColor(COLOR_BTNSHADOW))
    hPenBtnFace = CreatePen(0, 1, GetSysColor(COLOR_BTNFACE))
    
    lColorHighlightText = GetSysColor(COLOR_HIGHLIGHTTEXT)
    lColorMenuText = GetSysColor(COLOR_MENUTEXT)
    lColorGrayText = GetSysColor(COLOR_GRAYTEXT)
    
    hDC = GetDC(hWnd)
    hFontOld = SelectObject(hDC, oNCM.MenuFont)
    
    hWndMenu = hWnd
    hPrevMenu = GetMenu(hWndMenu)
    
    hMenuBar = Create(hPrevMenu)
    
    If hMenuBar <> 0 Then
        SubClassMenuBar.Hook Me, hWndMenu
        lRC = SetMenu(hWndMenu, hMenuBar)
        lRC = DrawMenuBar(hWndMenu)
        bShow = True
    End If
    
    #If DBG Then
        T "<<< Show"
    #End If
End Sub

Public Sub Draw()
    If Not Ambient.UserMode Then Exit Sub
    If Not bShow Then Exit Sub
    If hMenuBar <> 0 Then
        lRC = SetMenu(hWndMenu, hMenuBar)
        lRC = DrawMenuBar(hWndMenu)
    End If
End Sub

Public Sub Hide()
    If Not Ambient.UserMode Then Exit Sub
    If Not bShow Then Exit Sub
    
    #If DBG Then
        T ">>> Hide 0x" + Hex$(hWndMenu)
    #End If
    
    SubClassMenuBar.Unhook
    
    hDC = GetDC(hWndMenu)
    SelectObject hDC, hFontOld
    
    hMenuBar = Destroy(hMenuBar)
    
    DeleteObject hBrushHighlight
    DeleteObject hBrushMenu
    DeleteObject hPenHighlight
    DeleteObject hPenMenu
    DeleteObject hPenBtnHighlight
    DeleteObject hPenBtnShadow
    DeleteObject hPenBtnFace
    
    If hPrevMenu <> 0 Then
        lRC = SetMenu(hWndMenu, hPrevMenu)
        lRC = DrawMenuBar(hWndMenu)
    End If
    
    bShow = False

    #If DBG Then
        T "<<< Hide"
    #End If
End Sub

Public Function AddMenuBarItem(MenuBarItem As MenuBarItem, _
                               Optional ByVal After As Integer) As Integer
                          
    Dim iPos As Integer
                          
    iPos = oMenuBarItems.AddMenuBarItem(MenuBarItem, After)
    
    If Not bShow Then Exit Function
    
    SubClassMenuBar.Unhook
    Update
    SubClassMenuBar.Hook Me, hWndMenu
    
    If hMenuBar <> 0 Then
        lRC = SetMenu(hWndMenu, hMenuBar)
        lRC = DrawMenuBar(hWndMenu)
    End If
    
    AddMenuBarItem = iPos
End Function

Public Sub RemoveMenuBarItem(ByVal Index As Integer)
    Dim oItem As MenuBarItem
    
    Set oItem = oMenuBarItems.Item(Index)
    
    oMenuBarItems.RemoveMenuBarItem Index
    
    If Not bShow Then Exit Sub
    
    SubClassMenuBar.Unhook
    
    oItem.Delete hMenuBar, oItem.ID, False
    oMenuItems.RemoveMenuBarItem oItem
    With oItem
        .TopItem = False
        .MenuHandle = 0
        .Pos = 0
        .ID = 0
    End With
            
    Update
    
    SubClassMenuBar.Hook Me, hWndMenu

    If hMenuBar <> 0 Then
        lRC = SetMenu(hWndMenu, hMenuBar)
        lRC = DrawMenuBar(hWndMenu)
    End If
End Sub

Private Function Create(ByVal hPrevMenu As Long) As Long
    #If DBG Then
        T ">>> Create hPrevMenu = 0x" & Hex(hPrevMenu)
    #End If
    
    Dim hMenu As Long
    Dim oItem As MenuBarItem
    Dim lItem As Long
    
    If hPrevMenu = 0 Then
        hMenu = CreateMenu()
    Else
        hMenu = hPrevMenu
    End If

    #If DBG Then
        T "hMenu = 0x" + Hex$(hMenu)
    #End If

    If hMenu <> 0 Then
        lItem = 0
        For Each oItem In oMenuBarItems
            With oItem
                .TopItem = True
                .MenuHandle = hMenu
                .Pos = lItem
                Set .MenuItems = oMenuItems
            End With
            
            oMenuItems.AddMenuBarItem oItem
        
            oItem.Insert hMenu, lItem, True
            lItem = lItem + 1
        Next
    End If
    
    Create = hMenu
    
    #If DBG Then
        T "<<< Create"
    #End If
End Function

Private Sub Update()
    Dim hMenu As Long
    Dim oItem As MenuBarItem
    Dim lItem As Long
    
    hMenu = hMenuBar
    
    #If DBG Then
        T ">>> Update hMenu = 0x" & Hex(hMenu)
    #End If

    If hMenu <> 0 Then
        lItem = 0
        For Each oItem In oMenuBarItems
            
            oItem.Pos = lItem
            
            If oItem.MenuHandle = 0 Then
                With oItem
                    .TopItem = True
                    .MenuHandle = hMenu
                    Set .MenuItems = oMenuItems
                End With
                
                oMenuItems.AddMenuBarItem oItem
                
                oItem.Insert hMenu, lItem, True
            End If
            
            lItem = lItem + 1
        Next
    End If

    #If DBG Then
        T "<<< Update"
    #End If
End Sub

Private Function Destroy(ByVal hMenu As Long) As Long
    #If DBG Then
        T ">>> Destroy hMenu = 0x" & Hex(hMenu)
    #End If
    
    Dim oItem As MenuBarItem
    Dim lItem As Long

    If hMenu <> 0 Then
        lItem = 0
        For Each oItem In oMenuBarItems
            oItem.Delete hMenu, oItem.ID, False
            lItem = lItem + 1
            
            oMenuItems.RemoveMenuBarItem oItem
            
            With oItem
                .TopItem = False
                .MenuHandle = 0
                .Pos = 0
                .ID = 0
            End With
        Next
        
        If hPrevMenu = 0 Then
            DestroyMenu hMenu
        End If
        
        hMenu = 0
    End If
    
    Destroy = hMenu
    
    #If DBG Then
        T "<<< Destroy"
    #End If
End Function

Public Sub RaiseEventItemSelect(Item As MenuBarItem)
    RaiseEvent ItemSelect(Item)
End Sub

Public Sub RaiseEventItemClick(Item As MenuBarItem)
    RaiseEvent ItemClick(Item)
End Sub

Public Sub CleanUp()
    oMenuBarItems.CleanUp
    Set oMenuBarItems = Nothing
    oMenuItems.CleanUp
    Set oMenuItems = Nothing
    Set oItem = Nothing
    Set oSelectedItem = Nothing
    Set oIML = Nothing
    Set oCommandList = Nothing
    Set oImageList = Nothing
End Sub
'
' SubClass MsgProc
'
Public Sub MsgProc(ByVal hWnd As Long, _
                   ByVal wMsg As Long, _
                   ByVal wParam As Long, _
                   ByVal lParam As Long, _
                   lReturn As Long, _
                   bResult As Boolean)
Attribute MsgProc.VB_MemberFlags = "40"
    
    On Error GoTo OnError_Msg_MsgProc

    Select Case wMsg
        Case WM_MEASUREITEM:
            #If TRACE_WM Then
                T "WM_MEASUREITEM: 0x" + Hex$(wParam) + " 0x" + Hex$(lParam)
            #End If
                      
            If wParam = 0& Then
                CopyMem mi, ByVal lParam, Len(mi)
                If mi.CtlType = ODT_MENU Then
                    If mi.ItemID > 0 Then
                        Set oItem = oMenuItems.Item(mi.ItemID)
                        
                        Set oIML = oItem.MenuBar.ImageList

                        hDC = GetDC(hWnd)

                        lImageWidth = 0

                        r.Left = 0
                        r.Top = 0

                        If oItem.TopItem Then
                            DrawText hDC, oItem.CommandItem.Caption, Len(oItem.CommandItem.Caption), r, DT_SINGLELINE + DT_CALCRECT
                            r.Right = r.Right - 12
                        Else
                            DrawText hDC, oItem.CommandItem.CaptionKey, Len(oItem.CommandItem.CaptionKey), r, DT_SINGLELINE + DT_CALCRECT
                            If Not oIML Is Nothing Then lImageWidth = oIML.ImageWidth
                        End If

                        mi.ItemWidth = lImageWidth + r.Right + 12
                        mi.ItemHeight = lMenuSizeY + 2
                        
                        CopyMem ByVal lParam, mi, Len(mi)
                        bResult = False
                        lReturn = 1
                    End If
                End If
            End If

        Case WM_DRAWITEM:
            #If TRACE_WM Then
                T "WM_DRAWITEM: 0x" + Hex$(wParam) + " 0x" + Hex$(lParam)
            #End If
            
            If wParam = 0& Then
                CopyMem di, ByVal lParam, LenB(di)
                
                If di.CtlType = ODT_MENU And _
                   di.ItemID > 0 And _
                   di.ItemAction < 8 _
                Then
                   
                    With di
                        Set oItem = oMenuItems.Item(.ItemID)
                        Set oIML = oItem.MenuBar.ImageList
                        
                        If (.ItemState And ODS_SELECTED) = ODS_SELECTED And oItem.CommandItem.Enabled Then
                            hBrushOld = SelectObject(.hDC, hBrushHighlight)
                            hPenOld = SelectObject(.hDC, hPenHighlight)
                        Else
                            hBrushOld = SelectObject(.hDC, hBrushMenu)
                            hPenOld = SelectObject(.hDC, hPenMenu)
                        End If
                        
                        SetBkMode .hDC, TRANSPARENT
                    
                        r.Left = .rcItem.Left
                        r.Top = .rcItem.Top
                        r.Right = .rcItem.Right
                        r.Bottom = .rcItem.Bottom
                        
                        If oItem.TopItem Then
                            lRC = Rectangle(.hDC, r.Left, r.Top, r.Right, r.Bottom)
                            If oItem.CommandItem.Enabled Then
                                If (.ItemState And ODS_SELECTED) = ODS_SELECTED Then
                                    lTextColorOld = SetTextColor(.hDC, lColorHighlightText)
                                Else
                                    lTextColorOld = SetTextColor(.hDC, lColorMenuText)
                                End If
                                r.Top = r.Top + 2
                                lRC = DrawText(.hDC, oItem.CommandItem.Caption, Len(oItem.CommandItem.Caption), r, DT_CENTER)
                                SetTextColor .hDC, lTextColorOld
                            Else
                                lTextColorOld = SetTextColor(.hDC, lColorHighlightText)
                                r.Left = r.Left + 1
                                r.Right = r.Right + 1
                                r.Top = r.Top + 3
                                lRC = DrawText(.hDC, oItem.CommandItem.Caption, Len(oItem.CommandItem.Caption), r, DT_CENTER)
                                SetTextColor .hDC, lColorGrayText
                                r.Left = r.Left - 1
                                r.Right = r.Right - 1
                                r.Top = r.Top - 1
                                lRC = DrawText(.hDC, oItem.CommandItem.Caption, Len(oItem.CommandItem.Caption), r, DT_CENTER)
                                SetTextColor .hDC, lTextColorOld
                            End If
                        Else
                            If Not oIML Is Nothing Then
                                If oIML.ListImages.Count > 0 Then
                                    r.Right = .rcItem.Left + lMenuSizeX + 1
                                    
                                    vImage = Empty
                                    
                                    If oItem.CommandItem.ItemType = cmdTypeCheck Then
                                        If oItem.CommandItem.Checked = cmdItemChecked Then
                                            vImage = vImageChecked
                                        Else
                                            vImage = vImageUnChecked
                                        End If
                                    Else
                                        vImage = oItem.CommandItem.Image
                                    End If
                                    
                                    If Not IsMissing(vImage) Then
                                        lPosY = (lMenuSizeY - oIML.ImageHeight) \ 2 + 1
                                        If lPosY < 0 Then lPosY = 0
                                        lPosX = lPosY + 1
                                        lPosY = .rcItem.Top + lPosY
                                        lPosX = .rcItem.Left + lPosX
                                        
                                        If oItem.CommandItem.Enabled Then
                                            ImageList_Draw oIML.hImageList, _
                                                oIML.ListImages(vImage).Index - 1, _
                                                .hDC, lPosX, lPosY, ILD_TRANSPARENT
                                        Else
                                            DisableListImage.DisableListImage oIML, vImage, .hDC, lPosX, lPosY
                                        End If
                                        
                                        If oItem.CommandItem.ItemType <> cmdTypeCheck Then
                                            If (.ItemState And ODS_SELECTED) = ODS_SELECTED And oItem.CommandItem.Enabled Then
                                                ThreedBox .hDC, .rcItem.Left, .rcItem.Top, .rcItem.Left + lMenuSizeX, .rcItem.Bottom - 1
                                            Else
                                                Rec .hDC, .rcItem.Left, .rcItem.Top, .rcItem.Left + lMenuSizeX, .rcItem.Bottom - 1
                                            End If
                                        End If
                                    End If
                                    r.Left = r.Right + 1
                                    r.Right = .rcItem.Right
                                End If
                            End If
                            
                            lRC = Rectangle(.hDC, r.Left, r.Top, r.Right, r.Bottom)
                            
                            r.Right = r.Right - 5
                            
                            If oItem.CommandItem.Enabled Then
                                If (.ItemState And ODS_SELECTED) = ODS_SELECTED Then
                                    lTextColorOld = SetTextColor(.hDC, lColorHighlightText)
                                Else
                                    lTextColorOld = SetTextColor(.hDC, lColorMenuText)
                                End If
        
                                r.Left = r.Left + 3
                                r.Top = r.Top + 3
                                lRC = DrawText(.hDC, oItem.CommandItem.Caption, Len(oItem.CommandItem.Caption), r, DT_LEFT)
                                lRC = DrawText(.hDC, oItem.CommandItem.KeyString, Len(oItem.CommandItem.KeyString), r, DT_RIGHT)
                                SetTextColor .hDC, lTextColorOld
                            Else
                                lTextColorOld = SetTextColor(.hDC, lColorHighlightText)
                                r.Left = r.Left + 3
                                r.Top = r.Top + 3
                                lRC = DrawText(.hDC, oItem.CommandItem.Caption, Len(oItem.CommandItem.Caption), r, DT_LEFT)
                                lRC = DrawText(.hDC, oItem.CommandItem.KeyString, Len(oItem.CommandItem.KeyString), r, DT_RIGHT)
                                SetTextColor .hDC, lColorGrayText
                                r.Left = r.Left - 1
                                r.Top = r.Top - 1
                                lRC = DrawText(.hDC, oItem.CommandItem.Caption, Len(oItem.CommandItem.Caption), r, DT_LEFT)
                                lRC = DrawText(.hDC, oItem.CommandItem.KeyString, Len(oItem.CommandItem.KeyString), r, DT_RIGHT)
                                SetTextColor .hDC, lTextColorOld
                            End If
                        End If
                        
                        SelectObject .hDC, hBrushOld
                        SelectObject .hDC, hPenOld
                    End With
                    bResult = False
                End If
            End If
            
        Case WM_MENUSELECT:
            #If TRACE_WM Then
                T "WM_MENUSELECT: 0x" + Hex$(wParam) + " 0x" + Hex$(lParam)
            #End If
                        
            BitWise.HILO wParam, wFlags, wID
            hMenu = lParam
            
            If (wFlags = &HFFFF) And (hMenu = 0) Then
                If Not oSelectedItem Is Nothing Then
                    With oSelectedItem
                        If .CommandItem.ItemType = cmdTypeCheck Then
                            If .CommandItem.Checked = cmdItemChecked Then
                                .CommandItem.Checked = cmdItemUnchecked
                            Else
                                .CommandItem.Checked = cmdItemChecked
                            End If
                        End If
                        .MenuBar.RaiseEventItemClick oSelectedItem
                        TimerMenubar.AsyncClick .MenuBar.CommandList, .CommandItem
                    End With
                    Set oSelectedItem = Nothing
                End If
            Else
                Set oSelectedItem = Nothing
                If (wFlags And MF_POPUP) = MF_POPUP Then
                Else
                    If wID > 0 Then
                        Set oSelectedItem = oMenuItems.Item(wID)
                        lSelectedID = wID
                        lSelectedhMenu = hMenu
                        With oSelectedItem
                            If .CommandItem.ItemType <> cmdTypeSeperator Then
                                .MenuBar.RaiseEventItemSelect oSelectedItem
                                .MenuBar.CommandList.EventItemSelect .CommandItem
                            End If
                        End With
                    End If
                End If
            End If
            
            bResult = False
            
        Case WM_ENTERMENULOOP:
            bMenuLoop = True
            
        Case WM_EXITMENULOOP:
            bMenuLoop = False
        
        Case WM_MENUCHAR:
            BitWise.HILO wParam, wFlags, wUser
            hMenu = lParam
            
            For i = 0 To GetMenuItemCount(hMenu) - 1
                wID = GetMenuItemID(hMenu, i)
                If wID = &HFFFFFFFF Then
                    mii.fMask = MIIM_ID
                    If GetMenuItemInfo(hMenu, i, True, mii) <> 0 Then
                        wID = mii.wID
                    Else
                        wID = 0
                    End If
                End If
                Set oItem = oMenuItems.Item(wID)
                If Asc(UCase$(Chr$(wUser))) = oItem.CommandItem.Mnemonic Then
                    lReturn = HL2L(MNC_EXECUTE, i)
                    bResult = False
                    Exit For
                End If
            Next
            
        Case WM_WININICHANGE:
            oNCM.Refresh
        
            Hide
            Show hWnd
            
    End Select
    
OnError_Exit_MsgProc:
    Exit Sub

OnError_Msg_MsgProc:
    MsgBox "Internal Error in Sub:" & vbCrLf & vbCrLf & _
           "'SAPDBCommand\MenuBar\MsgProc()'" & vbCrLf & vbCrLf & _
           "Message = 0x" & Hex(wMsg) & vbCrLf & _
           "Error " & CStr(Err.Number) & ": " & Err.Description, vbExclamation, App.Title
    SubClassMenuBar.Unhook
    
    Resume OnError_Exit_MsgProc
End Sub

Private Sub ThreedBox(ByVal hDC As Long, _
                      ByVal X1 As Long, _
                      ByVal Y1 As Long, _
                      ByVal X2 As Long, _
                      ByVal Y2 As Long)
                      
    If hDC = 0 Then Exit Sub
    
    hPenOld = SelectObject(hDC, hPenBtnHighlight)
    
    'FirstLightLine
    MoveToEx hDC, X1, Y2, tPoint
    LineTo hDC, X1, Y1
    'SecondLightLine
    LineTo hDC, X2, Y1
    
    SelectObject hDC, hPenBtnShadow
    
    'FirstDarkLine
    MoveToEx hDC, X1, Y2, tPoint
    LineTo hDC, X2, Y2
    'SecondDarkLine
    LineTo hDC, X2, Y1
    
    SelectObject hDC, hPenOld
End Sub

Private Sub Rec(ByVal hDC As Long, _
                ByVal X1 As Long, _
                ByVal Y1 As Long, _
                ByVal X2 As Long, _
                ByVal Y2 As Long)
                      
    If hDC = 0 Then Exit Sub
    
    hPenOld = SelectObject(hDC, hPenBtnFace)
    
    MoveToEx hDC, X1, Y2, tPoint
    LineTo hDC, X1, Y1
    LineTo hDC, X2, Y1
    LineTo hDC, X2, Y2
    LineTo hDC, X1, Y2
    SelectObject hDC, hPenOld
End Sub

'''

#If DBG Then

Public Property Get Trace() As Object
    Set Trace = oTrace
End Property

Public Property Set Trace(NewVal As Object)
    Set oTrace = NewVal
End Property

Private Sub T(ByVal sText As String)
    If Not oTrace Is Nothing Then
        oTrace.Text "MenuBar: " + sText
    End If
End Sub

#End If



