VERSION 5.00
Begin VB.UserControl OutMenu 
   ClientHeight    =   1335
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2265
   ScaleHeight     =   89
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   151
   ToolboxBitmap   =   "OutMenu.ctx":0000
   Begin VB.PictureBox picForm 
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000004&
      BorderStyle     =   0  'None
      Height          =   1095
      Left            =   60
      ScaleHeight     =   73
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   101
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   60
      Width           =   1515
      Begin VB.PictureBox picScroll 
         BorderStyle     =   0  'None
         Height          =   915
         Left            =   60
         ScaleHeight     =   61
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   85
         TabIndex        =   1
         TabStop         =   0   'False
         Top             =   60
         Width           =   1275
         Begin VB.VScrollBar scrV 
            Height          =   735
            Left            =   960
            TabIndex        =   2
            TabStop         =   0   'False
            Top             =   60
            Visible         =   0   'False
            Width           =   210
         End
         Begin VB.PictureBox picMenu 
            AutoRedraw      =   -1  'True
            BackColor       =   &H80000004&
            BorderStyle     =   0  'None
            Height          =   735
            Left            =   60
            ScaleHeight     =   49
            ScaleMode       =   3  'Pixel
            ScaleWidth      =   57
            TabIndex        =   3
            Top             =   60
            Width           =   855
         End
      End
   End
   Begin VB.Timer timOutMenu 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   1680
      Top             =   120
   End
End
Attribute VB_Name = "OutMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Enum OutMenuBorderStyleConstants
    omeBorderStyleNone
    omeBorderStyleSingle
    omeBorderStyleRaised
    omeBorderStyleSunken
End Enum

Private lBorderStyle As OutMenuBorderStyleConstants

Private oCommandList As CommandList

Private oOutMenuItems As OutMenuItems

Private iButtonHeight As Integer
Private iItemHeight As Integer

Private iMinButtonHeight As Integer
Private iMinItemHeight As Integer

Private lMenuSizeY As Long

Private oButtonDown As OutMenuItem
Private iButtonDown As Integer
Private oButtonAct As OutMenuItem
Private iButtonAct As Integer

Private oItemAct As OutMenuItem
Private iItemAct As Integer
Private oItemLast As OutMenuItem
Private iItemLast As Integer

Private r As RECT
'
' Public
'
' Events
'
Public Event ItemClick(ByVal Item As OutMenuItem)
Public Event ItemSelect(ByVal Item As OutMenuItem)
'
' Properties
'
Public Property Get BorderStyle() As OutMenuBorderStyleConstants
    BorderStyle = lBorderStyle
End Property
Public Property Let BorderStyle(ByVal NewVal As OutMenuBorderStyleConstants)
    lBorderStyle = NewVal
    PropertyChanged "BorderStyle"
    Draw
End Property

Public Property Get Enabled() As Boolean
    Enabled = UserControl.Enabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    UserControl.Enabled = NewVal
    PropertyChanged "Enabled"
End Property

Public Property Get CommandList() As CommandList
    Set CommandList = oCommandList
End Property
Public Property Set CommandList(NewVal As CommandList)
    Set oCommandList = NewVal
End Property

Public Property Get OutMenuItems() As OutMenuItems
    Set OutMenuItems = oOutMenuItems
End Property

Public Property Get ButtonHeight() As Integer
    ButtonHeight = iButtonHeight
End Property
Public Property Let ButtonHeight(ByVal NewVal As Integer)
    iButtonHeight = NewVal
    
    If iButtonHeight < iMinButtonHeight Then iButtonHeight = iMinButtonHeight
    
    PropertyChanged "ButtonHeight"
End Property

Public Property Get ItemHeight() As Integer
    ItemHeight = iItemHeight
End Property
Public Property Let ItemHeight(ByVal NewVal As Integer)
    iItemHeight = NewVal
    
    If iItemHeight < iMinItemHeight Then iItemHeight = iMinItemHeight
    
    PropertyChanged "ItemHeight"
End Property

' Hidden Properties
Public Property Get ButtonsPic() As Object
Attribute ButtonsPic.VB_MemberFlags = "40"
    Set ButtonsPic = picForm
End Property
Public Property Get ItemsPic() As Object
Attribute ItemsPic.VB_MemberFlags = "40"
    Set ItemsPic = picMenu
End Property
Public Property Get ButtonAct() As OutMenuItem
Attribute ButtonAct.VB_MemberFlags = "40"
    Set ButtonAct = oButtonAct
End Property
'
' Methods
'
Public Sub Refresh()
    Draw
End Sub

Public Sub CleanUp()
    oOutMenuItems.CleanUp
    Set oOutMenuItems = Nothing
    Set oButtonDown = Nothing
    Set oButtonAct = Nothing
    Set oItemAct = Nothing
    Set oItemLast = Nothing
    Set oCommandList = Nothing
End Sub
'
' Private
'
' Events UserControl
'
Private Sub UserControl_Initialize()
    Dim tm As TEXTMETRIC
    
    Set oCommandList = Nothing
    
    lBorderStyle = omeBorderStyleSunken
    
    Set oOutMenuItems = New OutMenuItems
    Set oOutMenuItems.OutMenu = Me
    oOutMenuItems.TopItems = True
    
    GetTextMetrics UserControl.hDC, tm
    iMinButtonHeight = tm.tmHeight + 6
    iButtonHeight = iMinButtonHeight
    iMinItemHeight = tm.tmHeight + 4
    iItemHeight = iMinItemHeight
    
    lMenuSizeY = GetSystemMetrics(SM_CYMENUSIZE) + 2
    If iItemHeight < lMenuSizeY Then iItemHeight = lMenuSizeY
    
    scrV.Top = 0
    scrV.Width = GetSystemMetrics(SM_CXVSCROLL)
    
    picForm.Move 0, 0
    picMenu.Move 0, 0

    Set oButtonDown = Nothing
    iButtonDown = 0
    Set oButtonAct = Nothing
    iButtonAct = 0
End Sub

Private Sub UserControl_Resize()
    picForm.Move 0, 0, ScaleWidth, ScaleHeight
    Draw
End Sub

Private Sub UserControl_Paint()
    Draw
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    BackColor = PropBag.ReadProperty("BackColor")
    BorderStyle = PropBag.ReadProperty("BorderStyle", omeBorderStyleSunken)
    Enabled = PropBag.ReadProperty("Enabled")
    ButtonHeight = PropBag.ReadProperty("ButtonHeight")
    ItemHeight = PropBag.ReadProperty("ItemHeight")
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    PropBag.WriteProperty "BackColor", BackColor
    PropBag.WriteProperty "BorderStyle", BorderStyle, omeBorderStyleSunken
    PropBag.WriteProperty "Enabled", Enabled
    PropBag.WriteProperty "ButtonHeight", ButtonHeight
    PropBag.WriteProperty "ItemHeight", ItemHeight
End Sub

Private Sub picForm_MouseDown(Menu As Integer, Shift As Integer, x As Single, y As Single)
    Set oButtonDown = FindButtonByPos(x, y, iButtonDown)

    If Not oButtonDown Is Nothing Then oButtonDown.DrawButton True
End Sub

Private Sub picForm_MouseUp(Menu As Integer, Shift As Integer, x As Single, y As Single)
    If Not oButtonDown Is Nothing Then
        oButtonDown.DrawButton False
                
        oOutMenuItems.UnSelect
        
        oButtonDown.Selected = True
        
        Set oItemAct = Nothing
        iItemAct = 0
        
        Draw

        RaiseEvent ItemClick(oButtonDown)
        oCommandList.EventItemClick oButtonDown.CommandItem

        Set oButtonAct = oButtonDown
        iButtonAct = iButtonAct
        Set oButtonDown = Nothing
        iButtonDown = 0
    End If
End Sub
'
' picScroll
'
Private Sub picScroll_Resize()
    Dim iWidth As Integer
        
    iWidth = picScroll.ScaleWidth
    If iWidth < 0 Then iWidth = 0
    picMenu.Width = iWidth
    
    scrV.Left = picScroll.ScaleWidth - scrV.Width
    scrV.Height = picScroll.ScaleHeight
    
    picMenu_Resize
End Sub
'
' picMenu
'
Private Sub picMenu_Resize()
    If picMenu.Height > picScroll.ScaleHeight Then
        scrV.Visible = True
    Else
        scrV.Visible = False
    End If
    
    scrV.Max = picMenu.Height - picScroll.ScaleHeight
    If picScroll.ScaleHeight > 0 Then scrV.LargeChange = picScroll.ScaleHeight
    
    DrawItems
End Sub

Private Sub picMenu_GotFocus()
    If oButtonAct Is Nothing Then Exit Sub

    If oItemAct Is Nothing Then
        Set oItemAct = oItemLast
        iItemAct = iItemLast
    End If

    If Not oItemAct Is Nothing Then
        oItemAct.DrawItem True
    Else
        If Not oButtonAct.OutMenuItems Is Nothing Then
            If oButtonAct.OutMenuItems.Count > 0 Then
                Set oItemAct = oButtonAct.OutMenuItems.Item(1)
                oItemAct.DrawItem True
                iItemAct = 1
            End If
        End If
    End If
End Sub

Private Sub picMenu_LostFocus()
    If Not oItemAct Is Nothing Then oItemAct.DrawItem False

    Set oItemLast = oItemAct
    iItemLast = iItemAct

    Set oItemAct = Nothing
    iItemAct = 0
End Sub

Private Sub picMenu_Click()
    If Not oItemAct Is Nothing Then
        If Not oItemAct.CommandItem.ItemType = cmdTypeSeperator Then
            RaiseEvent ItemClick(oItemAct)
            oCommandList.EventItemClick oItemAct.CommandItem
        End If
    End If
End Sub

Private Sub picMenu_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim oItem As OutMenuItem
    Dim iItem As Integer

    Set oItem = FindItemByPos(x, y, iItem)

    If iItem = iItemAct Then Exit Sub

    If Not oItem Is Nothing Then

        If Not timOutMenu.Enabled Then timOutMenu.Enabled = True

        If Not oItemAct Is Nothing Then oItemAct.DrawItem False
        oItem.DrawItem True
        If Not oItem.CommandItem.ItemType = cmdTypeSeperator Then
            RaiseEvent ItemSelect(oItem)
            oCommandList.EventItemSelect oItem.CommandItem
        End If
    End If
    Set oItemAct = oItem
    iItemAct = iItem
End Sub

Private Sub picMenu_KeyDown(KeyCode As Integer, Shift As Integer)
    Dim bChanged As Boolean
    Dim iNewItem As Integer

    If oButtonAct Is Nothing Then Exit Sub

    bChanged = False

    If Shift = 0 Then
        Select Case KeyCode
            Case vbKeyHome:
                iNewItem = 1
                bChanged = True
            Case vbKeyUp:
                If iItemAct > 1 Then
                    iNewItem = iItemAct - 1
                Else
                    iNewItem = 1
                End If
                bChanged = True
            Case vbKeyDown:
                If iItemAct < oButtonAct.OutMenuItems.Count Then
                    iNewItem = iItemAct + 1
                Else
                    iNewItem = oButtonAct.OutMenuItems.Count
                End If
                bChanged = True
            Case vbKeyEnd:
                iNewItem = oButtonAct.OutMenuItems.Count
                bChanged = True
            Case vbKeyReturn:
                If Not oItemAct Is Nothing Then
                    If Not oItemAct.CommandItem.ItemType = cmdTypeSeperator Then
                        RaiseEvent ItemClick(oItemAct)
                        oCommandList.EventItemClick oItemAct.CommandItem
                    End If
                End If
        End Select
    End If

    If Not bChanged Then Exit Sub
    If iNewItem = iItemAct Then Exit Sub

    If Not oItemAct Is Nothing Then
        oItemAct.DrawItem False
    End If

    Set oItemAct = oButtonAct.OutMenuItems.Item(iNewItem)
    iItemAct = iNewItem

    oItemAct.DrawItem True

    If Not oItemAct.CommandItem.ItemType = cmdTypeSeperator Then
        RaiseEvent ItemSelect(oItemAct)
        oCommandList.EventItemSelect oItemAct.CommandItem
    End If

    If oItemAct.Bottom + picMenu.Top > picScroll.ScaleHeight Then scrV.Value = oItemAct.Bottom - picScroll.ScaleHeight
    If oItemAct.Top + picMenu.Top < 0 Then scrV.Value = oItemAct.Top
End Sub
'
' scrV
'
Private Sub scrV_Change()
    picMenu.Top = -scrV.Value
End Sub

Private Sub scrV_Scroll()
    picMenu.Top = -scrV.Value
End Sub
'
' timOutMenu
'
Private Sub timOutMenu_Timer()
    Dim p As POINTAPI
    Dim r As RECT

    GetCursorPos p
    GetWindowRect picMenu.hWnd, r

    If p.x >= r.Left And p.x <= r.Right And _
       p.y >= r.Top And p.y <= r.Bottom Then

        '
    Else
        If Not oItemAct Is Nothing Then
            oItemAct.DrawItem False
            Set oItemAct = Nothing
            iItemAct = 0
        Else
            timOutMenu.Enabled = False
        End If
    End If
End Sub
'
' Sub/Functions
'
Public Sub Draw()
    picForm.Cls
    DrawBorder
    DrawOutMenu
End Sub

Private Sub DrawBorder()
    Dim r As RECT
    
    Select Case lBorderStyle
        Case omeBorderStyleNone:
        Case omeBorderStyleSingle:
            picForm.Line (0, 0)-(ScaleWidth - 1, ScaleHeight - 1), 0, B
        Case omeBorderStyleRaised:
            r.Left = 0
            r.Top = 0
            r.Right = ScaleWidth
            r.Bottom = ScaleHeight
            DrawEdge picForm.hDC, r, EDGE_RAISED, BF_RECT + BF_SOFT
        Case omeBorderStyleSunken:
            r.Left = 0
            r.Top = 0
            r.Right = ScaleWidth
            r.Bottom = ScaleHeight
            DrawEdge picForm.hDC, r, EDGE_SUNKEN, BF_RECT + BF_SOFT
    End Select
End Sub

Private Sub DrawOutMenu()
    Dim iBorderSize As Integer
    Dim oItem As OutMenuItem
    Dim iItems As Integer
    
    Dim iTop  As Integer
    Dim iFormLeft As Integer
    Dim iFormTop As Integer
    Dim iFormWidth As Integer
    Dim iFormHeight As Integer
    
    If Not Ambient.UserMode Then Exit Sub
    If oOutMenuItems Is Nothing Then Exit Sub
    If oOutMenuItems.Count = 0 Then Exit Sub
        
    Set oButtonAct = oOutMenuItems.CheckSelect(iButtonAct)
    
    Select Case lBorderStyle
        Case omeBorderStyleNone:    iBorderSize = 0
        Case omeBorderStyleSingle:  iBorderSize = 1
        Case omeBorderStyleRaised:  iBorderSize = 2
        Case omeBorderStyleSunken:  iBorderSize = 2
    End Select
    
    iFormLeft = iBorderSize
    iFormWidth = picForm.ScaleWidth - 2 * iBorderSize
    If iFormWidth < 0 Then iFormWidth = 0
   
    iTop = iBorderSize
   
    iItems = 0
    For Each oItem In oOutMenuItems
        If oItem.CommandItem.Visible Then iItems = iItems + 1
    Next
    
    For Each oItem In oOutMenuItems
        If oItem.CommandItem.Visible Then
            With oItem
                .Left = iBorderSize
                .Top = iTop
                .Width = picForm.ScaleWidth + 1 - 2 * iBorderSize
                .Height = iButtonHeight
            End With
            
            oItem.DrawButton False
            
            iItems = iItems - 1
            
            If oItem.Selected Then
                iFormTop = iTop + oItem.Height - 1
                iTop = picForm.ScaleHeight - (iItems * iButtonHeight) + iItems - iBorderSize
                iFormHeight = iTop - iFormTop
                If iFormHeight < 0 Then iFormHeight = 0
            Else
                iTop = iTop + oItem.Height - 1
            End If
        End If
    Next
    
    picScroll.Move iFormLeft, iFormTop, iFormWidth, iFormHeight

    DrawItems
End Sub

Private Sub DrawItems()
    Dim oItem As OutMenuItem

    picMenu.Cls

    If Not Ambient.UserMode Then Exit Sub
    If oButtonAct Is Nothing Then Exit Sub
    If oButtonAct.OutMenuItems Is Nothing Then Exit Sub
    If oButtonAct.OutMenuItems.Count = 0 Then Exit Sub

    SizeItems oButtonAct.OutMenuItems

    For Each oItem In oButtonAct.OutMenuItems
        If oItem.CommandItem.Visible Then oItem.DrawItem False
    Next

    If Not oItemAct Is Nothing Then oItemAct.DrawItem True
End Sub

Private Sub SizeItems(ByVal oItems As OutMenuItems)
    Dim oItem As OutMenuItem
    Dim iTop  As Integer
    Dim iScrWidth As Integer

    iTop = 0

    For Each oItem In oItems
        With oItem
            .Left = 2
            .Top = iTop
            .Width = picMenu.ScaleWidth - 4
            Select Case .CommandItem.ItemType
                Case cmdTypeDefault, cmdTypeGroup:
                    .Height = iItemHeight
                Case cmdTypeSeperator:
                    .Height = iItemHeight \ 2
            End Select
        End With
        If oItem.CommandItem.Visible Then iTop = iTop + oItem.Height
    Next
    picMenu.Height = oItems.Item(oItems.Count).Bottom + 1

    If picMenu.Height > picScroll.ScaleHeight Then
        scrV.Visible = True
        iScrWidth = scrV.Width
    Else
        scrV.Visible = False
        iScrWidth = 0
    End If

    For Each oItem In oItems
        With oItem
            .Width = picMenu.ScaleWidth - iScrWidth - 4
        End With
    Next
End Sub

Private Function FindButtonByPos(ByVal x As Integer, ByVal y As Integer, iButton As Integer) As OutMenuItem
    Dim oItem As OutMenuItem
    Dim i As Integer
        
    Set FindButtonByPos = Nothing
    iButton = 0
    
    If oOutMenuItems Is Nothing Then Exit Function
    
    i = 0
    
    If y >= 0 And y <= picForm.ScaleHeight Then
        For Each oItem In oOutMenuItems
            i = i + 1
            If y >= oItem.Top And y <= oItem.Bottom And oItem.CommandItem.Visible Then
                Set FindButtonByPos = oItem
                iButton = i
                Exit Function
            End If
        Next
    End If
End Function

Private Function FindItemByPos(ByVal x As Integer, ByVal y As Integer, iItem As Integer) As OutMenuItem
    Dim oItem As OutMenuItem
    Dim i As Integer
    
    Set FindItemByPos = Nothing
    iItem = 0

    If oButtonAct Is Nothing Then Exit Function
    If oButtonAct.OutMenuItems Is Nothing Then Exit Function

    i = 0

    If y >= 0 And y <= picMenu.ScaleHeight Then
        For Each oItem In oButtonAct.OutMenuItems
            i = i + 1
            If y >= oItem.Top And y <= oItem.Bottom And oItem.CommandItem.Visible Then
                Set FindItemByPos = oItem
                iItem = i
                Exit Function
            End If
        Next
    End If
End Function

' Trace

#If DBG Then

Public Property Get Trace() As Object
    Set Trace = oTrace
End Property

Public Property Set Trace(NewVal As Object)
    Set oTrace = NewVal
End Property

#End If



