VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "OutMenuItems"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oItems As New Collection
Private oOutMenu As OutMenu
Private oParent As OutMenuItem
Private bTopItems As Boolean
'
' Public Properties
'
Public Property Get Count() As Long
    Count = oItems.Count
End Property

Public Property Get Item(ByVal Index As Long) As OutMenuItem
Attribute Item.VB_UserMemId = 0
    Set Item = oItems(Index)
End Property
'
' Public Sub/Function
'
Public Function Add(ByVal CommandKey As Long) As OutMenuItem
    Dim oItem As New OutMenuItem
    
    With oItem
        Set .CommandItem = oOutMenu.CommandList.CommandItems.Item(CommandKey)
        Set .OutMenu = oOutMenu
        Set .Parent = oParent
        .TopItem = bTopItems
    End With
    
    oItems.Add oItem
    
    oItem.Index = oItems.Count
    
    oItem.CommandItem.LinkedItems.Add oItem, cmdItemClassOutMenu

    Set Add = oItem
    Set oItem = Nothing
End Function

Public Sub Remove(ByVal Index As Long)
    Dim lIndex As Long
    
    oItems.Remove Index

    For lIndex = 1 To oItems.Count
       oItems.Item(lIndex).IndexSet lIndex
    Next
End Sub
'
' Friend Properties
'
Friend Property Get Parent() As OutMenuItem
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As OutMenuItem)
    Set oParent = NewVal
End Property

Friend Property Get OutMenu() As OutMenu
Attribute OutMenu.VB_MemberFlags = "40"
    Set OutMenu = oOutMenu
End Property
Friend Property Set OutMenu(NewVal As OutMenu)
    Set oOutMenu = NewVal
End Property

Friend Property Get TopItems() As Boolean
Attribute TopItems.VB_MemberFlags = "40"
    TopItems = bTopItems
End Property
Friend Property Let TopItems(ByVal NewVal As Boolean)
    bTopItems = NewVal
End Property
'
' Hidden Properties
'
Public Property Get NewEnum()
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = oItems.[_NewEnum]
End Property
'
' Hidden Sub/Function
'
Public Sub UnSelect()
Attribute UnSelect.VB_MemberFlags = "40"
    Dim i As Integer
    
    For i = 1 To Count
       Item(i).Selected = False
    Next
End Sub

Public Function CheckSelect(iButton As Integer) As OutMenuItem
Attribute CheckSelect.VB_MemberFlags = "40"
    Dim i As Integer
    Dim iItem As Integer
    Dim bSelected As Boolean

    bSelected = False

    iItem = 0

    For i = 1 To Count
        iItem = iItem + 1
        If Item(i).Selected Then
            bSelected = True
            Set CheckSelect = Item(i)
            iButton = iItem
            Exit For
        End If
    Next

    If Not bSelected Then
        Item(1).Selected = True
        Set CheckSelect = Item(1)
        iButton = 1
    End If
End Function
'
' Private Sub/Function
'
Private Sub Class_Initialize()
    Set oOutMenu = Nothing
    Set oParent = Nothing
    bTopItems = False
End Sub

Public Sub CleanUp()
    Dim i As Integer
    Dim iCount As Integer
    
    iCount = oItems.Count
    For i = 1 To iCount
        Item(i).CleanUp
    Next
    
    For i = 1 To iCount
        oItems.Remove 1
    Next
    
    Set oItems = Nothing
    Set oOutMenu = Nothing
    Set oParent = Nothing
End Sub

