VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PopupItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

' Public Properties
Private oCommandItem As CommandItem

Private oPopupItems As PopupItems
Private hPopup As Long
Private hMenu As Long

Private oMenuItems As MenuItems

Private lID As Long
Private lPos As Long

Private oPopup As Popup
'
' Public Properties
'
Public Property Get CommandItem() As CommandItem
    Set CommandItem = oCommandItem
End Property
Public Property Set CommandItem(ByVal NewVal As CommandItem)
    Set oCommandItem = NewVal
End Property

Public Property Get PopupItems() As PopupItems
    If oPopupItems Is Nothing Then
        Set oPopupItems = New PopupItems
        Set oPopupItems.Popup = oPopup
    End If
    Set PopupItems = oPopupItems
End Property

Public Property Get MenuHandle() As Long
    MenuHandle = hMenu
End Property
Public Property Let MenuHandle(ByVal NewVal As Long)
    hMenu = NewVal
End Property
'
' Friend Properties
'
Friend Property Get ID() As Long
    ID = lID
End Property
Friend Property Let ID(ByVal NewVal As Long)
    lID = NewVal
End Property

Friend Property Get Pos() As Long
    Pos = lPos
End Property
Friend Property Let Pos(ByVal NewVal As Long)
    lPos = NewVal
End Property

Friend Property Set Popup(ByVal NewVal As Popup)
    Set oPopup = NewVal
End Property

Friend Property Set MenuItems(NewVal As MenuItems)
    Set oMenuItems = NewVal
End Property

'
' Friend Sub/Function
'
Friend Sub Insert(ByVal hMenu As Long, _
                  ByVal lItem As Long, _
                  ByVal bByPosition As Boolean)
    
    #If DBG Then
        T ">>> Insert hMenu = 0x" + Hex$(hMenu) + " lItem = " + CStr(lItem) + " bByPos = " + CStr(bByPosition)
    #End If

    Dim mii As MENUITEMINFO

    If hMenu = 0 Then Exit Sub
    
    With mii
        .fMask = MIIM_ID + MIIM_DATA
        .fType = MFT_OWNERDRAW
        .fState = MFS_ENABLED
        .wID = 0
        .hSubMenu = 0
        .hbmpChecked = 0
        .hbmpUnchecked = 0
        .dwItemData = 0
        .dwTypeData = ""
        .cch = 0
    End With

    mii.cbSize = Len(mii)

    Select Case oCommandItem.ItemType
        Case cmdTypeDefault, cmdTypeGroup:
            mii.fMask = MIIM_TYPE + MIIM_ID + MIIM_STATE
            mii.fType = MFT_OWNERDRAW
            mii.wID = lID
        Case cmdTypeCheck:
            mii.fMask = MIIM_TYPE + MIIM_ID + MIIM_STATE
            mii.fType = MFT_OWNERDRAW
            mii.wID = lID
            mii.fState = 0
            If Not oCommandItem.Enabled Then mii.fState = mii.fState + MFS_DISABLED
            If oCommandItem.Checked Then mii.fState = mii.fState + MFS_CHECKED
        Case cmdTypeSeperator:
            mii.fMask = MIIM_TYPE + MIIM_ID
            mii.fType = MFT_SEPARATOR
            mii.wID = lID
        Case cmdTypeSubCommand:
            mii.fMask = MIIM_TYPE + MIIM_ID + MIIM_SUBMENU
            mii.fType = MFT_OWNERDRAW
            mii.wID = lID
            mii.hSubMenu = 0
            If Not oPopupItems Is Nothing Then
                If oPopupItems.Count > 0 Then
                    hPopup = Create()
                    mii.hSubMenu = hPopup
                End If
            End If
    End Select
    
    If oCommandItem.Visible Then
        InsertMenuItem hMenu, lItem, CLng(bByPosition), mii
    End If
    
    #If DBG Then
        T "<<< Insert"
    #End If
End Sub

Friend Sub Delete(ByVal hMenu As Long, ByVal lItem As Long, ByVal bByPosition As Boolean)
    #If DBG Then
        T ">>> Delete hMenu = 0x" + Hex$(hMenu) + " lItem = " + CStr(lItem) + " bByPos = " + CStr(bByPosition)
    #End If
    
    Dim lFlags As Long
    Dim lRC As Long
    
    If hMenu = 0 Then Exit Sub
    
    If oCommandItem.ItemType = cmdTypeSubCommand Then
        hPopup = Destroy(hPopup)
    End If
    
    If oCommandItem.Visible Then
        If bByPosition Then
            lFlags = MF_BYPOSITION
        Else
            lFlags = MF_BYCOMMAND
        End If
        
        lRC = DeleteMenu(hMenu, lItem, lFlags)
        #If DBG Then
            T "DeleteMenu -> " + CStr(lRC)
        #End If
    End If

    #If DBG Then
        T "<<< Delete"
    #End If
End Sub

Private Function Create() As Long
    #If DBG Then
        T ">>> Create"
    #End If
    
    Dim hMenu As Long
    Dim oItem As PopupItem
    Dim lItem As Long
    
    hMenu = CreateMenu()
    
    #If DBG Then
        T "hMenu = 0x" + Hex$(hMenu)
    #End If
    
    If hMenu <> 0 Then
        lItem = 0
        For Each oItem In oPopupItems
            With oItem
                .MenuHandle = hMenu
                .Pos = lItem
                Set .MenuItems = oMenuItems
            End With
            
            oMenuItems.AddPopupItem oItem      'oItem.ID is setting
            
            oItem.Insert hMenu, lItem, True
            lItem = lItem + 1
        Next
    End If
    
    Create = hMenu

    #If DBG Then
        T "<<< Create"
    #End If
End Function

Private Function Destroy(ByVal hMenu As Long) As Long
    #If DBG Then
        T ">>> Destroy hMenu = 0x" & Hex(hMenu)
    #End If
    
    Dim oItem As PopupItem
    Dim lItem As Long
    Dim lRC As Long

    If hMenu <> 0 Then
        lItem = 0
        For Each oItem In oPopupItems
            oItem.Delete hMenu, oItem.ID, False
            lItem = lItem + 1
            
            oMenuItems.RemovePopupItem oItem
            
            With oItem
                .MenuHandle = 0
                .Pos = 0
                .ID = 0
            End With
        Next
        
        lRC = DestroyMenu(hMenu)
        #If DBG Then
           T "DestroyMenu -> " + CStr(lRC)
        #End If

        hMenu = 0
    End If
    
    Destroy = hMenu
    #If DBG Then
        T "<<< Destroy"
    #End If
End Function

Friend Sub Visible()
    
    If hMenu = 0 Then Exit Sub
    
    Select Case oCommandItem.Visible
        Case False: DeleteMenu hMenu, lID, MF_BYCOMMAND
        Case True:  Insert hMenu, lPos, True
    End Select
End Sub
'
' Private Sub/Function
'
Private Sub Class_Initialize()
    Set oCommandItem = Nothing
    
    Set oPopupItems = Nothing
    
    hPopup = 0
    hMenu = 0
    
    lID = 0
    lPos = 0
End Sub

Public Sub CleanUp()
    If Not oPopupItems Is Nothing Then
        oPopupItems.CleanUp
        Set oPopupItems = Nothing
    End If
    Set oCommandItem = Nothing
    Set oPopup = Nothing
    Set oMenuItems = Nothing
End Sub

#If DBG Then

Private Sub T(ByVal sText As String)
    If Not oTrace Is Nothing Then
        oTrace.Text "PopupItem: " + sText
    End If
End Sub

#End If

