VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSComCtl.ocx"
Begin VB.UserControl ToolBar 
   Alignable       =   -1  'True
   ClientHeight    =   885
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3420
   ScaleHeight     =   59
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   228
   ToolboxBitmap   =   "ToolBar.ctx":0000
   Begin MSComctlLib.Toolbar TBR 
      Height          =   390
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   2010
      _ExtentX        =   3545
      _ExtentY        =   688
      ButtonWidth     =   635
      ButtonHeight    =   582
      AllowCustomize  =   0   'False
      Wrappable       =   0   'False
      _Version        =   393216
   End
End
Attribute VB_Name = "ToolBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Enum ToolBarBorderStyleConstants
    tbrBorderStyleNone
    tbrBorderStyleSingle
    tbrBorderStyleRaised
    tbrBorderStyleSunken
    tbrBorderStyleSoft
    tbrBorderStyleSoftTopBottom
    tbrBorderStyleTop
End Enum

Private lBorderStyle As ToolBarBorderStyleConstants

Private oCommandList As CommandList

Private oToolBarItems As ToolBarItems

Private bShowCaptions As Boolean
Private bStyleFlat As Boolean
Private bStyleList As Boolean

'''

Private iBorderLeft As Integer
Private iBorderTop As Integer
Private iBorderRight As Integer
Private iBorderBottom As Integer
Private iBorder As Integer
'
' Events
'
Public Event ItemClick(ByVal Item As ToolbarItem)
Public Event ItemSelect(ByVal Item As ToolbarItem)
'
' Properties
'
Public Property Get BorderStyle() As ToolBarBorderStyleConstants
    BorderStyle = lBorderStyle
End Property
Public Property Let BorderStyle(ByVal NewVal As ToolBarBorderStyleConstants)
    lBorderStyle = NewVal
    PropertyChanged "BorderStyle"
    BorderSize
    UserControl_Resize
    DrawBorder
End Property

Public Property Get Enabled() As Boolean
    Enabled = UserControl.Enabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    UserControl.Enabled = NewVal
    PropertyChanged "Enabled"
End Property

Public Property Get CommandList() As CommandList
    Set CommandList = oCommandList
End Property
Public Property Set CommandList(NewVal As CommandList)
    Set oCommandList = NewVal
    If Not oCommandList Is Nothing Then
        Set TBR.ImageList = oCommandList.ImageList
    End If
End Property

Public Property Get ToolBarItems() As ToolBarItems
    Set ToolBarItems = oToolBarItems
End Property

Public Property Get ShowCaptions() As Boolean
    ShowCaptions = bShowCaptions
End Property
Public Property Let ShowCaptions(ByVal NewVal As Boolean)
    bShowCaptions = NewVal
    PropertyChanged "ShowCaptions"
End Property

Public Property Get StyleFlat() As Boolean
    StyleFlat = bStyleFlat
End Property
Public Property Let StyleFlat(ByVal NewVal As Boolean)
    bStyleFlat = NewVal
    PropertyChanged "StyleFlat"
    If bStyleFlat Then
        TBR.Style = tbrFlat
    Else
        TBR.Style = tbrStandard
    End If
End Property

Public Property Get StyleList() As Boolean
    StyleList = bStyleList
End Property
Public Property Let StyleList(ByVal NewVal As Boolean)
    bStyleList = NewVal
    PropertyChanged "StyleList"
    If bStyleList Then
        TBR.TextAlignment = tbrTextAlignRight
    Else
        TBR.TextAlignment = tbrTextAlignBottom
    End If
End Property

Friend Property Get ToolbarCtrl() As MSComCtlLib.ToolBar
    Set ToolbarCtrl = TBR
End Property
'
' Methods
'
Public Sub Refresh()
    TBR.Refresh
End Sub

Public Sub CleanUp()
    oToolBarItems.CleanUp
    Set oToolBarItems = Nothing
    Set oCommandList = Nothing
End Sub
'
' Events
'
Private Sub UserControl_Initialize()
    Set oCommandList = Nothing
    
    lBorderStyle = tbrBorderStyleNone
    
    Set oToolBarItems = New ToolBarItems
    Set oToolBarItems.ToolBar = Me
    
    bShowCaptions = False
    bStyleFlat = True
    bStyleList = False
End Sub

Private Sub UserControl_Resize()
    Dim iHeight As Integer
    Dim iWidth As Integer
    
    iHeight = ScaleY(iBorderTop + TBR.Height + iBorderBottom, vbPixels, vbTwips)
    If UserControl.Height < iHeight Then
        UserControl.SIZE Width, iHeight
    End If
    
    iWidth = ScaleWidth - iBorderLeft - iBorder
    If iWidth < 0 Then iWidth = 0
    TBR.Move iBorderLeft, iBorderTop, iWidth
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    BorderStyle = PropBag.ReadProperty("BorderStyle", tbrBorderStyleNone)
    Enabled = PropBag.ReadProperty("Enabled")
    ShowCaptions = PropBag.ReadProperty("ShowCaptions")
    StyleFlat = PropBag.ReadProperty("StyleFlat")
    StyleList = PropBag.ReadProperty("StyleList")
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    PropBag.WriteProperty "BorderStyle", BorderStyle, tbrBorderStyleNone
    PropBag.WriteProperty "Enabled", Enabled
    PropBag.WriteProperty "ShowCaptions", ShowCaptions
    PropBag.WriteProperty "StyleFlat", StyleFlat
    PropBag.WriteProperty "StyleList", StyleList
End Sub

Private Sub UserControl_Paint()
    DrawBorder
End Sub

'''

Private Sub TBR_ButtonClick(ByVal Button As MSComCtlLib.Button)
    Dim oCommandItem As CommandItem
    
    Set oCommandItem = oCommandList.CommandItems(Button.Tag)
    oCommandList.EventItemClick oCommandItem
End Sub
'
' Private Sub/Functions
'
Private Sub DrawBorder()
    Dim r As RECT
    
    UserControl.Cls
    
    Select Case lBorderStyle
        Case tbrBorderStyleNone:
        Case tbrBorderStyleSingle:
            UserControl.Line (0, 0)-(UserControl.ScaleWidth - 1, UserControl.ScaleHeight - 1), 0, B
        Case tbrBorderStyleRaised:
            r.Left = 0
            r.Top = 0
            r.Right = UserControl.ScaleWidth
            r.Bottom = UserControl.ScaleHeight
            DrawEdge UserControl.hDC, r, EDGE_RAISED, BF_RECT + BF_SOFT
        Case tbrBorderStyleSunken:
            r.Left = 0
            r.Top = 0
            r.Right = UserControl.ScaleWidth
            r.Bottom = UserControl.ScaleHeight
            DrawEdge UserControl.hDC, r, EDGE_SUNKEN, BF_RECT + BF_SOFT
        Case tbrBorderStyleSoft:
            UserControl.Line (0, 0)-(UserControl.ScaleWidth - 1, 0), vb3DHighlight
            UserControl.Line (0, 0)-(0, UserControl.ScaleHeight - 1), vb3DHighlight
            UserControl.Line (0, UserControl.ScaleHeight - 1)-(UserControl.ScaleWidth - 1, ScaleHeight - 1), vb3DShadow
            UserControl.Line (UserControl.ScaleWidth - 1, 0)-(UserControl.ScaleWidth - 1, UserControl.ScaleHeight - 1), vb3DShadow
        Case tbrBorderStyleSoftTopBottom:
            UserControl.Line (0, 0)-(UserControl.ScaleWidth - 1, 0), vb3DHighlight
            UserControl.Line (0, UserControl.ScaleHeight - 1)-(UserControl.ScaleWidth - 1, UserControl.ScaleHeight - 1), vb3DShadow
        Case tbrBorderStyleTop:
            UserControl.Line (0, 0)-(UserControl.ScaleWidth - 1, 0), vb3DShadow
            UserControl.Line (0, 1)-(UserControl.ScaleWidth - 1, 1), vb3DHighlight
    End Select
End Sub

Private Function BorderSize()
    iBorderLeft = 0
    iBorderTop = 0
    iBorderRight = 0
    iBorderBottom = 0
    iBorder = 2
    
    Select Case lBorderStyle
        Case tbrBorderStyleSingle, tbrBorderStyleSoft:
            iBorderLeft = 1 + iBorder
            iBorderTop = 1 + iBorder
            iBorderRight = 1 + iBorder
            iBorderBottom = 1
        Case tbrBorderStyleRaised, tbrBorderStyleSunken:
            iBorderLeft = 2 + iBorder
            iBorderTop = 2 + iBorder
            iBorderRight = 2 + iBorder
            iBorderBottom = 2
        Case tbrBorderStyleSoftTopBottom:
            iBorderLeft = 0 + iBorder
            iBorderTop = 1 + iBorder
            iBorderRight = 0 + iBorder
            iBorderBottom = 1
        Case tbrBorderStyleTop:
            iBorderLeft = 0 + iBorder
            iBorderTop = 2 + iBorder
            iBorderRight = 0 + iBorder
            iBorderBottom = 0
    End Select
End Function

' Trace

#If DBG Then

Public Property Get Trace() As Object
    Set Trace = oTrace
End Property

Public Property Set Trace(NewVal As Object)
    Set oTrace = NewVal
End Property

#End If

