VERSION 1.0 CLASS
BEGIN
  MultiUse = 0   'False
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Trace"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private Declare Function GetTickCount Lib "Kernel32.dll" () As Long

Private Const MAX_LINES = 1000

Private bTrace As Boolean
Private fTrace As frmTrace

Private lCount As Long
Private sCount As String

Public Property Get IsOn() As Boolean
    IsOn = bTrace
End Property

Public Sub TraceOn()
    If bTrace Then Exit Sub
    
    If fTrace Is Nothing Then
        Set fTrace = New frmTrace
        fTrace.Show
    End If
    
    bTrace = True
End Sub

Public Sub Text(Text As String)
    If Not bTrace Then Exit Sub
    
    lCount = lCount + 1
    sCount = Format$(lCount, "00000") + " " + Format$(GetTickCount(), "0000000000") + " " + "0x" + Hex(App.ThreadID) + " "
    
    TextToScreen sCount + Text
End Sub

Public Sub TextAdd(Text As String)
    If Not bTrace Then Exit Sub
    
    TextAddToScreen Text
End Sub

Public Sub TraceOff()
    If Not bTrace Then Exit Sub
    
    If Not fTrace Is Nothing Then
        Unload fTrace
        Set fTrace = Nothing
    End If
    
    bTrace = False
End Sub

'''

Private Sub TextToScreen(sText As String)
    fTrace.lstTrace.AddItem sText, 0
End Sub

Private Sub TextAddToScreen(sText As String)
    fTrace.lstTrace.List(0) = fTrace.lstTrace.List(0) & sText
End Sub


'''

Private Sub Class_Initialize()
    lCount = 0
End Sub
Private Sub Class_Terminate()
    TraceOff
End Sub


