Attribute VB_Name = "GLB"
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit
    
Public Const CLOSEMODE_DEFAULT = 0
Public Const CLOSEMODE_WRONGSTATE = 1
Public Const CLOSEMODE_APPSERVER = 2
Public Const CLOSEMODE_WINDOWS = 3
Public Const CLOSEMODE_TASKMANAGER = 4
    
'''

Public Const DB_STATE_OFFLINE = &H1
Public Const DB_STATE_COLD = &H2
Public Const DB_STATE_WARM = &H4

Public oRes As New DBMRes.Resource

Public iDX As Integer
Public iDY As Integer

'''

Const PROP_DEF_TOOLBAR = True
Const PROP_DEF_POPUP = True
Const PROP_DEF_ENABLED = True
Const PROP_DEF_TITLEBAR = True
Const PROP_DEF_BACKCOLOR = vbButtonFace

'''

Private lSenderID As Long

'''

Sub Main()
    Init
End Sub

Private Sub Init()
    iDX = 6 * Screen.TwipsPerPixelX
    iDY = 6 * Screen.TwipsPerPixelY
    
    lSenderID = 0
End Sub

Public Sub ReadDefaultProps(PropBag As PropertyBag, Ctl As Object)
    On Error Resume Next
    With PropBag
        Ctl.ToolBar = .ReadProperty("ToolBar", PROP_DEF_TOOLBAR)
        Ctl.Popup = .ReadProperty("Popup", PROP_DEF_POPUP)
        Ctl.Enabled = .ReadProperty("Enabled", PROP_DEF_ENABLED)
        Ctl.BackColor = .ReadProperty("BackColor", PROP_DEF_BACKCOLOR)
    End With
End Sub

Public Sub WriteDefaultProps(PropBag As PropertyBag, Ctl As Object)
    On Error Resume Next
    With PropBag
        .WriteProperty "ToolBar", Ctl.ToolBar, PROP_DEF_TOOLBAR
        .WriteProperty "Popup", Ctl.Popup, PROP_DEF_POPUP
        .WriteProperty "Enabled", Ctl.Enabled, PROP_DEF_ENABLED
        .WriteProperty "BackColor", Ctl.BackColor, PROP_DEF_BACKCOLOR
    End With
End Sub

Public Function IsStateOK(ByVal lState As DBMLib.DBMDatabaseStateConstants, _
                          ByVal lValid As Long)
    Dim bOK As Boolean
                             
    bOK = False
    
    Select Case lState
        Case dbmDBStateOffline: bOK = ((lValid And DB_STATE_OFFLINE) = DB_STATE_OFFLINE)
        Case dbmDBStateCold:    bOK = ((lValid And DB_STATE_COLD) = DB_STATE_COLD)
        Case dbmDBStateWarm:    bOK = ((lValid And DB_STATE_WARM) = DB_STATE_WARM)
        Case dbmDBStateUnknown: bOK = False
    End Select

    IsStateOK = bOK
End Function

'''

Public Sub SetHeader(lvw As MSComctlLib.ListView, _
                     sHeader As String, _
                     iColPos() As Integer, _
                     iColLen() As Integer, _
                     iColCnt As Integer)
                     
    Dim iPos1 As Integer
    Dim iPos2 As Integer
    Dim iLen As Integer
    Dim sName As String
    Dim oColumn As MSComctlLib.ColumnHeader
    Dim iColMax As Integer
    
    If Len(sHeader) = 0 Then Exit Sub
    
    lvw.ColumnHeaders.Clear
    iColCnt = 0
    
    iPos1 = 1
    iPos2 = 0
    Do
        iPos2 = InStr(iPos1, sHeader, " | ")
        If iPos2 > 0 Then
            iLen = iPos2 - iPos1
            sName = Trim$(Mid$(sHeader, iPos1, iPos2 - iPos1))
        Else
            iLen = Len(sHeader) - iPos1 + 1
            sName = Trim$(Mid$(sHeader, iPos1))
        End If
        Set oColumn = lvw.ColumnHeaders.Add(, , sName)
        iColCnt = iColCnt + 1
        If iColCnt > UBound(iColPos) Then
            iColMax = UBound(iColPos) + 10
            ReDim Preserve iColPos(1 To iColMax) As Integer
            ReDim Preserve iColLen(1 To iColMax) As Integer
        End If
        iColPos(iColCnt) = iPos1
        iColLen(iColCnt) = iLen
        iPos1 = iPos2 + 3
    Loop While iPos2 > 0
End Sub

Public Sub FillResult(lvw As MSComctlLib.ListView, _
                      sResult As String, _
                      iColPos() As Integer, _
                      iColLen() As Integer, _
                      iColCnt As Integer)
    Dim lPos1 As Long
    Dim sLine As String
    Dim oItem As MSComctlLib.ListItem
    Dim i As Integer
    
    lPos1 = 1
    Do While lPos1 < Len(sResult)
        sLine = GetLine(sResult, lPos1)
        Set oItem = lvw.ListItems.Add(, , Trim$(Left$(sLine, iColLen(1))))
        For i = 2 To iColCnt
            oItem.SubItems(i - 1) = Trim$(Mid$(sLine, iColPos(i), iColLen(i)))
        Next
    Loop
End Sub

Private Function GetLine(sData As String, _
                         lPos As Long) As String
    Dim lP1 As Long
    Dim sLine As String

    sLine = ""

    If lPos <= Len(sData) Then
        lP1 = InStr(lPos, sData, vbLf)
        If lP1 > 0 Then
            If lP1 > 1 Then
                If Mid(sData, lP1 - 1, 1) = vbCr Then
                    sLine = Mid$(sData, lPos, lP1 - lPos - 1)
                Else
                    sLine = Mid$(sData, lPos, lP1 - lPos)
                End If
            Else
                sLine = ""
            End If
            lPos = lP1 + 1
        Else
            sLine = Mid$(sData, lPos)
            lPos = Len(sData) + 1
        End If
    End If

    lP1 = InStr(1, sLine, Chr(0))
    If lP1 > 0 Then sLine = Left$(sLine, lP1 - 1)

    GetLine = sLine
End Function

'''

Public Function GetSenderID() As Long
    lSenderID = lSenderID + 1
    GetSenderID = lSenderID
End Function

'''

Public Sub TIBPicture(oTIB As Object, oPicture As StdPicture)
    If Not oTIB Is Nothing Then Set oTIB.Picture = oPicture
End Sub

Public Sub TIBCaption(oTIB As Object, sCaption As String)
    If Not oTIB Is Nothing Then oTIB.Caption = sCaption
End Sub

Public Sub TIBAt(oTIB As Object, dAt As Date)
    If Not oTIB Is Nothing Then oTIB.At = dAt
End Sub

Public Sub TIBEnabled(oTIB As Object, bEnabled As Boolean)
    If Not oTIB Is Nothing Then oTIB.Enabled = bEnabled
End Sub

