VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MsFlxGrd.ocx"
Begin VB.UserControl ctlMapChar 
   ClientHeight    =   3375
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2835
   ScaleHeight     =   3375
   ScaleWidth      =   2835
   ToolboxBitmap   =   "MapChar.ctx":0000
   Begin VB.TextBox edtCell 
      Appearance      =   0  'Flat
      Height          =   288
      Left            =   960
      TabIndex        =   1
      Top             =   1440
      Visible         =   0   'False
      Width           =   1452
   End
   Begin MSFlexGridLib.MSFlexGrid grdMapchars 
      Height          =   3132
      Left            =   0
      TabIndex        =   0
      Top             =   240
      Width           =   2772
      _ExtentX        =   4895
      _ExtentY        =   5530
      _Version        =   393216
      Cols            =   3
      FixedCols       =   0
      BackColorSel    =   -2147483643
      HighLight       =   0
      ScrollBars      =   2
   End
End
Attribute VB_Name = "ctlMapChar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private Declare Function GetSystemMetrics Lib "User32.dll" ( _
    ByVal nIndex As Long) As Long
    
Const SM_CXVSCROLL = 2
Const SM_CYEDGE = 46

'''

Public Event Change()

Private nEdtRow As Long
Private nEdtCol As Long

Private nVisibleRows As Long
Private bEnterCell_SelfInvoked As Boolean
Private bScroll_SelfInvoked As Boolean

Private Const Caption_ROW = 0
Private Const FIRST_ROW = 1

Private Const INTERN_COL = 0
Private Const MAPCODE_COL = 1
Private Const MAPCHAR_COL = 2

Private Const FIRST_COL = INTERN_COL
Private Const LAST_COL = MAPCHAR_COL

Private Const INTERN_SIZE = 2
Private Const MAPCODE_SIZE = 4
Private Const MAPCHAR_SIZE = 2

Private Const INTERN_HEAD = "Intern"
Private Const MAPCODE_HEAD = "Ext. Hex"
Private Const MAPCHAR_HEAD = "Ext. ASCII"

Private Const COL_RESWIDTH As Long = 150

Private nHeightDiff As Long
'
' End General Declarations
' *******************************************************************************

' *******************************************************************************
' Properties
'

' *******************************************************************************
' Public Property Let Enabled
'
Public Property Let Enabled(bValue As Boolean)
  edtCell.Enabled = bValue
  grdMapchars.Enabled = bValue
End Property ' Let Enabled

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    UserControl.BackColor = NewVal
    PropertyChanged "BackColor"
End Property

' *******************************************************************************
' Public Subs/Functions
'

' *******************************************************************************
' Public Sub Grid_Clear
'
Public Sub Grid_Clear()
  grdMapchars.AddItem ("")
  grdMapchars.RowHeight(grdMapchars.Rows - 1) = edtCell.Height + Screen.TwipsPerPixelX
  grdMapchars.TextMatrix(grdMapchars.Rows - 1, MAPCODE_COL) = ""
  grdMapchars.TextMatrix(grdMapchars.Rows - 1, MAPCHAR_COL) = ""
  
  ' remove all non fixed rows execept one
  While grdMapchars.Rows > 2
    grdMapchars.RemoveItem (1)
  Wend
  
  ' grid layout
  Call CalcLayout
End Sub ' Grid_Clear

' *******************************************************************************
' Public Sub Grid_Setup
'
Public Sub Grid_Setup(oMapcharSet As DBMLib.MapcharSet)
  Dim nIndex As Long
  Dim sIntern As String
  Dim sMapCode As String
    
  ' remove all non fixed rows execept one
  While grdMapchars.Rows > 2
    grdMapchars.RemoveItem (1)
  Wend
  
  ' setup table head
  grdMapchars.TextMatrix(Caption_ROW, INTERN_COL) = INTERN_HEAD
  grdMapchars.ColAlignment(INTERN_COL) = flexAlignRightCenter
  grdMapchars.TextMatrix(Caption_ROW, MAPCODE_COL) = MAPCODE_HEAD
  grdMapchars.ColAlignment(MAPCODE_COL) = flexAlignRightCenter
  grdMapchars.TextMatrix(Caption_ROW, MAPCHAR_COL) = MAPCHAR_HEAD
  grdMapchars.ColAlignment(MAPCHAR_COL) = flexAlignLeftCenter
  grdMapchars.RowHeight(Caption_ROW) = edtCell.Height
    
  ' add rows
  For nIndex = 1 To oMapcharSet.MaxCode
    
    Call oMapcharSet.GetCode(nIndex, sIntern, sMapCode)
   
    grdMapchars.AddItem (sIntern)
    grdMapchars.RowHeight(grdMapchars.Rows - 1) = edtCell.Height + Screen.TwipsPerPixelX
    grdMapchars.TextMatrix(grdMapchars.Rows - 1, MAPCODE_COL) = sMapCode
    grdMapchars.TextMatrix(grdMapchars.Rows - 1, MAPCHAR_COL) = CodeToChar(sMapCode)
    
  Next
   
  ' remove last initial empty  row
  If (grdMapchars.Rows > 2) Then
    grdMapchars.RemoveItem (1)
  End If
  
  ' grid layout
  Call CalcLayout
  
  ' set active row
  grdMapchars.Row = FIRST_ROW
  grdMapchars.Col = FIRST_COL
  Call Grid_EnterEdit
End Sub ' Grid_Setup

' *******************************************************************************
' Public Sub Grid_PutMapchars
'
Public Sub Grid_PutMapchars(oMapcharSet As DBMLib.MapcharSet)
  Dim nCurRow As Long
  
  ' get current cell form edit control
    If (edtCell.Visible) Then
      grdMapchars.TextMatrix(nEdtRow, nEdtCol) = edtCell.Text
    End If
  
  ' Clear Codes
  Call oMapcharSet.Clear
  
  ' get values in loop
  For nCurRow = FIRST_ROW To grdMapchars.Rows - 1
  
    Call oMapcharSet.SetCode(nCurRow, _
                             grdMapchars.TextMatrix(nCurRow, INTERN_COL), _
                             grdMapchars.TextMatrix(nCurRow, MAPCODE_COL))
  Next
End Sub ' Grid_PutMapchars

' *******************************************************************************
' Private/Friend Subs/Functions
'

' *******************************************************************************
' Private Sub edtCell_Change
'
' description: Eventhandling
'
Private Sub edtCell_Change()
  If (edtCell.Text <> grdMapchars.TextMatrix(nEdtRow, nEdtCol)) Then
    RaiseEvent Change
  End If
  If (nEdtCol = MAPCODE_COL) Then
    grdMapchars.TextMatrix(nEdtRow, MAPCHAR_COL) = CodeToChar(edtCell.Text)
  ElseIf (nEdtCol = MAPCHAR_COL) Then
    grdMapchars.TextMatrix(nEdtRow, MAPCODE_COL) = CharToCode(edtCell.Text)
  End If
End Sub ' edtCell_Change

' *******************************************************************************
' Private Sub edtCell_KeyDown
'
' description: Eventhandling
'
Private Sub edtCell_KeyDown(KeyCode As Integer, Shift As Integer)
  Dim sKeys As String
  
  If ((KeyCode = vbKeyUp) And (Shift = 0)) Then
    sKeys = "{UP}"
  ElseIf ((KeyCode = vbKeyDown) And (Shift = 0)) Then
    sKeys = "{DOWN}"
  ElseIf ((KeyCode = vbKeyPageUp) And (Shift = 0)) Then
    sKeys = "{PGUP}"
  ElseIf ((KeyCode = vbKeyPageDown) And (Shift = 0)) Then
    sKeys = "{PGDN}"
  ElseIf ((KeyCode = vbKeyHome) And (Shift = vbCtrlMask)) Then
    sKeys = "^{HOME}"
  ElseIf ((KeyCode = vbKeyEnd) And (Shift = vbCtrlMask)) Then
    sKeys = "^{END}"
  ElseIf ((KeyCode = vbKeyLeft) And _
          (Shift = 0) And _
          (edtCell.Visible And edtCell.SelLength = 0 And edtCell.SelStart = 0)) Then
    sKeys = "{LEFT}"
  ElseIf ((KeyCode = vbKeyRight) And _
          (Shift = 0) And _
          (edtCell.Visible And edtCell.SelLength = 0 And edtCell.SelStart = Len(edtCell.Text))) Then
    sKeys = "{RIGHT}"
  Else
    sKeys = ""
  End If

  If (Len(sKeys) > 0) Then
    KeyCode = 0
    Grid_LeaveEdit
    SendKeys sKeys
    DoEvents
    If (Not edtCell.Visible) Then
      Call Grid_EnterEdit
    End If
  End If
End Sub ' edtCell_KeyDown

' *******************************************************************************
' Private Sub grdMapchars_EnterCell
'
' description: Eventhandling
'
Private Sub grdMapchars_EnterCell()
  If (Not bEnterCell_SelfInvoked) Then
    If (grdMapchars.Row < grdMapchars.TopRow) Then
       bScroll_SelfInvoked = True
       grdMapchars.TopRow = grdMapchars.Row
       bScroll_SelfInvoked = False
    End If
    
    If (edtCell.Visible) Then
      Call Grid_LeaveEdit
    End If
    Call Grid_EnterEdit
  End If
End Sub ' grdMapchars_EnterCell

' *******************************************************************************
' Private Sub grdMapchars_Scroll
'
' description: Eventhandling
'
Private Sub grdMapchars_Scroll()
  Dim newEditRow As Long
  
  If (Not bScroll_SelfInvoked) Then
    
    newEditRow = nEdtRow
  
    If (nEdtRow < grdMapchars.TopRow) Then
      newEditRow = grdMapchars.TopRow
    ElseIf (nEdtRow >= (grdMapchars.TopRow + nVisibleRows)) Then
      newEditRow = grdMapchars.TopRow + nVisibleRows - 1
    End If
    
    If (newEditRow <> nEdtRow) Then
      
      grdMapchars.Row = newEditRow
   
    Else
      
      If (edtCell.Visible) Then
        Call edtCell.Move(grdMapchars.CellLeft + grdMapchars.Left, _
                          grdMapchars.CellTop + grdMapchars.Top, _
                          grdMapchars.CellWidth)
      End If
    
    End If
  
  End If
End Sub ' grdMapchars_Scroll

' *******************************************************************************
' Private Sub UserControl_EnterFocus
'
' description: Eventhandling
'
Private Sub UserControl_EnterFocus()
    edtCell.Visible = False
  
  If (grdMapchars.Enabled) Then
    Call Grid_EnterEdit
  End If
End Sub ' UserControl_EnterFocus

' *******************************************************************************
' Private Sub UserControl_ExitFocus
'
' description: Eventhandling
'
Private Sub UserControl_ExitFocus()
  Call Grid_LeaveEdit
End Sub ' UserControl_ExitFocus

' *******************************************************************************
' Private Sub UserControl_Initialize
'
' description: Eventhandling
'
Private Sub UserControl_Initialize()
  nHeightDiff = Height - grdMapchars.Height
  Call UserControl_Resize
End Sub ' UserControl_Initialize

' *******************************************************************************
' Private Sub UserControl_Resize
'
' description: Eventhandling
'
Private Sub UserControl_Resize()
  If (Height - nHeightDiff > 0) Then
    grdMapchars.Height = Height - nHeightDiff
  End If
End Sub ' UserControl_Resize

' *******************************************************************************
' Private Sub Grid_EnterEdit
'
Private Sub Grid_EnterEdit()
  If (grdMapchars.Row >= grdMapchars.TopRow) Then
    
    If (grdMapchars.Col < FIRST_COL) Then
      grdMapchars.Col = FIRST_COL
    ElseIf (grdMapchars.Col > LAST_COL) Then
      grdMapchars.Col = LAST_COL
    Else
   
      nEdtRow = grdMapchars.Row
      nEdtCol = grdMapchars.Col
      
      ' setup cell edit field
      Call edtCell.Move(grdMapchars.CellLeft + grdMapchars.Left, _
                        grdMapchars.CellTop + grdMapchars.Top, _
                        grdMapchars.CellWidth)
      Select Case (nEdtCol)
        Case INTERN_COL
          edtCell.MaxLength = INTERN_SIZE
        Case MAPCODE_COL
          edtCell.MaxLength = MAPCODE_SIZE
        Case MAPCHAR_COL
          edtCell.MaxLength = MAPCHAR_SIZE
      End Select
      edtCell.Text = grdMapchars.TextMatrix(nEdtRow, nEdtCol)
      edtCell.SelStart = 0
      edtCell.SelLength = Len(edtCell.Text)
      edtCell.Visible = True
      If (edtCell.Visible) Then
        Call edtCell.SetFocus
      End If
    
    End If
  
  End If
End Sub ' Grid_EnterEdit

' *******************************************************************************
' Private Sub Grid_LeaveEdit
'
Private Sub Grid_LeaveEdit()
  If (edtCell.Visible) Then
    edtCell.Visible = False
    grdMapchars.TextMatrix(nEdtRow, nEdtCol) = edtCell.Text
  End If
End Sub ' Grid_LeaveEdit

' *******************************************************************************
' Private Function CalcLayout
'
' description: calculate the grid layout after init and resize
'
Private Sub CalcLayout()
  Dim nScrollWidth As Long
  
  ' Calculate fully visible rows
  nVisibleRows = CalcVisibleRows
      
  ' setting width
  If (nVisibleRows < (grdMapchars.Rows - 1)) Then
    nScrollWidth = Screen.TwipsPerPixelX * GetSystemMetrics(SM_CXVSCROLL)
  Else
    nScrollWidth = 0
  End If
 
  grdMapchars.ColWidth(INTERN_COL) = TextWidth(INTERN_HEAD) + COL_RESWIDTH
  grdMapchars.ColWidth(MAPCODE_COL) = TextWidth(MAPCODE_HEAD) + COL_RESWIDTH
  grdMapchars.ColWidth(MAPCHAR_COL) = grdMapchars.Width - nScrollWidth - _
                                    grdMapchars.ColWidth(INTERN_COL) - _
                                    grdMapchars.ColWidth(MAPCODE_COL) - _
                                    (2 * Screen.TwipsPerPixelX * GetSystemMetrics(SM_CYEDGE))
End Sub ' CalcLayout

' *******************************************************************************
' Private Function CalcVisibleRows
'
'
Private Function CalcVisibleRows() As Long
  Dim nTopRow As Long
  Dim nCurRow As Long
  Dim bExit As Boolean
  
  nTopRow = grdMapchars.TopRow
  grdMapchars.TopRow = FIRST_ROW
  nCurRow = FIRST_ROW
  CalcVisibleRows = 0
  bExit = False
     
  While (Not bExit)
    If (nCurRow >= grdMapchars.Rows) Then
      bExit = True
    ElseIf (grdMapchars.RowPos(nCurRow) + grdMapchars.RowHeight(nCurRow)) > grdMapchars.Height Then
      bExit = True
    Else
      nCurRow = nCurRow + 1
      CalcVisibleRows = CalcVisibleRows + 1
    End If
  Wend

  grdMapchars.TopRow = nTopRow
End Function ' CalcVisibleRows

' * ==================================================================
' * Public Function CodeToChar
' *
Public Function CodeToChar(ByVal sMapCode As String) As String
  Dim sChar1 As String
  Dim sChar2 As String
  
  sChar1 = " "
  sChar2 = " "
  
  If (Len(sMapCode) >= 2) Then
    sChar1 = Chr(Val("&H" & Left(sMapCode, 2)))
  End If
  If (Len(sMapCode) >= 4) Then
    sChar2 = Chr(Val("&H" & Right(sMapCode, 2)))
  End If
    
  CodeToChar = IIf(sChar1 <> " ", sChar1, "") & IIf(sChar2 <> " ", sChar2, "")
End Function ' CodeToChar

' * ==================================================================
' * Public Function CharToCode
' *
Public Function CharToCode(ByVal sMapChar As String) As String
  Dim sChar1 As String
  Dim sChar2 As String
  
  sChar1 = Hex(Asc(" "))
  sChar2 = Hex(Asc(" "))
  
  If (Len(sMapChar) > 0) Then
      sChar1 = Hex(Asc(Left(sMapChar, 1)))
  End If
  If (Len(sMapChar) > 1) Then
      sChar2 = Hex(Asc(Right(sMapChar, 1)))
  End If
  
  CharToCode = IIf(Len(sChar1) = 1, " " & sChar1, sChar1) & IIf(Len(sChar2) = 1, " " & sChar2, sChar2)
End Function ' CharToCode
