VERSION 1.0 CLASS
BEGIN
  MultiUse = 0   'False
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Application"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const CML_OPT_HELP = "?"
Const CML_OPT_NODE = "n"
Const CML_OPT_DB = "d"
Const CML_OPT_USER = "u"
Const CML_OPT_FILE = "f"
Const CML_OPT_PROMPT = "prompt"
Const CML_OPT_VER = "version"
Const CML_OPT_NOLOGO = "nologo"
Const CML_OPT_TRACE = "trace"

Const CML_OPT_NI = "O1"

Private CML As New CmdLine

'''

Const FILE_EXT_DB = "dbmdb"

Const KEY_FILEID = "FileID"

Const KEY_NAME = "Name"
Const KEY_SERVER = "Server"
Const KEY_DATABASE = "Database"
Const KEY_USER = "Username"
Const KEY_PWD = "Password"
Const KEY_KERNEL = "Kernel"
Const KEY_AUTO = "Autorefresh"
Const KEY_INTV = "Interval"
Const KEY_TRACE = "Trace"

Const VAL_FILEID_DB = "DBMDB"

Const VAL_YES = "Yes"
Const VAL_NO = "No"

Const VAL_KNL_FAST = "Fast"
Const VAL_KNL_QUICK = "Quick"
Const VAL_KNL_SLOW = "Slow"

'''

Public Enum DBMGUIModeConstants
    dbmGUIModeDefault
    dbmGUIModeSingleDB
    dbmGUIModeConfigFile
End Enum

Private lMode As DBMGUIModeConstants

'''

Private sServerName As String
Private sDatabaseName As String
Private sUsername As String
Private sPassword As String

Private bPrompt As Boolean

Private bTrace As Boolean

'''

Private oFileDatabases As FileDatabases

'''

Private oDatabases As Databases

'''

Private bNoLogo As Boolean
Private fSplash As frmSplash

'''

Private bHideOnTerminate As Boolean

'''

Public Property Get CommandLine() As String
    CommandLine = CML.Text
End Property
Public Property Let CommandLine(NewVal As String)
    CML.Text = NewVal
End Property

Public Property Get Mode() As DBMGUIModeConstants
    Mode = lMode
End Property
Public Property Let Mode(ByVal NewVal As DBMGUIModeConstants)
    lMode = NewVal
End Property

Public Property Get Databasename() As String
    Databasename = sDatabaseName
End Property
Public Property Let Databasename(NewVal As String)
    sDatabaseName = NewVal
End Property

Public Property Get Servername() As String
    Servername = sServerName
End Property
Public Property Let Servername(NewVal As String)
    sServerName = NewVal
End Property

Public Property Get Username() As String
    Username = sUsername
End Property
Public Property Let Username(NewVal As String)
    Dim s As String
    Dim l As Long
    
    s = NewVal
    l = InStr(1, s, ",")
    
    If l > 0 Then
        sUsername = Trim$(Left$(s, l - 1))
        sPassword = Trim$(Mid$(s, l + 1))
    Else
        sUsername = s
    End If
End Property

Public Property Get Password() As String
    Password = sPassword
End Property
Public Property Let Password(NewVal As String)
    sPassword = NewVal
End Property

Public Property Get Prompt() As Boolean
    Prompt = bPrompt
End Property
Public Property Let Prompt(ByVal NewVal As Boolean)
    bPrompt = NewVal
End Property

Public Property Get Trace() As Boolean
    Trace = bTrace
End Property
Public Property Let Trace(ByVal NewVal As Boolean)
    bTrace = NewVal
End Property

'''

Public Property Get NoLogo() As Boolean
    NoLogo = bNoLogo
End Property
Public Property Let NoLogo(ByVal NewVal As Boolean)
    bNoLogo = NewVal
End Property

'''

Public Property Get HideOnTerminate() As Boolean
    HideOnTerminate = bHideOnTerminate
End Property
Public Property Let HideOnTerminate(ByVal NewVal As Boolean)
    bHideOnTerminate = NewVal
End Property

'''

Public Property Get Databases() As Databases
    If oDatabases Is Nothing Then
        Set oDatabases = New Databases
    End If
    Set Databases = oDatabases
End Property

'''

Public Property Get FileDatabases() As FileDatabases
    If oFileDatabases Is Nothing Then
        Set oFileDatabases = New FileDatabases
    End If
    Set FileDatabases = oFileDatabases
End Property

'''

Public Sub ShowForm()
    Dim bStart As Boolean
    Dim sFilename As String
    
    If CML(CML_OPT_HELP).InCmdLine Then
        Set frmCmdLineOpt.CmdLine = CML
        frmCmdLineOpt.Show vbModal
        Exit Sub
    End If
    
    If CML(CML_OPT_VER).InCmdLine Then
        frmAbout.Show vbModal
        Exit Sub
    End If
    
    bNoLogo = CML(CML_OPT_NOLOGO).InCmdLine
            
    If CML.Exists(CML_OPT_NI) Then
        Mode = dbmGUIModeSingleDB
        Servername = CML(CML_OPT_NI).Value
        Databasename = ""
        Username = ""
    Else
        If CML(CML_OPT_NODE).InCmdLine Or _
           CML(CML_OPT_DB).InCmdLine Or _
           CML(CML_OPT_USER).InCmdLine Or _
           CML(CML_OPT_PROMPT).InCmdLine _
        Then
            Mode = dbmGUIModeSingleDB
            Servername = CML(CML_OPT_NODE).Value
            Databasename = CML(CML_OPT_DB).Value
            Username = CML(CML_OPT_USER).Value
            Prompt = CML(CML_OPT_PROMPT).InCmdLine
            Trace = CML(CML_OPT_TRACE).InCmdLine
        ElseIf CML(CML_OPT_FILE).InCmdLine Then
            Mode = dbmGUIModeConfigFile
            sFilename = CML(CML_OPT_FILE).Value
        End If
    End If
    
    bStart = False
    
    Select Case lMode
        Case dbmGUIModeDefault:
            bStart = True
        Case dbmGUIModeSingleDB:
            bStart = ConnectOptions()
        Case dbmGUIModeConfigFile:
            bStart = FileDatabases.OpenFile(sFilename)
    End Select
    
    If Not bStart Then Exit Sub
    
    If Not bNoLogo Then
        ShowSplash 5000, True, True
        DoEvents
    End If
    
    Select Case lMode
        Case dbmGUIModeDefault:     REG.Init
        Case dbmGUIModeSingleDB:    REG.Init True, False, False, False
        Case dbmGUIModeConfigFile:  REG.Init True, False, False, False
    End Select
    
    If FRM Is Nothing Then
        Set FRM = New frmDBM
    End If
    
    FRM.Show
    DoEvents
            
    If lMode = dbmGUIModeConfigFile Then
        If Len(FileDatabases.File) > 0 Then
            FRM.Caption = FileDatabases.File + " - " + TXT_APPLICATION
        Else
            FRM.Caption = "? - " + TXT_APPLICATION
        End If
    End If
    
    If REG.Settings.AutoConnect Then
        FRM.DBListRefreshAllItems
    End If
    
    FRM.DBListSelectFirstItem
    
    If Not bNoLogo Then
        HideSplash
    End If
End Sub

Public Sub HideForm()
    If Not FRM Is Nothing Then
        Unload FRM
        Set FRM = Nothing
    End If
End Sub

'''

Public Sub ShowAbout()
    frmAbout.Show vbModal
End Sub

'''

Public Sub AppServerTerminate(AppServer As Object)
    Dim oDB As DBMLib.Database
    Dim bCancel As Boolean
    
    If Not AppServer Is Nothing Then
        Set oDB = AppServer.Database
    
        DOCS.HideByDB oDB, bCancel, dbmCloseModeAppServer
    
        If oDatabases.Exists(oDB.Name) Then
            oDatabases.Remove oDB.Name
        End If
        
        FRM.DatabaseSetItemByDB oDB
        
        FRM.DatabaseSetActByItem Nothing
    End If
End Sub

Public Sub CleanUp()
    If Not oDatabases Is Nothing Then oDatabases.CleanUp
    
    Set oDatabases = Nothing
End Sub

'''

Private Sub Class_Initialize()
    If App.StartMode = vbSModeAutomation Then
        Set GUI = Me
    End If
    
    lMode = dbmGUIModeDefault
    
    sServerName = ""
    sDatabaseName = ""
    sUsername = ""
    sPassword = ""
    
    bPrompt = False
    
    bTrace = False
    
    bNoLogo = False
    
    bHideOnTerminate = False
    
    CmdLineOptsInit
End Sub

Private Sub Class_Terminate()
    If bHideOnTerminate Then
        HideForm
    End If
End Sub

'''

Private Sub CmdLineOptsInit()
    Dim lPrefix As CmdLinePrefixConstants
    lPrefix = cmlPrefixMinus
    CML.Add lPrefix, CML_OPT_HELP, True, True, "", "Show command line options."
    CML.Add lPrefix, CML_OPT_NODE, True, True, "node", "Name of servernode."
    CML.Add lPrefix, CML_OPT_DB, True, True, "database", "Name of database."
    CML.Add lPrefix, CML_OPT_USER, True, True, "username[,password]", "Database Manager Operator."
    CML.Add lPrefix, CML_OPT_FILE, True, True, "filename", "Open configuration file."
    CML.Add lPrefix, CML_OPT_PROMPT, True, True, "", "Prompt for connection."
    CML.Add lPrefix, CML_OPT_VER, True, True, "", "Show version infos."
    CML.Add lPrefix, CML_OPT_NOLOGO, True, True, "", "Do not show the startup screen."
    CML.Add lPrefix, CML_OPT_TRACE, True, True, "", "Turn trace on."
End Sub

'''

Private Function ConnectOptions() As Boolean
    Dim f As New frmConnect
    Dim bOK As Boolean
    
    bOK = False
    
    If bPrompt Or _
       Len(sDatabaseName) = 0 Or _
       Len(sUsername) = 0 Or _
       Len(sPassword) = 0 _
    Then
        If f.Options(sServerName, sDatabaseName, sUsername, sPassword) Then
            bOK = True
        End If
    Else
        bOK = True
    End If
    
    ConnectOptions = bOK
End Function

'''

Private Sub ShowSplash(Optional ByVal Delay As Long, _
                       Optional ByVal AlwaysOnTop As Boolean, _
                       Optional ByVal OnClickClose As Boolean)
    Set fSplash = New frmSplash
    
    With fSplash
        .Delay = Delay
        .AllwaysOnTop = AlwaysOnTop
        .OnClickClose = OnClickClose
    End With
        
    fSplash.Show
    DoEvents
End Sub

Private Sub HideSplash()
    Unload fSplash
    Set fSplash = Nothing
End Sub
