VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CmdLineOpt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private lPrefix As CmdLinePrefixConstants
Private sName As String
Private bIsOptional As Boolean
Private bMatchCase As Boolean
Private sValueDesc As String
Private sDescription As String
Private sValue As String
Private bInCmdLine As Boolean

Public Property Get Prefix() As CmdLinePrefixConstants
    Prefix = lPrefix
End Property
Public Property Let Prefix(ByVal NewVal As CmdLinePrefixConstants)
    lPrefix = NewVal
End Property

Public Property Get PrefixString() As String
    Select Case lPrefix
        Case cmlPrefixSlash: PrefixString = "/"
        Case cmlPrefixMinus: PrefixString = "-"
        Case cmlPrefixPlus:  PrefixString = "+"
    End Select
End Property

Public Property Get Name() As String
    Name = sName
End Property
Public Property Let Name(NewVal As String)
    sName = NewVal
End Property

Public Property Get IsOptional() As Boolean
    IsOptional = bIsOptional
End Property
Public Property Let IsOptional(ByVal NewVal As Boolean)
    bIsOptional = NewVal
End Property

Public Property Get MatchCase() As Boolean
    MatchCase = bMatchCase
End Property
Public Property Let MatchCase(ByVal NewVal As Boolean)
    bMatchCase = NewVal
End Property

Public Property Get ValueDesc() As String
    ValueDesc = sValueDesc
End Property
Public Property Let ValueDesc(NewVal As String)
    sValueDesc = NewVal
End Property

Public Property Get Description() As String
    Description = sDescription
End Property
Public Property Let Description(NewVal As String)
    sDescription = NewVal
End Property

Public Property Get Value() As String
    Value = sValue
End Property
Public Property Let Value(NewVal As String)
    sValue = NewVal
End Property

Public Property Get InCmdLine() As Boolean
    InCmdLine = bInCmdLine
End Property
Public Property Let InCmdLine(ByVal NewVal As Boolean)
    bInCmdLine = NewVal
End Property

Private Sub Class_Initialize()
    lPrefix = cmlPrefixMinus
    sName = ""
    bIsOptional = True
    bMatchCase = False
    sValueDesc = ""
    sDescription = ""
    sValue = ""
    bInCmdLine = False
End Sub
