Attribute VB_Name = "modDBM"
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Const DEF_VERNUM = "7.4"

Public Const TXT_PRODUCT = "SAP DB"
Public Const TXT_APPLICATION = "Database Manager"
Public Const TXT_VERTEXT = "Version"
Public Const TXT_COPYRIGHT = "Copyright  1998-2001 by SAP AG"

Public TXT_VERNUM As String
Public TXT_VERSION As String
Public TXT_TITLE As String

'''

Public Const V71 = &H7010000
Public Const V72 = &H7020000
Public Const V73 = &H7030000
Public Const V74 = &H7040000

'''

Public Const REG_DB_VAL_NAME = "Name"
Public Const REG_DB_VAL_SERVER = "Server"
Public Const REG_DB_VAL_USER = "Username"
Public Const REG_DB_VAL_PWD = "Password"
Public Const REG_DB_VAL_VER = "Version"
Public Const REG_DB_VAL_KERNEL = "Kernel"
Public Const REG_DB_VAL_AUTOREFRESH = "Autorefresh"
Public Const REG_DB_VAL_INTERVAL = "Interval"
Public Const REG_DB_VAL_EVENTS = "Events"
Public Const REG_DB_VAL_TRACE = "Trace"
Public Const REG_DB_VAL_INST = "InstanceType"
Public Const REG_DB_VAL_NOEXTBACKUP = "NoExternalBackup"

Public Const REG_TR_VAL_SELECTED = "Selected"
Public Const REG_TR_VAL_EXPANDED = "Expanded"

'''

Public Const vbKeyPopup = 93

'''

Public Enum IconResourceIDs
    icrDragFolder = 101
    icrDragDatabase
    icrNoDrop
    icrConfigFile = 201
    icrDatabaseFile
End Enum

'''

Public GUI As DBMGui.Application

Public RES As New DBMRes.Resource

Public FRM As frmDBM
Public REG As New DBMGui.Registry

Public DOCS As New Documents
Public COLS As New DatabaseCols

Public CMDOBJ As New CmdObject

#If DBG Then
Public oDbgTrace As Object
#End If

'''

Private Declare Sub CheckDBMAPI Lib "dbmapi.dll" Alias "cn14cmdCancel" (ByVal lSession As Long)

'''

Sub Main()
    If Not Check() Then Exit Sub
    
    GetVersion
    
    App.OleRequestPendingMsgText = "OleRequestPending (DBMGUI)"
    App.OleServerBusyMsgText = "OleServerBusy (DBMGUI)"
    App.OleRequestPendingTimeout = 30000
    
    If App.StartMode = vbSModeStandalone Then
        Set GUI = New DBMGui.Application
        
        GUI.CommandLine = Command()
        
        GUI.ShowForm
    End If
End Sub

Private Function Check() As Boolean
    Dim bRC As Boolean
    
    On Error Resume Next
    
    bRC = True
    
    CheckDBMAPI 0
    
    If Err.Number <> 0 Then
        MsgBox "Error " + CStr(Err.Number) + ": " + Err.Description, vbCritical, TXT_APPLICATION
        bRC = False
    End If
    
    Check = bRC
End Function

Private Sub GetVersion()
    Dim oFile As New File
    Dim sMajor As String
    Dim sMinor As String
    Dim sRevision As String
    Dim sPatch As String
    
    oFile.Filename = App.Path & "\DBMGui.exe"
    oFile.Refresh
    If Not oFile.VersionString = "?" Then
        SplitVersion oFile.VersionString, sMajor, sMinor, sRevision, sPatch
    Else
        SplitVersion DEF_VERNUM, sMajor, sMinor, sRevision, sPatch
    End If
    
    If sMajor = "7000" Then
        TXT_VERNUM = DEF_VERNUM
    Else
        TXT_VERNUM = sMajor & "." & sMinor
    End If
    TXT_VERSION = TXT_VERTEXT + " " + TXT_VERNUM
    TXT_TITLE = TXT_APPLICATION + " " + TXT_VERNUM
End Sub

Private Sub SplitVersion(ByVal sVersion As String, _
                         sMajor As String, _
                         sMinor As String, _
                         sRevision As String, _
                         sPatch As String)
    Dim lPos1 As Long
    Dim lPos2 As Long
    
    sMajor = "0"
    sMinor = "0"
    sRevision = "0"
    sPatch = "0"
    
    If Len(sVersion) > 0 Then
        lPos1 = 1
        lPos2 = InStr(lPos1, sVersion, ".")
        If lPos2 > 0 Then
            sMajor = Left$(sVersion, lPos2 - 1)
            lPos1 = lPos2 + 1
            lPos2 = InStr(lPos1, sVersion, ".")
            If lPos2 > 0 Then
                sMinor = Mid$(sVersion, lPos1, lPos2 - lPos1)
                lPos1 = lPos2 + 1
                lPos2 = InStr(lPos1, sVersion, ".")
                If lPos2 > 0 Then
                    sRevision = Mid$(sVersion, lPos1, lPos2 - lPos1)
                    sPatch = Mid$(sVersion, lPos2 + 1)
                Else
                    sRevision = Mid$(sVersion, lPos1)
                End If
            Else
                sMinor = Mid$(sVersion, lPos1)
            End If
        Else
            sMajor = sVersion
        End If
    End If
End Sub

Public Sub SplitFilename(ByVal sFilename As String, _
                         sPath As String, _
                         sFile As String)
    Dim iPos1 As Integer
    Dim iPos2 As Integer
        
    sFilename = Trim$(sFilename)
    
    sPath = ""
    sFile = ""
    
    If Len(sFilename) > 0 Then
        iPos1 = 0
        Do
            iPos2 = iPos1 + 1
            iPos1 = InStr(iPos1 + 1, sFilename, "\")
        Loop Until iPos1 = 0
        
        sPath = Trim$(Left$(sFilename, iPos2 - 1))
        sFile = Trim$(Mid$(sFilename, iPos2))
    End If
End Sub

Public Sub SplitFile(ByVal sFile As String, _
                     sName As String, _
                     sExtension As String)
    Dim iPos As Integer
    
    sFile = Trim$(sFile)
    
    sName = ""
    sExtension = ""
    
    If Len(sFile) > 0 Then
        iPos = InStr(1, sFile, ".")
        If iPos > 0 Then
            sName = Left$(sFile, iPos - 1)
            sExtension = Mid$(sFile, iPos + 1)
        Else
            sName = sFile
        End If
    End If
End Sub

Public Function GetLongFilename(ByVal sShortName As String) As String
    Dim sLongName As String
    Dim sTemp As String
    Dim iPos As Integer
    
    sShortName = sShortName & "\"
    
    iPos = InStr(4, sShortName, "\")
    
    Do While iPos
        sTemp = Dir(Left$(sShortName, iPos - 1), vbNormal + vbHidden + vbSystem + vbDirectory)
        If sTemp = "" Then
            GetLongFilename = ""
            Exit Function
        End If
        sLongName = sLongName + "\" + sTemp
        iPos = InStr(iPos + 1, sShortName, "\")
    Loop

    GetLongFilename = Left$(sShortName, 2) & sLongName
End Function

Public Function FileExists(ByVal sFilename As String) As Boolean
    FileExists = False
    If Len(sFilename) > 0 Then
        FileExists = Not (Dir(sFilename) = "")
    End If
End Function

