VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "File"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private Declare Sub CopyMemory Lib "Kernel32.dll" Alias "RtlMoveMemory" ( _
    hpvDest As Any, _
    ByVal hpvSource As Any, _
    ByVal cbCopy As Long)
    
Private Declare Function GetFileVersionInfoSize Lib "Version.DLL" Alias "GetFileVersionInfoSizeA" ( _
    ByVal sFilename As String, _
    lVerHandle As Long) As Long
    
Private Declare Function GetFileVersionInfo Lib "Version.DLL" Alias "GetFileVersionInfoA" ( _
    ByVal sFilename As String, _
    ByVal lVerHandle As Long, _
    ByVal lSize As Long, _
    lData As Byte) As Long

Private Declare Function VerQueryValue Lib "Version.DLL" Alias "VerQueryValueA" ( _
    bVerData As Any, _
    ByVal sSubBlock As String, _
    lBufPos As Long, _
    lLen As Long) As Long

Private Const SUBBLOCK_FIXEDFILEINFO = "\"

Private Type VS_FIXEDFILEINFO
    Signature As Long
    StrucVersion As Long
    FileVersionMS As Long
    FileVersionLS As Long
    ProductVersionMS As Long
    ProductVersionLS As Long
    FileFlagsMask As Long
    FileFlags As Long
    FileOS As Long
    FileType As Long
    FileSubtype As Long
    FileDateMS As Long
    FileDateLS As Long
End Type

'''

Private Type INTEGER_2_TYPE
    lo As Integer
    hi As Integer
End Type

Private Type LONG_1_TYPE
    l As Long
End Type

'''

Private sFilename As String
Private sPath As String
Private sName As String

Private tFileInfo As VS_FIXEDFILEINFO
Private bFileInfo As Boolean

'''

Public Property Get Filename() As String
    Filename = sFilename
End Property
Public Property Let Filename(NewVal As String)
    Dim lPos As Long
    
    sFilename = NewVal
    
    lPos = Len(sFilename)
    
    Do While lPos > 0
        If Mid$(sFilename, lPos, 1) = "\" Then
            Exit Do
        End If
        lPos = lPos - 1
    Loop
    
    If lPos > 0 Then
        sPath = Left(sFilename, lPos)
        sName = Mid$(sFilename, lPos + 1)
    Else
        sPath = ""
        sName = sFilename
    End If
End Property

Public Property Get Name() As String
    Name = sName
End Property

Public Property Get Path() As String
    Path = sPath
End Property

Public Property Get VersionString() As String
    Dim l As LONG_1_TYPE
    Dim ms As INTEGER_2_TYPE
    Dim ls As INTEGER_2_TYPE

    If Not bFileInfo Then Refresh
    
    If bFileInfo Then
        l.l = tFileInfo.FileVersionMS
        LSet ms = l
    
        l.l = tFileInfo.FileVersionLS
        LSet ls = l
    
        VersionString = CStr(ms.hi) & "." & CStr(ms.lo) & "." & CStr(ls.hi) & "." & CStr(ls.lo)
    Else
        VersionString = "?"
    End If
End Property

Public Property Get FileDate() As Date
    If Exists() Then
        FileDate = FileDateTime(Filename)
    Else
        FileDate = Empty
    End If
End Property

Public Property Get FileDateString() As String
    Dim d As Date
    d = FileDate
    FileDateString = Format$(d, "Short Date") + " " + Format$(d, "Short Time")
End Property

'''

Public Function Exists() As Boolean
    Exists = False
    If Filename <> "" Then
        Exists = Not (Dir(Filename) = "")
    End If
End Function

Public Function Refresh()
    bFileInfo = ReadFileInfo()
End Function

'''

Private Sub Class_Initialize()
    sFilename = ""
    bFileInfo = False
End Sub

'''

Private Function ReadFileInfo() As Boolean
    Dim lVerSize As Long
    Dim lVerHandle As Long

    Dim lBufPtr As Long
    Dim bVerData() As Byte

    ReadFileInfo = False
    
    If Not Exists() Then Exit Function
    
    lVerSize = GetFileVersionInfoSize(sFilename, lVerHandle)
    If lVerSize > 0 Then
        ReDim bVerData(lVerSize)
        If GetFileVersionInfo(sFilename, lVerHandle, lVerSize, bVerData(0)) <> 0 Then
            If VerQueryValue(bVerData(0), SUBBLOCK_FIXEDFILEINFO, lBufPtr, lVerSize) <> 0 Then
                CopyMemory tFileInfo, lBufPtr, lVerSize
                ReadFileInfo = True
            End If
        End If
    End If
End Function

'''

