VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FileDatabases"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const FILE_DB_PROP_DBNAME = "Databasename"
Const FILE_DB_PROP_SERVER = "Servername"
Const FILE_DB_PROP_USER = "Username"
Const FILE_DB_PROP_PWD = "Password"
Const FILE_DB_PROP_VER = "Version"
Const FILE_DB_PROP_KERNEL = "Kernel"
Const FILE_DB_PROP_AUTOREFRESH = "Autorefresh"
Const FILE_DB_PROP_INTERVAL = "Interval"
Const FILE_DB_PROP_EVENTS = "Events"
Const FILE_DB_PROP_TRACE = "Trace"
Const FILE_DB_PROP_INST = "InstanceType"
Const FILE_DB_PROP_NOEXTBACKUP = "NoExternalBackup"

Const FILE_DB_VAL_YES = "Yes"
Const FILE_DB_VAL_NO = "No"

Const FILE_DB_KNL_FAST = "Fast"
Const FILE_DB_KNL_QUICK = "Quick"
Const FILE_DB_KNL_SLOW = "Slow"

Const FILE_DB_INST_OLTP = "OLTP"
Const FILE_DB_INST_LVC = "LVC"
Const FILE_DB_INST_CS = "CS"
Const FILE_DB_INST_BW = "BW"

Private oItems As New Collection

Private sFilename As String
Private sPath As String
Private sFile As String

Private bDirty As Boolean

Public Property Get Count() As Integer
    Count = oItems.Count
End Property

Public Property Get Item(Index As Variant) As FileDatabase
Attribute Item.VB_UserMemId = 0
    Set Item = oItems(Index)
End Property

Public Property Get NewEnum()
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = oItems.[_NewEnum]
End Property

'''

Public Property Get Filename() As String
    Filename = sFilename
End Property
Public Property Get Path() As String
    Path = sPath
End Property
Public Property Get File() As String
    File = sFile
End Property

'''

Public Property Get Dirty() As Boolean
    Dirty = bDirty
End Property
Public Property Let Dirty(ByVal NewVal As Boolean)
    bDirty = NewVal
End Property

'''

Public Function OpenFile(ByVal Filename As String) As Boolean
    Dim bOK As Boolean
    Dim hFile As Integer
    Dim sLine As String
    Dim bProp As Boolean
    Dim oFileDB As FileDatabase
    Dim lPos As String
    Dim sProp As String
    Dim sVal As String
    
    bOK = False
    
    If FileExists(Filename) Then
        Clear
    
        hFile = FreeFile()
        Open Filename For Input As #hFile
        
        Do While Not EOF(hFile)
            Line Input #hFile, sLine
            sLine = Trim$(sLine)
            If Len(sLine) > 0 Then
                If Left$(sLine, 1) = "[" And Right$(sLine, 1) = "]" Then
                    If Not oFileDB Is Nothing Then
                        Set oFileDB = Nothing
                    End If
                    Set oFileDB = New FileDatabase
                    oFileDB.Name = Trim$(Mid$(sLine, 2, Len(sLine) - 2))
                    oItems.Add oFileDB, oFileDB.Name
                Else
                    If Not oFileDB Is Nothing Then
                        lPos = InStr(1, sLine, "=")
                        If lPos > 0 Then
                            sProp = UCase$(Trim$(Left$(sLine, lPos - 1)))
                            sVal = Trim$(Mid$(sLine, lPos + 1))
                        Else
                            sProp = UCase$(Trim$(sLine))
                            sVal = ""
                        End If
                        
                        With oFileDB
                            Select Case sProp
                                Case UCase$(FILE_DB_PROP_DBNAME):       .Databasename = sVal
                                Case UCase$(FILE_DB_PROP_SERVER):       .Servername = sVal
                                Case UCase$(FILE_DB_PROP_USER):         .Username = sVal
                                Case UCase$(FILE_DB_PROP_PWD):          .Password = sVal
                                Case UCase$(FILE_DB_PROP_VER):          .Version = sVal
                                Case UCase$(FILE_DB_PROP_KERNEL):
                                    Select Case UCase$(sVal)
                                        Case UCase$(FILE_DB_KNL_FAST):  .Kernel = DBMLib.DBMDatabaseKernelConstants.dbmFastKernel
                                        Case UCase$(FILE_DB_KNL_QUICK): .Kernel = DBMLib.DBMDatabaseKernelConstants.dbmQuickKernel
                                        Case UCase$(FILE_DB_KNL_SLOW):  .Kernel = DBMLib.DBMDatabaseKernelConstants.dbmSlowKernel
                                        Case Else:                      .Kernel = DBMLib.DBMDatabaseKernelConstants.dbmFastKernel
                                    End Select
                                Case UCase$(FILE_DB_PROP_AUTOREFRESH):  .Autorefresh = (UCase$(sVal) = UCase$(FILE_DB_VAL_YES))
                                Case UCase$(FILE_DB_PROP_INTERVAL):
                                    If IsNumeric(sVal) Then
                                        .Interval = CLng(sVal)
                                    Else
                                        .Interval = 0
                                    End If
                                Case UCase$(FILE_DB_PROP_EVENTS):       .Events = (UCase$(sVal) = UCase$(FILE_DB_VAL_YES))
                                Case UCase$(FILE_DB_PROP_TRACE):        .Trace = (UCase$(sVal) = UCase$(FILE_DB_VAL_YES))
                                Case UCase$(FILE_DB_PROP_INST):
                                    Select Case UCase$(sVal)
                                        Case UCase$(FILE_DB_INST_OLTP): .InstanceType = DBMLib.DBMDatabaseInstanceTypeConstants.dbmInstanceTypeOLTP
                                        Case UCase$(FILE_DB_INST_LVC):  .InstanceType = DBMLib.DBMDatabaseInstanceTypeConstants.dbmInstanceTypeLVC
                                        Case UCase$(FILE_DB_INST_CS):   .InstanceType = DBMLib.DBMDatabaseInstanceTypeConstants.dbmInstanceTypeCS
                                        Case UCase$(FILE_DB_INST_BW):   .InstanceType = DBMLib.DBMDatabaseInstanceTypeConstants.dbmInstanceTypeBW
                                        Case Else:                      .InstanceType = DBMLib.DBMDatabaseInstanceTypeConstants.dbmInstanceTypeNone
                                    End Select
                                Case UCase$(FILE_DB_PROP_NOEXTBACKUP):  .NoExternalBackup = .Trace = (UCase$(sVal) = UCase$(FILE_DB_VAL_YES))
                            End Select
                        End With
                    End If
                End If
                
            End If
        Loop
        
        Close hFile
        
        bOK = True
    Else
        Clear
        bOK = True
    End If
    
    If bOK Then
        sFilename = Filename
        SplitFilename Filename, sPath, sFile
        
        bDirty = False
    End If
    
    OpenFile = bOK
End Function

Public Function SaveFile(ByVal Filename As String) As Boolean
    Dim bOK As Boolean
    Dim hFile As Integer
    Dim sLine As String
    Dim bProp As Boolean
    Dim oFileDB As FileDatabase
    Dim lPos As String
    Dim sProp As String
    Dim sVal As String
    
    bOK = False
    
    hFile = FreeFile()
    
    Open Filename For Output As #hFile
    
    bOK = True
    
    For Each oFileDB In oItems
        With oFileDB
            Print #hFile, "[" + .Name + "]"
            Print #hFile, FILE_DB_PROP_DBNAME + "=" + .Databasename
            Print #hFile, FILE_DB_PROP_SERVER + "=" + .Servername
            Print #hFile, FILE_DB_PROP_USER + "=" + .Username
            Print #hFile, FILE_DB_PROP_PWD + "=" + .Password
            Print #hFile, FILE_DB_PROP_VER + "=" + .Version
            Select Case .Kernel
                Case DBMLib.DBMDatabaseKernelConstants.dbmFastKernel:   sVal = FILE_DB_KNL_FAST
                Case DBMLib.DBMDatabaseKernelConstants.dbmQuickKernel:  sVal = FILE_DB_KNL_QUICK
                Case DBMLib.DBMDatabaseKernelConstants.dbmSlowKernel:   sVal = FILE_DB_KNL_SLOW
                Case Else:                                              sVal = ""
            End Select
            Print #hFile, FILE_DB_PROP_KERNEL + "=" + sVal
            If .Autorefresh Then
                sVal = FILE_DB_VAL_YES
            Else
                sVal = FILE_DB_VAL_NO
            End If
            Print #hFile, FILE_DB_PROP_AUTOREFRESH + "=" + sVal
            Print #hFile, FILE_DB_PROP_INTERVAL + "=" + CStr(.Interval)
            If .Events Then
                sVal = FILE_DB_VAL_YES
            Else
                sVal = FILE_DB_VAL_NO
            End If
            Print #hFile, FILE_DB_PROP_EVENTS + "=" + sVal
            If .Trace Then
                sVal = FILE_DB_VAL_YES
            Else
                sVal = FILE_DB_VAL_NO
            End If
            Print #hFile, FILE_DB_PROP_TRACE + "=" + sVal
            Select Case .InstanceType
                Case DBMLib.DBMDatabaseInstanceTypeConstants.dbmInstanceTypeOLTP:   sVal = FILE_DB_INST_OLTP
                Case DBMLib.DBMDatabaseInstanceTypeConstants.dbmInstanceTypeLVC:    sVal = FILE_DB_INST_LVC
                Case DBMLib.DBMDatabaseInstanceTypeConstants.dbmInstanceTypeCS:     sVal = FILE_DB_INST_CS
                Case DBMLib.DBMDatabaseInstanceTypeConstants.dbmInstanceTypeBW:     sVal = FILE_DB_INST_BW
                Case Else:                                                          sVal = ""
            End Select
            Print #hFile, FILE_DB_PROP_INST + "=" + sVal
            If .NoExternalBackup Then
                sVal = FILE_DB_VAL_YES
            Else
                sVal = FILE_DB_VAL_NO
            End If
            Print #hFile, FILE_DB_PROP_NOEXTBACKUP + "=" + sVal
            
            Print #hFile,
        End With
    Next
    
    Close hFile
    
    If bOK Then
        sFilename = Filename
        SplitFilename Filename, sPath, sFile
        
        bDirty = False
    End If
    
    SaveFile = bOK
End Function

Public Function Add(Name As String, _
                    Servername As String, _
                    Databasename As String, _
                    Username As String, _
                    Password As String, _
                    Version As String, _
                    Kernel As DBMLib.DBMDatabaseKernelConstants, _
                    InstanceType As DBMLib.DBMDatabaseInstanceTypeConstants) As FileDatabase
    Dim oFileDB As New FileDatabase
    Dim oPwd As New DBMPwd.Crypt
    
    Set Add = Nothing
    
    With oFileDB
        .Name = Name
        .Servername = Servername
        .Databasename = Databasename
        .Username = Username
        .Password = oPwd.Encrypt(Password)
        .Version = Version
        .Kernel = CLng(Kernel)
        .Autorefresh = False
        .Interval = 60000
        .Events = False
        .Trace = False
        .InstanceType = CLng(InstanceType)
    End With
    
    oItems.Add oFileDB, oFileDB.Name
    
    bDirty = True
    
    Set Add = oFileDB
End Function

Public Function Exists(Index As Variant) As Boolean
    Dim oFileDB As FileDatabase
    On Error Resume Next
    Set oFileDB = oItems(Index)
    If Err.Number Then
        Exists = False
    Else
        Exists = True
    End If
End Function

Public Sub Clear()
    Dim lCount As Long
    Dim l As Long
    
    lCount = oItems.Count
    For l = 1 To lCount
        oItems.Remove 1
    Next
End Sub

Public Sub Remove(Index As Variant)
    oItems.Remove Index
    bDirty = True
End Sub

Public Sub Rename(Index As Variant, NewName As String)
    Dim oFileDB As FileDatabase
    Set oFileDB = oItems(Index)
    oItems.Remove Index
    oItems.Add oFileDB, NewName
    oFileDB.Name = NewName
    bDirty = True
End Sub

