VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsVersion"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" ( _
    hpvDest As Any, _
    ByVal hpvSource As Any, _
    ByVal cbCopy As Long)

Private Declare Function GetFileVersionInfoSize Lib "Version.DLL" Alias "GetFileVersionInfoSizeA" ( _
    ByVal sFilename As String, _
    lVerHandle As Long) As Long

Private Declare Function GetFileVersionInfo Lib "Version.DLL" Alias "GetFileVersionInfoA" ( _
    ByVal sFilename As String, _
    ByVal lVerHandle As Long, _
    ByVal lSize As Long, _
    ByVal lData As String) As Long

Private Declare Function VerQueryValue Lib "Version.DLL" Alias "VerQueryValueA" ( _
    ByVal bVerData As String, _
    ByVal sSubBlock As String, _
    lBufPos As Long, _
    lLen As Long) As Long

Private Type VS_FIXEDFILEINFO
    dwSignature As Long
    dwStrucVersion As Long
    dwFileVersionMS As Long
    dwFileVersionLS As Long
    dwProductVersionMS As Long
    dwProductVersionLS As Long
    dwFileFlagsMask As Long
    dwFileFlags As Long
    dwFileOS As Long
    dwFileType As Long
    dwFileSubtype As Long
    dwFileDateMS As Long
    dwFileDateLS As Long
End Type

' VS_VERSION.dwFileFlags
Const VS_FFI_SIGNATURE = &HFEEF04BD
Const VS_FFI_STRUCVERSION = &H10000
Const VS_FFI_FILEFLAGSMASK = &H3F

' VS_VERSION.dwFileFlags
Const VS_FF_DEBUG = &H1
Const VS_FF_PRERELEASE = &H2
Const VS_FF_PATCHED = &H4
Const VS_FF_PRIVATEBUILD = &H8
Const VS_FF_INFOINFERRED = &H10
Const VS_FF_SPECIALBUILD = &H20

' VS_VERSION.dwFileOS
Const VOS_UNKNOWN = &H0
Const VOS_DOS = &H10000
Const VOS_OS216 = &H20000
Const VOS_OS232 = &H30000
Const VOS_NT = &H40000

Const VOS__BASE = &H0
Const VOS__WINDOWS16 = &H1
Const VOS__PM16 = &H2
Const VOS__PM32 = &H3
Const VOS__WINDOWS32 = &H4

Const VOS_DOS_WINDOWS16 = &H10001
Const VOS_DOS_WINDOWS32 = &H10004
Const VOS_OS216_PM16 = &H20002
Const VOS_OS232_PM32 = &H30003
Const VOS_NT_WINDOWS32 = &H40004

' VS_VERSION.dwFileType
Const VFT_UNKNOWN = &H0
Const VFT_APP = &H1
Const VFT_DLL = &H2
Const VFT_DRV = &H3
Const VFT_FONT = &H4
Const VFT_VXD = &H5
Const VFT_STATIC_LIB = &H7

' VS_VERSION.dwFileSubtype for VFT_WINDOWS_DRV
Const VFT2_UNKNOWN = &H0
Const VFT2_DRV_PRINTER = &H1
Const VFT2_DRV_KEYBOARD = &H2
Const VFT2_DRV_LANGUAGE = &H3
Const VFT2_DRV_DISPLAY = &H4
Const VFT2_DRV_MOUSE = &H5
Const VFT2_DRV_NETWORK = &H6
Const VFT2_DRV_SYSTEM = &H7
Const VFT2_DRV_INSTALLABLE = &H8
Const VFT2_DRV_SOUND = &H9
Const VFT2_DRV_COMM = &HA
Const VFT2_DRV_INPUTMETHOD = &HB

' VS_VERSION.dwFileSubtype for VFT_WINDOWS_FONT
Const VFT2_FONT_RASTER = &H1
Const VFT2_FONT_VECTOR = &H2
Const VFT2_FONT_TRUETYPE = &H3

'''

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Private Declare Function FileTimeToLocalFileTime Lib "kernel32.dll" ( _
    lpFileTime As FILETIME, _
    lpLocalFileTime As FILETIME) As Long

Private Declare Function FileTimeToSystemTime Lib "kernel32.dll" ( _
    lpFileTime As FILETIME, _
    lpSystemTime As SYSTEMTIME) As Long

'''

Private Declare Function lstrlen Lib "kernel32.dll" Alias "lstrlenA" ( _
    ByVal lpString As String) As Long

'''

Private sFilename As String
Private sVer As String
Private pData As Long
Private cData As Long
Private tFixedFileInfo As VS_FIXEDFILEINFO
Private sPrefix As String

' Create new Version object
Sub Create(Filename As String)

    ' If it already exists, destroy it
    If sVer <> "" Then ReInit

    Dim hVer As Long, cVer As Long
    
    ' Get size and handle of version data
    cVer = GetFileVersionInfoSize(Filename, hVer)
    If cVer = 0 Then
        ' No error means file has no resources
        If Err.LastDllError = 0 Then Exit Sub
        LastDllError
    End If
    sVer = String$(cVer, 0)
    
    Dim f As Long
    f = GetFileVersionInfo(Filename, hVer, cVer, sVer)
    If f = 0 Then LastDllError

    ' Get tFixedFileInfo portion of data
    f = VerQueryValue(sVer, "\", pData, cData)
    If f = 0 Then LastDllError
    CopyMemory tFixedFileInfo, ByVal pData, Len(tFixedFileInfo)

    ' Get version as hex number with low and high reversed
    f = VerQueryValue(sVer, "\VarFileInfo\Translation", pData, cData)
    If f = 0 Then LastDllError
    If cData = 0 Then
        ' No version information
        ReInit
        Exit Sub
    End If

    ' Success - copy internal data to prefix and exe name
    CopyMemory cVer, ByVal pData, cData
    ' Version APIs are extremely picky about format of this string
    sPrefix = "\StringFileInfo\" & _
              FmtHex(LoWord(cVer), 4) & _
              FmtHex(HiWord(cVer), 4) & "\"
              
    sFilename = Filename
End Sub

Property Get Filename() As String
    Filename = sFilename
End Property
Property Let Filename(Filename As String)
Attribute Filename.VB_UserMemId = 0
    ReInit
    Create Filename
End Property

Private Sub ReInit()
    sFilename = ""
    sVer = ""
    
    With tFixedFileInfo
        .dwSignature = 0&
        .dwStrucVersion = 0&
        .dwFileVersionMS = 0&
        .dwFileVersionLS = 0&
        .dwProductVersionMS = 0&
        .dwProductVersionLS = 0&
        .dwFileFlagsMask = 0&
        .dwFileFlags = 0&
        .dwFileOS = 0&
        .dwFileType = 0&
        .dwFileSubtype = 0&
        .dwFileDateMS = 0&
        .dwFileDateLS = 0&
    End With
End Sub

Private Function BufToStr(pBuf As Long, cBuf) As String
    Dim s As String
    s = String$(cBuf + 1, 0)
    CopyMemory ByVal s, ByVal pBuf, cBuf
    BufToStr = StrZToStr(s)
End Function

Property Get FullFileVersion() As String
    If sVer = "" Then
        FullFileVersion = ""
    Else
        FullFileVersion = HiWord(tFixedFileInfo.dwFileVersionMS) & "." & _
                          LoWord(tFixedFileInfo.dwFileVersionMS) & "." & _
                          HiWord(tFixedFileInfo.dwFileVersionLS) & "." & _
                          LoWord(tFixedFileInfo.dwFileVersionLS)
    End If
End Property

Property Get FullProductVersion() As String
    If sVer = "" Then
        FullProductVersion = ""
    Else
        FullProductVersion = HiWord(tFixedFileInfo.dwProductVersionMS) & "." & _
                             LoWord(tFixedFileInfo.dwProductVersionMS) & "." & _
                             HiWord(tFixedFileInfo.dwProductVersionLS) & "." & _
                             LoWord(tFixedFileInfo.dwProductVersionLS)
    End If
End Property

Property Get FileVersionMajor() As Long
    FileVersionMajor = tFixedFileInfo.dwFileVersionMS
End Property

Property Get FileVersionMinor() As Long
    FileVersionMinor = tFixedFileInfo.dwFileVersionLS
End Property

Property Get ProductVersionMajor() As Long
    ProductVersionMajor = tFixedFileInfo.dwProductVersionMS
End Property

Property Get ProductVersionMinor() As Long
    ProductVersionMinor = tFixedFileInfo.dwProductVersionLS
End Property

Property Get BuildOptions() As Long
    BuildOptions = tFixedFileInfo.dwFileFlags
End Property

Property Get BuildString() As String
    With tFixedFileInfo
        If sVer = "" Then Exit Property
        Dim s As String
        If .dwFileFlags And VS_FF_DEBUG Then s = s & "Debug "
        If .dwFileFlags And VS_FF_PRERELEASE Then s = s & "Prerelease "
        If .dwFileFlags And VS_FF_PATCHED Then s = s & "Patched "
        If .dwFileFlags And VS_FF_PRIVATEBUILD Then s = s & "PrivateBuild "
        If .dwFileFlags And VS_FF_INFOINFERRED Then s = s & "InfoInferred "
        If .dwFileFlags And VS_FF_SPECIALBUILD Then s = s & "SpecialBuild "
        BuildString = s
    End With
End Property

Property Get Environment() As String
    If sVer = "" Then Exit Property
    Dim s As String
    Select Case LoWord(tFixedFileInfo.dwFileOS)
    Case VOS__WINDOWS16
        s = "Windows (16-bit)"
    Case VOS__PM16
        s = "PM (16-bit)"
    Case VOS__PM32
        s = "PM (32-bit)"
    Case VOS__WINDOWS32
        s = "Windows (32-bit)"
    End Select
    Select Case HiWord(tFixedFileInfo.dwFileOS)
    Case HiWord(VOS_DOS)
        s = s & " under MS-DOS"
    Case HiWord(VOS_OS216)
        s = s & " under OS/2 (16-bit)"
    Case HiWord(VOS_OS232)
        s = s & " under OS/2 (32-bit)"
    Case HiWord(VOS_NT)
        s = s & " under Windows-NT"
    End Select
    Environment = s
End Property

Property Get ExeType() As String
    If sVer = "" Then Exit Property
    Dim s As String
    Select Case tFixedFileInfo.dwFileType
    Case VFT_APP:
        s = "Application"
    Case VFT_DLL:
        s = "Dynamic Link Library"
    Case VFT_DRV:
        s = "Driver"
        Select Case tFixedFileInfo.dwFileSubtype
        Case VFT2_DRV_PRINTER
            s = s & ":Printer"
        Case VFT2_DRV_KEYBOARD
            s = s & ":Keyboard"
        Case VFT2_DRV_LANGUAGE
            s = s & ":Language"
        Case VFT2_DRV_DISPLAY
            s = s & ":Display"
        Case VFT2_DRV_MOUSE
            s = s & ":Mouse"
        Case VFT2_DRV_NETWORK
            s = s & ":Network"
        Case VFT2_DRV_SYSTEM
            s = s & ":System"
        Case VFT2_DRV_INSTALLABLE
            s = s & ":Installable"
        Case VFT2_DRV_SOUND
            s = s & ":Sound"
        Case VFT2_DRV_COMM
            s = s & ":Communications"
        End Select
    Case VFT_FONT:
        s = "Font"
        Select Case tFixedFileInfo.dwFileSubtype
        Case VFT2_FONT_RASTER
            s = s & ":Raster"
        Case VFT2_FONT_VECTOR
            s = s & ":Vector"
        Case VFT2_FONT_TRUETYPE
            s = s & ":TrueType"
        End Select
    Case VFT_VXD:
        s = "VXD"
    Case VFT_STATIC_LIB:
        s = "Static Library"
    Case Else
        s = "Unknown"
    End Select
    ExeType = s
End Property

Property Get TimeStamp() As Date
    Dim f As Boolean, ft As FILETIME, ftl As FILETIME, st As SYSTEMTIME
    If tFixedFileInfo.dwFileDateMS = 0 And tFixedFileInfo.dwFileDateLS = 0 Then Exit Property
    ft.dwHighDateTime = tFixedFileInfo.dwFileDateMS
    ft.dwLowDateTime = tFixedFileInfo.dwFileDateLS
    f = FileTimeToLocalFileTime(ft, ftl)
    If f Then f = FileTimeToSystemTime(ftl, st)
    If f = False Then Exit Property
    TimeStamp = DateSerial(st.wYear, st.wMonth, st.wDay) + _
                TimeSerial(st.wHour, st.wMinute, st.wSecond)
End Property

'''

Property Get Comments() As String
    If sVer = "" Then Exit Property
    If VerQueryValue(sVer, sPrefix & "Comments", pData, cData) Then
        Comments = BufToStr(pData, cData)
    End If
End Property

Property Get Company() As String
    If sVer = "" Then Exit Property
    If VerQueryValue(sVer, sPrefix & "CompanyName", pData, cData) Then
        Company = BufToStr(pData, cData)
    End If
End Property

Property Get Description() As String
    If sVer = "" Then Exit Property
    If VerQueryValue(sVer, sPrefix & "FileDescription", pData, cData) Then
        Description = BufToStr(pData, cData)
    End If
End Property

Property Get ProductVersionString() As String
    If sVer = "" Then Exit Property
    If VerQueryValue(sVer, sPrefix & "ProductVersion", pData, cData) Then
        ProductVersionString = BufToStr(pData, cData)
    End If
End Property

Property Get FileVersionString() As String
    If sVer = "" Then Exit Property
    If VerQueryValue(sVer, sPrefix & "FileVersion", pData, cData) Then
        FileVersionString = BufToStr(pData, cData)
    End If
End Property

Property Get InternalName() As String
    If sVer = "" Then Exit Property
    If VerQueryValue(sVer, sPrefix & "InternalName", pData, cData) Then
        InternalName = BufToStr(pData, cData)
    End If
End Property

Property Get Copyright() As String
    If sVer = "" Then Exit Property
    If VerQueryValue(sVer, sPrefix & "LegalCopyright", pData, cData) Then
        Copyright = BufToStr(pData, cData)
    End If
End Property

Property Get Trademarks() As String
    If sVer = "" Then Exit Property
    If VerQueryValue(sVer, sPrefix & "LegalTradeMarks", pData, cData) Then
        Trademarks = BufToStr(pData, cData)
    End If
End Property

Property Get OriginalFilename() As String
    If sVer = "" Then Exit Property
    If VerQueryValue(sVer, sPrefix & "OriginalFilename", pData, cData) Then
        OriginalFilename = BufToStr(pData, cData)
    End If
End Property

Property Get PrivateBuild() As String
    If sVer = "" Then Exit Property
    If VerQueryValue(sVer, sPrefix & "PrivateBuild", pData, cData) Then
        PrivateBuild = BufToStr(pData, cData)
    End If
End Property

Property Get ProductName() As String
    If sVer = "" Then Exit Property
    If VerQueryValue(sVer, sPrefix & "ProductName", pData, cData) Then
        ProductName = BufToStr(pData, cData)
    End If
End Property

Property Get ProductVersion() As String
    If sVer = "" Then Exit Property
    If VerQueryValue(sVer, sPrefix & "ProductVersion", pData, cData) Then
        ProductVersion = BufToStr(pData, cData)
    End If
End Property

Property Get SpecialBuild() As String
    If sVer = "" Then Exit Property
    If VerQueryValue(sVer, sPrefix & "SpecialBuild", pData, cData) Then
        SpecialBuild = BufToStr(pData, cData)
    End If
End Property

Property Get Custom(sCustom As String) As String
    If sVer = "" Then Exit Property
    If VerQueryValue(sVer, sPrefix & sCustom, pData, cData) Then
        Custom = BufToStr(pData, cData)
    End If
End Property

'''

Private Sub LastDllError()
    MsgBox "LastDllError", vbExclamation, App.Title
End Sub

'''

Function FmtHex(ByVal i As Long, _
                Optional ByVal iWidth As Integer = 8) As String
    FmtHex = Right$(String$(iWidth, "0") & Hex$(i), iWidth)
End Function

Function LoWord(ByVal dw As Long) As Integer
    If dw And &H8000& Then
        LoWord = dw Or &HFFFF0000
    Else
        LoWord = dw And &HFFFF&
    End If
End Function

Function HiWord(ByVal dw As Long) As Integer
    HiWord = (dw And &HFFFF0000) \ 65536
End Function

Function StrZToStr(s As String) As String
    StrZToStr = Left$(s, lstrlen(s))
End Function
