VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "BackupResult"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

' backup result names from vnc003c

Private Const BA_RESULT_RC = "Returncode"
Private Const BA_RESULT_DATE = "Date"
Private Const BA_RESULT_TIME = "Time"
Private Const BA_RESULT_DATABASE = "Database"
Private Const BA_RESULT_SERVER = "Server"
Private Const BA_RESULT_KNLVER = "Kernel Version"
Private Const BA_RESULT_PGSTRAN = "Pages Transferred"
Private Const BA_RESULT_PGSLEFT = "Pages Left"
Private Const BA_RESULT_VOLUMES = "Volumes"
Private Const BA_RESULT_MEDNAME = "Medianame"
Private Const BA_RESULT_LOCATION = "Location"
Private Const BA_RESULT_ERRTEXT = "Errortext"
Private Const BA_RESULT_LABEL = "Label"
Private Const BA_RESULT_ISCONS = "Is Consistent"
Private Const BA_RESULT_FLOGPG = "First LOG Page"
Private Const BA_RESULT_LLOGPG = "Last LOG Page"
Private Const BA_RESULT_DBSTMD1 = "DB Stamp 1 Date"
Private Const BA_RESULT_DBSTMT1 = "DB Stamp 1 Time"
Private Const BA_RESULT_DBSTMD2 = "DB Stamp 2 Date"
Private Const BA_RESULT_DBSTMT2 = "DB Stamp 2 Time"
Private Const BA_RESULT_PGCNT = "Page Count"
Private Const BA_RESULT_DEVUSE = "Devices Used"
Private Const BA_RESULT_DBID = "Database ID"
Private Const BA_RESULT_MAXUSEDDATAPAGE = "Max Used Data Page"
Private Const BA_RESULT_REDOTRANSR = "Redo Transactions Read"
Private Const BA_RESULT_REDOTRANSD = "Redo Transactions Done"

Private Const LBL_DATA = "DAT"
Private Const LBL_PAGES = "PAG"
Private Const LBL_LOG = "LOG"

Private oParent As Object
    
Private sReturncode As String
Private sDate As String
Private sTime As String
Private sDatabase As String
Private sServer As String
Private sKernelVersion As String
Private sTransferredPages As String
Private sLeftPages As String
Private sVolumes As String
Private sMediaName As String
Private sLocation As String
Private sErrorText As String
Private sLabel As String
Private sIsConsistent As String
Private sFirstLogPage As String
Private sLastLogPage As String
Private sDBStamp1Date As String
Private sDBStamp1Time As String
Private sDBStamp2Date As String
Private sDBStamp2Time As String
Private sPageCount As String
Private sDevicesUsed As String
Private sDatabaseID As String
Private sMaxUsedDataPage As String
Private sRedoTransRead As String
Private sRedoTransDone As String
'
' Properties
'
Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTBackupResult
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent.Database
End Property
'
'
'
Public Property Get ReturnCode() As Long
    ReturnCode = GetLongFromString(sReturncode)
End Property

Public Property Get DateVal() As Date
    Dim d As Date
    d = GetDateFromString(sDate)
    If Not IsEmpty(d) Then
        d = d + GetTimeFromString(sTime)
    End If
    DateVal = d
End Property

Public Property Get ServerName() As String
    ServerName = sServer
End Property

Public Property Get DatabaseName() As String
    DatabaseName = sDatabase
End Property

Public Property Get KernelVersion() As String
    KernelVersion = sKernelVersion
End Property

Public Property Get TransferredPages() As Long
    TransferredPages = GetLongFromString(sTransferredPages)
End Property
Public Property Get TransferredKB() As Long
    TransferredKB = TransferredPages * (Database.PageSize \ 1024)
End Property

Public Property Get LeftPages() As Long
    LeftPages = GetLongFromString(sLeftPages)
End Property
Public Property Get LeftKB() As Long
    LeftKB = LeftPages * (Database.PageSize \ 1024)
End Property

Public Property Get MaxPages() As Long
    MaxPages = PageCount
End Property
Public Property Get MaxKB() As Long
    MaxKB = MaxPages * (Database.PageSize \ 1024)
End Property

Public Property Get Percent() As Integer
    Dim lPages As Long
    
    lPages = MaxPages
    
    If lPages > 0 Then
        Percent = TransferredPages * 100 / lPages
        ' new
        If Percent > 100 Then Percent = 100
        ' ***
    Else
        Percent = 0
    End If
End Property

Public Property Get Volumes() As Long
    Volumes = GetLongFromString(sVolumes)
End Property

Public Property Get MediaName() As String
    MediaName = sMediaName
End Property

Public Property Get Location() As String
    Location = sLocation
End Property

Public Property Get Label() As String
    Label = sLabel
End Property

Public Property Get ErrorText() As String
    ErrorText = sErrorText
End Property

Public Property Get IsConsistent() As Boolean
    IsConsistent = GetBoolFromString(sIsConsistent)
End Property

Public Property Get FirstLogPage() As Long
    FirstLogPage = GetLongFromString(sFirstLogPage)
End Property

Public Property Get LastLogPage() As Long
    LastLogPage = GetLongFromString(sLastLogPage)
End Property

Public Property Get DBStamp1Date() As Variant
    DBStamp1Date = GetDateFromString(sDBStamp1Date)
End Property

Public Property Get DBStamp1Time() As Variant
    DBStamp1Time = GetTimeFromString(sDBStamp1Time)
End Property

Public Property Get DBStamp2Date() As Variant
    DBStamp2Date = GetDateFromString(sDBStamp2Date)
End Property

Public Property Get DBStamp2Time() As Variant
    DBStamp2Time = GetTimeFromString(sDBStamp2Time)
End Property

Public Property Get DBStamp1() As Date
    Dim d As Variant
    d = DBStamp1Date
    If Not IsEmpty(d) Then
        d = d + DBStamp1Time
    End If
    DBStamp1 = d
End Property

Public Property Get DBStamp2() As Date
    Dim d As Variant
    d = DBStamp2Date
    If Not IsEmpty(d) Then
        d = d + DBStamp2Time
    End If
    DBStamp2 = d
End Property

Public Property Get PageCount() As Long
    PageCount = GetLongFromString(sPageCount)
End Property
Public Property Get PageCountKB() As Long
    PageCountKB = PageCount * (Database.PageSize \ 1024)
End Property

Public Property Get DevicesUsed() As Long
    DevicesUsed = GetLongFromString(sDevicesUsed)
End Property

Public Property Get DatabaseID() As String
    DatabaseID = sDatabaseID
End Property

Public Property Get MaxUsedDataPage() As Long
    MaxUsedDataPage = GetLongFromString(sMaxUsedDataPage)
End Property

Public Property Get RedoTransRead() As Long
    RedoTransRead = GetLongFromString(sRedoTransRead)
End Property

Public Property Get RedoTransDone() As Long
    RedoTransDone = GetLongFromString(sRedoTransDone)
End Property

Public Property Get BackupType() As DBMBackupTypeConstants
    Select Case UCase$(Left$(sLabel, 3))
        Case LBL_DATA:  BackupType = dbmBTData
        Case LBL_PAGES: BackupType = dbmBTPages
        Case LBL_LOG:   BackupType = dbmBTLog
    End Select
End Property

Public Property Let Data(sData As String)
    Dim lPos1 As Long
    Dim lPos2 As Long
    Dim sLine As String
    Dim sName As String
    Dim sValue As String
    
    With Database
        lPos1 = 1
        Do While lPos1 < Len(sData)
            sLine = Trim$(.ServerObject.GetLine(sData, lPos1))
            If Len(sLine) > 0 Then
                lPos2 = 1
                sName = Trim$(.ServerObject.GetField(sLine, vbTab, lPos2))
                sValue = Trim$(.ServerObject.GetField(sLine, vbTab, lPos2))
                Select Case sName
                    Case BA_RESULT_RC:              sReturncode = sValue
                    Case BA_RESULT_DATE:            sDate = sValue
                    Case BA_RESULT_TIME:            sTime = sValue
                    Case BA_RESULT_DATABASE:        sDatabase = sValue
                    Case BA_RESULT_SERVER:          sServer = sValue
                    Case BA_RESULT_KNLVER:          sKernelVersion = sValue
                    Case BA_RESULT_PGSTRAN:         sTransferredPages = sValue
                    Case BA_RESULT_PGSLEFT:         sLeftPages = sValue
                    Case BA_RESULT_VOLUMES:         sVolumes = sValue
                    Case BA_RESULT_MEDNAME:         sMediaName = sValue
                    Case BA_RESULT_LOCATION:        sLocation = sValue
                    Case BA_RESULT_ERRTEXT:         sErrorText = sValue
                    Case BA_RESULT_LABEL:           sLabel = sValue
                    Case BA_RESULT_ISCONS:          sIsConsistent = sValue
                    Case BA_RESULT_FLOGPG:          sFirstLogPage = sValue
                    Case BA_RESULT_LLOGPG:          sLastLogPage = sValue
                    Case BA_RESULT_DBSTMD1:         sDBStamp1Date = sValue
                    Case BA_RESULT_DBSTMT1:         sDBStamp1Time = sValue
                    Case BA_RESULT_DBSTMD2:         sDBStamp2Date = sValue
                    Case BA_RESULT_DBSTMT2:         sDBStamp2Time = sValue
                    Case BA_RESULT_PGCNT:           sPageCount = sValue
                    Case BA_RESULT_DEVUSE:          sDevicesUsed = sValue
                    Case BA_RESULT_DBID:            sDatabaseID = sValue
                    Case BA_RESULT_MAXUSEDDATAPAGE: sMaxUsedDataPage = sValue
                    Case BA_RESULT_REDOTRANSR:      sRedoTransRead = sValue
                    Case BA_RESULT_REDOTRANSD:      sRedoTransDone = sValue
                End Select
            End If
        Loop
    End With
End Property
'
' Methods
'
Public Sub Clear()
    Dim sValue As String
    
    sValue = ""
    
    sReturncode = sValue
    sDate = sValue
    sTime = sValue
    sDatabase = sValue
    sServer = sValue
    sKernelVersion = sValue
    sTransferredPages = sValue
    sLeftPages = sValue
    sVolumes = sValue
    sMediaName = sValue
    sLocation = sValue
    sErrorText = sValue
    sLabel = sValue
    sIsConsistent = sValue
    sFirstLogPage = sValue
    sLastLogPage = sValue
    sDBStamp1Date = sValue
    sDBStamp1Time = sValue
    sDBStamp2Date = sValue
    sDBStamp2Time = sValue
    sPageCount = sValue
    sDevicesUsed = sValue
    sDatabaseID = sValue
    sMaxUsedDataPage = sValue
    sRedoTransRead = sValue
    sRedoTransDone = sValue
End Sub

Public Sub CleanUp()
    Set oParent = Nothing
End Sub

'''

Private Sub Class_Initialize()
    InitObject ObjectType
End Sub
Private Sub Class_Terminate()
    TermObject ObjectType
End Sub

Private Function GetDateFromString(sDate As String) As Variant
    If Len(sDate) > 0 Then
        GetDateFromString = DateSerial(Val(Left$(sDate, 4)), Val(Mid$(sDate, 5, 2)), Val(Mid$(sDate, 7, 2)))
    Else
        GetDateFromString = Empty
    End If
End Function

Private Function GetTimeFromString(sTime As String) As Variant
    If Len(sTime) > 0 Then
        GetTimeFromString = TimeSerial(Val(Mid$(sTime, 3, 2)), Val(Mid$(sTime, 5, 2)), Val(Mid$(sTime, 7, 2)))
    Else
        GetTimeFromString = Empty
    End If
End Function

Private Function GetLongFromString(sLong As String) As Long
    GetLongFromString = 0
    
    If Len(sLong) > 0 Then
        If IsNumeric(sLong) Then
            GetLongFromString = Val(sLong)
        End If
    End If
End Function

Private Function GetBoolFromString(sBool As String) As Boolean
    Select Case UCase$(sBool)
        Case "TRUE":    GetBoolFromString = True
        Case "FALSE":   GetBoolFromString = False
        Case Else:      GetBoolFromString = False
    End Select
End Function

