VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Columns"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oParent As Object

Private sSchemaName As String
Private sTableName As String
Private sColumnName As String

Private bOpen As Boolean

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTColumns
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent.Database
End Property

'''

Public Property Get SchemaName() As String
    SchemaName = sSchemaName
End Property
Public Property Get TableName() As String
    TableName = sTableName
End Property
Public Property Get ColumnName() As String
    ColumnName = sColumnName
End Property

'''

Public Function OpenColumns(SchemaName As String, _
                            TableName As String, _
                            ColumnName As String, _
                            Header As String, _
                            Result As String, _
                            Continue As Boolean) As Boolean
    Dim bOK As Boolean
    Dim sWhere As String
    
    bOK = False
    
    sSchemaName = SchemaName
    sTableName = TableName
    sColumnName = ColumnName
    
    sWhere = ""
    
    If Len(sSchemaName) > 0 Then
        If sSchemaName <> "*" Then
            sWhere = sWhere + " ""Owner"" LIKE '" + sSchemaName + "' AND"
        End If
    End If
    If Len(sTableName) > 0 Then
        If sTableName <> "*" Then
            sWhere = sWhere + " ""Table Name"" LIKE '" + sTableName + "' AND"
        End If
    End If
    If Len(sColumnName) > 0 Then
        If sColumnName <> "*" Then
            sWhere = sWhere + " ""Column Name"" LIKE '" + sColumnName + "' AND"
        End If
    End If

    If Right(sWhere, 3) = "AND" Then
        sWhere = Left$(sWhere, Len(sWhere) - 4)
    End If
    
    Database.Busy = True
    
    If Database.Check() Then
        With Database
            If DBMSRVSQL.Connect(.ServerObject) Then
                If DBMSRVInfo.InfoSelect(.ServerObject, "COLUMNS", sWhere, Header, Result, Continue) Then
                    bOpen = True
                    bOK = True
                Else
                    DBMSRVSQL.Release .ServerObject
                End If
                
            End If
        End With
    End If
    
    Database.Busy = False
    
    OpenColumns = bOK
End Function

Public Function FetchColumns(Header As String, _
                             Result As String, _
                             Continue As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If bOpen Then
        Database.Busy = True
        
        If Database.Check() Then
            With Database
                If DBMSRVInfo.InfoFetch(.ServerObject, Header, Result, Continue) Then
                    bOK = True
                End If
            End With
        End If
        
        Database.Busy = False
    End If
    
    FetchColumns = bOK
End Function

Public Function CloseColumns() As Boolean
    Dim bOK As Boolean

    If Not bOpen Then
        CloseColumns = True
        Exit Function
    End If

    bOK = False
    
    Database.Busy = True
    
    If Database.Check() Then
        With Database
            If DBMSRVSQL.Release(.ServerObject) Then
                bOpen = False
            End If
        End With
    End If

    Database.Busy = False
    
    CloseColumns = bOK
End Function

'''

Public Sub CleanUp()
    Set oParent = Nothing
    bOpen = False
End Sub

Private Sub Class_Initialize()
    InitObject ObjectType
End Sub

Private Sub Class_Terminate()
    TermObject ObjectType
End Sub




