VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DevSpaces"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"33F01F1D028E"
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const FUNC_OPEN = "OpenDevSpaces"

' some kernel parameters
Const PARAM_MIRRORED_DATA_V71 = "MIRRORED_DATA"
Const PARAM_MIRRORED_DATA_V72 = "_MIRRORED_DATA"
Const PARAM_LOG_MODE = "LOG_MODE"
Const PARAM_MAXARCHIVELOGS = "MAXARCHIVELOGS"
Const PARAM_MAXDATADEVSPACES = "MAXDATADEVSPACES"
Const VALUE_MIRRORED_YES = "YES"
Const VALUE_MIRRORED_NO = "NO"
Const VALUE_LOG_MODE_DUAL = "DUAL"
Const VALUE_LOG_MODE_SINGLE = "SINGLE"
Const VALUE_LOG_MODE_DEMO = "DEMO"

' constants for data devs
Const MAX_DATA = 1024

' constants for sys devs
Const MAX_SYS = 1

' constants for log devs
Const MAX_LOG = 32

' current configuration
Private g_bMirrored As Boolean
Private g_bDualLog As Boolean
Private g_nSysdevs As Long
Private g_nLogdevs As Long
Private g_nDatadevs As Long

Private oParent As Object

Private oItems As New Collection

Private bOpen As Boolean

'''

Private dAt As Date

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTDevSpaces
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent.Database
End Property

Public Property Get Count() As Integer
    Count = oItems.Count
End Property

Public Property Get Item(ByVal Index As Variant) As DevSpace
Attribute Item.VB_UserMemId = 0
    Set Item = oItems(Index)
End Property

Public Property Get NewEnum()
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = oItems.[_NewEnum]
End Property

'''

Public Property Get At() As Date
    At = dAt
End Property

Public Property Get DataPages() As Long
    Dim oItem As DevSpace
    Dim lItem As Long
    Dim lSum As Long
    
    lSum = 0
    
    For lItem = 1 To oItems.Count
        Set oItem = oItems(lItem)
        If oItem.DeviceClass = dbmDSCData Then
            If oItem.Exists Then
                lSum = lSum + oItem.SizePages
            End If
        End If
    Next
    
    DataPages = lSum
End Property

Public Property Get DataKB() As Long
    DataKB = DataPages * (Database.PageSize \ 1024)
End Property

Public Property Get NewDataPages() As Long
    Dim oItem As DevSpace
    Dim lItem As Long
    Dim lSum As Long
    
    lSum = 0
    
    For lItem = 1 To oItems.Count
        Set oItem = oItems(lItem)
        If oItem.DeviceClass = dbmDSCData Then
            If Not oItem.Exists Then
                lSum = lSum + oItem.SizePages
            End If
        End If
    Next
    
    NewDataPages = lSum
End Property

Public Property Get NewDataKB() As Long
    NewDataKB = NewDataPages * (Database.PageSize \ 1024)
End Property

Public Property Get LeftDataPages() As Long
    Dim lSum As Long
    
    lSum = Val(Database.Parameters.GetValue(PARAM_MAXDATAPAGES)) - DataPages
    
    If lSum < 0 Then lSum = 0
    
    LeftDataPages = lSum
End Property

Public Property Get LeftDataKB() As Long
    LeftDataKB = LeftDataPages * (Database.PageSize \ 1024)
End Property

Public Property Get LeftNewDataPages() As Long
    Dim lSum As Long
    
    lSum = LeftDataPages - NewDataPages
    
    If lSum < 0 Then lSum = 0
    
    LeftNewDataPages = lSum
End Property

Public Property Get LeftNewDataKB() As Long
    LeftNewDataKB = LeftNewDataPages * (Database.PageSize \ 1024)
End Property

Public Property Get AfterRestartDataPages() As Long
    Dim oItem As DevSpace
    Dim lItem As Long
    Dim lSum As Long
    Dim lMax As Long
    
    lSum = 0
    lMax = 0
    
    For lItem = 1 To oItems.Count
        Set oItem = oItems(lItem)
        If oItem.DeviceClass = dbmDSCData Then
            lSum = lSum + oItem.SizePages
            If oItem.SizePages > lMax Then
                lMax = oItem.SizePages
            End If
        End If
    Next
    
    AfterRestartDataPages = lSum + lMax
End Property

Public Property Get Dirty() As Boolean
    Dim oDevSpace As DevSpace
    Dim lCount As Long
    Dim lItem As Long

    Dirty = False
    
    lCount = oItems.Count
    For lItem = 1 To lCount
        Set oDevSpace = oItems(lItem)
        If oDevSpace.Dirty Then
            Dirty = True
            Exit For
        End If
    Next
End Property

Public Property Get Complete() As Boolean
    Dim oDevSpace As DevSpace
    Dim lCount As Long
    Dim lItem As Long
    Dim bSys As Boolean
    Dim bLog As Boolean
    Dim bDat As Boolean

    Complete = False
    
    If Database.Version.Number < dbmversion74 Then
        bSys = False
    Else
        bSys = True
    End If
    bLog = False
    bDat = False
    
    lCount = oItems.Count
    For lItem = 1 To lCount
        Set oDevSpace = oItems(lItem)
        
        Select Case oDevSpace.DeviceClass
            Case dbmDSCSys:
                If Not bSys And oDevSpace.Complete Then
                    bSys = True
                End If
            Case dbmDSCLog:
                If Not bLog And oDevSpace.Complete Then
                    bLog = True
                End If
            Case dbmDSCData:
                If Not bDat And oDevSpace.Complete Then
                    bDat = True
                End If
        End Select
        
        If bSys And bLog And bDat Then
            Complete = True
            Exit For
        End If
    Next
End Property

Public Property Get CompleteMirroredLog() As Boolean
    Dim oDevSpace As DevSpace
    Dim lCount As Long
    Dim lItem As Long
    Dim bComplete As Boolean

    bComplete = True
    
    lCount = oItems.Count
    For lItem = 1 To lCount
        Set oDevSpace = oItems(lItem)
        If oDevSpace.DeviceClass = dbmDSCLog And _
           oDevSpace.Exists _
        Then
            If Not oDevSpace.CompleteMirrored Then
                bComplete = False
                Exit For
            End If
        End If
    Next
    
    CompleteMirroredLog = bComplete
End Property

Public Property Get NextUnUsedLogDevSpace() As DevSpace
    Dim oDevSpace As DevSpace
    Dim lCount As Long
    Dim lItem As Long
    
    Set NextUnUsedLogDevSpace = Nothing
    
    lCount = oItems.Count
    For lItem = 1 To lCount
        Set oDevSpace = oItems(lItem)
        If oDevSpace.DeviceClass = dbmDSCLog Then
            If Not oDevSpace.Exists Then
                Set NextUnUsedLogDevSpace = oDevSpace
                Exit For
            End If
        End If
    Next
End Property

Public Property Get NextUnUsedDataDevSpace() As DevSpace
    Dim oDevSpace As DevSpace
    Dim lCount As Long
    Dim lItem As Long
    
    Set NextUnUsedDataDevSpace = Nothing
    
    lCount = oItems.Count
    For lItem = 1 To lCount
        Set oDevSpace = oItems(lItem)
        If oDevSpace.DeviceClass = dbmDSCData Then
            If Not oDevSpace.Exists Then
                Set NextUnUsedDataDevSpace = oDevSpace
                Exit For
            End If
        End If
    Next
End Property

Public Property Get IsOpen() As Boolean
    IsOpen = bOpen
End Property

'''

Private Function Add(ByVal nNumber As Long, _
                     ByVal nClass As DBMDevSpaceClassConstans, _
                     ByVal bMirrored As Boolean) As Boolean
    Dim oDevSpace As New DBMLib.DevSpace
    
    With oDevSpace
        Set .Parent = Me
        .Number = nNumber
        .DeviceClass = nClass
        .Mirrored = bMirrored
    End With
    
    oItems.Add oDevSpace, oDevSpace.Name
      
    Add = oDevSpace.Refresh()
End Function

Private Sub Remove(ByVal Index As Integer)
    oItems.Remove Index
End Sub

Private Sub Clear()
    Dim iCount As Integer
    Dim i As Integer
    
    iCount = oItems.Count

    For i = 1 To iCount
        oItems(1).CleanUp
        oItems.Remove 1
    Next
End Sub

'''

Public Function OpenDevSpaces(Optional ByVal Asynchron As Boolean = False, _
                              Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_OPEN, False, SenderID)
        Else
            QUEUE.QueueItems.Add Me, FUNC_OPEN, SenderID
            bOK = True
        End If
    End If
    
    OpenDevSpaces = bOK
End Function

'''

Public Sub CleanUp()
    Clear
End Sub

'''

Private Sub Class_Initialize()
    InitObject ObjectType
End Sub

Private Sub Class_Terminate()
    TermObject ObjectType
End Sub

'''

Public Function Execute(ByVal FunctionName As String, ByVal Asynchron As Boolean, Optional ByVal SenderID As Long) As Boolean
    Dim bOK As Boolean
    
    Database.Busy = True
    
    bOK = False
    
    Select Case FunctionName
        Case FUNC_OPEN: bOK = ExecuteOpenDevSpaces(Asynchron, SenderID)
    End Select
            
    Database.Busy = False
    
    Execute = bOK
End Function

Private Function ExecuteOpenDevSpaces(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    Dim oParameters As Parameters
    Dim bMirrored As Boolean
    Dim bDualLog As Boolean
    Dim nSysdevs As Long
    Dim nLogdevs As Long
    Dim nDatadevs As Long
    Dim bSession As Boolean
    Dim bStatus As Boolean
    Dim sError As String
    
    bOK = True
    
    With Database
        If .Check() Then
            Set oParameters = Database.Parameters
            
            bSession = False
            
            If Not oParameters.IsOpen Then
                bOK = oParameters.OpenParameters(True)
                bSession = bOK
            End If
            
            If bOK Then
                If .Version.Number >= dbmVersion73 Then
                    bMirrored = False
                Else
                    If .Version.Number >= dbmVersion72 Then
                        bMirrored = (UCase(oParameters.Item(PARAM_MIRRORED_DATA_V72, True).Value) = VALUE_MIRRORED_YES)
                    Else
                        bMirrored = (UCase(oParameters.Item(PARAM_MIRRORED_DATA_V71, True).Value) = VALUE_MIRRORED_YES)
                    End If
                End If
                    
                bDualLog = (UCase(oParameters.Item(PARAM_LOG_MODE, True).Value) = VALUE_LOG_MODE_DUAL)
                
                If .Version.Number < dbmversion74 Then
                    nSysdevs = MAX_SYS
                Else
                    nSysdevs = 0
                End If
                
                nLogdevs = oParameters.Item(PARAM_MAXARCHIVELOGS, True).Value
                If (nLogdevs > MAX_LOG) Then
                    nLogdevs = MAX_LOG
                End If
                
                nDatadevs = oParameters.Item(PARAM_MAXDATADEVSPACES, True).Value
                If (nDatadevs > MAX_DATA) Then
                    nDatadevs = MAX_DATA
                End If
            
                g_bMirrored = bMirrored
                g_bDualLog = bDualLog
                g_nSysdevs = nSysdevs
                g_nLogdevs = nLogdevs
                g_nDatadevs = nDatadevs
            
                Clear
        
                If bOK Then
                    bOK = InitSysDevs
                End If
        
                If bOK Then
                    bOK = InitDataDevs
                End If
            
                If bOK Then
                    bOK = InitLogDevs
                End If
        
            End If
            
            .LastError.SetByServerObject .ServerObject
            
            If bSession Then
                bOK = oParameters.CloseParameters(True)
            End If
        End If
        
        If bOK Then dAt = Now()
        
        If bAsynchron Then
            .EventDevSpacesOpen lSenderID, Not bOK
        End If
    End With
    
    ExecuteOpenDevSpaces = bOK
End Function


'''

Private Function InitSysDevs() As Boolean
    Dim bOK As Boolean
    Dim lIndex As Long
    
    bOK = True
    
    For lIndex = 1 To g_nSysdevs
        bOK = Add(lIndex, dbmDSCSys, g_bMirrored)
        If Not bOK Then Exit For
    Next
    
    InitSysDevs = bOK
End Function

Private Function InitLogDevs() As Boolean
    Dim bOK As Boolean
    Dim lIndex As Long
    
    bOK = True
    
    For lIndex = 1 To g_nLogdevs
        bOK = Add(lIndex, dbmDSCLog, g_bDualLog)
        If Not bOK Then Exit For
    Next
    
    InitLogDevs = bOK
End Function

Private Function InitDataDevs() As Boolean
    Dim bOK As Boolean
    Dim lIndex As Long
    
    bOK = True
    
    For lIndex = 1 To g_nDatadevs
        bOK = Add(lIndex, dbmDSCData, g_bMirrored)
        If Not bOK Then Exit For
    Next
    
    InitDataDevs = bOK
End Function

