VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "HistoryItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Enum HistoryColumnConstants
    dbmBHCSysKey = 1
    dbmBHCLabel
    dbmBHCAction
    dbmBHCLastSavePoint
    dbmBHCFirstCommit
    dbmBHCLastCommit
    dbmBHCStartDate
    dbmBHCStopDate
    dbmBHCLogPage
    dbmBHCFromPage
    dbmBHCToPage
    dbmBHCLogRequired
    dbmBHCMediaName
    dbmBHCSizeKB
    dbmBHCSizePages
    dbmBHCVolumes
    dbmBHCResult
End Enum

Private oParent As Object

Private lIndex As Long

Private sLine As String

Private lLineNum As Long

'''

Private Const ACTION_SAVE = "SAVE"
Private Const ACTION_RESTORE = "REST"
Private Const ACTION_HISTLOST = "HIST"

Private Const LBL_DATA = "DAT"
Private Const LBL_PAGES = "PAG"
Private Const LBL_LOG = "LOG"

'''

Private oMedia As Media
Private oExternalIDs As ExternalIDs

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTHistoryItem
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent.Database
End Property

'''

Friend Property Let Line(NewVal As String)
    sLine = NewVal
End Property

Public Property Get LineNum() As Long
    LineNum = lLineNum
End Property
Friend Property Let LineNum(ByVal NewVal As Long)
    lLineNum = NewVal
End Property

Public Property Get SysKey() As String
    SysKey = Mid$(sLine, BHColPos(BH_COL_SYSKEY), BHColLen(BH_COL_SYSKEY))
End Property
Public Property Get Label() As String
    Label = Mid$(sLine, BHColPos(BH_COL_LABEL), BHColLen(BH_COL_LABEL))
End Property
Public Property Get LabelNum() As Long
    LabelNum = Val(Mid$(Label, 5))
End Property
Public Property Get Action() As String
    Action = Mid$(sLine, BHColPos(BH_COL_ACTION), BHColLen(BH_COL_ACTION))
End Property
Public Property Get DBStamp1() As Date
    If IsDate(Mid$(sLine, BHColPos(BH_COL_DBSTAMP1), BHColLen(BH_COL_DBSTAMP1))) Then
        DBStamp1 = CDate(Mid$(sLine, BHColPos(BH_COL_DBSTAMP1), BHColLen(BH_COL_DBSTAMP1)))
    Else
        DBStamp1 = Empty
    End If
End Property
Public Property Get DBStamp2() As Date
    If IsDate(Mid$(sLine, BHColPos(BH_COL_DBSTAMP2), BHColLen(BH_COL_DBSTAMP2))) Then
        DBStamp2 = CDate(Mid$(sLine, BHColPos(BH_COL_DBSTAMP2), BHColLen(BH_COL_DBSTAMP2)))
    Else
        DBStamp2 = Empty
    End If
End Property
Public Property Get LastSavePoint() As Variant
    If BackupType <> dbmBTLog Then
        LastSavePoint = DBStamp1
    Else
        LastSavePoint = ""
    End If
End Property
Public Property Get FirstCommit() As Variant
    If BackupType = dbmBTLog Then
        FirstCommit = DBStamp1
    Else
        FirstCommit = ""
    End If
End Property
Public Property Get LastCommit() As Variant
    If BackupType = dbmBTLog Then
        LastCommit = DBStamp2
    Else
        LastCommit = ""
    End If
End Property
Public Property Get StartDate() As Date
    If IsDate(Mid$(sLine, BHColPos(BH_COL_STARTDATE), BHColLen(BH_COL_STARTDATE))) Then
        StartDate = CDate(Mid$(sLine, BHColPos(BH_COL_STARTDATE), BHColLen(BH_COL_STARTDATE)))
    Else
        StartDate = Empty
    End If
End Property
Public Property Get StopDate() As Date
    If IsDate(Mid$(sLine, BHColPos(BH_COL_STOPDATE), BHColLen(BH_COL_STOPDATE))) Then
        StopDate = CDate(Mid$(sLine, BHColPos(BH_COL_STOPDATE), BHColLen(BH_COL_STOPDATE)))
    Else
        StopDate = Empty
    End If
End Property

Public Property Get LogPage() As Variant
    Dim s As String
    If BackupType <> dbmBTLog Then
        s = Trim$(Mid$(sLine, BHColPos(BH_COL_FROMPAGE), BHColLen(BH_COL_FROMPAGE)))
        If IsNumeric(s) Then
            LogPage = CLng(s)
        Else
            LogPage = ""
        End If
    Else
        LogPage = ""
    End If
End Property

Public Property Get FromPage() As Variant
    Dim s As String
    If BackupType = dbmBTLog Then
        s = Trim$(Mid$(sLine, BHColPos(BH_COL_FROMPAGE), BHColLen(BH_COL_FROMPAGE)))
        If IsNumeric(s) Then
            FromPage = CLng(s)
        Else
            FromPage = ""
        End If
    Else
        FromPage = ""
    End If
End Property
Public Property Get ToPage() As Variant
    Dim s As String
    If BackupType = dbmBTLog Then
        s = Trim$(Mid$(sLine, BHColPos(BH_COL_TOPAGE), BHColLen(BH_COL_TOPAGE)))
        If IsNumeric(s) Then
            ToPage = CLng(s)
        Else
            ToPage = ""
        End If
    Else
        ToPage = ""
    End If
End Property
Public Property Get LogRequired() As String
    LogRequired = Trim$(Mid$(sLine, BHColPos(BH_COL_LOGREQUIRED), BHColLen(BH_COL_LOGREQUIRED)))
End Property
Public Property Get MediaName() As String
    MediaName = Trim$(Mid$(sLine, BHColPos(BH_COL_MEDIANAME), BHColLen(BH_COL_MEDIANAME)))
End Property
Public Property Get SizePages() As Variant
    Dim s As String
    s = Trim$(Mid$(sLine, BHColPos(BH_COL_PAGESTRANSFERED), BHColLen(BH_COL_PAGESTRANSFERED)))
    If IsNumeric(s) Then
        SizePages = CLng(s)
    Else
        SizePages = ""
    End If
End Property
Public Property Get SizeKB() As Variant
    Dim s As String
    s = Trim$(Mid$(sLine, BHColPos(BH_COL_PAGESTRANSFERED), BHColLen(BH_COL_PAGESTRANSFERED)))
    If IsNumeric(s) Then
        SizeKB = CLng(s) * (Database.PageSize \ 1024)
    Else
        SizeKB = ""
    End If
End Property

Public Property Get Volumes() As Variant
    Dim s As String
    s = Trim$(Mid$(sLine, BHColPos(BH_COL_VOLUMES), BHColLen(BH_COL_VOLUMES)))
    If IsNumeric(s) Then
        Volumes = CLng(s)
    Else
        Volumes = ""
    End If
End Property

Public Property Get Result() As String
    Dim sRC As String
    Dim sRT As String
    sRC = Trim$(Mid$(sLine, BHColPos(BH_COL_RETURNCODE), BHColLen(BH_COL_RETURNCODE)))
    sRT = Trim$(Mid$(sLine, BHColPos(BH_COL_RETURNTEXT), BHColLen(BH_COL_RETURNTEXT)))
    If sRC = "0" Then
        Result = "OK"
    Else
        Result = "Error: " + sRT + "(" + sRC + ")"
    End If
End Property

Public Property Get ReturnCode() As Long
    Dim sRC As String
    sRC = Trim$(Mid$(sLine, BHColPos(BH_COL_RETURNCODE), BHColLen(BH_COL_RETURNCODE)))
    If Len(sRC) > 0 Then
        ReturnCode = Val(sRC)
    Else
        ReturnCode = 0
    End If
End Property

Public Property Get ReturnText() As String
    ReturnText = Trim(Mid(sLine, BHColPos(BH_COL_RETURNTEXT), BHColLen(BH_COL_RETURNTEXT)))
End Property

Public Property Get Text(ByVal Index As HistoryColumnConstants) As String
    Select Case Index
        Case dbmBHCSysKey:              Text = SysKey
        Case dbmBHCLabel:               Text = Label
        Case dbmBHCAction:              Text = Action
        Case dbmBHCLastSavePoint:       Text = LastSavePoint
        Case dbmBHCFirstCommit:         Text = FirstCommit
        Case dbmBHCLastCommit:          Text = LastCommit
        Case dbmBHCStartDate:           Text = StartDate
        Case dbmBHCStopDate:            Text = StopDate
        Case dbmBHCLogPage:             Text = LogPage
        Case dbmBHCFromPage:            Text = FromPage
        Case dbmBHCToPage:              Text = ToPage
        Case dbmBHCLogRequired:         Text = LogRequired
        Case dbmBHCMediaName:           Text = MediaName
        Case dbmBHCSizeKB:              Text = Format$(SizeKB, "#,#")
        Case dbmBHCSizePages:           Text = SizePages
        Case dbmBHCVolumes:             Text = Volumes
        Case dbmBHCResult:              Text = Result
    End Select
End Property

'''

Public Property Get ActionType() As DBMBackupActionConstants
    Select Case UCase$(Left$(Action, 4))
        Case ACTION_SAVE:     ActionType = dbmBASave
        Case ACTION_RESTORE:  ActionType = dbmBARestore
        Case ACTION_HISTLOST: ActionType = dbmBAHistLost
    End Select
End Property

Public Property Get BackupType() As DBMBackupTypeConstants
    Select Case UCase$(Left$(Label, 3))
        Case LBL_DATA:  BackupType = dbmBTData
        Case LBL_PAGES: BackupType = dbmBTPages
        Case LBL_LOG:   BackupType = dbmBTLog
    End Select
End Property

'''

Public Property Get Media() As Media
    If oMedia Is Nothing Then
        Set oMedia = New Media
    End If
    Set Media = oMedia
End Property

Public Property Get ExternalIDs() As ExternalIDs
    If oExternalIDs Is Nothing Then
        Set oExternalIDs = New ExternalIDs
    End If
    Set ExternalIDs = oExternalIDs
End Property

'''

Public Property Get Key() As String
    Key = "K" + Format$(lLineNum, "00000") + SysKey + Label
End Property

Public Property Get Index() As Long
    Index = lIndex
End Property
Friend Property Let Index(ByVal NewVal As Long)
    lIndex = NewVal
End Property

'''

Public Sub CleanUp()
    Set oParent = Nothing
End Sub

'''

Private Sub Class_Initialize()
    InitObject ObjectType
End Sub
Private Sub Class_Terminate()
    TermObject ObjectType
End Sub
