VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Media"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"33F01F2800D1"
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oItems As New Collection

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTMedia
End Property

Public Property Get Count() As Long
    Count = oItems.Count
End Property

Public Property Get Item(Index As Variant) As Medium
Attribute Item.VB_UserMemId = 0
    Set Item = oItems(Index)
End Property

Public Property Get ItemByName(ByVal Name As String) As Medium
    Dim l As Long
    
    Set ItemByName = Nothing
    
    For l = 1 To oItems.Count
        If UCase$(Trim$(Name)) = UCase$(oItems(l).Name) Then
            Set ItemByName = oItems(l)
            Exit For
        End If
    Next
End Property

Public Property Get ItemByLocation(ByVal Location As String) As Medium
    Dim i As Integer
    
    Set ItemByLocation = Nothing
    
    For i = 1 To oItems.Count
        If UCase$(Trim$(Location)) = UCase$(oItems(i).Location) Then
            Set ItemByLocation = oItems(i)
            Exit For
        End If
    Next
End Property

Public Property Get ItemByNewLocation(ByVal NewLocation As String) As Medium
    Dim i As Integer
    
    Set ItemByNewLocation = Nothing
    
    For i = 1 To oItems.Count
        If UCase$(Trim$(NewLocation)) = UCase$(oItems(i).NewLocation) Then
            Set ItemByNewLocation = oItems(i)
            Exit For
        End If
    Next
End Property

Public Property Get ItemAutoLog() As Medium
    Dim i As Integer
    
    Set ItemAutoLog = Nothing
    
    For i = 1 To oItems.Count
        If oItems(i).SaveType = dbmBTAuto Then
            Set ItemAutoLog = oItems(i)
            Exit For
        End If
    Next
End Property

Public Property Get NewEnum()
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = oItems.[_NewEnum]
End Property

'''

Friend Sub Add(Medium As Medium)
    oItems.Add Medium, Medium.Key
    Medium.Index = oItems.Count
End Sub

Public Sub Remove(Index As Variant)
    Dim lStart As Long
    
    lStart = oItems(Index).Index
        
    oItems(Index).CleanUp
    oItems.Remove Index
    
    SetIndex lStart
End Sub

Public Sub Clear()
    Dim l As Long
    Dim lCount As Long
    
    lCount = oItems.Count
    
    For l = 1 To lCount
        oItems(1).CleanUp
        oItems.Remove 1
    Next
End Sub

Public Sub CleanUp()
    Clear
End Sub

Public Function Exists(Index As Variant) As Boolean
    Dim oMedium As Medium
    
    On Error Resume Next

    Set oMedium = oItems(Index)
    
    If Err.Number Then
        Exists = False
    Else
        Exists = True
    End If
End Function

'''

Private Sub Class_Initialize()
    InitObject ObjectType
End Sub
Private Sub Class_Terminate()
    TermObject ObjectType
End Sub

Private Sub SetIndex(ByVal lStart As Long)
    Dim oMedium As Medium
    Dim lCount As Long
    Dim l As Long
    
    lCount = oItems.Count
    
    For l = lStart To lCount
        Set oMedium = oItems(l)
        oMedium.Index = l
    Next
End Sub


