VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "RestoreItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Enum RestoreItemTypeConstants
    dbmRITHistory
    dbmRITMedia
    dbmRITMedium
End Enum

Private oParent As Object

Private lIndex As Long

Private bSelected As Boolean

Private lItemType As RestoreItemTypeConstants

Private oHistoryItem As HistoryItem
Private oMediaGroup As MediaGroup
Private oMedium As Medium

Private sFirstLocation As String
Private sFirstExternalID As String

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTRestoreItem
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent.Database
End Property

Public Property Get Selected() As Boolean
    Selected = bSelected
End Property
Public Property Let Selected(ByVal NewVal As Boolean)
    bSelected = NewVal
End Property

Public Property Get ItemType() As RestoreItemTypeConstants
    ItemType = lItemType
End Property
Public Property Let ItemType(ByVal NewVal As RestoreItemTypeConstants)
    lItemType = NewVal
End Property

Public Property Get HistoryItem() As HistoryItem
    Set HistoryItem = oHistoryItem
End Property
Friend Property Set HistoryItem(NewVal As HistoryItem)
    Set oHistoryItem = NewVal
End Property

Public Property Get MediaGroup() As MediaGroup
    Set MediaGroup = oMediaGroup
End Property
Friend Property Set MediaGroup(NewVal As MediaGroup)
    Set oMediaGroup = NewVal
End Property

Public Property Get Medium() As Medium
    Set Medium = oMedium
End Property
Friend Property Set Medium(NewVal As Medium)
    Set oMedium = NewVal
End Property

Public Property Get FirstLocation() As String
    FirstLocation = sFirstLocation
End Property
Friend Property Let FirstLocation(NewVal As String)
    sFirstLocation = NewVal
End Property

Public Property Get FirstExternalID() As String
    FirstExternalID = sFirstExternalID
End Property
Friend Property Let FirstExternalID(NewVal As String)
    sFirstExternalID = NewVal
End Property

Public Property Get Index() As Long
    Index = lIndex
End Property
Friend Property Let Index(ByVal NewVal As Long)
    lIndex = NewVal
End Property

'''

Public Sub CleanUp()
    Set oHistoryItem = Nothing
    Set oMediaGroup = Nothing
    Set oMedium = Nothing

    Set oParent = Nothing
End Sub

'''

Private Sub Class_Initialize()
    InitObject ObjectType

    lItemType = dbmRITHistory
    
    bSelected = False
End Sub
Private Sub Class_Terminate()
    TermObject ObjectType
End Sub

