VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Version"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private sText As String      ' a.b.c.d

Private vMajor As Variant    ' a
Private vMinor As Variant    ' b
Private vRevision As Variant ' c
Private vPatch As Variant    ' d
Private lNumber As Long
Private lNumberHi As Long
Private lNumberLo As Long

Private sBuild As String     ' nnn-nnn-nnn-nnn

Public Property Get Text() As String
Attribute Text.VB_UserMemId = 0
    Text = vMajor & "." & vMinor & "." & vRevision & "." & vPatch
End Property
Public Property Let Text(NewVal As String)
    sText = Trim$(NewVal)
    AnalyzeVersion
End Property

Public Property Get Major() As Variant
    Major = vMajor
End Property
Public Property Get Minor() As Variant
    Minor = vMinor
End Property
Public Property Get Revision() As Variant
    Revision = vRevision
End Property
Public Property Get Patch() As Variant
    Patch = vPatch
End Property

Public Property Get Number() As Long
    Number = lNumber
End Property

Public Property Get NumberHi() As Long
    NumberHi = lNumberHi
End Property

Public Property Get NumberLo() As Long
    NumberLo = lNumberLo
End Property

Public Property Get Build() As String
    Build = sBuild
End Property
Public Property Let Build(NewVal As String)
    sBuild = NewVal
    AnalyzeBuild
End Property

'''

Private Sub Class_Initialize()
    sText = ""
    
    vMajor = 0
    vMinor = 0
    vRevision = 0
    vPatch = 0
    lNumber = 0
    lNumberHi = 0
    lNumberLo = 0
    
    sBuild = ""
End Sub

'''

Private Sub AnalyzeVersion()
    Dim lPos1 As Long
    Dim lPos2 As Long
    
    vMajor = 0
    vMinor = 0
    vRevision = 0
    vPatch = 0
    
    If Len(sText) > 0 Then
        lPos1 = 1
        lPos2 = InStr(lPos1, sText, ".")
        If lPos2 > 0 Then
            vMajor = Left(sText, lPos2 - 1)
            lPos1 = lPos2 + 1
            lPos2 = InStr(lPos1, sText, ".")
            If lPos2 > 0 Then
                vMinor = Mid(sText, lPos1, lPos2 - lPos1)
                lPos1 = lPos2 + 1
                lPos2 = InStr(lPos1, sText, ".")
                If lPos2 > 0 Then
                    vRevision = Mid(sText, lPos1, lPos2 - lPos1)
                    vPatch = Mid(sText, lPos2 + 1)
                Else
                    vRevision = Mid(sText, lPos1)
                End If
            Else
                vMinor = Mid(sText, lPos1)
            End If
        Else
            vMajor = sText
        End If
    End If
    
    Dim lMajor As Long
    Dim lMinor As Long
    Dim lRevision As Long
    
    lMajor = 0
    lMinor = 0
    lRevision = 0
    
    If IsNumeric(vMajor) Then
        lMajor = CLng(vMajor)
        If lMajor < CLng(0) Then lMajor = CLng(0)
        If lMajor > CLng(&H7F) Then lMajor = CLng(&H7F)
    End If
    If IsNumeric(vMinor) Then
        lMinor = CLng(vMinor)
        If lMinor < CLng(0) Then lMinor = CLng(0)
        If lMinor >= CLng(&H100) Then lMinor = CLng(&HFF)
    End If
    If IsNumeric(vRevision) Then
        lRevision = CLng(vRevision)
        If lRevision < CLng(0) Then lRevision = CLng(0)
        If lRevision >= CLng(&H10000) Then lRevision = CLng(&HFFFF)
    End If

    lNumber = lMajor * &H1000000 + lMinor * &H10000 + lRevision
    lNumberHi = lMajor * &H1000000 + lMinor * &H10000
    lNumberLo = lRevision
End Sub

Private Sub AnalyzeBuild()
    Dim vBuildPatch As Variant
    Dim lBuildPatch As Long
    Dim lPatch As Long
    
    vBuildPatch = 0
    
    If Len(sBuild) > 0 Then
        vBuildPatch = Left(sBuild, 3)
    End If
    
    If IsNumeric(vBuildPatch) And IsNumeric(vPatch) Then
        lBuildPatch = CLng(vBuildPatch)
        lPatch = CLng(vPatch)
        If lBuildPatch > lPatch Then
            vPatch = CStr(lBuildPatch)
        End If
    Else
        If vBuildPatch > vPatch Then
            vPatch = vBuildPatch
        End If
    End If
End Sub
