VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Panel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oSplitterBox As SplitterBox

Private sKey As String
Private iIndex As Integer

Private bIsSplitted As Boolean

Private oPanel1 As Panel
Private oPanel2 As Panel

Private iControl As Integer
Private sControl As String

Private lSplitType As SplitTypeConstants
Private iSplitSize As Integer
Private oSplitBar As Object

Private sPercent As Single

Private iLeft As Integer
Private iTop As Integer
Private iWidth As Integer
Private iHeight As Integer

Private bHidden As Boolean

Private bCaptionShow As Boolean
Private sCaptionText As String
Private oCaptionPicture As StdPicture

Private iMinWidth As Integer
Private iMinHeight As Integer

Private iMinSizeX As Integer
Private iMinSizeY As Integer

Friend Property Set SplitterBox(ByVal NewValue As SplitterBox)
    Set oSplitterBox = NewValue
End Property

Public Property Get Key() As String
    Key = sKey
End Property
Friend Property Let Key(ByVal NewValue As String)
    sKey = NewValue
End Property

Public Property Get Index() As Integer
    Index = iIndex
End Property
Friend Property Let Index(ByVal NewValue As Integer)
    iIndex = NewValue
End Property

Public Property Get IsSplitted() As Boolean
    IsSplitted = bIsSplitted
End Property
Friend Property Let IsSplitted(ByVal NewValue As Boolean)
    bIsSplitted = NewValue
End Property

Public Property Get Panel1() As Panel
    Set Panel1 = oPanel1
End Property
Friend Property Set Panel1(ByVal NewValue As Panel)
    Set oPanel1 = NewValue
End Property

Public Property Get Panel2() As Panel
    Set Panel2 = oPanel2
End Property
Friend Property Set Panel2(ByVal NewValue As Panel)
    Set oPanel2 = NewValue
End Property

Public Property Get ControlName() As String
    ControlName = sControl
End Property
Public Property Let ControlName(NewValue As String)
    sControl = NewValue
    If Len(sControl) > 0 Then
        iControl = oSplitterBox.ControlIndex(sControl)
        If iControl >= 0 Then
            GetMinSize iControl, iMinWidth, iMinHeight
        End If
    Else
        iControl = -1
    End If
End Property

Public Property Get SplitType() As SplitTypeConstants
    SplitType = lSplitType
End Property

Friend Property Let SplitSize(ByVal NewVal As Integer)
    iSplitSize = NewVal
End Property

Friend Property Set SplitBar(ByVal NewValue As Object)
    Set oSplitBar = NewValue
End Property

Public Property Get Percent() As Single
    Percent = sPercent
End Property
Public Property Let Percent(ByVal NewValue As Single)
    sPercent = NewValue
End Property

Public Property Get Left() As Integer
    Left = iLeft
End Property
Friend Property Let Left(ByVal NewValue As Integer)
    iLeft = NewValue
End Property

Public Property Get Top() As Integer
    Top = iTop
End Property
Friend Property Let Top(ByVal NewValue As Integer)
    iTop = NewValue
End Property

Public Property Get Width() As Integer
    Width = iWidth
End Property
Friend Property Let Width(ByVal NewValue As Integer)
    iWidth = NewValue
End Property

Public Property Get Height() As Integer
    Height = iHeight
End Property
Friend Property Let Height(ByVal NewValue As Integer)
    iHeight = NewValue
End Property

Public Property Get Hidden() As Boolean
    Hidden = bHidden
End Property
Public Property Let Hidden(ByVal NewValue As Boolean)
    bHidden = NewValue
    If IsSplitted Then
        oPanel1.Hidden = NewValue
        oPanel2.Hidden = NewValue
    End If
End Property

Public Property Get CaptionShow() As Boolean
    CaptionShow = bCaptionShow
End Property
Public Property Let CaptionShow(ByVal NewValue As Boolean)
    bCaptionShow = NewValue
End Property

Public Property Get CaptionText() As String
    CaptionText = sCaptionText
End Property
Public Property Let CaptionText(ByVal NewValue As String)
    sCaptionText = NewValue
    oSplitterBox.DrawCaption Me
End Property

Public Property Get CaptionPicture() As StdPicture
    Set CaptionPicture = oCaptionPicture
End Property
Public Property Set CaptionPicture(ByVal NewValue As StdPicture)
    Set oCaptionPicture = NewValue
End Property

Friend Property Get CaptionHeight() As Integer
    If bCaptionShow Then
        CaptionHeight = 18 * Screen.TwipsPerPixelY
    Else
        CaptionHeight = 0
    End If
End Property

'''

Public Sub Split(ControlName1 As String, _
                 ControlName2 As String, _
                 ByVal Percent1 As Single, _
                 ByVal Percent2 As Single, _
                 Optional ByVal PanelKey1 As String, _
                 Optional ByVal PanelKey2 As String, _
                 Optional ByVal SplitType As SplitTypeConstants, _
                 Optional ByVal SplitSize As Integer = 4, _
                 Optional ByVal MinSize As Integer = 0)
                 
    If Percent1 < 0# Then Percent1 = 0#
    If Percent1 > 100# Then Percent1 = 100#
    Percent2 = 100# - Percent1
    
    iMinSizeX = MinSize * Screen.TwipsPerPixelX
    iMinSizeY = MinSize * Screen.TwipsPerPixelY
    
    Select Case SplitType
        Case spbSplitTypeHorizontaly: iSplitSize = SplitSize * Screen.TwipsPerPixelY
        Case spbSplitTypeVerticaly:   iSplitSize = SplitSize * Screen.TwipsPerPixelX
    End Select
      
    Set oPanel1 = New Panel
        
    With oPanel1
        Set .SplitterBox = oSplitterBox
        .ControlName = ControlName1
        .Key = PanelKey1
    End With
        
    Set oPanel2 = New Panel
       
    With oPanel2
        Set .SplitterBox = oSplitterBox
        .ControlName = ControlName2
        .Key = PanelKey2
    End With
    
    oPanel1.Percent = Percent1
    oPanel2.Percent = Percent2
    
    lSplitType = SplitType
        
    With oSplitterBox
        .Panels.Add oPanel1, PanelKey1
        .Panels.Add oPanel2, PanelKey2
    End With
        
    '''
    
    Set oSplitBar = oSplitterBox.GetSplitBar(SplitType)
    With oSplitBar
        .Tag = Key
    End With
        
    '''
    
    bIsSplitted = True
    
    sControl = ""
    iControl = -1
End Sub

'''

Friend Sub Resize(ByVal iL As Integer, _
                  ByVal iT As Integer, _
                  ByVal iW As Integer, _
                  ByVal iH As Integer)
    Dim oControl As Object
    
    Dim sSize As Single
    Dim sSize1 As Single
    Dim sSize2 As Single
    Dim iSplit As Integer
                  
    iLeft = iL
    iTop = iT
    iWidth = iW
    iHeight = iH
                  
    If iWidth < 0 Then iWidth = 0
    If iHeight < 0 Then iHeight = 0
                  
    If IsSplitted Then
        Select Case lSplitType
        
            Case spbSplitTypeHorizontaly:
            
                sSize = CSng(iHeight)
                
                If oPanel1.Hidden Then
                    If oPanel2.Hidden Then
                        sSize1 = 0#
                        sSize2 = 0#
                        iSplit = 0
                    Else
                        sSize1 = 0#
                        sSize2 = sSize
                        iSplit = 0
                    End If
                Else
                    If oPanel2.Hidden Then
                        sSize1 = sSize
                        sSize2 = 0#
                        iSplit = 0
                    Else
                        sSize1 = sSize * (oPanel1.Percent / 100#)
                        If sSize1 < CSng(iMinSizeY) Then sSize1 = CSng(iMinSizeY)
                        sSize2 = sSize - sSize1
                        If sSize2 < CSng(iMinSizeY) Then sSize2 = CSng(iMinSizeY)
                        iSplit = iSplitSize
                    End If
                End If
                
                If sSize1 <= 0# Then sSize1 = 0#
                If sSize2 <= 0# Then sSize2 = 0#
                
                oPanel1.Resize iLeft, iTop, iWidth, CInt(sSize1)
                oSplitBar.Move iLeft, iTop + CInt(sSize1), iWidth, iSplit
                oPanel2.Resize iLeft, iTop + CInt(sSize1) + iSplit, iWidth, CInt(sSize2) - iSplit
                
            Case spbSplitTypeVerticaly:
            
                sSize = CSng(iWidth)
                
                If oPanel1.Hidden Then
                    If oPanel2.Hidden Then
                        sSize1 = 0#
                        sSize2 = 0#
                        iSplit = 0
                    Else
                        sSize1 = 0#
                        sSize2 = sSize
                        iSplit = 0
                    End If
                Else
                    If oPanel2.Hidden Then
                        sSize1 = sSize
                        sSize2 = 0#
                        iSplit = 0
                    Else
                        sSize1 = sSize * (oPanel1.Percent / 100#)
                        If sSize1 < CSng(iMinSizeX) Then sSize1 = CSng(iMinSizeX)
                        sSize2 = sSize - sSize1
                        If sSize2 < CSng(iMinSizeX) Then sSize2 = CSng(iMinSizeX)
                        iSplit = iSplitSize
                    End If
                End If
                
                If sSize1 <= 0# Then sSize1 = 0#
                If sSize2 <= 0# Then sSize2 = 0#
                
                oPanel1.Resize iLeft, iTop, CInt(sSize1), iHeight
                oSplitBar.Move iLeft + CInt(sSize1), iTop, iSplit, iHeight
                oPanel2.Resize iLeft + CInt(sSize1) + iSplit, iTop, CInt(sSize2) - iSplit, iHeight
        End Select
    Else
        If bCaptionShow Then
            oSplitterBox.DrawCaption Me
        End If
        
        If iControl >= 0 Then
            Set oControl = oSplitterBox.Control(iControl)
            If (iHeight - CaptionHeight) <= iMinHeight Or iWidth <= iMinWidth Or bHidden Then
                oControl.Visible = False
            Else
                oControl.Move iLeft, iTop + CaptionHeight, iWidth, iHeight - CaptionHeight
                oControl.Visible = True
            End If
        End If
    End If
End Sub

Friend Sub SetPos(ByVal iPos As Integer)
    Dim iSize As Integer
    Dim iSize1 As Integer
    Dim iSize2 As Integer
    
    If IsSplitted Then
        Select Case lSplitType
        
            Case spbSplitTypeHorizontaly:
                If iPos < iTop Then
                    iPos = iTop
                End If
                If iPos > iTop + iHeight - iSplitSize Then
                    iPos = iTop + iHeight - iSplitSize
                End If
            
                iSize1 = iPos - oPanel1.Top
                If iSize1 < iMinSizeY Then iSize1 = iMinSizeY
                iSize2 = iHeight - iSize1
                If iSize2 < iMinSizeY Then
                    iSize2 = iMinSizeY
                    iSize1 = iHeight - iSize2
                    If iSize1 < iMinSizeY Then iSize1 = iMinSizeY
                End If
            
                oPanel1.Percent = CSng(iSize1) * 100# / iHeight
                oPanel2.Percent = CSng(iSize2) * 100# / iHeight
            
                oPanel1.Resize iLeft, iTop, iWidth, iSize1
                oSplitBar.Move iLeft, iTop + iSize1, iWidth, iSplitSize
                oPanel2.Resize iLeft, iTop + iSize1 + iSplitSize, iWidth, iSize2 - iSplitSize
            
            Case spbSplitTypeVerticaly:
                If iPos < iLeft Then
                    iPos = iLeft
                End If
                If iPos > iLeft + iWidth - iSplitSize Then
                    iPos = iLeft + iWidth - iSplitSize
                End If
                
                iSize1 = iPos - oPanel1.Left
                If iSize1 < iMinSizeX Then iSize1 = iMinSizeX
                iSize2 = iWidth - iSize1
                If iSize2 < iMinSizeX Then
                    iSize2 = iMinSizeX
                    iSize1 = iWidth - iSize2
                    If iSize1 < iMinSizeX Then iSize1 = iMinSizeX
                End If
            
                oPanel1.Percent = CSng(iSize1) * 100# / iWidth
                oPanel2.Percent = CSng(iSize2) * 100# / iWidth
            
                oPanel1.Resize iLeft, iTop, iSize1, iHeight
                oSplitBar.Move iLeft + iSize1, iTop, iSplitSize, iHeight
                oPanel2.Resize iLeft + iSize1 + iSplitSize, iTop, iSize2 - iSplitSize, iHeight
            
        End Select
    End If
End Sub

'''

Private Sub Class_Initialize()
    Set oSplitterBox = Nothing
    
    bIsSplitted = False
    
    Set oPanel1 = Nothing
    Set oPanel2 = Nothing
    
    sControl = ""
    iControl = -1
    
    Set oSplitBar = Nothing
    
    bHidden = False
    
    bCaptionShow = False
    sCaptionText = ""
    Set oCaptionPicture = Nothing
End Sub

Private Sub GetMinSize(ByVal iControl As Integer, iMinWidth As Integer, iMinHeight As Integer)
    Dim oControl As Object
    
    Set oControl = oSplitterBox.Control(iControl)
    
    With oControl
        .Width = 0
        .Height = 0
        iMinWidth = .Width
        iMinHeight = .Height
    End With
End Sub
