VERSION 5.00
Begin VB.UserControl SplitterBox 
   Alignable       =   -1  'True
   AutoRedraw      =   -1  'True
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ControlContainer=   -1  'True
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.PictureBox picSplitter 
      BackColor       =   &H80000010&
      BorderStyle     =   0  'None
      Height          =   555
      Left            =   840
      ScaleHeight     =   555
      ScaleWidth      =   555
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   1380
      Visible         =   0   'False
      Width           =   555
   End
   Begin VB.Image imgSplitter 
      Height          =   495
      Index           =   0
      Left            =   840
      MousePointer    =   99  'Custom
      Top             =   480
      Width           =   615
   End
End
Attribute VB_Name = "SplitterBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const IDC_HSPLIT = 101
Const IDC_VSPLIT = 102

Public Enum SplitTypeConstants
    spbSplitTypeHorizontaly
    spbSplitTypeVerticaly
End Enum

Private bIsSplitted As Boolean

Private oPanels As New Panels

Private iSplitBars As Integer

Private bSplit As Boolean
Private xSplit As Single
Private ySplit As Single
Private oSplit As Panel

Private iTPPX As Integer
Private iTPPY As Integer

'''

Public Property Get hWnd() As Long
    hWnd = UserControl.hWnd
End Property

Public Property Get Panels() As Panels
    Set Panels = oPanels
End Property

Public Property Let PercentString(NewVal As String)
    Dim sPercent As String
    Dim sValue As String
    Dim lPanel As Long
    
    sPercent = Trim$(NewVal)
    
    If Len(sPercent) = 0 Then Exit Property
    
    For lPanel = 1 To oPanels.Count
        If (3 * (lPanel - 1) + 1) < Len(sPercent) Then
            sValue = Mid$(sPercent, 3 * (lPanel - 1) + 1, 3)
            If IsNumeric(sValue) Then
                oPanels(lPanel).Percent = CSng(sValue)
            Else
                Exit For
            End If
        Else
            Exit For
        End If
    Next
End Property

Public Property Get PercentString() As String
    Dim sPercent As String
    Dim oPanel As Panel
    
    sPercent = ""
    
    For Each oPanel In oPanels
        sPercent = sPercent + Format$(CLng(oPanel.Percent), "000")
    Next
    
    PercentString = sPercent
End Property

Public Property Let HiddenString(NewVal As String)
    Dim sHidden As String
    Dim sValue As String
    Dim lPanel As Long
    
    sHidden = Trim$(NewVal)
    
    If Len(sHidden) = 0 Then Exit Property
    
    For lPanel = 1 To oPanels.Count
        If lPanel < Len(sHidden) Then
            sValue = Mid$(sHidden, lPanel, 1)
            Select Case sHidden
                Case "0": oPanels(lPanel).Hidden = False
                Case "1": oPanels(lPanel).Hidden = True
            End Select
        End If
    Next
End Property

Public Property Get HiddenString() As String
    Dim sHidden As String
    Dim oPanel As Panel
    
    sHidden = ""
    
    For Each oPanel In oPanels
        Select Case oPanel.Hidden
            Case False: sHidden = sHidden + "0"
            Case True: sHidden = sHidden + "1"
        End Select
    Next
    
    HiddenString = sHidden
End Property

'''

Friend Property Get ControlIndex(Name As String) As Integer
    Dim iCtl As Integer
    
    ControlIndex = -1
    
    For iCtl = 0 To UserControl.ContainedControls.Count - 1
        If UserControl.ContainedControls(iCtl).Name = Name Then
            ControlIndex = iCtl
            Exit Property
        End If
    Next
End Property

Friend Property Get Control(ByVal Index As Integer) As Object
    Set Control = UserControl.ContainedControls(Index)
End Property

'''

Public Sub Split(ControlName1 As String, _
                 ControlName2 As String, _
                 ByVal Percent1 As Single, _
                 ByVal Percent2 As Single, _
                 Optional ByVal PanelKey1 As String, _
                 Optional ByVal PanelKey2 As String, _
                 Optional ByVal SplitType As SplitTypeConstants, _
                 Optional ByVal SplitSize As Integer = 4, _
                 Optional ByVal MinSize As Integer = 0)
                 
    Dim oPanel As New Panel
    
    With oPanel
        Set .SplitterBox = Me
        .Key = "ROOT"
        
        .Percent = 100#
    End With
    
    oPanels.Add oPanel, oPanel.Key
    
    oPanel.Split ControlName1, ControlName2, Percent1, Percent2, PanelKey1, PanelKey2, SplitType, SplitSize, MinSize
    
    bIsSplitted = True
End Sub
    
Public Sub Refresh()
    If bIsSplitted Then
        oPanels(1).Resize 0, 0, ScaleWidth, ScaleHeight
    End If
End Sub


Public Sub UnSplit()
    Dim oPanel As Panel
    Dim i As Integer

    For Each oPanel In oPanels
        With oPanel
            Set .SplitterBox = Nothing
            Set .Panel1 = Nothing
            Set .Panel2 = Nothing
            
            .ControlName = ""
            
            Set .SplitBar = Nothing
            Set .CaptionPicture = Nothing
        End With
    Next

    oPanels.Clear
    
    imgSplitter(0).MousePointer = vbDefault

    For i = 1 To iSplitBars - 1
        Unload imgSplitter(i)
    Next

    bIsSplitted = False
    iSplitBars = 0
    bSplit = False
End Sub

'''

Friend Function GetSplitBar(ByVal lSplitType As SplitTypeConstants) As Object
    Dim iIndex As Integer
    
    If iSplitBars = 0 Then
        iIndex = iSplitBars
        iSplitBars = 1
    Else
        iIndex = iSplitBars
        Load imgSplitter(iIndex)
        imgSplitter(iIndex).Visible = True
        iSplitBars = iSplitBars + 1
    End If
    
    Select Case lSplitType
        Case spbSplitTypeHorizontaly:
            imgSplitter(iIndex).MousePointer = vbCustom
            imgSplitter(iIndex).MouseIcon = LoadResPicture(IDC_HSPLIT, vbResCursor)
            
        Case spbSplitTypeVerticaly:
            imgSplitter(iIndex).MousePointer = vbCustom
            imgSplitter(iIndex).MouseIcon = LoadResPicture(IDC_VSPLIT, vbResCursor)
            
    End Select
    
    Set GetSplitBar = imgSplitter(iIndex)
End Function

'''

Private Sub imgSplitter_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not bIsSplitted Then Exit Sub
    
    bSplit = True

    xSplit = X
    ySplit = Y

    Set oSplit = oPanels(imgSplitter(Index).Tag)

    With imgSplitter(Index)
        picSplitter.Move .Left, .Top, .Width, .Height
    End With

    picSplitter.ZOrder 0
    picSplitter.Visible = True
End Sub

Private Sub imgSplitter_MouseMove(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim iPos As Integer
    
    If Not bSplit Then Exit Sub

    Select Case oSplit.SplitType
        Case spbSplitTypeHorizontaly:
            iPos = Y + imgSplitter(Index).Top - ySplit
            picSplitter.Top = iPos
        Case spbSplitTypeVerticaly:
            iPos = X + imgSplitter(Index).Left - xSplit
            picSplitter.Left = iPos
    End Select
End Sub

Private Sub imgSplitter_MouseUp(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim iPos As Integer

    If Not bSplit Then Exit Sub

    Select Case oSplit.SplitType
        Case spbSplitTypeHorizontaly:
            iPos = Y + imgSplitter(Index).Top - ySplit
        Case spbSplitTypeVerticaly:
            iPos = X + imgSplitter(Index).Left - xSplit
    End Select

    oSplit.SetPos iPos

    picSplitter.Visible = False
    bSplit = False
End Sub

'''

Private Sub UserControl_Initialize()
    bIsSplitted = False
    
    iSplitBars = 0
    
    bSplit = False
    
    iTPPX = Screen.TwipsPerPixelX
    iTPPY = Screen.TwipsPerPixelY
End Sub

Private Sub UserControl_Resize()
    If bIsSplitted Then
        oPanels(1).Resize 0, 0, ScaleWidth, ScaleHeight
    End If
End Sub

'''

Friend Function GetTextHeight() As Integer
    GetTextHeight = TextHeight("A")
End Function

Friend Sub DrawCaption(ByVal oPanel As Panel)
    Dim iTextHeight As Integer
    Dim iLeft As Integer
    Dim iTop As Integer
    
    Dim r As RECT
    
    UserControl.Cls
        
    With oPanel
    
        If .Width >= (4 * iTPPY) Then
            UserControl.Line (.Left, .Top + .CaptionHeight)-(.Left, .Top), vb3DShadow
            UserControl.Line -(.Left + .Width - iTPPX, .Top), vb3DShadow
            UserControl.Line -(.Left + .Width - iTPPX, .Top + .CaptionHeight), vb3DHighlight
            UserControl.Line (.Left + iTPPX, .Top + .CaptionHeight)-(.Left + iTPPX, .Top + iTPPY), vb3DHighlight
            UserControl.Line -(.Left + .Width - 2 * iTPPX, .Top + iTPPY), vb3DHighlight
            UserControl.Line -(.Left + .Width - 2 * iTPPX, .Top + .CaptionHeight), vb3DShadow
        End If
        
        If .Width >= (20 * iTPPY) Then
            iLeft = .Left + 2 * iTPPX
            iTop = .Top + 2 * iTPPY
            
            If Not .CaptionPicture Is Nothing Then
                UserControl.PaintPicture .CaptionPicture, iLeft, iTop
                iLeft = iLeft + 20 * iTPPX
            End If
            
            r.Left = ScaleX(iLeft, UserControl.ScaleMode, vbPixels)
            r.Top = ScaleY(iTop, UserControl.ScaleMode, vbPixels)
            r.Right = ScaleX(.Left, UserControl.ScaleMode, vbPixels) + ScaleX(.Width, UserControl.ScaleMode, vbPixels) - 4
            r.Bottom = r.Top + 16
        
            DrawText UserControl.hdc, .CaptionText, Len(.CaptionText), r, DT_LEFT + DT_SINGLELINE + DT_NOPREFIX + DT_VCENTER + DT_WORD_ELLIPSIS
        End If
    End With
End Sub


    

