VERSION 5.00
Begin VB.UserControl ctlDrawText 
   AutoRedraw      =   -1  'True
   CanGetFocus     =   0   'False
   ClientHeight    =   2535
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3945
   ScaleHeight     =   169
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   263
End
Attribute VB_Name = "ctlDrawText"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

'''

Private Declare Function DrawText Lib "User32.dll" Alias "DrawTextA" ( _
    ByVal hdc As Long, _
    ByVal lpStr As String, _
    ByVal nCount As Long, _
    lpRect As RECT, _
    ByVal wFormat As Long) As Long

Const DT_LEFT = &H0
Const DT_TOP = &H0
Const DT_CENTER = &H1
Const DT_RIGHT = &H2
Const DT_VCENTER = &H4
Const DT_BOTTOM = &H8
Const DT_WORDBREAK = &H10
Const DT_SINGLELINE = &H20
Const DT_EXPANDTABS = &H40
Const DT_TABSTOP = &H80
Const DT_NOCLIP = &H100
Const DT_EXTERNALLEADING = &H200
Const DT_CALCRECT = &H400
Const DT_NOPREFIX = &H800
Const DT_INTERNAL = &H1000
Const DT_EDITCONTROL = &H2000
Const DT_PATH_ELLIPSIS = &H4000
Const DT_END_ELLIPSIS = &H8000
Const DT_MODIFYSTRING = &H10000
Const DT_RTLREADING = &H20000
Const DT_WORD_ELLIPSIS = &H40000

'''

Private sCaption As String
Private lBackColor As OLE_COLOR
Private lForeColor As OLE_COLOR

'''

Public Property Get Caption() As String
    Caption = sCaption
End Property
Public Property Let Caption(NewVal As String)
    sCaption = NewVal
    PropertyChanged "Caption"
    DrawCaption
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = lBackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    lBackColor = NewVal
    PropertyChanged "BackColor"
    UserControl.BackColor = lBackColor
    DrawCaption
End Property

Public Property Get ForeColor() As OLE_COLOR
    ForeColor = lForeColor
End Property
Public Property Let ForeColor(ByVal NewVal As OLE_COLOR)
    lForeColor = NewVal
    PropertyChanged "ForeColor"
    UserControl.ForeColor = lForeColor
    DrawCaption
End Property

'''

Private Sub UserControl_Initialize()
    sCaption = ""
    lBackColor = vb3DFace
    lForeColor = vbWindowText
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    Caption = PropBag.ReadProperty("Caption", "")
    BackColor = PropBag.ReadProperty("BackColor", vb3DFace)
    ForeColor = PropBag.ReadProperty("ForeColor", vbWindowText)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "Caption", Caption, ""
    PropBag.WriteProperty "BackColor", BackColor, vb3DFace
    PropBag.WriteProperty "ForeColor", ForeColor, vbWindowText
End Sub

Private Sub UserControl_Resize()
    DrawCaption
End Sub

'''

Private Sub DrawCaption()
    Dim r As RECT
    
    With r
        .Left = 0
        .Top = 0
        .Right = ScaleWidth
        .Bottom = ScaleHeight
    End With
    
    UserControl.Cls
    
    DrawText UserControl.hdc, sCaption, Len(sCaption), r, DT_WORDBREAK + DT_NOPREFIX + DT_CENTER + DT_CALCRECT
    
    r.Right = ScaleWidth
    
    If r.Bottom < ScaleHeight Then
        r.Top = r.Top + ((ScaleHeight - r.Bottom) \ 2)
        r.Bottom = r.Bottom + ((ScaleHeight - r.Bottom) \ 2)
    End If
    
    DrawText UserControl.hdc, sCaption, Len(sCaption), r, DT_WORDBREAK + DT_NOPREFIX + DT_CENTER
End Sub




