Attribute VB_Name = "OnError"
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const VBEXT_MT_METHOD = 1
Const VBEXT_MT_PROPERTY = 2

Const VBEXT_PK_PROC = 0
Const VBEXT_PK_LET = 1
Const VBEXT_PK_SET = 2
Const VBEXT_PK_GET = 3

Const MT_METHOD = "Method"
Const MT_PROPERTY = "Property"

Const PK_LET = "Let"
Const PK_SET = "Set"
Const PK_GET = "Get"

Public Sub Error(Number As Long, _
                 Description As String, _
                 Name As String, _
                 MemberType As Integer, ProcKind As Integer)
                 
    Dim s As String
    
    s = "Internal Error in "
    Select Case MemberType
                    
        Case VBEXT_MT_METHOD:
            s = s + MT_METHOD + " "
            
        Case VBEXT_MT_PROPERTY:
            s = s + MT_PROPERTY + " "
            Select Case ProcKind
                Case VBEXT_PK_LET: s = s + PK_LET + " "
                Case VBEXT_PK_SET: s = s + PK_SET + " "
                Case VBEXT_PK_GET: s = s + PK_GET + " "
            End Select
            
    End Select
    
    s = s + "'" + Name + "'!" + vbCrLf + vbCrLf
    s = s + "Error " + CStr(Number) + ": " + Description

    MsgBox s, vbExclamation, App.Title
End Sub
