VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ASObject"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Class:      AutoSuppose
'
'-----------------------------------------------------------------------
'
' responsible:  WolfgangA
'
' special area: ASObjects
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
' Module Name
'--------------------------------------------------------
Const MODULE_NAME = "AutoSupposeObjects"

' Enumarations
Public Enum SupposeType
    asTypeSQL = 0
    asTypeStatement = 1
    asTypeInfo = 2
    asTypeUser = 3
End Enum

Private pSupposeTypeSQL         As Boolean
Private pSupposeTypeStatement   As Boolean
Private pSupposeTypeInfo        As Boolean
Private pSupposeTypeUser        As Boolean
Private pSQLSupposeList         As New Collection
Private pStatementSupposeList   As New Collection
Private pInfoSupposeList        As New Collection
Private pUserSupposeList        As New Collection

Private m_sAllSingleKeyWords    As String

Public Property Let supposeTypeSQL(ByVal NewSupposeTypeSQL As Boolean)
    On Error GoTo errP_Let_SupposeTypeSQL

    Const FUNCTION_NAME = "P_Let supposeTypeSQL"

    pSupposeTypeSQL = NewSupposeTypeSQL

    Exit Property

errP_Let_SupposeTypeSQL:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get supposeTypeSQL() As Boolean
    On Error GoTo errP_Get_SupposeTypeSQL

    Const FUNCTION_NAME = "P_Get supposeTypeSQL"

    supposeTypeSQL = pSupposeTypeSQL

    Exit Property

errP_Get_SupposeTypeSQL:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Let supposeTypeInfo(NewSupposeTypeInfo As Boolean)
    On Error GoTo errP_Let_SupposeTypeInfo

    Const FUNCTION_NAME = "P_Let supposeTypeInfo"

    pSupposeTypeInfo = NewSupposeTypeInfo

    Exit Property

errP_Let_SupposeTypeInfo:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get supposeTypeInfo() As Boolean
    On Error GoTo errP_Get_SupposeTypeInfo

    Const FUNCTION_NAME = "P_Get supposeTypeInfo"

    supposeTypeInfo = pSupposeTypeInfo

    Exit Property

errP_Get_SupposeTypeInfo:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Let supposeTypeStatement(NewSupposeTypeStatement As Boolean)
    On Error GoTo errP_Let_SupposeTypeStatement

    Const FUNCTION_NAME = "P_Let supposeTypeStatement"

    pSupposeTypeStatement = NewSupposeTypeStatement

    Exit Property

errP_Let_SupposeTypeStatement:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get supposeTypeStatement() As Boolean
    On Error GoTo errP_Get_SupposeTypeStatement

    Const FUNCTION_NAME = "P_Get supposeTypeStatement"

    supposeTypeStatement = pSupposeTypeStatement

    Exit Property

errP_Get_SupposeTypeStatement:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Let supposeTypeUser(NewSupposeTypeUser As Boolean)
    On Error GoTo errP_Let_SupposeTypeUser

    Const FUNCTION_NAME = "P_Let supposeTypeUser"

    pSupposeTypeUser = NewSupposeTypeUser

    Exit Property

errP_Let_SupposeTypeUser:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get supposeTypeUser() As Boolean
    On Error GoTo errP_Get_SupposeTypeUser

    Const FUNCTION_NAME = "P_Get supposeTypeUser"

    supposeTypeUser = pSupposeTypeUser

    Exit Property

errP_Get_SupposeTypeUser:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get sqlSupposeList() As Collection
    On Error GoTo errP_Get_SQLSupposeList

    Const FUNCTION_NAME = "P_Get sqlSupposeList"

    Set sqlSupposeList = pSQLSupposeList

    Exit Property

errP_Get_SQLSupposeList:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get statementSupposeList() As Collection
    On Error GoTo errP_Get_StatementSupposeList

    Const FUNCTION_NAME = "P_Get statementSupposeList"

    Set statementSupposeList = pStatementSupposeList

    Exit Property

errP_Get_StatementSupposeList:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get infoSupposeList() As Collection
    On Error GoTo errP_Get_InfoSupposeList

    Const FUNCTION_NAME = "P_Get infoSupposeList"

    Set infoSupposeList = pInfoSupposeList

    Exit Property

errP_Get_InfoSupposeList:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get userSupposeList() As Collection
    On Error GoTo errP_Get_UserSupposeList

    Const FUNCTION_NAME = "P_Get userSupposeList"

    Set userSupposeList = pUserSupposeList

    Exit Property

errP_Get_UserSupposeList:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Function loadSupposeLists(oDBConnection As SQLStudioDBLayer.Connection) As Boolean
    On Error GoTo errLoadSupposeLists

    Const FUNCTION_NAME = "LoadSupposeLists"

    'Some Kind of Transaction if Load... fails
    Dim NewSQLSupposeList       As New Collection
    Dim NewStatementSupposeList As New Collection
    Dim NewInfoSupposeList      As New Collection
    Dim NewUserSupposeList      As New Collection

    ' Inits
    loadSupposeLists = False
    
    m_sAllSingleKeyWords = ""

    If pSupposeTypeSQL Then
        If Not loadSupposeList(oDBConnection, NewSQLSupposeList, asTypeSQL) Then
            Exit Function
        End If
    End If

    If pSupposeTypeStatement Then
        If Not loadSupposeList(oDBConnection, NewStatementSupposeList, asTypeStatement) Then
            Exit Function
        End If
    End If

    If pSupposeTypeInfo Then
        If Not loadSupposeList(oDBConnection, NewInfoSupposeList, asTypeInfo) Then
            Exit Function
        End If
    End If

    If pSupposeTypeUser Then
        If Not loadSupposeList(oDBConnection, NewUserSupposeList, asTypeUser) Then
            Exit Function
        End If
    End If

    ' Set new lists
    Set pSQLSupposeList = NewSQLSupposeList
    Set pStatementSupposeList = NewStatementSupposeList
    Set pInfoSupposeList = NewInfoSupposeList
    Set pUserSupposeList = NewUserSupposeList

    ' Set rc
    loadSupposeLists = True

    Exit Function

errLoadSupposeLists:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Private Function loadSupposeList(ByVal DBConnection As SQLStudioDBLayer.Connection, ByVal SupposeList As Collection, ByVal SupposeType As SupposeType) As Boolean
    On Error GoTo errLoadSupposeList

    Const FUNCTION_NAME = "LoadSupposeList"

    Dim DBResult        As New SQLStudioDBLayer.result
    Dim Statement       As String
    Dim sValue          As String
    Dim lRet            As Long
    
    ' Inits
    loadSupposeList = False
    

    If DBConnection Is Nothing Then
    
        Exit Function
    Else
        Set DBResult.Connection = DBConnection
    End If

    Select Case SupposeType
        Case asTypeSQL, asTypeStatement, asTypeInfo:
            Statement = "SELECT SUPPOSE FROM SYSDBA.SYS_MYAUTOSUPPOSE WHERE TYPE = " + Trim$(Str$(SupposeType))
        Case asTypeUser:
            Statement = "SELECT SUPPOSE FROM SYSDBA.SYS_MYAUTOSUPPOSE WHERE TYPE = " + Trim$(Str$(SupposeType)) + " AND (OWNER = 'PUBLIC' OR OWNER = '" + m_oComFunc.ConvertStringForCharCol(DBConnection.UserGroup, True) + "')"
    End Select

    If Not DBResult.OpenResult(Statement, Internal) Then Exit Function
    If Not DBResult.Fetch() Then Exit Function

    While Not DBResult.NoRows
    
        If Not DBResult.GetData() Then Exit Function

        If Not DBResult.columns.item(1).ColIsNull And Len(DBResult.columns.item(1).ColValue) <> 0 Then
        
            sValue = DBResult.columns.item(1).ColValue
            SupposeList.add sValue
            
            addSingleKeyWord sValue
            
        End If

        If Not DBResult.Fetch() Then Exit Function
    Wend

    
    'rc
    loadSupposeList = True

    Exit Function

errLoadSupposeList:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      AddUserSuppose
'    description:   saves a new suppose value in database
'    arguments:     [in] DBConnection, database connection object pointer
'                   [in] NewUserSuppose, data to save
'
'    return value:  /
'
'=========================================================================================
Public Function addUserSuppose(DBConnection As SQLStudioDBLayer.Connection, ByVal NewUserSuppose As String) As Boolean
    On Error GoTo ErrAddUserSuppose

    Const FUNCTION_NAME = "AddUserSuppose"

    Dim DBFunctions     As New SQLStudioDBLayer.Functions
    Dim Statement       As String
    Dim Search          As Variant

    ' Inits
    addUserSuppose = False

    If Len(NewUserSuppose) = 0 Then
        addUserSuppose = True
        Exit Function
    End If
    
    If DBConnection Is Nothing Then
        Exit Function
    Else
        Set DBFunctions.Connection = DBConnection
    End If
       
    'check if new entry is already in list
    For Each Search In pUserSupposeList

        If Search = NewUserSuppose Then
            Exit Function
        End If
    Next
    'check if new entry is already in list
    For Each Search In pSQLSupposeList

        If Search = NewUserSuppose Then
            Exit Function
        End If
    Next 'check if new entry is already in list
    For Each Search In pStatementSupposeList

        If Search = NewUserSuppose Then
            Exit Function
        End If
    Next 'check if new entry is already in list
    For Each Search In pInfoSupposeList

        If Search = NewUserSuppose Then
            Exit Function
        End If
    Next

    Statement = "INSERT INTO SYSDBA.SYS_MYAUTOSUPPOSE VALUES ('" _
                + m_oComFunc.ConvertStringForCharCol(DBConnection.UserGroup, True) _
                + "'," + Trim$(Str$(asTypeUser)) + ",'" + _
                m_oComFunc.ConvertStringForCharCol(NewUserSuppose, True) _
                + "')"
    
    If Not DBFunctions.FullExecDirectStmt(Statement, Internal) Then Exit Function
    
    pUserSupposeList.add NewUserSuppose

    ' Set rc
    addUserSuppose = True

    Exit Function

ErrAddUserSuppose:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function removeUserSuppose(DBConnection As SQLStudioDBLayer.Connection, ByVal DeleteUserSuppose As String) As Boolean
    On Error GoTo errRemoveUserSuppose

    Const FUNCTION_NAME = "RemoveUserSuppose"

    Dim DBFunctions     As New SQLStudioDBLayer.Functions
    Dim Statement       As String
    Dim lRun            As Long
    Dim Search          As Variant

    ' Inits
    removeUserSuppose = False

    If Len(DeleteUserSuppose) = 0 Then
        removeUserSuppose = True
        Exit Function
    End If

    If DBConnection Is Nothing Then
        Exit Function
    Else
        Set DBFunctions.Connection = DBConnection
    End If

    Statement = "DELETE SYSDBA.SYS_MYAUTOSUPPOSE WHERE OWNER = '" + _
                 m_oComFunc.ConvertStringForCharCol(DBConnection.UserGroup, True) + "' AND TYPE = " + Trim$(Str$(asTypeUser)) + " AND SUPPOSE = '" + m_oComFunc.ConvertStringForCharCol(DeleteUserSuppose, True) + "'"

    If Not DBFunctions.FullExecDirectStmt(Statement, Internal) Then
        Exit Function
    End If

    lRun = 0
    For Each Search In pUserSupposeList

        lRun = lRun + 1
        If Search = DeleteUserSuppose Then

            pUserSupposeList.remove lRun
            lRun = lRun - 1
        End If
    Next
    
    removeSingleKeyWord DeleteUserSuppose

    ' Set rc
    removeUserSuppose = True

    Exit Function

errRemoveUserSuppose:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function clearSupposeList() As Boolean
    On Error GoTo ErrClearSupposeList

    Const FUNCTION_NAME = "ClearSupposeList"

    Dim lRun As Long

    'rc
    clearSupposeList = False

    While pSQLSupposeList.count > 0

        pSQLSupposeList.remove 1
    Wend

    While pStatementSupposeList.count > 0

        pStatementSupposeList.remove 1
    Wend

    While pInfoSupposeList.count > 0

        pInfoSupposeList.remove 1
    Wend

    While pUserSupposeList.count > 0

        pUserSupposeList.remove 1
    Wend
    
    m_sAllSingleKeyWords = ""

    ' Set rc
    clearSupposeList = True

    Exit Function

ErrClearSupposeList:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Private Sub Class_Initialize()
    On Error GoTo ErrClass_Initialize

    Const FUNCTION_NAME = "Class_Initialize"

    pSupposeTypeSQL = True
    pSupposeTypeStatement = True
    pSupposeTypeInfo = True
    pSupposeTypeUser = True
    
    m_sAllSingleKeyWords = ""

    Exit Sub

ErrClass_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Function removeSingleKeyWord(ByVal sValue As String)
    On Error GoTo ErrAddSingleKeyWord

    Const FUNCTION_NAME = "AddSingleKeyWord"
    
    Dim lRet            As Long
    Dim sNewWords       As String

    lRet = InStr(m_sAllSingleKeyWords, sValue)
    If lRet > 0 Then
    
        If Len(m_sAllSingleKeyWords) > lRet Then
        
            sNewWords = Left(m_sAllSingleKeyWords, lRet - 1)
            sNewWords = sNewWords + Right(m_sAllSingleKeyWords, Len(m_sAllSingleKeyWords) - lRet - Len(sValue))
            m_sAllSingleKeyWords = sNewWords
        End If
    End If
    
            
    Exit Function

ErrAddSingleKeyWord:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Private Function addSingleKeyWord(ByVal sValue As String)
    On Error GoTo ErrAddSingleKeyWord

    Const FUNCTION_NAME = "AddSingleKeyWord"
    
    Dim lRet            As Long

    lRet = InStr(sValue, " ")
    Do
        If lRet > 0 Then
        
            If Len(sValue) > lRet Then
            
                'Allow dubplicate entries because of remove single words
                'e.g.   select, select * from a select has to stay if one of the items is removed
                'If InStr(m_sAllSingleKeyWords, sValue) < 1 Then
                
                    m_sAllSingleKeyWords = m_sAllSingleKeyWords + " " + Left(sValue, lRet - 1)
                'End If
                sValue = Right(sValue, Len(sValue) - lRet)
            End If
        Else
            'If InStr(m_sAllSingleKeyWords, sValue) < 1 Then
                m_sAllSingleKeyWords = m_sAllSingleKeyWords + " " + sValue
            'End If
        End If
        
        lRet = InStr(sValue, " ")
        If lRet < 1 Then
        
             m_sAllSingleKeyWords = m_sAllSingleKeyWords + " " + sValue
        End If
    Loop While lRet > 0
    
    'add space at the last word for keyword list
    m_sAllSingleKeyWords = m_sAllSingleKeyWords + " "

    Exit Function

ErrAddSingleKeyWord:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Public Property Get allSingleKeyWords() As String
    On Error GoTo errP_Get_AllSingleKeyWords

    Const FUNCTION_NAME = "P_Get allSingleKeyWords"

    allSingleKeyWords = m_sAllSingleKeyWords

    Exit Property

errP_Get_AllSingleKeyWords:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
