VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Column"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oQTable As qTable

Private vImage As Variant
Private sText As String
Private bSelected As Boolean
Private vTag As Variant

Private lForeColor As OLE_COLOR
Private lBackColor As OLE_COLOR
Private lSelectedForeColor As OLE_COLOR
Private lSelectedBackColor As OLE_COLOR

Private lIndex As Long

Private m_sKey  As String
'
' Public
'
' Properties
'
Public Property Get image() As Variant
Attribute image.VB_Description = "Returns/sets the index of an image in the associated ImageList control. See property 'ImageList' from QueryTable control."
    image = vImage
End Property
Public Property Let image(ByVal NewVal As Variant)
    vImage = NewVal
End Property

Public Property Get text() As String
Attribute text.VB_Description = "Returns/sets the text to be displayed for a Column object."
Attribute text.VB_UserMemId = 0
    text = sText
End Property
Public Property Let text(ByVal NewVal As String)
    sText = NewVal
End Property

Public Property Let selected(ByVal NewVal As Boolean)
Attribute selected.VB_Description = "Returns/sets a value which determines if a Column object is selected."
    If NewVal <> bSelected Then
        bSelected = NewVal
        oQTable.drawColumn Me
    End If
End Property
Public Property Get selected() As Boolean
    selected = bSelected
End Property

Public Property Get tag() As Variant
Attribute tag.VB_Description = "Stores any extra data needed for your program."
    tag = vTag
End Property
Public Property Let tag(ByVal NewVal As Variant)
    vTag = NewVal
End Property

Public Property Get index() As Long
Attribute index.VB_Description = "Returns the index of a Column object in the Columns collection."
    index = lIndex
End Property
Friend Property Let index(ByVal NewVal As Long)
    lIndex = NewVal
End Property

Public Property Get foreColor() As OLE_COLOR
Attribute foreColor.VB_Description = "Returns/Sets the fore color for the Column object."
    foreColor = lForeColor
End Property
Public Property Let foreColor(ByVal NewVal As OLE_COLOR)
    lForeColor = NewVal
End Property

Public Property Get backColor() As OLE_COLOR
Attribute backColor.VB_Description = "Returns/Sets the back color for the Column object."
    backColor = lBackColor
End Property
Public Property Let backColor(ByVal NewVal As OLE_COLOR)
    lBackColor = NewVal
End Property

Public Property Get selectedForeColor() As OLE_COLOR
Attribute selectedForeColor.VB_Description = "Returns/Set the fore color for the Column object if there selected."
    selectedForeColor = lSelectedForeColor
End Property
Public Property Let selectedForeColor(ByVal NewVal As OLE_COLOR)
    lSelectedForeColor = NewVal
End Property

Public Property Get selectedBackColor() As OLE_COLOR
Attribute selectedBackColor.VB_Description = "Returns/Set the back color for the Column object if there selected."
    selectedBackColor = lSelectedBackColor
End Property
Public Property Let selectedBackColor(ByVal NewVal As OLE_COLOR)
    lSelectedBackColor = NewVal
End Property
'
' Methods
'
'
' Friends
'
Friend Property Set qTable(ByVal NewVal As qTable)
    Set oQTable = NewVal
End Property

Friend Function setIndex(ByVal NewVal As Long)
    lIndex = NewVal
End Function

Public Function getLeftPos(x As Single, y As Single)
Attribute getLeftPos.VB_Description = "Returns the middle left position of the Column object in the used container."
    Dim X2 As Single
    oQTable.getColumnPos index, x, X2, y
End Function

Public Function getRightPos(x As Single, y As Single)
Attribute getRightPos.VB_Description = "Returns the middle right position of the Column object in the used container."
    Dim X1 As Single
    oQTable.getColumnPos index, X1, x, y
End Function
Public Property Get key() As String
    key = m_sKey
End Property
Public Property Let key(NewKey As String)
    m_sKey = NewKey
End Property

'
' Methods
'
Public Function refresh()
Attribute refresh.VB_Description = "Forces a repaint of the Column object."
    oQTable.drawColumn Me
End Function

Friend Sub cleanUp()
    Set oQTable = Nothing
End Sub
'
' Hidden
'
'
' Private
'
' Initialize/Terminate
'
Private Sub Class_Initialize()

    vImage = Empty
    sText = ""
    bSelected = False
    
    lForeColor = vbWindowText
    lBackColor = vbWindowBackground
    lSelectedForeColor = vbHighlightText
    lSelectedBackColor = vbHighlight
    
End Sub

