VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Columns"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oItems As New Collection

Private oQTable As qTable
'
' Properties
'
Public Property Get count() As Long
Attribute count.VB_Description = "Returns the number of column objects in columns collection."
    count = oItems.count
End Property

Public Property Get item(ByVal index As Variant) As Column
Attribute item.VB_Description = "Returns a specific column object of column collection either by position or by key."
Attribute item.VB_UserMemId = 0
    Set item = oItems(index)
End Property

Public Property Get newEnum()
Attribute newEnum.VB_UserMemId = -4
Attribute newEnum.VB_MemberFlags = "40"
    Set newEnum = oItems.[_NewEnum]
End Property

Friend Property Set qTable(ByVal NewVal As qTable)
    Set oQTable = NewVal
End Property
'
' Methods
'
Public Function add(Optional ByVal Key As String, _
                    Optional ByVal text As String, _
                    Optional ByVal image As Variant) As Column
Attribute add.VB_Description = "Adds a column object to columns collection."
                    
    
    Dim oColumn As New Column
    
    Dim sKey As String
    
    With oColumn
        Set .qTable = oQTable
        .text = text
        .image = image
    End With
        
    If Key <> "" Then sKey = "Key" + Trim(Str(oItems.count))
    
    
    sKey = "Key" + Trim(Str(oItems.count)) + ":" + Key
    oItems.add oColumn, sKey
    oColumn.Key = sKey
    
    oColumn.index = oItems.count

    Set add = oColumn
    Set oColumn = Nothing
End Function

Public Function remove(ByVal index As Variant)
Attribute remove.VB_Description = "Removes a specific column object from column collection."
    Dim lIndex As Long
    
    oItems.remove index
    For lIndex = 1 To oItems.count
        oItems.item(lIndex).index = lIndex
    Next
End Function

Public Function clear()
Attribute clear.VB_Description = "Removes all Column objects in Columns collection."
    Dim lIndex As Long
    
    For lIndex = 1 To oItems.count
    
        '''MsgBox oItems.Count
        oItems.remove 1
    Next
End Function

Friend Sub cleanUp()

    Dim lIndex As Long
    Dim oColumn As Column
    
    lIndex = 1
    For Each oColumn In oItems
    
        '''MsgBox Str(oItems.Count) + " " + oColumn.Key
        oColumn.cleanUp
        oItems.remove oColumn.Key
    Next
    
    Set oQTable = Nothing
End Sub
'
' Sub/Function
'


