VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "File"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private Declare Sub CopyMemory Lib "Kernel32.dll" Alias "RtlMoveMemory" ( _
    hpvDest As Any, _
    ByVal hpvSource As Any, _
    ByVal cbCopy As Long)
    
Private Declare Function GetFileVersionInfoSize Lib "Version.DLL" Alias "GetFileVersionInfoSizeA" ( _
    ByVal sFilename As String, _
    lVerHandle As Long) As Long
    
Private Declare Function GetFileVersionInfo Lib "Version.DLL" Alias "GetFileVersionInfoA" ( _
    ByVal sFilename As String, _
    ByVal lVerHandle As Long, _
    ByVal lSize As Long, _
    lData As Byte) As Long

Private Declare Function VerQueryValue Lib "Version.DLL" Alias "VerQueryValueA" ( _
    bVerData As Any, _
    ByVal sSubBlock As String, _
    lBufPos As Long, _
    lLen As Long) As Long

Private Const SUBBLOCK_FIXEDFILEINFO = "\"

Private Type VS_FIXEDFILEINFO
    Signature As Long
    StrucVersion As Long
    FileVersionMS As Long
    FileVersionLS As Long
    ProductVersionMS As Long
    ProductVersionLS As Long
    FileFlagsMask As Long
    FileFlags As Long
    FileOS As Long
    FileType As Long
    FileSubtype As Long
    FileDateMS As Long
    FileDateLS As Long
End Type

'''

Private sName As String
Private sPath As String

Private tFileInfo As VS_FIXEDFILEINFO
Private bFileInfo As Boolean

'''

Public Property Get name() As String
    name = sName
End Property
Public Property Let name(ByVal NewVal As String)
    sName = NewVal
End Property

Public Property Get path() As String
    path = sPath
End Property
Public Property Let path(ByVal NewVal As String)
    If Right(Trim(NewVal), 1) = "\" Then
        sPath = Left(Trim(path), Len(NewVal) - 1)
    Else
        sPath = NewVal
    End If
End Property

Public Property Get fullName() As String
    If Len(sPath) > 0 Then
        fullName = sPath + "\" + sName
    Else
        fullName = sName
    End If
End Property

Public Property Get versionString() As String
    
    Dim ms As Long
    Dim ls As Long
    
    If Not bFileInfo Then refresh
    
    If bFileInfo Then
        ms = tFileInfo.FileVersionMS
        ls = tFileInfo.FileVersionLS
            
        versionString = CStr(m_oComFunc.hiWord(ms)) & "." & CStr(m_oComFunc.loWord(ms)) & "." & CStr(m_oComFunc.hiWord(ls)) & "." & CStr(m_oComFunc.loWord(ls))
    Else
        versionString = "?"
    End If
    
End Property
Public Property Get fileDate() As Date

    If exists() Then
        fileDate = FileDateTime(fullName)
    Else
        fileDate = Empty
    End If
    
End Property
Public Property Get fileDateString() As String

    Dim d As Date
    d = fileDate
    fileDateString = Format$(d, "Short Date") + " " + Format$(d, "Short Time")
    
End Property

'''

Public Function exists() As Boolean
    exists = False
    If fullName <> "" Then
        exists = Not (Dir(fullName) = "")
    End If
End Function

Public Function refresh()
    bFileInfo = readFileInfo()
End Function

'''

Private Sub Class_Initialize()
    sName = ""
    sPath = ""
    bFileInfo = False
End Sub

'''

Private Function readFileInfo() As Boolean
    Dim lVerSize As Long
    Dim lVerHandle As Long

    Dim lBufPtr As Long
    Dim bVerData() As Byte

    readFileInfo = False
    
    If Not exists() Then Exit Function
    
    lVerSize = GetFileVersionInfoSize(fullName, lVerHandle)
    If lVerSize > 0 Then
        ReDim bVerData(lVerSize)
        If GetFileVersionInfo(fullName, lVerHandle, lVerSize, bVerData(0)) <> 0 Then
            If VerQueryValue(bVerData(0), SUBBLOCK_FIXEDFILEINFO, lBufPtr, lVerSize) <> 0 Then
                CopyMemory tFileInfo, lBufPtr, lVerSize
                readFileInfo = True
            End If
        End If
    End If
End Function

'''

