Attribute VB_Name = "Timer"
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private Declare Function SetTimer Lib "user32.dll" ( _
    ByVal hWnd As Long, _
    ByVal nIDEvent As Long, _
    ByVal uElapse As Long, _
    ByVal lpTimerFunc As Long) As Long
    
Private Declare Function KillTimer Lib "user32.dll" ( _
    ByVal hWnd As Long, _
    ByVal nIDEvent As Long) As Long

'''

Private oReceiver As Object
Private lDelay As Long
Private lTimerID As Long
Private bInExecute As Boolean

'''

Public Function startTimer(ByVal Receiver As Object, _
                      ByVal Delay As Long)
                      
    Set oReceiver = Receiver
    lDelay = Delay
    lTimerID = SetTimer(0, 0, lDelay, AddressOf timerProc)
End Function

Public Function stopTimer()
    If lTimerID <> 0 Then
        KillTimer 0, lTimerID
        lTimerID = 0
    End If
End Function

'''

Private Sub timerProc(ByVal lHwnd As Long, _
                      ByVal lMsg As Long, _
                      ByVal lTimerID As Long, _
                      ByVal lTime As Long)
    
    If Not bInExecute Then
        bInExecute = True
        oReceiver.timerEvent
        bInExecute = False
    End If
End Sub





