Attribute VB_Name = "Common"
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'========================================================================================
'
' module:      CDTCommon.bas
'
'========================================================================================
'
' responsible:    WolfgangA
'
' special area:   SQLStudio
'
' description:    Common declarations and functions.
'
'========================================================================================

Option Explicit

Const MODULE_NAME = "CDTable.Common"

Public Const MAX_KEY_COLUMNS = 512
Public Const MAX_KEY_LENGTH = 1024
Public Const MAX_COLUMNS = 1024
Public Const SAPDB_FALSE = 0
Public Const SAPDB_TRUE = 1
Public Const VK_UP = &H26
Public Const VK_DOWN = &H28

'==============================================================================
' Enum declarations
'==============================================================================
Public Enum eFocusMove
    FocusMoveForward = 0
    FocusMoveBackward = 1
    FocusMoveIntern = 2
End Enum

Public Enum eMode
    CreateNew = 0
    CreateFromTable = 1
    CreateFromQuery = 2
    AlterTable = 3
    OpenDraft = 4
End Enum

Public Enum eAlterType
    AlterNoChange = 0
    AlterAdd = 1
    AlterrEmove = 2
    AlterChange = 3
End Enum

'==============================================================================
' Type declarations
'==============================================================================
Public Type tIncompleteDefinition
    bOccured       As Boolean
    bIgnore        As Boolean
    iPage          As Integer
    lRow           As Long
    lCol           As Long
End Type

'==============================================================================
' Global variables
'==============================================================================
Public m_tIncompleteDef            As tIncompleteDefinition

Public m_oComFunc                  As New SQLStudioUtil.Functions

'==============================================================================
' Function declarations
'==============================================================================
Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer

Declare Function table_new Lib "TableDefC" () As Long
Declare Function table_copy Lib "TableDefC" (ByVal this As Long) As Long
Declare Function table_delete Lib "TableDefC" (ByVal this As Long) As Long

Declare Function table_name Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function table_setName Lib "TableDefC" (ByVal this As Long, ByVal name As Long) As Long
Declare Function table_setName Lib "TableDefC" (ByVal this As Long, ByRef name As Byte) As Long
Declare Function table_mode Lib "TableDefC" (ByVal this As Long) As Long
Declare Function table_setMode Lib "TableDefC" (ByVal this As Long, ByVal mode As Long) As Long
Declare Function table_basedOn Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function table_setBasedOn Lib "TableDefC" (ByVal this As Long, ByVal basedOn As Long) As Long
Declare Function table_setBasedOn Lib "TableDefC" (ByVal this As Long, ByRef basedOn As Byte) As Long
Declare Function table_createAs Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
Declare Function table_setCreateAs Lib "TableDefC" (ByVal this As Long, ByRef createas As Byte) As Long
Declare Function table_sampleValue Lib "TableDefC" (ByVal this As Long) As Long
Declare Function table_setSampleValue Lib "TableDefC" (ByVal this As Long, ByVal value As Long) As Long
Declare Function table_sampleUnit Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function table_setSampleUnit Lib "TableDefC" (ByVal this As Long, ByVal unit As Long) As Long
Declare Function table_setSampleUnit Lib "TableDefC" (ByVal this As Long, ByRef unit As Byte) As Long
Declare Function table_duplicates Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function table_setDuplicates Lib "TableDefC" (ByVal this As Long, ByVal Duplicates As Long) As Long
Declare Function table_setDuplicates Lib "TableDefC" (ByVal this As Long, ByRef Duplicates As Byte) As Long
Declare Function table_temporary Lib "TableDefC" (ByVal this As Long) As Byte
Declare Function table_setTemporary Lib "TableDefC" (ByVal this As Long, ByVal Temporary As Byte) As Long
Declare Function table_ignoreRollback Lib "TableDefC" (ByVal this As Long) As Byte
Declare Function table_setIgnoreRollback Lib "TableDefC" (ByVal this As Long, ByVal IgnoreRollback As Byte) As Long
Declare Function table_caseSensitive Lib "TableDefC" (ByVal this As Long) As Byte
Declare Function table_setCaseSensitive Lib "TableDefC" (ByVal this As Long, ByVal CaseSensitive As Byte) As Long
Declare Function table_comment Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function table_setComment Lib "TableDefC" (ByVal this As Long, ByVal comment As Long) As Long
Declare Function table_setComment Lib "TableDefC" (ByVal this As Long, ByRef comment As Byte) As Long
Declare Function table_ignoreIncomplete Lib "TableDefC" (ByVal this As Long) As Byte
Declare Function table_setIgnoreIncomplete Lib "TableDefC" (ByVal this As Long, ByVal ignoreincomplete As Byte) As Long
Declare Function table_setAlterType Lib "TableDefC" (ByVal this As Long, ByVal AlterType As Long) As Long

Declare Function table_addColumn Lib "TableDefC" (ByVal this As Long) As Long
Declare Function table_removeColumn Lib "TableDefC" (ByVal this As Long, ByVal Index As Long) As Long
Declare Function table_column Lib "TableDefC" (ByVal this As Long, ByVal Index As Long) As Long
Declare Function table_findColumn Lib "TableDefC" (ByVal this As Long, ByRef name As Byte) As Long
Declare Function table_columnCount Lib "TableDefC" (ByVal this As Long) As Long
Declare Function table_twistColumns Lib "TableDefC" (ByVal this As Long, ByVal Index As Long) As Long

Declare Function table_addConstraint Lib "TableDefC" (ByVal this As Long) As Long
Declare Function table_removeConstraint Lib "TableDefC" (ByVal this As Long, ByVal Index As Long) As Long
Declare Function table_constraint Lib "TableDefC" (ByVal this As Long, ByVal Index As Long) As Long
Declare Function table_findConstraint Lib "TableDefC" (ByVal this As Long, ByRef name As Byte) As Long
Declare Function table_constraintCount Lib "TableDefC" (ByVal this As Long) As Long

Declare Function table_addForeignKey Lib "TableDefC" (ByVal this As Long) As Long
Declare Function table_removeForeignKey Lib "TableDefC" (ByVal this As Long, ByVal Index As Long) As Long
Declare Function table_foreignKey Lib "TableDefC" (ByVal this As Long, ByVal Index As Long) As Long
Declare Function table_findForeignKey Lib "TableDefC" (ByVal this As Long, ByRef name As Byte) As Long
Declare Function table_foreignKeyCount Lib "TableDefC" (ByVal this As Long) As Long

Declare Function table_reset Lib "TableDefC" (ByVal this As Long) As Long
'Declare Function table_readTableDefinition Lib "TableDefC" (ByVal this As Long, ByVal tablename As Long, ByVal owner As Long) As Long
Declare Function table_readTableDefinition Lib "TableDefC" (ByVal this As Long, ByRef tablename As Byte, ByRef owner As Byte) As Long
Declare Function table_hasValidColumns Lib "TableDefC" (ByVal this As Long) As Byte
Declare Function table_isDirty Lib "TableDefC" (ByVal this As Long) As Byte
Declare Function table_resetDirty Lib "TableDefC" (ByVal this As Long) As Long
Declare Function table_findIncompleteDefs Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
Declare Function table_genCreateStatement Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
Declare Function table_genAlterStatement Lib "TableDefC" (ByVal this As Long, ByVal oldTable As Long, ByRef out As Byte) As Long
Declare Function table_genDescription Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function table_parseDescription Lib "TableDefC" (ByVal this As Long, ByVal description As Long) As Long
Declare Function table_parseDescription Lib "TableDefC" (ByVal this As Long, ByRef description As Byte) As Long
Declare Function table_setConnection Lib "TableDefC" (ByVal this As Long, ByVal hdbc As Long, ByVal henv As Long) As Byte


Declare Function column_name Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function column_setName Lib "TableDefC" (ByVal this As Long, ByVal name As Long) As Long
Declare Function column_setName Lib "TableDefC" (ByVal this As Long, ByRef name As Byte) As Long

Declare Function column_oldName Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
Declare Function column_setOldName Lib "TableDefC" (ByVal this As Long, ByRef name As Byte) As Long
Declare Function column_dataType Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function column_setDataType Lib "TableDefC" (ByVal this As Long, ByVal datatype As Long) As Long
Declare Function column_setDataType Lib "TableDefC" (ByVal this As Long, ByRef datatype As Byte) As Long
Declare Function column_dimension Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function column_setDimension Lib "TableDefC" (ByVal this As Long, ByVal dimension As Long) As Long
Declare Function column_setDimension Lib "TableDefC" (ByVal this As Long, ByRef dimension As Byte) As Long
Declare Function column_codeType Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function column_setCodeType Lib "TableDefC" (ByVal this As Long, ByVal codetype As Long) As Long
Declare Function column_setCodeType Lib "TableDefC" (ByVal this As Long, ByRef codetype As Byte) As Long
Declare Function column_key Lib "TableDefC" (ByVal this As Long) As Byte
Declare Function column_setKey Lib "TableDefC" (ByVal this As Long, ByVal Key As Byte) As Long
Declare Function column_notNull Lib "TableDefC" (ByVal this As Long) As Byte
Declare Function column_setNotNull Lib "TableDefC" (ByVal this As Long, ByVal NotNull As Byte) As Long
Declare Function column_defaultValue Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function column_setDefaultValue Lib "TableDefC" (ByVal this As Long, ByVal DefaultValue As Long) As Long
Declare Function column_setDefaultValue Lib "TableDefC" (ByVal this As Long, ByRef DefaultValue As Byte) As Long
Declare Function column_unique Lib "TableDefC" (ByVal this As Long) As Byte
Declare Function column_setUnique Lib "TableDefC" (ByVal this As Long, ByVal Unique As Byte) As Long
Declare Function column_comment Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function column_setComment Lib "TableDefC" (ByVal this As Long, ByVal comment As Long) As Long
Declare Function column_setComment Lib "TableDefC" (ByVal this As Long, ByRef comment As Any) As Long
Declare Function column_alterType Lib "TableDefC" (ByVal this As Long) As Long
Declare Function column_setAlterType Lib "TableDefC" (ByVal this As Long, ByVal AlterType As Long) As Long

Declare Function column_findIncomplete Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
Declare Function column_genCreateStatement Lib "TableDefC" (ByVal this As Long, ByVal mode As Long, ByVal CaseSensitive As Long, ByRef out As Byte) As Long
Declare Function column_genDescription Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
Declare Function column_parseDescription Lib "TableDefC" (ByVal this As Long, ByRef description As Byte) As Long


Declare Function constraint_name Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function constraint_setName Lib "TableDefC" (ByVal this As Long, ByVal name As Long) As Long
Declare Function constraint_setName Lib "TableDefC" (ByVal this As Long, ByRef name As Byte) As Long
Declare Function constraint_alterType Lib "TableDefC" (ByVal this As Long) As Long
Declare Function constraint_setAlterType Lib "TableDefC" (ByVal this As Long, ByVal AlterType As Long) As Long

Declare Function constraint_addCondition Lib "TableDefC" (ByVal this As Long) As Long
Declare Function constraint_removeCondition Lib "TableDefC" (ByVal this As Long, ByVal Index As Long) As Long
Declare Function constraint_condition Lib "TableDefC" (ByVal this As Long, ByVal Index As Long) As Long
Declare Function constraint_conditionCount Lib "TableDefC" (ByVal this As Long) As Long

Declare Function constraint_findIncomplete Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
Declare Function constraint_genCreateStatement Lib "TableDefC" (ByVal this As Long, ByVal mode As Long, ByVal CaseSensitive As Long, ByRef out As Byte) As Long
Declare Function constraint_genAlterStatement Lib "TableDefC" (ByVal this As Long, ByVal CaseSensitive As Long, ByRef out As Byte) As Long
'Declare Function constraint_parseConditions Lib "TableDefC" (ByVal this As Long, ByVal Conditions As Long) As Long
Declare Function constraint_parseConditions Lib "TableDefC" (ByVal this As Long, ByRef Conditions As Byte) As Long
'Declare Function constraint_isFunction Lib "TableDefC" (ByVal this As Long, ByVal str As Long) As Byte
Declare Function constraint_isFunction Lib "TableDefC" (ByVal this As Long, ByRef str As Byte) As Byte
Declare Function constraint_genDescription Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
Declare Function constraint_parseDescription Lib "TableDefC" (ByVal this As Long, ByRef description As Byte) As Long


Declare Function condition_column Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function condition_setColumn Lib "TableDefC" (ByVal this As Long, ByVal column As Long) As Long
Declare Function condition_setColumn Lib "TableDefC" (ByVal this As Long, ByRef column As Byte) As Long
Declare Function condition_predicate Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function condition_setPredicate Lib "TableDefC" (ByVal this As Long, ByVal Predicate As Long) As Long
Declare Function condition_setPredicate Lib "TableDefC" (ByVal this As Long, ByRef Predicate As Byte) As Long
Declare Function condition_notOperator Lib "TableDefC" (ByVal this As Long) As Byte
Declare Function condition_setNotOperator Lib "TableDefC" (ByVal this As Long, ByVal notoperator As Byte) As Long
Declare Function condition_expression Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function condition_setExpression Lib "TableDefC" (ByVal this As Long, ByVal Expression As Long) As Long
Declare Function condition_setExpression Lib "TableDefC" (ByVal this As Long, ByRef Expression As Byte) As Long
Declare Function condition_noExpression Lib "TableDefC" (ByVal this As Long) As Byte
Declare Function condition_setNoExpression Lib "TableDefC" (ByVal this As Long, ByVal NoExpression As Byte) As Long
Declare Function condition_logOperator Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function condition_setLogOperator Lib "TableDefC" (ByVal this As Long, ByVal LogOperator As Long) As Long
Declare Function condition_setLogOperator Lib "TableDefC" (ByVal this As Long, ByRef LogOperator As Byte) As Long
Declare Function condition_alterType Lib "TableDefC" (ByVal this As Long) As Long
Declare Function condition_setAlterType Lib "TableDefC" (ByVal this As Long, ByVal AlterType As Long) As Long

Declare Function condition_findIncomplete Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
Declare Function condition_genCreateStatement Lib "TableDefC" (ByVal this As Long, ByVal mode As Long, ByVal CaseSensitive As Long, ByRef out As Byte) As Long
Declare Function condition_genDescription Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
Declare Function condition_parseDescription Lib "TableDefC" (ByVal this As Long, ByRef description As Byte) As Long


Declare Function foreignkey_name Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function foreignkey_setName Lib "TableDefC" (ByVal this As Long, ByVal name As Long) As Long
Declare Function foreignkey_setName Lib "TableDefC" (ByVal this As Long, ByRef name As Byte) As Long
Declare Function foreignkey_referencingColumns Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function foreignkey_setReferencingColumns Lib "TableDefC" (ByVal this As Long, ByVal Columns As Long) As Long
Declare Function foreignkey_setReferencingColumns Lib "TableDefC" (ByVal this As Long, ByRef Columns As Byte) As Long
Declare Function foreignkey_reference Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function foreignkey_setReference Lib "TableDefC" (ByVal this As Long, ByVal Reference As Long) As Long
Declare Function foreignkey_setReference Lib "TableDefC" (ByVal this As Long, ByRef Reference As Byte) As Long
Declare Function foreignkey_onDelete Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function foreignkey_setOnDelete Lib "TableDefC" (ByVal this As Long, ByVal OnDelete As Long) As Long
Declare Function foreignkey_setOnDelete Lib "TableDefC" (ByVal this As Long, ByRef OnDelete As Byte) As Long
Declare Function foreignkey_comment Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
'Declare Function foreignkey_setComment Lib "TableDefC" (ByVal this As Long, ByVal comment As Long) As Long
Declare Function foreignkey_setComment Lib "TableDefC" (ByVal this As Long, ByRef comment As Byte) As Long
Declare Function foreignkey_alterType Lib "TableDefC" (ByVal this As Long) As Long
Declare Function foreignkey_setAlterType Lib "TableDefC" (ByVal this As Long, ByVal AlterType As Long) As Long

Declare Function foreignkey_findIncomplete Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
Declare Function foreignkey_genCreateStatement Lib "TableDefC" (ByVal this As Long, ByVal mode As Long, ByVal CaseSensitive As Long, ByRef out As Byte) As Long
Declare Function foreignkey_genDescription Lib "TableDefC" (ByVal this As Long, ByRef out As Byte) As Long
Declare Function foreignkey_parseDescription Lib "TableDefC" (ByVal this As Long, ByRef description As Byte) As Long

'=========================================================================================
'    function:      InitByteArray
'    description:   Initializes all fields of a byte array to 1.
'    arguments:     [in] arr - Array to initialize
'    return value:  -
'=========================================================================================
Public Function initByteArray(arr() As Byte)
    On Error GoTo errInitByteArray
    
    Const FUNCTION_NAME = "InitByteArray"

    Dim i    As Long
    
    For i = 0 To UBound(arr)
        arr(i) = 1
    Next
    
    Exit Function
    
errInitByteArray:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'=========================================================================================
'    function:      InternalError
'    description:   Display an error message in a message box.
'    arguments:     [in] CurrentError - error object
'                   [in] ModulName    - name of the module where the error occured
'                   [in] FunctionName - name of the function in which the error occured
'    return value:  -
'=========================================================================================
Public Function internalError(ByVal CurrentError As ErrObject, ModulName As String, FunctionName As String)
    MsgBox "Module:" + Chr$(9) + ModulName + Chr$(13) + Chr$(10) + "Function:" + Chr$(9) + _
            FunctionName + Chr$(13) + Chr$(10) + "Error No:" + Chr$(9) + _
            Trim$(str$(CurrentError.number)) + Chr$(13) + Chr$(10) + "Error:" + Chr$(9) + _
            CurrentError.description, vbExclamation, "Unexpected Error:"
End Function

