VERSION 5.00
Object = "{C5996774-01AB-11D5-B32A-0050DADF6C37}#1.3#0"; "SQLStudioQCon.ocx"
Begin VB.Form frmImportTableDefinition 
   Caption         =   "Import"
   ClientHeight    =   6030
   ClientLeft      =   2775
   ClientTop       =   3765
   ClientWidth     =   6195
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   NegotiateMenus  =   0   'False
   ScaleHeight     =   6030
   ScaleWidth      =   6195
   StartUpPosition =   1  'CenterOwner
   Begin SQLStudioQCon.Result resDefinitions 
      Height          =   5055
      Left            =   105
      TabIndex        =   2
      Top             =   105
      Width           =   6210
      _ExtentX        =   10954
      _ExtentY        =   8916
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3950
      TabIndex        =   1
      Top             =   5400
      Width           =   1215
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   375
      Left            =   1000
      TabIndex        =   0
      Top             =   5400
      Width           =   1215
   End
End
Attribute VB_Name = "frmImportTableDefinition"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'========================================================================================
'
' module:      ImportTableDefinition.frm
'
'========================================================================================
'
' responsible:    WolfgangA
'
' special area:   SQLStudio
'
' description:    Form for displaying parts of the table definition that can be imported
'                 (columns, constraints or foreign keys).
'
'========================================================================================

Option Explicit

Const MODULE_NAME = "frmImportTableDefinition"

Private m_oConnection     As SQLStudioDBLayer.connection
Private m_oGlobalInfo      As SQLStudioMan.globalInfo
Private m_sMode           As String
Private m_lOldWidth       As Long
Private m_lOldHeight      As Long
Private m_sNullRep        As String
Private m_bNoAction       As Boolean
Private m_cTableDef       As Long

'=========================================================================================
'    property:      tableDef (Let)
'    description:   Sets the value of the private member m_cTableDef to the given value.
'    arguments:     [in] vData - new value of the property
'    return value:  -
'=========================================================================================
Public Property Let tableDef(vData As Long)
    On Error GoTo errP_SET_TableDef

    Const FUNCTION_NAME = "p_Set tableDef"
    
    m_cTableDef = vData
    
    Exit Property
    
errP_SET_TableDef:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    property:      tableDef (Get)
'    description:   Gets the value of the private member m_cTableDef.
'    arguments:     -
'    return value:  Long
'=========================================================================================
Public Property Get tableDef() As Long
    On Error GoTo errP_Get_TableDef

    Const FUNCTION_NAME = "G_Get tableDef"
    
    tableDef = m_cTableDef
    
    Exit Property
    
errP_Get_TableDef:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    property:      globalInfo (Set)
'    description:   Sets the private member m_oGlobalInfo to the given value.
'    arguments:     [in] newGlobalInfo - new value of the property
'    return value:  -
'=========================================================================================
Public Property Set globalInfo(newGlobalInfo As SQLStudioMan.globalInfo)
    On Error GoTo errP_SET_globalInfo

    Const FUNCTION_NAME = "p_SET globalInfo"
    
    Set m_oGlobalInfo = newGlobalInfo
    
    Exit Property
    
errP_SET_globalInfo:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    property:      Connection (Set)
'    description:   Sets the private member m_oConnection to the given value.
'    arguments:     [in] NewConnection - new value of the property
'    return value:  -
'=========================================================================================
Public Property Set connection(NewConnection As SQLStudioDBLayer.connection)
    On Error GoTo errP_SET_Connection

    Const FUNCTION_NAME = "p_SET Connection"
    
    Set m_oConnection = NewConnection
    
    Exit Property
    
errP_SET_Connection:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    property:      Connection (Get)
'    description:   Gets the value of the private member m_oConnection.
'    arguments:     -
'    return value:  sqlstudiodblayer.Connection
'=========================================================================================
Public Property Get connection() As SQLStudioDBLayer.connection
    On Error GoTo errP_Get_Connection

    Const FUNCTION_NAME = "G_GET Connection"
    
    Set connection = m_oConnection
    
    Exit Property
    
errP_Get_Connection:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    property:      Mode (Let)
'    description:   Sets the value of the private member m_sMode to the given value.
'    arguments:     [in] ImportMode - new value of the property
'    return value:  -
'=========================================================================================
Public Property Let mode(ImportMode As String)
    On Error GoTo errP_LET_Mode

    Const FUNCTION_NAME = "p_LET_Mode"
    
    m_sMode = ImportMode
    
    Exit Property
    
errP_LET_Mode:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    property:      Mode (Get)
'    description:   Gets the value of the private member m_sMode.
'    arguments:     -
'    return value:  String
'=========================================================================================
Public Property Get mode() As String
    On Error GoTo errP_Get_Mode

    Const FUNCTION_NAME = "G_GET_Mode"
    
    Let mode = m_sMode
    
    Exit Property
    
errP_Get_Mode:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    property:      noAction (Get)
'    description:   Gets the value of the private member m_bNoAction.
'    arguments:     -
'    return value:  String
'=========================================================================================
Public Property Get noAction() As String
    On Error GoTo errP_Get_NoAction

    Const FUNCTION_NAME = "GET NoAction"
    
    Let noAction = m_bNoAction
    
    Exit Property
    
errP_Get_NoAction:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    function:      cmdOK_Click
'    description:   Handles the Click event of the button "OK". Closes the form.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub cmdOK_Click()
    On Error GoTo errCmdOK_Click

    Const FUNCTION_NAME = "cmdOK_Click"
    
    Dim sep             As String
    
    sep = m_oComFunc.getTokenSeperator(qplObjectLevel1)
    
    Select Case m_sMode
    Case "Columns":
        evaluateImportedColumns resDefinitions.getSelectionWithUserSep(sep)
    Case "Constraints":
        evaluateImportedConstraints resDefinitions.getSelectionWithUserSep(sep)
    Case "ForeignKeys":
        evaluateImportedForeignKeys resDefinitions.getSelectionWithUserSep(sep)
    End Select
    
    Unload Me
    
    Exit Sub

errCmdOK_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      cmdCancel_Click
'    description:   Handles the Click event of the button "Cancel". Closes the form.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub cmdCancel_Click()
    On Error GoTo errCmdCancel_Click

    Const FUNCTION_NAME = "cmdCancel_Click"
    
    m_bNoAction = True
    Unload Me
    
    Exit Sub

errCmdCancel_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      Form_KeyDown
'    description:   Handles the KeyDown event of the form.
'    arguments:     [in] KeyCode - code of the pressed key
'                   [in] Shift   - flag if the shift key was pressed
'    return value:  -
'=========================================================================================
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrForm_KeyDown

    Const FUNCTION_NAME = "Form_KeyDown"

    Select Case KeyCode
    Case vbKeyReturn:
        Select Case m_sMode
        Case "Columns:"
            evaluateImportedColumns resDefinitions.selection
        Case "Constraints":
            evaluateImportedConstraints resDefinitions.selection
        Case "Constraints":
            'EvaluateImportedForeignKeys resDefinitions.Selection
        End Select
    
        Unload Me
    Case vbKeyEscape:
        m_bNoAction = True
        Unload Me
    End Select
    
    Exit Sub

ErrForm_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      Form_Load
'    description:   Initializations when the form is loaded.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub Form_Load()
    On Error GoTo ErrForm_Load

    Const FUNCTION_NAME = "Form_Load"

    Dim name                As String
    Dim FontBold            As Boolean
    Dim FontItalic          As Boolean
    Dim FontSize            As Long
    Dim FontStrikethrough   As Boolean
    Dim FontUnderline       As Boolean
    
    '--------------------------------------------------------------------------
    ' Initialize the private member variables.
    '--------------------------------------------------------------------------
    m_lOldWidth = 0
    m_lOldHeight = 0
    
    '--------------------------------------------------------------------------
    ' Load font settings from the globalInfo object.
    '--------------------------------------------------------------------------
    m_oGlobalInfo.UserProfile.getReportFont name, _
                                        FontBold, _
                                        FontItalic, _
                                        FontSize, _
                                        FontStrikethrough, _
                                        FontUnderline
    
    '--------------------------------------------------------------------------
    ' Initialize the result table.
    '--------------------------------------------------------------------------
    Set resDefinitions.globalInfo = m_oGlobalInfo
    resDefinitions.showSQLStatement = False
    resDefinitions.selectionMode = flexSelectionByRow
    
    Exit Sub

ErrForm_Load:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      Form_Resize
'    description:   Handles the Resize event of the form. Resize and reposition the
'                   contained controls.
'    arguments:     -
'    return value:  -
'=========================================================================================
Private Sub Form_Resize()
    On Error GoTo ErrForm_Resize

    Const FUNCTION_NAME = "Form_Resize"

    '--------------------------------------------------------------------------
    ' Recalculate the new horizontal dimensions only if the width of
    ' the control was changed.
    '--------------------------------------------------------------------------
    If m_lOldWidth <> Me.ScaleWidth Then
        resDefinitions.Width = Me.ScaleWidth - 200
        cmdOK.Left = ((Me.ScaleWidth / 2) - cmdOK.Width) / 2
        cmdCancel.Left = ((Me.ScaleWidth / 2) - cmdCancel.Width) / 2 + (Me.ScaleWidth / 2)
        m_lOldWidth = Me.ScaleWidth
    End If
        
    '--------------------------------------------------------------------------
    ' Recalculate the new vertical dimensions only if the height of
    ' the control was changed.
    '--------------------------------------------------------------------------
    If m_lOldHeight <> Me.ScaleHeight Then
        resDefinitions.Height = Me.ScaleHeight - 1200
        cmdOK.top = resDefinitions.Height + (1200 - cmdOK.Height) / 2
        cmdCancel.top = cmdOK.top
        m_lOldHeight = Me.ScaleHeight
    End If
    
    Exit Sub

ErrForm_Resize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      ImportDefinitions
'    description:   Import the definitions from the database (depending of the mode).
'    arguments:     [in] Mode - Import mode
'    return value:  Boolean
'=========================================================================================
Public Function importDefinitions(mode As String) As Boolean
    On Error GoTo errImportDefinitions

    Const FUNCTION_NAME = "ImportDefinitions"

    Dim statement  As String
    Dim oResult    As New SQLStudioDBLayer.Result
    
    importDefinitions = False
    
    m_oGlobalInfo.Hourglass.State = qpArrowHourglassOn
    
    '--------------------------------------------------------------------------
    ' Defining the SQL statement depending on the selected mode (columns,
    ' constraints, foreign keys).
    '--------------------------------------------------------------------------
    Select Case mode
    Case "Columns":
        If table_temporary(m_cTableDef) = True Then
            statement = "SELECT   A.owner, A.tablename, A.columnname, A.datatype, " + _
                        "         A.comment, A.len, A.dec, A.codetype, A.mode, A.default " + _
                        "FROM     domain.columns A " + _
                        "WHERE    A.owner = '" + m_oGlobalInfo.conMan.uid + "' " + _
                        "AND      A.datatype <> 'LONG' " + _
                        "ORDER BY A.tablename, A.columnname"
        Else
            statement = "SELECT   A.owner, A.tablename, A.columnname, A.datatype, " + _
                        "         A.comment, A.len, A.dec, A.codetype, A.mode, A.default " + _
                        "FROM     domain.columns A " + _
                        "WHERE    A.owner = '" + m_oGlobalInfo.conMan.uid + "' " + _
                        "ORDER BY A.tablename, A.columnname"
        End If
    Case "Constraints":
        statement = "SELECT   A.owner, A.tablename, A.constraintname, A.definition " + _
                    "FROM     domain.constraints A " + _
                    "WHERE    A.owner = '" + m_oGlobalInfo.conMan.uid + "' " + _
                    "ORDER BY A.tablename, A.constraintname"
    Case "ForeignKeys":
        statement = "SELECT   owner, tablename, fkeyname, columnname, refowner, reftablename, refcolumnname, rule, comment " + _
                    "FROM     foreignkeycolumns " + _
                    "WHERE    owner = '" + m_oGlobalInfo.conMan.uid + "' " + _
                    "ORDER BY tablename, fkeyname"
    End Select
    
    '--------------------------------------------------------------------------
    ' Initialize the DBResult object.
    '--------------------------------------------------------------------------
    Set oResult.connection = m_oConnection
    oResult.resultMode = sapdbSimpleMode
    '--------------------------------------------------------------------------
    ' Open the result (execute the statement).
    '--------------------------------------------------------------------------
    If Not oResult.openResult(statement, Internal) Then
        m_oGlobalInfo.Hourglass.State = qpArrowHourglassOff
        Exit Function
    End If
    
    If oResult.noRows Then
        Select Case mode
        Case "Columns":
            MsgBox LoadResString(223), vbExclamation, LoadResString(222)
        Case "Constraints":
            MsgBox LoadResString(225), vbExclamation, LoadResString(224)
        Case "ForeignKeys":
            MsgBox LoadResString(227), vbExclamation, LoadResString(226)
        End Select
        
        m_oGlobalInfo.Hourglass.State = qpArrowHourglassOff
        
        Exit Function
    End If
    
    '--------------------------------------------------------------------------
    ' Give the opened DBResult object to the result table in the form.
    '--------------------------------------------------------------------------
    Set resDefinitions.Result = oResult
    resDefinitions.showResult
    
    m_sNullRep = oResult.representationOfNullValue
    m_sMode = mode
    
    m_oGlobalInfo.Hourglass.State = qpArrowHourglassOff
    importDefinitions = True
    
    Exit Function

errImportDefinitions:
    m_oGlobalInfo.Hourglass.State = qpArrowHourglassOff
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      evaluateImportedColumns
'    description:   Evaluate the given string and extract the imported column information
'                   from it.
'    arguments:     [in] Data - String to evaluate
'    return value:  -
'=========================================================================================
Private Function evaluateImportedColumns(Data As String)
    On Error GoTo errEvaluateImportedColumns
    
    Const FUNCTION_NAME = "evaluateImportedColumns"
    
    Dim Columns            As New Collection
    Dim col                As Long
    Dim iStart             As Integer
    Dim iEnd               As Integer
    Dim s                  As Variant
    Dim i                  As Integer
    Dim attributes(0 To 9) As String
    Dim name(512)          As Byte
    Dim datatype(512)      As Byte
    Dim dimension(512)     As Byte
    Dim codetype(512)      As Byte
    Dim default(512)       As Byte
    Dim comment(512)       As Byte
    Dim namelen            As Integer
    Dim datatypelen        As Integer
    Dim dimensionlen       As Integer
    Dim codetypelen        As Integer
    Dim defaultlen         As Integer
    Dim commentlen         As Integer
    Dim sep                As String
    Dim bArray()           As Byte
    
    sep = m_oComFunc.getTokenSeperator(qplObjectLevel1)
    
    initByteArray name
    initByteArray datatype
    initByteArray dimension
    initByteArray codetype
    initByteArray default
    initByteArray comment
    
    If Data = m_oGlobalInfo.conMan.uid Then
        m_bNoAction = True
        Exit Function
    Else
        m_bNoAction = False
    End If
    
    '--------------------------------------------------------------------------
    ' Extract the single columns from the given string.
    '--------------------------------------------------------------------------
    iStart = 1
    iEnd = InStr(iStart, Data, vbCrLf)
    
    While iEnd > 0
        Columns.Add Mid(Data, iStart, iEnd - iStart)
        iStart = iEnd + 2
        iEnd = InStr(iStart, Data, vbCrLf)
    Wend
    
    Columns.Add Mid(Data, iStart)
    
    '--------------------------------------------------------------------------
    ' Remove all empty item from the end of the table definition object.
    '--------------------------------------------------------------------------
    For i = table_columnCount(m_cTableDef) - 1 To 0 Step -1
        col = table_column(m_cTableDef, i)
        
        namelen = column_name(col, name(0))
        datatypelen = column_dataType(col, datatype(0))
        dimensionlen = column_dimension(col, dimension(0))
        codetypelen = column_codeType(col, codetype(0))
        defaultlen = column_defaultValue(col, default(0))
        commentlen = column_comment(col, comment(0))
        
        If Left(name, namelen) = "" And Left(datatype, datatypelen) = "" And _
           Left(dimension, dimensionlen) = "" And Left(codetype, codetypelen) = "" And _
           column_key(col) = False And column_notNull(col) = False And _
           Left(default, defaultlen) = "" And column_unique(col) = False And _
           Left(comment, commentlen) = "" Then
            table_removeColumn m_cTableDef, i
        Else
            Exit For
        End If
    Next
    
    '--------------------------------------------------------------------------
    ' Extract the single column attributes for each column.
    '--------------------------------------------------------------------------
    For Each s In Columns
        i = 0
        iStart = 1
        iEnd = InStr(iStart, s, sep)
        
        While iEnd > 0
            attributes(i) = Mid(s, iStart, iEnd - iStart)
            iStart = iEnd + 1
            iEnd = InStr(iStart, s, sep)
            i = i + 1
        Wend
        attributes(i) = Mid(s, iStart)
        
        
        col = table_addColumn(m_cTableDef)
        'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
        'column_setDataType col, StrPtr(StrConv(attributes(3), vbProperCase))
        'convert string to ucs2 byte array and pass it to function
        bArray = StrConv(attributes(3), vbProperCase) + vbNullChar
        column_setDataType col, bArray(0)
        If attributes(4) <> "" And attributes(4) <> m_sNullRep Then
        
            'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
            'column_setComment col, attributes(4)
            'convert string to ucs2 byte array and pass it to function
            bArray = attributes(4) & vbNullChar
            column_setComment col, bArray(0)
        End If
        If attributes(7) <> "" And attributes(7) <> m_sNullRep Then
        
            'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
            'column_setCodeType col, StrPtr(attributes(7))
            'convert string to ucs2 byte array and pass it to function
            bArray = attributes(7) & vbNullChar
            column_setCodeType col, bArray(0)
        End If
        
        datatypelen = column_dataType(col, datatype(0))
        Select Case Left(datatype, datatypelen)
        Case "Char", "Varchar", "Float":
        
            'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
            'column_setDimension col, StrPtr(CInt(attributes(5)))
            'convert string to ucs2 byte array and pass it to function
            bArray = attributes(5) + vbNullChar
            column_setDimension col, bArray(0)
        Case "Fixed":
            'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
            'column_setDimension col, StrPtr(attributes(5) + "," + attributes(6))
            'convert string to ucs2 byte array and pass it to function
            bArray = attributes(5) + "," + attributes(6) + vbNullChar
            column_setDimension col, bArray(0)
        End Select
        
        Select Case attributes(8)
        Case "KEY":
            column_setKey col, SAPDB_TRUE
        Case "MAN":
            column_setNotNull col, SAPDB_TRUE
        End Select
        
        If attributes(9) <> "" And attributes(9) <> m_sNullRep Then
            If Left(attributes(9), 7) = "DEFAULT" Then
            
                'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
                'column_setDefaultValue col, StrPtr(Mid(Trim(attributes(9)), 9))
                'convert string to ucs2 byte array and pass it to function
                bArray = Mid(Trim(attributes(9)), 9) & vbNullChar
                column_setDefaultValue col, bArray(0)
            Else
                'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
                'column_setDefaultValue col, StrPtr(attributes(9))
                'convert string to ucs2 byte array and pass it to function
                bArray = attributes(9) & vbNullChar
                column_setDefaultValue col, bArray(0)
            End If
        End If
    Next
    
    Exit Function
    
errEvaluateImportedColumns:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'=========================================================================================
'    function:      evaluateImportedConstraints
'    description:   Evaluate the given string and extract the imported constraint
'                   information from it.
'    arguments:     [in] Data - String to evaluate
'    return value:  -
'=========================================================================================
Private Function evaluateImportedConstraints(Data As String)
    On Error GoTo errEvaluateImportedConstraints
    
    Const FUNCTION_NAME = "evaluateImportedConstraints"
    
    Dim Constraints        As New Collection
    Dim constr             As Long
    Dim iStart             As Integer
    Dim iEnd               As Integer
    Dim s                  As Variant
    Dim i                  As Integer
    Dim attributes(0 To 3) As String
    Dim sep                As String
    Dim bArray()           As Byte
    
    sep = m_oComFunc.getTokenSeperator(qplObjectLevel1)
    
    If Data = m_oGlobalInfo.conMan.uid Then
        m_bNoAction = True
        Exit Function
    Else
        m_bNoAction = False
    End If
    
    '--------------------------------------------------------------------------
    ' Extract the single constraints from the given string.
    '--------------------------------------------------------------------------
    iStart = 1
    iEnd = InStr(iStart, Data, vbCrLf)
    
    While iEnd > 0
        Constraints.Add Mid(Data, iStart, iEnd - iStart)
        iStart = iEnd + 2
        iEnd = InStr(iStart, Data, vbCrLf)
    Wend
    
    Constraints.Add Mid(Data, iStart)
        
    '--------------------------------------------------------------------------
    ' Extract the single constraint definitions for each constraint.
    '--------------------------------------------------------------------------
    For Each s In Constraints
        i = 0
        iStart = 1
        iEnd = InStr(iStart, s, sep)
        
        While iEnd > 0
            attributes(i) = Mid(s, iStart, iEnd - iStart)
            iStart = iEnd + 1
            iEnd = InStr(iStart, s, sep)
            i = i + 1
        Wend
        attributes(i) = Mid(s, iStart)
        
        
        constr = table_addConstraint(m_cTableDef)
        
        'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
        'constraint_setName constr, StrPtr(LoadResString(103))
        'convert string to ucs2 byte array and pass it to function
        bArray = LoadResString(103) & vbNullChar
        constraint_setName constr, bArray(0)
        
        'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
        'constraint_parseConditions constr, StrPtr(attributes(3))
        'convert string to ucs2 byte array and pass it to function
        bArray = attributes(3) & vbNullChar
        constraint_parseConditions constr, bArray(0)
    Next
    
    Exit Function
    
errEvaluateImportedConstraints:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'=========================================================================================
'    function:      evaluateImportedForeignKeys
'    description:   Evaluate the given string and extract the imported foreign key
'                   information from it.
'    arguments:     [in] Data - String to evaluate
'    return value:  -
'=========================================================================================
Private Function evaluateImportedForeignKeys(Data As String)
    On Error GoTo errEvaluateImportedForeignKeys
    
    Const FUNCTION_NAME = "evaluateImportedForeignKeys"
    
    Dim ForeignKeys        As New Collection
    Dim forkey             As Long
    Dim iStart             As Integer
    Dim iEnd               As Integer
    Dim s                  As Variant
    Dim i                  As Integer
    Dim attributes(0 To 8) As String
    Dim name               As String
    Dim refcols(512)       As Byte
    Dim ref(512)           As Byte
    Dim refcolslen         As Integer
    Dim reflen             As Integer
    Dim sep                As String
    Dim bArray()           As Byte
    
    sep = m_oComFunc.getTokenSeperator(qplObjectLevel1)
    
    initByteArray refcols
    initByteArray ref
    
    If Data = m_oGlobalInfo.conMan.uid Then
        m_bNoAction = True
        Exit Function
    Else
        m_bNoAction = False
    End If
    
    '--------------------------------------------------------------------------
    ' Extract the single constraints from the given string.
    '--------------------------------------------------------------------------
    iStart = 1
    iEnd = InStr(iStart, Data, vbCrLf)
    
    While iEnd > 0
        ForeignKeys.Add Mid(Data, iStart, iEnd - iStart - 1)
        iStart = iEnd + 2
        iEnd = InStr(iStart, Data, vbCrLf)
    Wend
    
    ForeignKeys.Add Mid(Data, iStart)
        
    '--------------------------------------------------------------------------
    ' Extract the single constraint definitions for each constraint.
    '--------------------------------------------------------------------------
    name = ""
    For Each s In ForeignKeys
        i = 0
        iStart = 1
        iEnd = InStr(iStart, s, sep)
        
        While iEnd > 0
            attributes(i) = Mid(s, iStart, iEnd - iStart)
            iStart = iEnd + 1
            iEnd = InStr(iStart, s, sep)
            i = i + 1
        Wend
        attributes(i) = Mid(s, iStart)
        
        
        If name <> attributes(2) Then
            forkey = table_addForeignKey(m_cTableDef)
            
            'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
            'foreignkey_setName forkey, StrPtr(LoadResString(103))
            'convert string to ucs2 byte array and pass it to function
            bArray = LoadResString(103) & vbNullChar
            foreignkey_setName forkey, bArray(0)
            
            'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
            'foreignkey_setReference forkey, StrPtr(attributes(4) + "." + attributes(5) + " (")
            'convert string to ucs2 byte array and pass it to function
            bArray = attributes(4) + "." + attributes(5) + " (" & vbNullChar
            foreignkey_setReference forkey, bArray(0)
            
            If Left(attributes(7), 6) = "DELETE" Then
            
                'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
                'foreignkey_setOnDelete forkey, StrPtr(Mid(attributes(7), 8))
                'convert string to ucs2 byte array and pass it to function
                bArray = Mid(attributes(7), 8) & vbNullChar
                foreignkey_setOnDelete forkey, bArray(0)
            Else
                'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
                'foreignkey_setOnDelete forkey, StrPtr(attributes(7))
                'convert string to ucs2 byte array and pass it to function
                bArray = attributes(7) & vbNullChar
                foreignkey_setOnDelete forkey, bArray(0)
            End If
            If attributes(8) <> "" And attributes(8) <> m_sNullRep Then
            
                'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
                'foreignkey_setComment forkey, StrPtr(attributes(8))
                'convert string to ucs2 byte array and pass it to function
                bArray = attributes(8) & vbNullChar
                foreignkey_setComment forkey, bArray(0)
            End If
            name = attributes(2)
        End If
    
        refcolslen = foreignkey_referencingColumns(forkey, refcols(0))
        reflen = foreignkey_reference(forkey, ref(0))
        If Left(refcols, refcolslen) <> "" Then
        
            'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
            'foreignkey_setReferencingColumns forkey, StrPtr(Left(refcols, refcolslen) + ",")
            'convert string to ucs2 byte array and pass it to function
            bArray = Left(refcols, refcolslen) + "," & vbNullChar
            foreignkey_setReferencingColumns forkey, bArray(0)
            
            'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
            'foreignkey_setReference forkey, StrPtr(Left(Left(ref, reflen), Len(Left(ref, reflen)) - 1) + ",")
            'convert string to ucs2 byte array and pass it to function
            bArray = Left(Left(ref, reflen), Len(Left(ref, reflen)) - 1) + "," & vbNullChar
            foreignkey_setReference forkey, bArray(0)
        End If
    
        refcolslen = foreignkey_referencingColumns(forkey, refcols(0))
        reflen = foreignkey_reference(forkey, ref(0))
        
        'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
        'foreignkey_setReferencingColumns forkey, StrPtr(Left(refcols, refcolslen) + attributes(3))
        'convert string to ucs2 byte array and pass it to function
        bArray = Left(refcols, refcolslen) + attributes(3) & vbNullChar
        foreignkey_setReferencingColumns forkey, bArray(0)
        
        'Replace StrPtr to be prepared for VB.NET, StrPtr is not supported in VB.NET
        'foreignkey_setReference forkey, StrPtr(Left(ref, reflen) + attributes(6) + ")")
        'convert string to ucs2 byte array and pass it to function
        bArray = Left(ref, reflen) + attributes(6) + ")" & vbNullChar
        foreignkey_setReference forkey, bArray(0)
    Next
    
    Exit Function
    
errEvaluateImportedForeignKeys:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function


