VERSION 5.00
Begin VB.UserControl SynonymDefinition 
   ClientHeight    =   3690
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   7065
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   3690
   ScaleWidth      =   7065
   Begin VB.Frame fraMisc 
      Height          =   540
      Left            =   180
      TabIndex        =   6
      Top             =   1095
      Width           =   6630
      Begin VB.CheckBox chkUpperCase 
         Caption         =   "Synonymname uppercase"
         Height          =   375
         Left            =   1620
         TabIndex        =   8
         Top             =   135
         Width           =   2340
      End
      Begin VB.CheckBox chkPublic 
         Caption         =   "Public"
         Height          =   375
         Left            =   165
         TabIndex        =   7
         TabStop         =   0   'False
         Top             =   135
         Width           =   840
      End
   End
   Begin VB.Frame fraComment 
      Caption         =   "Comment"
      Height          =   1725
      Left            =   180
      OLEDropMode     =   1  'Manual
      TabIndex        =   4
      Top             =   1695
      Width           =   6400
      Begin VB.TextBox txtComment 
         Height          =   1200
         Left            =   180
         MultiLine       =   -1  'True
         OLEDropMode     =   1  'Manual
         ScrollBars      =   2  'Vertical
         TabIndex        =   1
         TabStop         =   0   'False
         Top             =   330
         Width           =   6000
      End
   End
   Begin VB.TextBox txtSynonymname 
      Height          =   315
      Left            =   1800
      MousePointer    =   3  'I-Beam
      OLEDropMode     =   1  'Manual
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   300
      Width           =   3660
   End
   Begin VB.Label lblTable 
      Caption         =   "<none>"
      Height          =   255
      Left            =   1860
      OLEDropMode     =   1  'Manual
      TabIndex        =   2
      Top             =   750
      Width           =   7860
   End
   Begin VB.Label lblTableLabel 
      Caption         =   "for Table:"
      Height          =   255
      Left            =   180
      OLEDropMode     =   1  'Manual
      TabIndex        =   5
      Top             =   750
      Width           =   1455
   End
   Begin VB.Label lblSynonymname 
      Caption         =   "Synonym Name:"
      Height          =   255
      Left            =   180
      OLEDropMode     =   1  'Manual
      TabIndex        =   3
      Top             =   360
      Width           =   1575
   End
   Begin VB.Menu mnuSynonymDefinition 
      Caption         =   "Synonym &Definition"
      NegotiatePosition=   2  'Middle
      Begin VB.Menu mnuCreateSynonym 
         Caption         =   "&Create Synonym"
      End
      Begin VB.Menu mnuShowSQL 
         Caption         =   "Export to DirectS&QL"
      End
   End
End
Attribute VB_Name = "SynonymDefinition"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'========================================================================================
'
' module:      SynonymDefinition.ctl
'
'========================================================================================
'
' responsible:    RalfS/WolfgangA
'
' special area:   SQLStudio
'
' description:    Control for creating a new synonym definition.
'
'========================================================================================

Option Explicit

'==============================================================================
' Constant definitions
'==============================================================================
Const MODULE_NAME = "SQLStudio.SynonymDefinitionControl"
Const MX_COLUMN_NAME = 256

'==============================================================================
' Event declarations
'==============================================================================
Event CloseMe()

Event ShowSQLInDirectSQL(oSFC As SQLStudioMan.storedFileContent)
'==============================================================================
' Private members
'==============================================================================
Private m_lParentWnd                As Long
Private m_oGlobalInfo                As SQLStudioMan.globalInfo
Private m_oConnection               As SQLStudioDBLayer.connection
Private m_sTablename                As String
Private m_lOldWidth                 As Long
Private m_lOldHeight                As Long
Private m_bLoaded                   As Boolean
Private m_bNoDragDrop               As Boolean

Private m_lAppVersion               As Long

Private m_oSQLStatement             As New BreakStatement

Private m_bUpperCase                As Boolean
'=========================================================================================
'    property:      AppVersion (Let)
'    description:   Sets the private member m_lAppVersion to the given value.
'    arguments:     [in] NewAppVersion - new value of the property
'    return value:  -
'=========================================================================================
Public Property Let appVersion(NewAppVersion As Long)
    On Error GoTo errP_LET_AppVersion

    Const FUNCTION_NAME = "p_let appVersion"
    
    m_lAppVersion = NewAppVersion
    
    Exit Property
    
errP_LET_AppVersion:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'==============================================================================
' Set the private member m_lParentWnd to the given value
'==============================================================================
Public Property Let callingWindow(hWnd As Long)
    On Error GoTo errP_LET_CallingWindow

    Const FUNCTION_NAME = "p_LET CallingWindow"

    m_lParentWnd = hWnd

    Exit Property

errP_LET_CallingWindow:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'==============================================================================
' Create a new instance of the globalInfo class and store it in the private
' member m_oGlobalInfo.
'==============================================================================
Public Property Set globalInfo(newGlobalInfo As SQLStudioMan.globalInfo)
    On Error GoTo errP_SET_globalInfo

    Const FUNCTION_NAME = "p_SET globalInfo"

    Set m_oGlobalInfo = newGlobalInfo
    '--------------------------------------------------------------------------
    ' Initializations
    '--------------------------------------------------------------------------
    'check initial value of uppercase value
    If m_oGlobalInfo.UserProfile.identifiersCaseSensitiv Then
        chkUpperCase.value = vbUnchecked
        m_bUpperCase = False
    Else
        chkUpperCase.value = vbChecked
        m_bUpperCase = True
    End If
    
    
    Exit Property

errP_SET_globalInfo:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'==============================================================================
' Create a new instance of the Connection class and store it in the
' private member m_oConnection.
'==============================================================================
Public Property Set connection(NewConnection As SQLStudioDBLayer.connection)
    On Error GoTo errP_SET_Connection

    Const FUNCTION_NAME = "p_SET Connection"
    
    Set m_oConnection = NewConnection
    
    Exit Property
    
errP_SET_Connection:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'==============================================================================
' Get the value of the private member m_oConnection
'==============================================================================
Public Property Get connection() As SQLStudioDBLayer.connection
    On Error GoTo errP_Get_Connection

    Const FUNCTION_NAME = "G_GET Connection"
    
    Set connection = m_oConnection
    
    Exit Property
    
errP_Get_Connection:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'==============================================================================
' Get the value of the parent control.
'==============================================================================
Public Property Get parentControl() As Object
    On Error GoTo errP_Get_ParentControl

    Const FUNCTION_NAME = "G_GET ParentControl"

    Set parentControl = Parent

    Exit Property

errP_Get_ParentControl:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'==============================================================================
' Handle the KeyDown event for the Public checkbox.
'==============================================================================
Private Sub chkPublic_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errChkPublic_KeyDown
    
    Const FUNCTION_NAME = "chkPublic_KeyDown"
    
    If KeyCode <> vbKeyTab Then Exit Sub
    
    If Shift = 0 Then
        If txtComment.Visible = True Then txtComment.SetFocus
    Else
        If txtSynonymname.Visible = True Then txtSynonymname.SetFocus
    End If
    
    Exit Sub
    
errChkPublic_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub chkPublic_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errChkPublic_MouseUp
    
    Const FUNCTION_NAME = "chkPublic_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSynonymDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
errChkPublic_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the Public checkbox.
'==============================================================================
Private Sub chkPublic_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errChkPublic_OLEDragDrop
    
    Const FUNCTION_NAME = "chkPublic_OLEDragDrop"
    
    m_sTablename = ""
    dragDropActions
    
    Exit Sub
    
errChkPublic_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub chkPublic_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo errChkPublic_OLEDragOver
    
    Const FUNCTION_NAME = "chkPublic_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
errChkPublic_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub fraComment_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrfraComment_MouseUp
    
    Const FUNCTION_NAME = "fraComment_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSynonymDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
ErrfraComment_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the Comment frame.
'==============================================================================
Private Sub fraComment_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrfraComment_OLEDragDrop
    
    Const FUNCTION_NAME = "fraComment_OLEDragDrop"
    
    m_sTablename = ""
    dragDropActions
    
    Exit Sub
    
ErrfraComment_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub fraComment_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo ErrfraComment_OLEDragOver
        
    Const FUNCTION_NAME = "fraComment_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
ErrfraComment_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub fraMisc_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
 On Error GoTo errfraMisc_MouseUp
    
    Const FUNCTION_NAME = "fraMisc_MouseUp"
    
    Select Case Button
    Case vbRightButton:
        PopupMenu mnuSynonymDefinition, vbPopupMenuRightButton
    End Select
    
    Exit Sub
    
errfraMisc_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub lblSynonymname_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo errLblSynonymname_OLEDragOver
    
    Const FUNCTION_NAME = "lblSynonymname_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
errLblSynonymname_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub lblTable_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblTable_MouseUp
    
    Const FUNCTION_NAME = "lblTable_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSynonymDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
errLblTable_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the label of the 'on Table' field.
'==============================================================================
Private Sub lblTable_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblTable_OLEDragDrop
    
    Const FUNCTION_NAME = "lblTable_OLEDragDrop"
    
    m_sTablename = ""
    dragDropActions
    
    Exit Sub
    
errLblTable_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub lblTable_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo errLblTable_OLEDragOver
    
    Const FUNCTION_NAME = "lblTable_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
errLblTable_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub lblTableLabel_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblTableLabel_MouseUp
    
    Const FUNCTION_NAME = "lblTableLabel_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSynonymDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
errLblTableLabel_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the label of the 'on Table' field.
'==============================================================================
Private Sub lblTableLabel_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblTableLabel_OLEDragDrop
    
    Const FUNCTION_NAME = "lblTableLabel_OLEDragDrop"
    
    m_sTablename = ""
    dragDropActions
    
    Exit Sub
    
errLblTableLabel_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub lblSynonymname_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblSynonymname_MouseUp
    
    Const FUNCTION_NAME = "lblSynonymname_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSynonymDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
errLblSynonymname_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the label of the Synonym Name field.
'==============================================================================
Private Sub lblSynonymname_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errLblSynonymname_OLEDragDrop
    
    Const FUNCTION_NAME = "lblSynonymname_OLEDragDrop"
    
    m_sTablename = ""
    dragDropActions
    
    Exit Sub
    
errLblSynonymname_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub lblTableLabel_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo errLblTableLabel_OLEDragOver
    
    Const FUNCTION_NAME = "lblTableLabel_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
errLblTableLabel_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the Click event for the table menu item "Create Synonym".
'==============================================================================
Private Sub mnuCreateSynonym_Click()
    On Error GoTo errMnuCreateSynonym_Click
    
    Const FUNCTION_NAME = "mnuCreateSynonym_Click"
    
    execute
    
    Exit Sub
    
errMnuCreateSynonym_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' When the menu "Show SQL" was clicked, compose an SQL statement with
' the currently entered values.
'==============================================================================
Private Sub mnuShowSQL_Click()
    On Error GoTo errMnuShowSQL_Click
    
    Const FUNCTION_NAME = "mnuShowSQL_Click"
    
    Dim sStatement As String
    
    sStatement = composeSQLStatement
    
    '--------------------------------------------------------------------------
    ' If the returned string is empty, no Synonym name was specified. In this
    ' case an error message is displayed. Otherwise the SQL statement will
    ' be displayed in a new window.
    '--------------------------------------------------------------------------
    If sStatement = "" Then
        MsgBox LoadResString(505), vbExclamation, LoadResString(504)
    Else
        showSQLStatement (sStatement)
    End If
    
    Exit Sub
    
errMnuShowSQL_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the KeyDown event for the Comment field.
'==============================================================================
Private Sub txtComment_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrtxtComment_KeyDown
    
    Const FUNCTION_NAME = "txtComment_KeyDown"
    
    If m_bNoDragDrop = True Then Exit Sub
    If KeyCode <> vbKeyTab Then Exit Sub
    
    If Shift = 0 Then
        If txtSynonymname.Visible = True Then txtSynonymname.SetFocus
    Else
        If chkPublic.Visible = True Then chkPublic.SetFocus
    End If
    
    Exit Sub
    
ErrtxtComment_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the KeyPress event for the comment textbox.
'==============================================================================
Private Sub txtComment_KeyPress(KeyAscii As Integer)
    On Error GoTo ErrtxtComment_KeyPress
    
    Const FUNCTION_NAME = "txtComment_KeyPress"
    
    '--------------------------------------------------------------------------
    ' The TAB key was pressed.
    '--------------------------------------------------------------------------
    If KeyAscii = 9 Then KeyAscii = 0
    
    Exit Sub
    
ErrtxtComment_KeyPress:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event.
'==============================================================================
Private Sub txtComment_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrtxtComment_MouseUp
    
    Const FUNCTION_NAME = "txtComment_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSynonymDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
ErrtxtComment_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the Comment field.
'==============================================================================
Private Sub txtComment_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrtxtComment_OLEDragDrop
    
    Const FUNCTION_NAME = "txtComment_OLEDragDrop"
    
    m_sTablename = ""
    dragDropActions
    
    Exit Sub
    
ErrtxtComment_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub txtComment_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo ErrtxtComment_OLEDragOver
    
    Const FUNCTION_NAME = "txtComment_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
ErrtxtComment_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the KeyDown event for the Synonym Name field.
'==============================================================================
Private Sub txtSynonymname_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrtxtSynonymname_KeyDown
    
    Const FUNCTION_NAME = "txtSynonymname_KeyDown"
    
    If m_bNoDragDrop = True Then Exit Sub
    If KeyCode <> vbKeyTab Then Exit Sub
    
    If Shift = 0 Then
        If chkPublic.Visible = True Then chkPublic.SetFocus
    Else
        If txtComment.Visible = True Then txtComment.SetFocus
    End If
    
    Exit Sub
    
ErrtxtSynonymname_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub txtSynonymname_KeyPress(KeyAscii As Integer)
  On Error GoTo ErrtxtSynonymname_KeyPress
    
    Const FUNCTION_NAME = "txtSynonymname_KeyPress"

    If m_bUpperCase Then
        KeyAscii = Asc(UCase(Chr(KeyAscii)))
    End If
    
    Exit Sub
    
ErrtxtSynonymname_KeyPress:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event for the Synonym Name field.
'==============================================================================
Private Sub txtSynonymname_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrtxtSynonymname_MouseUp
    
    Const FUNCTION_NAME = "txtSynonymname_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSynonymDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
ErrtxtSynonymname_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the Synonym Name field.
'==============================================================================
Private Sub txtSynonymname_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo ErrtxtSynonymname_OLEDragDrop
    
    Const FUNCTION_NAME = "txtSynonymname_OLEDragDrop"
    
    m_sTablename = ""
    dragDropActions
    
    Exit Sub
    
ErrtxtSynonymname_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub txtSynonymname_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo ErrtxtSynonymname_OLEDragOver
    
    Const FUNCTION_NAME = "txtSynonymname_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
ErrtxtSynonymname_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Initialize the user control.
'==============================================================================
Private Sub UserControl_Initialize()
    On Error GoTo errUserControl_Initialize
    
    Const FUNCTION_NAME = "UserControl_Initialize"
    
    Dim i As Integer
    
    m_bLoaded = False
    m_bNoDragDrop = False
    
    '--------------------------------------------------------------------------
    ' Initialization of the strings.
    '--------------------------------------------------------------------------
    lblSynonymname.Caption = LoadResString(500)
    lblTableLabel.Caption = LoadResString(501)
    chkPublic.Caption = LoadResString(502)
    fraComment.Caption = LoadResString(503)
    
    m_oSQLStatement.addComment "//"
    m_oSQLStatement.addComment "--"
    
    m_lAppVersion = 72200
    
    m_bUpperCase = True
    
    Exit Sub
    
errUserControl_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the MouseUp event for the user control.
'==============================================================================
Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errUserControl_MouseUp
    
    Const FUNCTION_NAME = "UserControl_MouseUp"
    
    If Button = vbRightButton Then _
        PopupMenu mnuSynonymDefinition, vbPopupMenuRightButton
    
    Exit Sub
    
errUserControl_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the DragDrop event for the user control.
'==============================================================================
Private Sub UserControl_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    On Error GoTo errUserControl_OLEDragDrop
    
    Const FUNCTION_NAME = "UserControl_OLEDragDrop"
    
    m_sTablename = ""
    dragDropActions
    
    Exit Sub
    
errUserControl_OLEDragDrop:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub UserControl_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    On Error GoTo errUserControl_OLEDragOver
    
    Const FUNCTION_NAME = "UserControl_OLEDragOver"
    
    checkDragObject Effect
    
    Exit Sub
    
errUserControl_OLEDragOver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Handle the resize event for the control.
'==============================================================================
Private Sub UserControl_Resize()
    On Error GoTo errUserControl_Resize

    Const FUNCTION_NAME = "UserControl_Resize"
    
    resizeControls
    
    Exit Sub
    
errUserControl_Resize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Compose the CREATE statement with the values currently entered in the widgets.
'==============================================================================
Private Function composeSQLStatement() As String
    On Error GoTo errComposeSQLStatement

    Const FUNCTION_NAME = "composeSQLStatement"
    
    Dim sSQL           As String
    Dim i              As Integer
    Dim sSeperator     As String
    Dim sPublic        As String
    
    sSeperator = vbNewLine + "//" + vbNewLine
    
    '--------------------------------------------------------------------------
    ' Check if a Synonym name was given. If not, an empty string will be
    ' returned.
    '--------------------------------------------------------------------------
    If txtSynonymname.text = "" Then
        composeSQLStatement = ""
        Exit Function
    End If
    
    If chkPublic.value = 0 Then
        sPublic = ""
    Else
        sPublic = "PUBLIC "
    End If
                
    '----------------------------------------------------------------------
    ' Create the CREATE Synonym clause with the entered synonym name.
    '----------------------------------------------------------------------
    sSQL = vbNewLine + "CREATE " + sPublic + "SYNONYM "
    If m_bUpperCase Then
        sSQL = sSQL + Chr(34) + UCase(txtSynonymname.text) + Chr(34)
    Else
        sSQL = sSQL + Chr(34) + txtSynonymname.text + Chr(34)
    End If
    
    sSQL = sSQL + " FOR " + Chr(34) + m_sTablename + Chr(34)
    
    '----------------------------------------------------------------------
    ' Append the SQL statement for the entered comment.
    '----------------------------------------------------------------------
    If txtComment.text <> "" Then
        sSQL = sSQL + sSeperator + "COMMENT ON " + sPublic + "SYNONYM "
        If m_bUpperCase Then
           sSQL = sSQL + Chr(34) + UCase(txtSynonymname.text) + Chr(34)
        Else
           sSQL = sSQL + Chr(34) + txtSynonymname.text + Chr(34)
        End If
        sSQL = sSQL + " IS '" + txtComment.text + "'"
    End If
    
    composeSQLStatement = sSQL
    
    Exit Function
    
errComposeSQLStatement:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'==============================================================================
' Execute the resulting SQL statement.
'==============================================================================
Public Function execute()
    On Error GoTo errExecute
    
    Const FUNCTION_NAME = "execute"
    
    Dim sSQL            As String
    Dim oResult         As SQLStudioDBLayer.Result
    
    '--------------------------------------------------------------------------
    ' Generate the SQL statements depending on the input of the user.
    '--------------------------------------------------------------------------
    sSQL = composeSQLStatement
    
    '--------------------------------------------------------------------------
    ' If the returned string is empty, no Synonym name was specified. In this
    ' case an error message is displayed. Otherwise the SQL statement will
    ' be sent to the database.
    '--------------------------------------------------------------------------
    If sSQL = "" Then
        MsgBox LoadResString(511), vbExclamation, LoadResString(510)
    Else
        '----------------------------------------------------------------------
        ' Initialize the SQL statement object
        '----------------------------------------------------------------------
        Set m_oSQLStatement.connection = m_oConnection
        m_oSQLStatement.resultMode = sapdbSimpleMode
        m_oSQLStatement.callingWindow = m_lParentWnd
        m_oSQLStatement.statement = sSQL
        
        '----------------------------------------------------------------------
        ' Execute each SQL statement of the given string.
        '----------------------------------------------------------------------
        While Not m_oSQLStatement.eos And _
              Len(Trim$(m_oSQLStatement.currentStatement)) > 0 And _
              Trim$(m_oSQLStatement.currentStatement) <> vbCrLf
            If m_oSQLStatement.execute(oResult, Internal) Then
                m_oSQLStatement.nextStatement
            Else
                m_oConnection.Error.showError
                m_oSQLStatement.statement = "ROLLBACK"
                m_oSQLStatement.execute oResult, Internal
                Exit Function
            End If
        Wend
                
        m_oSQLStatement.statement = "COMMIT"
        m_oSQLStatement.execute oResult, Internal
        
        '----------------------------------------------------------------------
        ' Display a feedback messagebox.
        '----------------------------------------------------------------------
        MsgBox LoadResString(508), vbExclamation, LoadResString(507)
    
        RaiseEvent CloseMe
    End If
    
    Exit Function
    
errExecute:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'==============================================================================
' Update the user interface when a table is dropped.
'==============================================================================
Public Function dragDropActions(Optional tablename As String)
    On Error GoTo ErrDragDropActions

    Const FUNCTION_NAME = "dragDropActions"
    
    Dim s               As String
    Dim i               As Integer
    Dim oResult         As New SQLStudioDBLayer.Result
    Dim oDragObject     As Object
    Dim sOwner          As String
    Dim sTable          As String
    Dim eType           As cvItemType
    
    Set oResult.connection = m_oConnection
    
    If m_bNoDragDrop = True Then Exit Function
    
    '--------------------------------------------------------------------------
    ' If no tablename was given, a table has been dropped onto the form.
    ' In this case the tablename has to be extracted from the dropped item.
    '--------------------------------------------------------------------------
    If tablename = "" Then
        For Each oDragObject In m_oGlobalInfo.dragObjects
        
            '--------------------------------------------------------------------------
            '   if a sql studio om is droped leave sub
            '--------------------------------------------------------------------------
            If TypeOf oDragObject Is SQLStudioMan.storedFileContent Then Exit Function
    
            If oDragObject.Format = DBOTable Then Exit For
        Next
    
        '--------------------------------------------------------------------------
        ' If no table object was dropped, an error message is displayed.
        '--------------------------------------------------------------------------
        If oDragObject Is Nothing Then
            MsgBox LoadResString(510), vbExclamation, LoadResString(509)
            Exit Function
        End If
        
        m_oGlobalInfo.clearDragObjects
    
        If Not m_oGlobalInfo.splitCatalogDragInfo(oDragObject.objectName, sOwner, sTable, eType) Then Exit Function
        
        If eType = cmSynonym Then
            MsgBox LoadResString(510), vbExclamation, LoadResString(509)
            Exit Function
        Else
            m_sTablename = sTable
        End If
    Else
        m_sTablename = tablename
    End If
    
    txtComment.text = ""
    
    lblTable.Caption = m_sTablename
        
    If Not Parent Is Nothing Then Parent.ZOrder
    If txtSynonymname.Visible = True Then txtSynonymname.SetFocus
    
    Exit Function
    
ErrDragDropActions:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'==============================================================================
' Load the definition of a given synonym.
'==============================================================================
Public Function loadSynonymDefinition(sName As String, sOwner As String)
    On Error GoTo errLoadSynonymDefinition

    Const FUNCTION_NAME = "loadSynonymDefinition"
    
    Dim s               As String
    Dim sql             As String
    Dim pos             As Integer
    Dim sStatement      As String
    Dim oResult         As New SQLStudioDBLayer.Result
    
    Set oResult.connection = m_oConnection
    
    '--------------------------------------------------------------------------
    ' Set the synonym name.
    '--------------------------------------------------------------------------
    txtSynonymname.text = sName
    
    '--------------------------------------------------------------------------
    ' Load the synonym definition.
    '--------------------------------------------------------------------------
    sql = "SELECT tablename, public, comment FROM synonyms WHERE synonymname = '" + sName + "' AND owner = '" + sOwner + "'"
    If Not oResult.openResult(sql, Internal) Then Exit Function
    If oResult.noRows Then Exit Function
    If Not oResult.fetch() Then Exit Function
    If Not oResult.GetData() Then Exit Function

    lblTable.Caption = oResult.Columns(1).colValue
    m_sTablename = oResult.Columns(1).colValue
    If oResult.Columns(2).colValue = "YES" Then
        chkPublic.value = 1
    Else
        chkPublic.value = 0
    End If
    If oResult.Columns(3).colValue <> oResult.representationOfNullValue Then _
        txtComment.text = oResult.Columns(3).colValue
    
    '--------------------------------------------------------------------------
    ' Disable the GUI.
    '--------------------------------------------------------------------------
    txtSynonymname.Locked = True
    txtComment.Locked = True
    chkPublic.Enabled = False
    mnuCreateSynonym.Enabled = False
    m_bNoDragDrop = True
    
    Exit Function
    
errLoadSynonymDefinition:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'==============================================================================
' Resize the single widgets according to the enclosing form.
'==============================================================================
Private Sub resizeControls()
    On Error GoTo errResizeControls

    Const FUNCTION_NAME = "ResizeControls"
    
    '--------------------------------------------------------------------------
    ' Recalculate the new horizontal dimensions only if the width of
    ' the control was changed.
    '--------------------------------------------------------------------------
    If m_lOldWidth <> UserControl.ScaleWidth Then
        txtSynonymname.Width = UserControl.ScaleWidth - txtSynonymname.Left - 200
        lblTable.Width = txtSynonymname.Width
        fraComment.Width = UserControl.ScaleWidth - 350
        txtComment.Width = fraComment.Width - 350
        fraMisc.Width = fraComment.Width
        m_lOldWidth = UserControl.ScaleWidth
    End If
        
    '--------------------------------------------------------------------------
    ' Recalculate the new vertical dimensions only if the height of
    ' the control was changed.
    '--------------------------------------------------------------------------
    If m_lOldHeight <> UserControl.ScaleHeight Then
        fraComment.Height = UserControl.ScaleHeight - fraComment.top - 200
        txtComment.Height = fraComment.Height - 550
        m_lOldHeight = UserControl.ScaleHeight
    End If
    
    Exit Sub
    
errResizeControls:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'==============================================================================
' Show the resulting SQL statement in a separate window.
'==============================================================================
Private Sub showSQLStatement(sStatement As String)
    On Error GoTo errShowSQLStatement

    Const FUNCTION_NAME = "showSQLStatement"
        
    Dim oSFC As New SQLStudioMan.storedFileContent
    
    oSFC.sqlData = sStatement
    'the saved object has to have actual version numbers
    oSFC.appVersion = m_lAppVersion
    oSFC.version = m_lAppVersion
    oSFC.storedIcon = cmStoredDSQL
    
    oSFC.FileName = ""
    
    RaiseEvent ShowSQLInDirectSQL(oSFC)
    
    Exit Sub
    
errShowSQLStatement:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Function checkDragObject(Effect As Long)
    On Error GoTo errCheckDragObject

    Const FUNCTION_NAME = "checkDragObject"
        
    Dim oDragObject     As Object
    
    For Each oDragObject In m_oGlobalInfo.dragObjects
        '--------------------------------------------------------------------------
        '   if a sql studio om is droped leave sub
        '--------------------------------------------------------------------------
        If TypeOf oDragObject Is SQLStudioMan.storedFileContent Then _
            Effect = Effect = vbDropEffectNone
        
    Next
    
    Exit Function
    
errCheckDragObject:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Private Sub chkUpperCase_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
 On Error GoTo errchkUpperCase_MouseUp
    
    Const FUNCTION_NAME = "chkUpperCase_MouseUp"
    
    Select Case Button
    Case vbRightButton:
        PopupMenu mnuSynonymDefinition, vbPopupMenuRightButton
    End Select
    
    Exit Sub
    
errchkUpperCase_MouseUp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub chkUpperCase_Click()
 On Error GoTo ErrchkUpperCase_Click
    
    Const FUNCTION_NAME = "chkUpperCase_Click"
    
    Dim i As Integer
    
    If chkUpperCase.value = vbChecked Then
    
        txtSynonymname = UCase(txtSynonymname)
        
        m_bUpperCase = True
    Else
        m_bUpperCase = False
    End If
    
    Exit Sub
    
ErrchkUpperCase_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub



