VERSION 5.00
Begin VB.Form frmProperties 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Properties"
   ClientHeight    =   2340
   ClientLeft      =   30
   ClientTop       =   270
   ClientWidth     =   4035
   Icon            =   "SOProperties.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2340
   ScaleWidth      =   4035
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.ComboBox lstCommitMode 
      Height          =   315
      Left            =   1728
      Style           =   2  'Dropdown List
      TabIndex        =   1
      ToolTipText     =   "SQLMode"
      Top             =   324
      Width           =   2208
   End
   Begin VB.ComboBox lstSQLMode 
      Height          =   315
      Left            =   1728
      Style           =   2  'Dropdown List
      TabIndex        =   2
      ToolTipText     =   "SQLMode"
      Top             =   738
      Width           =   2208
   End
   Begin VB.ComboBox lstIsolationlevel 
      Height          =   315
      Left            =   1728
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   1152
      Width           =   2208
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   2520
      TabIndex        =   5
      Top             =   1770
      Width           =   1200
   End
   Begin VB.CommandButton cmdOk 
      Caption         =   "&Ok"
      Default         =   -1  'True
      Height          =   375
      Left            =   495
      TabIndex        =   4
      Top             =   1770
      Width           =   1200
   End
   Begin VB.Label lblCommitMode 
      AutoSize        =   -1  'True
      Caption         =   "Auto Commit Mode:"
      Height          =   195
      Left            =   210
      TabIndex        =   0
      Top             =   330
      Width           =   1380
   End
   Begin VB.Label lblIso 
      AutoSize        =   -1  'True
      Caption         =   "Isolation Level:"
      Height          =   192
      Left            =   216
      TabIndex        =   7
      Top             =   1188
      Width           =   1068
   End
   Begin VB.Label lblSQLMode 
      AutoSize        =   -1  'True
      Caption         =   "SQL Mode:"
      Height          =   192
      Left            =   216
      TabIndex        =   6
      Top             =   744
      Width           =   804
   End
End
Attribute VB_Name = "frmProperties"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Module:      .frmProperties
'
'-----------------------------------------------------------------------
'
' responsible: WolfgangA
'
' special area: SQLStudio
'
' description:  Form to show properties of stored sqlstudio objects
'
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'--------------------------------------------------------
'module name
'--------------------------------------------------------
Const MODULE_NAME = "frmProperties"


Option Explicit

Private m_emIsoLevel        As IsoLevel
Private m_emSQLMode         As SQLMode
Private m_emAutoCommitMode  As AutoCommit
Private m_emObjectType      As fileType

Private m_bOK                 As Boolean
'=========================================================================================
'    function:      cmdCancel_Click
'    description:   the cancel button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdCancel_Click()
    On Error GoTo ErrcmdCancel_Click

    Const FUNCTION_NAME = "cmdCancel_Click"
        
    m_bOK = False
        
    Me.Visible = False
    
    Exit Sub
    
ErrcmdCancel_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      cmdOk_Click
'    description:   the ok button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdOK_Click()
    On Error GoTo ErrcmdOK_Click

    Const FUNCTION_NAME = "cmdOk_Click"
        
    getItemAttributes
    
    m_bOK = True
    Me.Visible = False
    
    Exit Sub
    
ErrcmdOK_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      Form_Load
'    description:   Occurs when a form is loaded.
'                   For a startup form, occurs when an application starts as
'                   the result of a Load statement or as the result of a
'                   reference to an unloaded form's properties or controls.
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Load()
 On Error GoTo ErrFormLoad
    
    Const FUNCTION_NAME = "Form_Load"
    
    m_bOK = False
    
    lstSQLMode.AddItem LoadResString(321), 0 'ADABAS
    lstSQLMode.AddItem LoadResString(322), 1 'DB2
    lstSQLMode.AddItem LoadResString(323), 2 'ANSI
    lstSQLMode.AddItem LoadResString(324), 3 'ORACLE
        
    lstIsolationlevel.AddItem LoadResString(301), 0
    lstIsolationlevel.AddItem LoadResString(302), 1
    lstIsolationlevel.AddItem LoadResString(303), 2
    lstIsolationlevel.AddItem LoadResString(304), 3
    'isolevel versioning is not supported by database
    'lstIsolationlevel.AddItem LoadResString(305), 4

    lstCommitMode.AddItem LoadResString(330), 0 'Auto Commit ON
    lstCommitMode.AddItem LoadResString(331), 1
    
    setItemAttributes
    
    Exit Sub
    
ErrFormLoad:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    property:      isoLevel
'    description:   get the value of the iso level of the object
'    arguments:     /
'
'    return value:  SQLStudioDBLayer.isoLevel
'
'=========================================================================================
Public Property Get IsoLevel() As IsoLevel
    On Error GoTo ErrP_GET_IsoLevel

    Const FUNCTION_NAME = "P_GET IsoLevel"
    
    IsoLevel = m_emIsoLevel
    
    Exit Property
    
ErrP_GET_IsoLevel:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      isoLevel
'    description:   set the value of the iso level of the object
'    arguments:     newIsoLevel
'
'    return value:  /
'
'=========================================================================================
Public Property Let IsoLevel(NewIsoLevel As IsoLevel)
    On Error GoTo ErrP_LET_IsoLevel

    Const FUNCTION_NAME = "P_LET IsoLevel"
    
    m_emIsoLevel = NewIsoLevel
    
    Exit Property
    
ErrP_LET_IsoLevel:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      sqlMode
'    description:   get the value of the sql mode of the object
'    arguments:     /
'
'    return value:  SQLStudioDBLayer.sqlMode
'
'=========================================================================================
Public Property Get SQLMode() As SQLMode
    On Error GoTo ErrP_GET_SQLMode

    Const FUNCTION_NAME = "P_GET SQLMode"
    
    SQLMode = m_emSQLMode
    
    Exit Property
    
ErrP_GET_SQLMode:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      sqlMode
'    description:   let the value of the sql mode of the object
'    arguments:     newSQLMode
'
'    return value:  /
'
'=========================================================================================
Public Property Let SQLMode(NewSQLMode As SQLMode)
    On Error GoTo errP_LET_SQLMode

    Const FUNCTION_NAME = "P_LET SQLMode"
    
    m_emSQLMode = NewSQLMode
    
    Exit Property
    
errP_LET_SQLMode:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      autoCommitMode
'    description:   get the auto commit on/off flag of the object
'    arguments:     /
'
'    return value:  SQLStudioDBLayer.AutoCommit
'
'=========================================================================================
Public Property Get autoCommitMode() As AutoCommit
    On Error GoTo ErrP_GET_AutoCommitMode

    Const FUNCTION_NAME = "P_GET AutoCommitMode"
    
    autoCommitMode = m_emAutoCommitMode
    
    Exit Property
    
ErrP_GET_AutoCommitMode:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      autoCommitMode
'    description:   set the auto commit on/off flag of the object
'    arguments:     newAutoCommit
'
'    return value:  /
'
'=========================================================================================
Public Property Let autoCommitMode(NewAutoCommitMode As AutoCommit)
    On Error GoTo errP_LET_AutoCommitMode

    Const FUNCTION_NAME = "P_LET AutoCommitMode"
    
    m_emAutoCommitMode = NewAutoCommitMode
    
    Exit Property
    
errP_LET_AutoCommitMode:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      objectType
'    description:   get which sql studio object type is represented
'    arguments:     /
'
'    return value:  fileType
'
'=========================================================================================
Public Property Get fileType() As fileType
    On Error GoTo ErrP_GET_fileType

    Const FUNCTION_NAME = "P_GET fileType"
    
    fileType = m_emObjectType
        
    Exit Property
    
ErrP_GET_fileType:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      objectType
'    description:   let which sql studio object type is represented
'    arguments:     [in] NewObjectType, new object type
'
'    return value:  /
'
'=========================================================================================
Public Property Let fileType(NewObjectType As fileType)
    On Error GoTo ErrP_LET_ObjectName

    Const FUNCTION_NAME = "P_LET fileType"
    
    m_emObjectType = NewObjectType
    
    lstCommitMode.Enabled = False
    lstSQLMode.Enabled = False
        
    If m_emObjectType = fileTypeStatement Then
        
        lstCommitMode.Enabled = True
        lstSQLMode.Enabled = True
    Else
        lstSQLMode.ListIndex = 0
    End If
    
    Exit Property
    
ErrP_LET_ObjectName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      ok
'    description:   get if ok button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Public Property Get ok() As Boolean
    On Error GoTo ErrP_GET_OK

    Const FUNCTION_NAME = "P_Get ok"
    
    ok = m_bOK
    
    Exit Property
    
ErrP_GET_OK:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    function:      setItemAttributes
'    description:   set the attributes of a sql studio object to dialog
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub setItemAttributes()
    On Error GoTo errSetItemAttributes
    
    Const FUNCTION_NAME = "setItemAttributes"
            
    If m_emAutoCommitMode = SQLStudioDBLayer.AutoCommitOn Then
    
        lstCommitMode.ListIndex = 0
    Else
        lstCommitMode.ListIndex = 1
    End If
    
    Select Case m_emSQLMode
    
        Case SQLStudioDBLayer.Internal
            lstSQLMode.ListIndex = 0
        Case SQLStudioDBLayer.DB2
            lstSQLMode.ListIndex = 1
        Case SQLStudioDBLayer.Ansi
            lstSQLMode.ListIndex = 2
        Case SQLStudioDBLayer.Oracle
            lstSQLMode.ListIndex = 3
    End Select
    
    Select Case m_emIsoLevel
        Case SQLStudioDBLayer.UnCommitted
            lstIsolationlevel.ListIndex = 0
        Case SQLStudioDBLayer.Committed
            lstIsolationlevel.ListIndex = 1
        Case SQLStudioDBLayer.Repeatable
            lstIsolationlevel.ListIndex = 2
        Case SQLStudioDBLayer.Serializable
            lstIsolationlevel.ListIndex = 3
    End Select
    
    Exit Sub

errSetItemAttributes:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      getItemAttributes
'    description:   get the attributes of a sql studio object from dialog
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub getItemAttributes()
    On Error GoTo errGetItemAttributes
    
    Const FUNCTION_NAME = "getItemAttributes"
            
    If lstCommitMode.ListIndex = 0 Then
        m_emAutoCommitMode = SQLStudioDBLayer.AutoCommitOn
    Else
        m_emAutoCommitMode = SQLStudioDBLayer.AutoCommitOff
    End If
    
    Select Case lstSQLMode.ListIndex
        Case 0
            m_emSQLMode = SQLStudioDBLayer.Internal
        Case 1
            m_emSQLMode = SQLStudioDBLayer.DB2
        Case 2
            m_emSQLMode = SQLStudioDBLayer.Ansi
        Case 3
            m_emSQLMode = SQLStudioDBLayer.Oracle
    End Select
    
    Select Case lstIsolationlevel.ListIndex
        Case 0
            m_emIsoLevel = SQLStudioDBLayer.UnCommitted
        Case 1
            m_emIsoLevel = SQLStudioDBLayer.Committed
        Case 2
            m_emIsoLevel = SQLStudioDBLayer.Repeatable
        Case 3
            m_emIsoLevel = SQLStudioDBLayer.Serializable
    End Select
    
    Exit Sub

errGetItemAttributes:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

