Attribute VB_Name = "Core"
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Module:      Core
'
'
'-----------------------------------------------------------------------
'
' responsible:  WolfgangA
'
' special area: SQL Studio DB Layer
'
' description:  contains constants, function imports
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


Global Const MX_CONNECT_STRING_OUT = 512

Global Const MX_DIAG_FIELD_OUT = 1024

Global Const SQL_CONCUR_READ_ONLY = 1
Global Const SQL_CONCUR_LOCK = 2
Global Const SQL_CONCUR_ROWVER = 3
Global Const SQL_CONCUR_VALUES = 4

'SQL_CURSOR_TYPE options
Global Const SQL_CURSOR_FORWARD_ONLY = 0       'UL
Global Const SQL_CURSOR_KEYSET_DRIVEN = 1      'UL
Global Const SQL_CURSOR_DYNAMIC = 2            'UL
Global Const SQL_CURSOR_STATIC = 3             'UL


Global Const SQL_NTS = -3                  ' NTS = Null Terminated String
Global Const SQL_SQLSTATE_SIZE = 5         ' size of SQLSTATE
Global Const SQL_MAX_MESSAGE_LENGTH = 4096 ' message buffer size
Global Const SQL_MAX_DSN_LENGTH = 32       ' maximum data source name size
'
' RETCODEs
'
Global Const SQL_ERROR = -1
Global Const SQL_INVALID_HANDLE = -2
Global Const SQL_NEED_DATA = 99
Global Const SQL_NO_DATA_FOUND = 100
Global Const SQL_SUCCESS = 0
Global Const SQL_SUCCESS_WITH_INFO = 1
Global Const SQLSTATE_SUCCESS = "00000"
Global Const SQLSTATE_DATA_TRUNCATED = "01004"
'
' SQLFreeStmt defines
'

Global Const SQL_DIAG_CONNECT_STRING = 1001
Global Const SQL_DIAG_IS_NI_CONNECTION = 1002
Global Const SQL_CLOSE = 0
Global Const SQL_DROP = 1
Global Const SQL_UNBIND = 2
Global Const SQL_RESET_PARAMS = 3

'
'
' SQLTransact defines
'
Global Const SQL_COMMIT = 0
Global Const SQL_ROLLBACK = 1



 
Global Const SQL_TYPE_MIN = -7             ' Core Functions = 1 / Level 1+2 Functions = -7
Global Const SQL_TYPE_NULL = 0
Global Const SQL_TYPE_MAX = 12
'
'
' Special length values
Global Const SQL_NULL_DATA = -1
Global Const SQL_DATA_AT_EXEC = -2

' SQLError defines
'
Global Const SQL_NULL_HENV = 0
Global Const SQL_NULL_HDBC = 0
Global Const SQL_NULL_HSTMT = 0

Global Const ODBC_ADD_DSN = 1         ' Add data source
Global Const ODBC_CONFIG_DSN = 2      ' Configure (edit) data source
Global Const ODBC_REMOVE_DSN = 3      ' Remove data source

Global Const MX_DATA_SOURCE_NAME = 256
Global Const MX_DESCRIPTION = 256
Global Const DSN_ADABAS = "ADABAS"
Global Const DSN_LIVECACHE = "LIVECACHE"
Global Const DSN_ADABAS2 = "SAPDB"
Global Const DSN_ADABAS3 = "SAP DB"


'
' Defines for SQLGetInfo
'
'''Global Const SQL_INFO_FIRST As Long = 0
'''Global Const SQL_ACTIVE_CONNECTIONS As Long = 0
'''Global Const SQL_ACTIVE_STATEMENTS As Long = 1
Global Const SQL_DATA_SOURCE_NAME As Long = 2
Global Const SQL_DRIVER_HDBC As Long = 3
Global Const SQL_DRIVER_HENV As Long = 4
Global Const SQL_DRIVER_HSTMT As Long = 5
Global Const SQL_DRIVER_NAME As Long = 6
Global Const SQL_DRIVER_VER As Long = 7
Global Const SQL_FETCH_DIRECTION As Long = 8
Global Const SQL_ODBC_VER As Long = 10
Global Const SQL_ROW_UPDATES As Long = 11
Global Const SQL_SERVER_NAME As Long = 13
Global Const SQL_ODBC_SQL_CONFORMANCE As Long = 15

 

Global Const SQL_INFO_DRIVER_START As Long = 1000

Global Const SQL_ATTR_ASYNC_ENABLE = 4
Global Const SQL_ASYNC_ENABLE_OFF = 0
Global Const SQL_ASYNC_ENABLE_ON = 1

Global Const SQL_QUERY_TIMEOUT = 0
Global Const SQL_MAX_ROWS = 1
Global Const SQL_NOSCAN = 2
Global Const SQL_MAX_LENGTH = 3
Global Const SQL_ASYNC_ENABLE = 4 '/* same as SQL_ATTR_ASYNC_ENABLE */
Global Const SQL_BIND_TYPE = 5
Global Const SQL_CURSOR_TYPE = 6
Global Const SQL_CONCURRENCY = 7
Global Const SQL_KEYSET_SIZE = 8
Global Const SQL_ROWSET_SIZE = 9
'''Global Const SQL_SIMULATE_CURSOR = 10
'''Global Const SQL_RETRIEVE_DATA = 11
Global Const SQL_USE_BOOKMARKS = 12
Global Const SQL_GET_BOOKMARK = 13 '     /*      GetStmtOption Only */
Global Const SQL_ROW_NUMBER = 14   '     /*      GetStmtOption Only */

Global Const SQL_ATTR_CONCURRENCY = SQL_CONCURRENCY
Global Const SQL_ATTR_CURSOR_TYPE = SQL_CURSOR_TYPE
Global Const SQL_ATTR_ROW_BIND_TYPE = SQL_BIND_TYPE
Global Const SQL_ATTR_USE_BOOKMARKS = SQL_USE_BOOKMARKS
Global Const SQL_ATTR_OPTIMIZE_CURSOR = 3002


Global Const SQL_UB_OFF = 0                    'UL
Global Const SQL_UB_ON = 1                     'UL
Global Const SQL_UB_DEFAULT = SQL_UB_OFF

Global Const SQL_NULL_HANDLE = 0

Global Const SQL_STILL_EXECUTING = 2


Global Const SQL_FALSE = 0
Global Const SQL_TRUE = 1



'========================================================================================='
' SQL portable types
' Transfer types for DATE, TIME, TIMESTAMP

Type DATE_STRUCT
  year As Integer
  month As Integer
  day As Integer
End Type

Type TIME_STRUCT
  hour As Integer
  minute As Integer
  second As Integer
End Type

Type TIMESTAMP_STRUCT
  year As Integer
  month As Integer
  day As Integer
  hour As Integer
  minute As Integer
  second As Integer
  fraction As Long
End Type

Type RECT_STRUCT
  left As Long
  top As Long
  right As Long
  bottom As Long
End Type

'=========================================================================================
'
' extended data types change this
'
'
' Options for SQLDriverConnect
'
Global Const SQL_DRIVER_NOPROMPT = 0
Global Const SQL_DRIVER_COMPLETE = 1
Global Const SQL_DRIVER_PROMPT = 2
Global Const SQL_DRIVER_COMPLETE_REQUIRED = 3
'
' Special return values for SQLGetData
'
Global Const SQL_NO_TOTAL = -4

Global Const SQL_HANDLE_ENV = 1
Global Const SQL_HANDLE_DBC = 2
Global Const SQL_HANDLE_STMT = 3
Global Const SQL_HANDLE_DESC = 4
'
' Transaction capable
'
Global Const SQL_TC_NONE = 0
Global Const SQL_TC_DML = 1
Global Const SQL_TC_ALL = 2
' #if ODBC 2.00
Global Const SQL_TC_DDL_COMMIT = 3
Global Const SQL_TC_DDL_IGNORE = 4
' #endif ODBC 2.00

Global Const SQL_PASS_THROUGH      As Long = 1001

Global Const MX_COLUMN_NAME = 512

'/* Operations in SQLSetPos */
Global Const SQL_POSITION = 0                 '        /*      1.0 FALSE */
Global Const SQL_REFRESH = 1                  '        /*      1.0 TRUE */
Global Const SQL_UPDATE = 2
Global Const SQL_DELETE = 3

'/* Lock options in SQLSetPos */
Global Const SQL_LOCK_NO_CHANGE = 0            '             /*      1.0 FALSE */
Global Const SQL_LOCK_EXCLUSIVE = 1            '             /*      1.0 TRUE */
Global Const SQL_LOCK_UNLOCK = 2


' Transaction isolation option masks
'
Global Const SQL_TXN_READ_UNCOMMITTED = 1          '0x00000001L
Global Const SQL_TXN_READ_COMMITTED = 2            '0x00000002L
Global Const SQL_TXN_REPEATABLE_READ = 4           '0x00000004L
Global Const SQL_TXN_SERIALIZABLE = 8              '0x00000008L
Global Const SQL_TXN_VERSIONING = 16               '0x00000010L

Global Const SQL_BIND_BY_COLUMN = 0        ' Suboption for SQL_BIND_TYPE
'
' options for SQLSetConnectOption/SQLGetConnectOption
'
Global Const SQL_AUTOCOMMIT = 102
Global Const SQL_TXN_ISOLATION = 108
Global Const SQL_CONNECT_OPT_DRVR_START = 1000
Global Const SQL_SQLMODE = SQL_CONNECT_OPT_DRVR_START + 2
Global Const SQL_CANCEL_ROUTERSTRING = SQL_CONNECT_OPT_DRVR_START + 10

Global Const SQL_IS_NI_CONNECTION = SQL_CONNECT_OPT_DRVR_START + 9
Global Const SQL_ATTR_SESSION_TIMEOUT = SQL_CONNECT_OPT_DRVR_START + 11
'
' SQL_autoCommit options
'
Global Const SQL_AUTOCOMMIT_OFF = 0
Global Const SQL_AUTOCOMMIT_ON = 1
Global Const SQL_AUTOCOMMIT_DEFAULT = 1

Global Const CPR_KIND_EMPTY = 0
Global Const CPR_KIND_ADABAS = 1
Global Const CPR_KIND_DB2 = 2
Global Const CPR_KIND_ANSI = 3
Global Const CPR_KIND_ORACLE = 4
Global Const CPR_KIND_SAPR3 = 5


'=========================================================================================

Declare Function SQLGetData Lib "odbc32.dll" (ByVal hStmt As Long, ByVal icol As Integer, ByVal ctype As Integer, Value As Any, ByVal valuemax As Long, ValueLen As Long) As Integer
Declare Function SQLGetStmtOption Lib "odbc32.dll" (ByVal hStmt As Long, ByVal opt As Integer, ByRef param As Long) As Integer
Declare Function SQLGetTypeInfo Lib "odbc32.dll" (ByVal hStmt As Long, ByVal sqltype As Integer) As Integer
Declare Function SQLParamData Lib "odbc32.dll" (ByVal hStmt As Long, Value As Long) As Integer
Declare Function SQLSetConnectOption Lib "odbc32.dll" (ByVal hDbc As Long, ByVal opt As Integer, ByVal param As Long) As Integer
'Declare Function SQLSetStmtOption Lib "odbc32.dll" (ByVal hStmt As Long, ByVal opt As Integer, ByVal param As Long) As Integer
Declare Function SQLSetStmtAttrLong Lib "odbc32.dll" Alias "SQLSetStmtAttr" (ByVal hStmt As Long, ByVal lAttribute As Long, ByVal lValue As Long, ByVal lStringLength As Long) As Integer
 

Declare Function SQLGetDiagFieldW Lib "odbc32.dll" (ByVal nHandleType As Integer, _
                                                    ByVal hStmt As Long, _
                                                    ByVal nRecNumber As Integer, _
                                                    ByVal nDiagId As Integer, _
                                                    bBuffer As Byte, _
                                                    ByVal lBufferLen As Long, _
                                                    ByRef lOutLen As Long) As Integer

'=========================================================================================
' Level 2 Functions
'
'
' SQLExtendedFetch "fFetchType" values
'
Global Const SQL_FETCH_NEXT = 1
Global Const SQL_FETCH_FIRST = 2
Global Const SQL_FETCH_LAST = 3
Global Const SQL_FETCH_PREV = 4
Global Const SQL_FETCH_ABSOLUTE = 5
Global Const SQL_FETCH_RELATIVE = 6
Global Const SQL_FETCH_RESUME = 7
'
Global Const SQL_PARAM_INPUT = 1

Public Const cnstQUERY_NULL = "?"

Public Const VK_ESCAPE = &H1B

'=========================================================================================
'
' Core Functions
'
Declare Function SQLAllocConnect Lib "odbc32.dll" (ByVal hEnv As Long, hDbc As Long) As Integer
Declare Function SQLAllocEnv Lib "odbc32.dll" (hEnv As Long) As Integer
Declare Function SQLAllocStmt Lib "odbc32.dll" (ByVal hDbc As Long, hStmt As Long) As Integer

Declare Function SQLCancel Lib "odbc32.dll" (ByVal hStmt As Long) As Integer
                                                   
Declare Function SQLDisconnect Lib "odbc32.dll" (ByVal hDbc As Long) As Integer


Declare Function SQLErrorW Lib "odbc32.dll" (ByVal hEnv As Long, _
                                             ByVal hDbc As Long, _
                                             ByVal hStmt As Long, _
                                             bSQLState As Byte, _
                                             nativeError As Long, _
                                             bErrorMsg As Byte, _
                                             ByVal errormsgmax As Integer, _
                                             ErrorMsgLen As Integer) As Integer



Declare Function SQLGetCursorNameW Lib "odbc32.dll" (ByVal hStmt As Long, _
                                                    cursor As Byte, _
                                                    ByVal cursormax As Integer, _
                                                    cursorlen As Integer) As Integer

                                                 
Declare Function SQLExecDirectW Lib "odbc32.dll" (ByVal hStmt As Long, _
                                                  bSqlstr As Byte, _
                                                  ByVal lSqlstrlen As Long) As Integer

Declare Function SQLFetch Lib "odbc32.dll" (ByVal hStmt As Long) As Integer

Declare Function SQLExtendedFetch Lib "odbc32.dll" (ByVal hStmt As Long, _
                                                    ByVal fetchtype As Integer, _
                                                    ByVal irow As Long, _
                                                    row As Long, _
                                                    rowstatus() As Integer) As Integer

Declare Function SQLFreeConnect Lib "odbc32.dll" (ByVal hDbc As Long) As Integer
Declare Function SQLFreeEnv Lib "odbc32.dll" (ByVal hEnv As Long) As Integer
Declare Function SQLFreeStmt Lib "odbc32.dll" (ByVal hStmt As Long, ByVal opt As Integer) As Integer
Declare Function SQLNumResultCols Lib "odbc32.dll" (ByVal hStmt As Long, cols As Integer) As Integer
Declare Function SQLRowCount Lib "odbc32.dll" (ByVal hStmt As Long, Rows As Long) As Integer
                                                        

'=======================================================================
'   WebAgent Pooling
'=======================================================================
Global Const WA_ERR_NO_ERROR = 0            '  /* this error is no error :-)  */
Global Const WA_ERR_MEMORY = 1              '  /* Memory allocation failure   */
Global Const WA_ERR_ODBC = 2                '  /* ODBC-error                  */


Declare Function sapdbwa_CreateDBCPool Lib "wapi.dll" (ByVal timeout As Long) As Long
Declare Function sapdbwa_DestroyDBCPool Lib "wapi.dll" (ByVal lPool As Long) As Byte


Declare Function sapdbwa_CreateDBC Lib "wapi.dll" () As Long
Declare Function sapdbwa_DestroyDBC Lib "wapi.dll" (ByVal sbc As Long) As Byte

Declare Function sapdbwa_DBCHandle Lib "wapi.dll" (ByVal dbc As Long) As Long
Declare Function sapdbwa_DBCEnv Lib "wapi.dll" (ByVal dbc As Long) As Long


Declare Function sapdbwa_DbConnect Lib "wapi.dll" (ByVal pool As Long) As Byte
Declare Function sapdbwa_DbDisconnect Lib "wapi.dll" (ByVal pool As Long) As Byte

Declare Function sapdbwa_DBCDisconnect Lib "wapi.dll" (ByVal DBCPool As Long, ByVal dbc As Long) As Byte

Declare Function sapdbwa_DBCConnect Lib "wapi.dll" (ByVal DBCPool As Long, _
                                              ByVal dbc As Long, _
                                              ByRef datasource As Byte, _
                                              ByRef driver As Byte, _
                                              ByRef dbServer As Byte, _
                                              ByRef dataBase As Byte, _
                                              ByRef user As Byte, _
                                              ByRef password As Byte, _
                                              ByRef sqltrace As Byte, _
                                              ByVal drivercompletion As Long, _
                                              ByVal hWnd As Long, _
                                              ByVal exclusive As Long) As Byte

'WABool WINAPI sapdbwa_DBCConnect( WADBCPoolP      dbcPool,
'                            WADBCP          dbc,
'                            const char     *datasource,
'                            const char     *driver,
'                            const char     *serverNode,
'                            const char     *serverDb,
'                            const char     *user,
'                            const char     *password,
'                            const char     *sqltrace,
'                            WAUint2         driverCompletion,
'                            SQLHWND         windowHandle,
'                            WADBCExclType   exclusive );


'WAerrP WINAPI sapdbwa_DBCGetErr( WADBCP dbc );
Declare Function sapdbwa_DBCGetErr Lib "wapi.dll" (ByVal dbc As Long) As Long

'void WINAPI sapdbwa_CopyErrMsg( WAerrP err, char *buf, WAUint4 bufLen );
Declare Function sapdbwa_CopyErrMsg Lib "wapi.dll" (ByVal err As Long, _
                                                    ByRef errbuffer As Byte, _
                                                    ByVal errbufferlen As Long) As Byte

'WAUint4 WINAPI sapdbwa_GetErrId( WAerrP err );
Declare Function sapdbwa_GetErrId Lib "wapi.dll" (ByVal err As Long) As Long

'WABool WINAPI sapdbwa_DBCSetAttr( WADBCP dbc, WAInt2 attr, WAInt4 value );
Declare Function sapdbwa_DBCSetAttr Lib "wapi.dll" (ByVal dbc As Long, ByVal attr As Integer, ByVal Value As Long) As Byte


'WABool WINAPI sapdbwa_DBCGetAttr( WADBCP dbc, WAInt2 attr, WAInt4 *pvalue );
Declare Function sapdbwa_DBCGetAttr Lib "wapi.dll" (ByVal dbc As Long, ByVal attr As Integer, ByRef Value As Long) As Byte

Declare Function sapdbwa_DBCGetUser Lib "wapi.dll" (ByVal dbc As Long, ByRef buf As Byte, ByVal buflen As Long) As Byte
Declare Function sapdbwa_DBCGetPassword Lib "wapi.dll" (ByVal dbc As Long, ByRef buf As Byte, ByVal buflen As Long) As Byte
Declare Function sapdbwa_DBCGetServerDb Lib "wapi.dll" (ByVal dbc As Long, ByRef buf As Byte, ByVal buflen As Long) As Byte
Declare Function sapdbwa_DBCGetServerNode Lib "wapi.dll" (ByVal dbc As Long, ByRef buf As Byte, ByVal buflen As Long) As Byte

Declare Function sapdbwa_GetNativeOdbcErr Lib "wapi.dll" (ByVal WAerrP As Long) As Long


'=========================================================================================




Declare Function SQLDescribeParam Lib "odbc32.dll" (ByVal hStmt As Long, ByVal ipar As Integer, sqltype As Integer, coldef As Long, scl As Integer, nullable As Integer) As Integer
Declare Function SQLNumParams Lib "odbc32.dll" (ByVal hStmt As Long, par As Integer) As Integer
Declare Function SQLParamOptions Lib "odbc32.dll" (ByVal hStmt As Long, ByVal row As Long, irow As Long) As Integer
Declare Function SQLSetPos Lib "odbc32.dll" (ByVal hStmt As Long, ByVal irow As Integer, ByVal rfrsh As Integer, ByVal lck As Integer) As Integer

Declare Function SQLPutData Lib "odbc32.dll" (ByVal hStmt As Long, _
                                              ByVal Value As String, _
                                              ByVal ValueLen As Long) As Integer

Declare Function GetForegroundWindow Lib "User32" () As Long
Declare Function GetFocus Lib "User32" () As Long
Declare Function GetActiveWindow Lib "User32" () As Long
Declare Function GetAsyncKeyState Lib "User32" (ByVal vKey As Long) As Integer

Declare Function UpdateWindow Lib "User32" (ByVal hWnd As Long) As Boolean
Declare Function InvalidateRect Lib "User32" (ByVal hWnd As Long, rect As Any, bErase As Boolean) As Boolean

'sleep
Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'Global Const SQL_ASYNC_ENABLE_DEFAULT        SQL_ASYNC_ENABLE_OFF
'
' Core Functions
'

Declare Function SQLDescribeColW Lib "odbc32.dll" (ByVal hStmt As Long, _
                                                   ByVal icol As Integer, _
                                                   colName As Byte, _
                                                   ByVal colnamemax As Integer, _
                                                   ColNameLen As Integer, _
                                                   sqltype As Integer, _
                                                   coldef As Long, _
                                                   scl As Integer, _
                                                   nullable As Integer) As Integer



Declare Function SQLExecute Lib "odbc32.dll" (ByVal hStmt As Long) As Integer

Declare Function SQLPrepareW Lib "odbc32.dll" (ByVal hStmt As Long, _
                                               sqlstr As Byte, _
                                               ByVal sqlstrlen As Long) As Integer
Declare Function SQLBindParameter Lib "odbc32.dll" (ByVal hStmt As Long, ByVal ipar As Integer, ByVal fParamType As Integer, ByVal fCType As Integer, ByVal fSqlType As Integer, ByVal cbColDef As Long, ByVal ibScale As Integer, ByRef rgbValue As Any, ByVal cbValueMax As Long, pcbValue As Long) As Integer

Declare Function pa81GetStrConnectOption Lib "sqlodext.dll" (ByVal hStmt As Long, ByVal opt As Integer, ByVal OptString As String) As Integer

