VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Result"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Module:      Result
'
'-----------------------------------------------------------------------
'
' responsible:  WolfgangA
'
' special area: SQL Studio DB Layer
'
' description:  result class for sapdb
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit

'module name
Const MODULE_NAME = "SQL Studio Database Result"



'============================================================================================
'From SQLUCODE.H
'#define SQL_WCHAR           (-8)
'#define SQL_WVARCHAR        (-9)
'#define SQL_WLONGVARCHAR    (-10)
'#define SQL_C_WCHAR         SQL_WCHAR

'/* One-parameter shortcuts for date/time data types */
'#if (ODBCVER >= 0x0300)
'#define SQL_TYPE_DATE      91
'#define SQL_TYPE_TIME      92
'#define SQL_TYPE_TIMESTAMP 93

'From SQL.H
'/* SQL data type codes */
'#define SQL_UNKNOWN_TYPE    0
'#define SQL_CHAR            1
'#define SQL_NUMERIC         2
'#define SQL_DECIMAL         3
'#define SQL_INTEGER         4
'#define SQL_SMALLINT        5
'#define SQL_FLOAT           6
'#define SQL_REAL            7
'#define SQL_DOUBLE          8
'#if (ODBCVER >= 0x0300)
'#define SQL_DATETIME        9
'#End If
'#define SQL_VARCHAR        12

'From SQLEXT.H
'#define SQL_C_BINARY     SQL_BINARY
'#define SQL_C_BIT        SQL_BIT
'/* SQL extended datatypes */
'#define SQL_DATE                                9
'#if (ODBCVER >= 0x0300)
'#define SQL_INTERVAL                            10
'#endif  /* ODBCVER >= 0x0300 */
'#define SQL_TIME                                10
'#define SQL_TIMESTAMP                           11
'#define SQL_LONGVARCHAR                         (-1)
'#define SQL_BINARY                              (-2)
'#define SQL_VARBINARY                           (-3)
'#define SQL_LONGVARBINARY                       (-4)
'#define SQL_BIGINT                              (-5)
'#define SQL_TINYINT                             (-6)
'#define SQL_BIT                                 (-7)

'#define SQL_C_CHAR    SQL_CHAR             /* CHAR, VARCHAR, DECIMAL, NUMERIC */
'#define SQL_C_LONG    SQL_INTEGER          /* INTEGER                      */
'#define SQL_C_SHORT   SQL_SMALLINT         /* SMALLINT                     */
'#define SQL_C_FLOAT   SQL_REAL             /* REAL                         */
'#define SQL_C_DOUBLE  SQL_DOUBLE           /* FLOAT, DOUBLE                */
'#if (ODBCVER >= 0x0300)
'#define SQL_C_NUMERIC       SQL_NUMERIC
'#endif  /* ODBCVER >= 0x0300 */
'#define SQL_C_DEFAULT 99
'
'#define SQL_SIGNED_OFFSET       (-20)
'#define SQL_UNSIGNED_OFFSET     (-22)
'
'/* C datatype to SQL datatype mapping */
'#define SQL_C_DATE       SQL_DATE
'#define SQL_C_TIME       SQL_TIME
'#define SQL_C_TIMESTAMP  SQL_TIMESTAMP
'#if (ODBCVER >= 0x0300)
'#define SQL_C_TYPE_DATE                 SQL_TYPE_DATE
'#define SQL_C_TYPE_TIME                 SQL_TYPE_TIME
'#define SQL_C_TYPE_TIMESTAMP            SQL_TYPE_TIMESTAMP
'#define SQL_C_INTERVAL_YEAR             SQL_INTERVAL_YEAR
'#define SQL_C_INTERVAL_MONTH            SQL_INTERVAL_MONTH
'#define SQL_C_INTERVAL_DAY              SQL_INTERVAL_DAY
'#define SQL_C_INTERVAL_HOUR             SQL_INTERVAL_HOUR
'#define SQL_C_INTERVAL_MINUTE           SQL_INTERVAL_MINUTE
'#define SQL_C_INTERVAL_SECOND           SQL_INTERVAL_SECOND
'#define SQL_C_INTERVAL_YEAR_TO_MONTH    SQL_INTERVAL_YEAR_TO_MONTH
'#define SQL_C_INTERVAL_DAY_TO_HOUR      SQL_INTERVAL_DAY_TO_HOUR
'#define SQL_C_INTERVAL_DAY_TO_MINUTE    SQL_INTERVAL_DAY_TO_MINUTE
'#define SQL_C_INTERVAL_DAY_TO_SECOND    SQL_INTERVAL_DAY_TO_SECOND
'#define SQL_C_INTERVAL_HOUR_TO_MINUTE   SQL_INTERVAL_HOUR_TO_MINUTE
'#define SQL_C_INTERVAL_HOUR_TO_SECOND   SQL_INTERVAL_HOUR_TO_SECOND
'#define SQL_C_INTERVAL_MINUTE_TO_SECOND SQL_INTERVAL_MINUTE_TO_SECOND

'#define SQL_UNICODE             SQL_WCHAR
'#define SQL_UNICODE_VARCHAR     SQL_WVARCHAR
'#define SQL_UNICODE_LONGVARCHAR SQL_WLONGVARCHAR
'#define SQL_UNICODE_CHAR        SQL_WCHAR
'===============================================================================


'local constants
Const MX_COLUMN_NAME = 512

'Const MX_DATE_COLUMN_VALUE = 6
Const MX_DATE_COLUMN_VALUE = MX_COLUMN_NAME
'Const MX_TIME_COLUMN_VALUE = 6
Const MX_TIME_COLUMN_VALUE = MX_COLUMN_NAME
'Const MX_TIMESTAMP_COLUMN_VALUE = 16
Const MX_TIMESTAMP_COLUMN_VALUE = MX_COLUMN_NAME
Const MX_DOUBLE_COLUMN_VALUE = 8

Const MX_COLUMN_GENERIC_NUMERIC = 64
Const MX_COLUMN_VALUE = 4096
Const MX_COLUMN_LONG_VALUE = 32786
Const MX_COLUMN_LONG_VALUE_CLIPBOARD = 1048576


'public column type definition
Public Enum sapdbTableType
    sapdbTableTypeUnknown = 0
    sapdbTableTypeResult = 1
    sapdbTableTypeSystem = 2
    sapdbTableTypeView = 3
    sapdbTableTypeTable = 4
End Enum

Public Enum odbcColumnType

    'core column types
    odbcColTypeChar = 1
    odbcColTypeNumeric = 2
    odbcColTypeDecimal = 3
    odbcColTypeInteger = 4
    odbcColTypeSmallInt = 5
    odbcColTypeFloat = 6
    odbcColTypeReal = 7
    odbcColTypeDouble = 8
    odbcColTypeVarChar = 12

    'extended column types
    odbcColTypeDate = 9
    odbcColTypeTime = 10
    odbcColTypeTimeStamp = 11
    odbcColTypeLongVarChar = -1
    odbcColTypeBinary = -2
    odbcColTypeVarBinary = -3
    odbcColTypeLongVarBinary = -4
    odbcColTypeBigInt = -5
    odbcColTypeTinyInt = -6
    odbcColTypeBit = -7
    odbcColTypeWChar = -8
    odbcColTypeWVarChar = -9
    odbcColTypeWLongVarChar = -10
End Enum

Public Enum SAPDBColumnType
    sapdbColTypeUnknown = 0
    sapdbColTypeChar = 1
    sapdbColTypeVarChar = 2
    sapdbColTypeLong = 3
    sapdbColTypeBoolean = 4
    sapdbColTypeFixed = 5
    sapdbColTypeFloat = 6
    sapdbColTypeInt = 7
    sapdbColTypeSmallInt = 8
    sapdbColTypeDate = 9
    sapdbColTypeTime = 10
    sapdbColTypeTimeStamp = 11
    'similair to long
    sapdbColTypeLongFile = 12
    'is mapped from DB to float
    'sapdbColTypeDouble = 13
End Enum

Public Enum SAPDBColumnCodeType
    sapdbColCodeTypeUnknown = 0
    sapdbColCodeTypeASCII = 1
    sapdbColCodeTypeBYTE = 2
    sapdbColCodeTypeEBCDIC = 3
    sapdbColCodeTypeUNICODE = 4
End Enum

Public Enum sapdbResultMode

    sapdbSimpleMode = 0
    sapdbSimpleUpdateMode = 1
    sapdbVirtualMode = 2
End Enum


'private property variables
Private m_nColCount                   As Integer
Private m_bNoRows                     As Boolean
Private m_lFetchedRows                As Long
Private m_lRowCount                   As Long
Private m_lLimitForLong               As Long
Private m_hResult                     As Long
Private m_sStatement                  As String
Private m_sAdditionalStatement        As String
Private m_sRepOfNullValue             As String
Private m_sResultName                 As String


'flag which shows that the result is build to represent the values of a DB procedure
Private m_bDBProcedureResult          As Boolean
Private m_lCallingWnd                 As Long

Private m_emResultMode              As sapdbResultMode

Private m_sValue                    As String
Private m_byUniCodeValue()          As Byte
Private m_sValueDate                As DATE_STRUCT
Private m_sValueTime                As TIME_STRUCT
Private m_sValueTimeStamp           As TIMESTAMP_STRUCT
Private m_sValueGenericNumber       As String
Private m_sValueLong                As String

Private m_oColumns                  As New Collection

Private m_oConnection               As SQLStudioDBLayer.connection
Private m_oFunctions                As New SQLStudioDBLayer.Functions

'remember the last sql mode used for opening a result
Private m_lastSQLMode               As sqlMode


'=========================================================================================
'    property:      dBProcedureResult
'    description:   get if result was used to open a db procedure
'    arguments:     /
'
'    return value:  true result was used to open a db procedure
'
'=========================================================================================
Public Property Get dbProcedureResult() As Boolean
    On Error GoTo errP_Get_DBProcedureResult

    Const FUNCTION_NAME = "P_GET dbProcedureResult"

    Let dbProcedureResult = m_bDBProcedureResult

    Exit Property

errP_Get_DBProcedureResult:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      statementString
'    description:   get sql statement of db result
'    arguments:     /
'
'    return value:  see description
'
'=========================================================================================
Public Property Get statementString() As String
    On Error GoTo errP_Get_Statement

    Const FUNCTION_NAME = "P_Get statementString"

    Let statementString = m_sStatement

    Exit Property

errP_Get_Statement:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      AdditionalStatement
'    description:   set an additional sql statement
'                   this property is used for show and explain statements
'                   to remember the show and explain statement
'                   because other controls use "select * from show"
'                   after executing a show or explain command
'    arguments:     [in] NewAdditionalStatement, additional sql statement
'
'    return value:  /
'
'=========================================================================================
Public Property Let additionalStatement(NewAdditionalStatement As String)
    On Error GoTo errP_Let_NewAdditionalStatement

    Const FUNCTION_NAME = "P_Let newSAdditionalStatement"

    Let m_sAdditionalStatement = NewAdditionalStatement

    Exit Property

errP_Let_NewAdditionalStatement:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      additionalStatement
'    description:   see set property
'    arguments:     /
'
'    return value:  additional statement
'
'=========================================================================================
Public Property Get additionalStatement() As String
    On Error GoTo errP_Get_NewAdditionalStatement

    Const FUNCTION_NAME = "P_Get newAdditionalStatement"

    Let additionalStatement = m_sAdditionalStatement

    Exit Property

errP_Get_NewAdditionalStatement:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    property:      colCount
'    description:   get number of columns in result
'    arguments:     /
'
'    return value:  number of columns in result
'
'=========================================================================================
Public Property Get colCount() As Integer
    On Error GoTo errP_Get_ColCount

    Const FUNCTION_NAME = "P_Get colCount"
    
    colCount = m_nColCount
    
    Exit Property
    
errP_Get_ColCount:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      rowCount
'    description:   get number of rows in result, if known
'                   if not -1 will be returned
'    arguments:     /
'
'    return value:  number of rows in result
'
'=========================================================================================
Public Property Get rowCount() As Long
    On Error GoTo errP_Get_ColCount

    Const FUNCTION_NAME = "P_Get colCount"
    
    rowCount = m_lRowCount
    
    Exit Property
    
errP_Get_ColCount:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      fetchedRows
'    description:   get number of fetched rows in result object
'    arguments:     /
'
'    return value:  number of fetched rows in result object
'
'=========================================================================================
Public Property Get fetchedRows() As Long
    On Error GoTo errP_Get_FetchedRows

    Const FUNCTION_NAME = "P_GET fetchedRows"
    
    fetchedRows = m_lFetchedRows
    
    Exit Property
    
errP_Get_FetchedRows:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      hResult
'    description:   handle of result object
'    arguments:     [in] NewHResult, handle for result object
'
'    return value:  /
'
'=========================================================================================
Private Property Let hResult(NewHResult As Long)
    On Error GoTo errP_Let_hResult

    Const FUNCTION_NAME = "P_LET hResult"
    
    m_hResult = NewHResult
    
    Exit Property
    
errP_Let_hResult:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      hResult
'    description:   get handle of result object
'    arguments:     /
'
'    return value:  handle for result object
'
'=========================================================================================
Public Property Get hResult() As Long
    On Error GoTo errP_Get_hResult

    Const FUNCTION_NAME = "P_GET hResult"
    
    hResult = m_hResult
    
    Exit Property
    
errP_Get_hResult:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      noRows
'    description:   set if result contains rows
'    arguments:     [in] NewNoRows, flag if result contains rows
'
'    return value:
'
'=========================================================================================
Private Property Let noRows(NewNoRows As Boolean)
    On Error GoTo errP_Let_NoRows

    Const FUNCTION_NAME = "P_Let noRows"
    
    m_bNoRows = NewNoRows
    
    Exit Property
    
errP_Let_NoRows:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      noRows
'    description:   get if result contains rows
'    arguments:     /
'
'    return value:  true if result contains rows
'
'=========================================================================================
Public Property Get noRows() As Boolean
    On Error GoTo errP_Get_NoRows

    Const FUNCTION_NAME = "P_Get noRows"
    
    noRows = m_bNoRows
    
    Exit Property
    
errP_Get_NoRows:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      columns
'    description:   set collection for columns
'    arguments:     [in] onewColumns, collection for columns
'
'    return value:  /
'
'=========================================================================================
Friend Property Let columns(onewColumns As Collection)
    On Error GoTo errP_Let_Columns

    Const FUNCTION_NAME = "P_LET Columns"
    
    Set m_oColumns = onewColumns
    
    Exit Property
    
errP_Let_Columns:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      columns
'    description:   Get collection for columns
'    arguments:     /
'
'    return value:  collection for columns
'
'=========================================================================================
Public Property Get columns() As Collection
    On Error GoTo errP_Get_Columns

    Const FUNCTION_NAME = "P_Get columns"
    
    Set columns = m_oColumns
    
    Exit Property
    
errP_Get_Columns:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      limitForLong
'    description:   set limit for long columns when getting blob data
'    arguments:     [in] NewLimitForLong, limit for long column data
'
'    return value:  /
'
'=========================================================================================
Public Property Let limitForLong(NewLimitForLong As Long)
    On Error GoTo errP_Let_LimitForLong

    Const FUNCTION_NAME = "P_LET limitForLong"
    
    m_lLimitForLong = NewLimitForLong
    
    Exit Property
    
errP_Let_LimitForLong:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      limitForLong
'    description:   Get limit for long columns when getting blob data
'    arguments:     /
'
'    return value:  see description
'
'=========================================================================================
Public Property Get limitForLong() As Long
    On Error GoTo errP_Get_LimitForLong

    Const FUNCTION_NAME = "P_Get limitForLong"
    
    limitForLong = m_lLimitForLong
    
    Exit Property
    
errP_Get_LimitForLong:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      resultMode
'    description:   set result mode of result class
'                   {sapdbSimpleMode,sapdbSimpleUpdateMode,sapdbVirtualMode}
'    arguments:     [in] NewResultMode, result mode of result class
'
'    return value:  /
'
'=========================================================================================
Public Property Let resultMode(NewResultMode As sapdbResultMode)
    On Error GoTo errP_Let_ResultMode

    Const FUNCTION_NAME = "P_LET resultMode"
    
    m_emResultMode = NewResultMode
    
    Exit Property
    
errP_Let_ResultMode:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      ResultMode
'    description:   get result mode of result class
'
'    arguments:     /
'
'    return value:  result mode of result class
'
'=========================================================================================
Public Property Get resultMode() As sapdbResultMode
    On Error GoTo errP_Get_ResultMode

    Const FUNCTION_NAME = "P_GET ResultMode"
    
    resultMode = m_emResultMode
    
    Exit Property
    
errP_Get_ResultMode:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      callingWindow
'    description:   set windows handle of calling window
'    arguments:     [in] hWnd, handle of calling window
'
'    return value:  /
'
'=========================================================================================
Public Property Let callingWindow(hnewCallingWnd As Long)
    On Error GoTo errP_Let_CallingWindow

    Const FUNCTION_NAME = "P_LET callingWindow"
    
    m_lCallingWnd = hnewCallingWnd
    
    m_oFunctions.callingWindow = m_lCallingWnd
    
    Exit Property
    
errP_Let_CallingWindow:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      resultName
'    description:   get name of result object
'    arguments:     /
'
'    return value:  name of result
'
'=========================================================================================
Public Property Get resultName() As String
    On Error GoTo errP_Get_ResultName

    Const FUNCTION_NAME = "P_GET ResultName"

    Let resultName = m_sResultName

    Exit Property

errP_Get_ResultName:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      resultName
'    description:   let name of result object
'    arguments:     [in] NewResultName, name of result
'
'    return value:  /
'
'=========================================================================================
Public Property Let resultName(NewResultName As String)
    On Error GoTo errP_Let_ResultName

    Const FUNCTION_NAME = "P_LET resultName"

    Let m_sResultName = NewResultName

    Exit Property

errP_Let_ResultName:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    function:      OpenResult
'    description:   open a result of a sql command
'    arguments:     [in] sCmdStr, sql command string
'                   [in] emSQLMode, sql mode for execute
'
'    return value:  true if succesfully
'
'=========================================================================================
Public Function openResult(ByVal sCmdStr As String, emSQLMode As sqlMode) As Boolean
    On Error GoTo errOpenResult

    Const FUNCTION_NAME = "openResult"

    '=local variables==================================================
    Dim lRc            As Integer
    Dim lStringLength  As Long
    '==================================================================
    
    'rc
    openResult = False

    'check it
    If m_oConnection.hEnv = SQL_NULL_HENV Or _
       m_oConnection.hDbc = SQL_NULL_HDBC Then Exit Function
       
    'close result first if one exists
    closeResult

    'init
    lStringLength = 0
    m_lastSQLMode = emSQLMode
    m_bDBProcedureResult = False
       
        
    m_sStatement = sCmdStr
    m_lFetchedRows = 0
    m_hResult = 0
    m_bNoRows = True

    'allocate handle for statement
    If Not m_oFunctions.allocStmt(m_hResult) Then Exit Function

    'in addition to the sql mode of the connection,
    'the database kernel can excute a statement in different sql mode
    'e.g. connection has sqlmode oracle, SQLStudio can execute a
    'a command in internal mode
    'lRc = SQLSetStmtOption(m_hResult, SQL_SQLMODE, emSQLMode)
    lRc = SQLSetStmtAttrLong(m_hResult, SQL_SQLMODE, emSQLMode, lStringLength)
    If lRc <> SQL_SUCCESS Then
        If Not m_oConnection.error.checkRC(lRc, m_hResult) Then

            Call commonFreeStmt(m_hResult)
            Exit Function
        End If
    End If
    
    'lRc = SQLSetStmtOption(m_hResult, SQL_ATTR_ROW_BIND_TYPE, SQL_BIND_BY_COLUMN)
    lRc = SQLSetStmtAttrLong(m_hResult, SQL_ATTR_ROW_BIND_TYPE, SQL_BIND_BY_COLUMN, lStringLength)
    If lRc <> SQL_SUCCESS Then
    
        If Not m_oConnection.error.checkRC(lRc, m_hResult) Then
    
            Call commonFreeStmt(m_hResult)
            Exit Function
        End If
    End If
    
    Select Case m_emResultMode:
    
        Case sapdbSimpleMode:
    
            'SQL_CONCUR_READ_ONLY = Cursor is read-only. No updates are allowed.
            'lRc = SQLSetStmtOption(m_hResult, SQL_ATTR_CONCURRENCY, SQL_CONCUR_READ_ONLY)
            lRc = SQLSetStmtAttrLong(m_hResult, SQL_ATTR_CONCURRENCY, SQL_CONCUR_READ_ONLY, lStringLength)
            If lRc <> SQL_SUCCESS Then
                
                If Not m_oConnection.error.checkRC(lRc, m_hResult) Then
        
                    Call commonFreeStmt(m_hResult)
                    Exit Function
                End If
            End If
            'lRc = SQLSetStmtOption(m_hResult, SQL_ATTR_CURSOR_TYPE, SQL_CURSOR_FORWARD_ONLY)
            lRc = SQLSetStmtAttrLong(m_hResult, SQL_ATTR_CURSOR_TYPE, SQL_CURSOR_FORWARD_ONLY, lStringLength)
            If lRc <> SQL_SUCCESS Then
              If Not m_oConnection.error.checkRC(lRc, m_hResult) Then
    
                    Call commonFreeStmt(m_hResult)
                    Exit Function
                End If
            End If
        
        Case sapdbSimpleUpdateMode:
        
        'update mode uses SQL_CURSOR_STATIC cursor model
        'SQL_CURSOR_KEYSET_DRIVEN with SQL_ATTR_OPTIMIZE_CURSOR is not usable
        'because there is no lock on the table/row, if data would change
        'Update with CURRENT OFF could change wrong row.
        'Cursor model SQL_CURSOR_FORWARD_ONLY is not usable,
        'because CURRENT OFF needs relative positioning.
            'SQL_CONCUR_LOCK = Cursor uses the lowest level of locking sufficient to ensure that the row can be updated.
            'lRc = SQLSetStmtOption(m_hResult, SQL_ATTR_CONCURRENCY, SQL_CONCUR_ROWVER)
            lRc = SQLSetStmtAttrLong(m_hResult, SQL_ATTR_CONCURRENCY, SQL_CONCUR_ROWVER, lStringLength)
            If lRc <> SQL_SUCCESS Then
                If Not m_oConnection.error.checkRC(lRc, m_hResult) Then
        
                    Call commonFreeStmt(m_hResult)
                    Exit Function
                End If
            End If
            
            'lRc = SQLSetStmtOption(m_hResult, SQL_ATTR_CURSOR_TYPE, SQL_CURSOR_STATIC)
            lRc = SQLSetStmtAttrLong(m_hResult, SQL_ATTR_CURSOR_TYPE, SQL_CURSOR_STATIC, lStringLength)
            If lRc <> SQL_SUCCESS Then
                
                If Not m_oConnection.error.checkRC(lRc, m_hResult) Then
                
                    Call commonFreeStmt(m_hResult)
                    Exit Function
                End If
            End If
            
    Case sapdbVirtualMode:
        'SQL_CONCUR_READ_ONLY = Cursor is read-only. No updates are allowed.
        'lRc = SQLSetStmtOption(m_hResult, SQL_ATTR_CONCURRENCY, SQL_CONCUR_READ_ONLY)
        lRc = SQLSetStmtAttrLong(m_hResult, SQL_ATTR_CONCURRENCY, SQL_CONCUR_READ_ONLY, lStringLength)
        If lRc <> SQL_SUCCESS Then
            
            If Not m_oConnection.error.checkRC(lRc, m_hResult) Then
    
                Call commonFreeStmt(m_hResult)
                Exit Function
            End If
        End If
        
        'lRc = SQLSetStmtOption(m_hResult, SQL_ATTR_OPTIMIZE_CURSOR, 1)
        lRc = SQLSetStmtAttrLong(m_hResult, SQL_ATTR_OPTIMIZE_CURSOR, 1, lStringLength)
        If lRc <> SQL_SUCCESS Then
        
            If Not m_oConnection.error.checkRC(lRc, m_hResult) Then

                'out of option range
                'the option SQL_ATTR_OPTIMIZE_CURSOR is implemented from version 6.2.10
                If InStr(m_oConnection.error.sqlState, "S1092") = 0 Then
                
                    Call commonFreeStmt(m_hResult)
                    Exit Function
                End If
            End If
        End If
        'lRc = SQLSetStmtOption(m_hResult, SQL_ATTR_CURSOR_TYPE, SQL_CURSOR_KEYSET_DRIVEN)
        lRc = SQLSetStmtAttrLong(m_hResult, SQL_ATTR_CURSOR_TYPE, SQL_CURSOR_KEYSET_DRIVEN, lStringLength)
        If lRc <> SQL_SUCCESS Then
        
            If Not m_oConnection.error.checkRC(lRc, m_hResult) Then

                Call commonFreeStmt(m_hResult)
                Exit Function
            End If
        End If
         
    Case Else:
        Exit Function
   End Select

   'lRc = SQLSetStmtOption(m_hResult, SQL_ATTR_USE_BOOKMARKS, SQL_UB_ON)
   lRc = SQLSetStmtAttrLong(m_hResult, SQL_ATTR_USE_BOOKMARKS, SQL_UB_ON, lStringLength)
   If lRc <> SQL_SUCCESS Then
       If Not m_oConnection.error.checkRC(lRc, m_hResult) Then
    
            Call commonFreeStmt(m_hResult)
            Exit Function
        End If
    End If
    
    'lRc = SQLSetStmtOption(m_hResult, SQL_ROWSET_SIZE, 1)
    lRc = SQLSetStmtAttrLong(m_hResult, SQL_ROWSET_SIZE, 1, lStringLength)
    If lRc <> SQL_SUCCESS Then
        If Not m_oConnection.error.checkRC(lRc, m_hResult) Then
    
            Call commonFreeStmt(m_hResult)
            Exit Function
        End If
    End If
    
    'open the result set
    If Not m_oFunctions.execDirectStmt(m_hResult, sCmdStr) Then

        'free statement
        Call commonFreeStmt(m_hResult)
        Exit Function
    End If
    
    If Not getColDescriptions Then Exit Function

    'is there a result?
    m_lRowCount = resultRows(m_hResult)
    If m_lRowCount = 0 Then

        openResult = True
        Exit Function
    Else
        m_bNoRows = False
    End If

    'rc
    openResult = True

    Exit Function

errOpenResult:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      closeResult
'    description:   close a open result
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Public Function closeResult()
    On Error GoTo ErrCloseResult

    Const FUNCTION_NAME = "closeResult"
    
    'check it
    If m_hResult = 0 Then Exit Function
    
    'free statement handle
    Call commonFreeStmt(m_hResult)
    
    m_hResult = 0

    Exit Function

ErrCloseResult:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      Fetch
'    description:   fetch the next row
'    arguments:     /
'
'    return value:  true if successfully
'
'=========================================================================================
Public Function fetch() As Boolean
    On Error GoTo ErrFetch

    Const FUNCTION_NAME = "fetch"
    
    'rc
    fetch = False
    
    'inits
    m_bNoRows = False
    
    If m_oConnection.hEnv = SQL_NULL_HENV Or _
       m_oConnection.hDbc = SQL_NULL_HDBC Then Exit Function

    'fetch
    If Not m_oConnection.error.checkRC(SQLFetch(m_hResult), m_hResult) Then Exit Function
    
    If m_oConnection.error.rc = SQL_NO_DATA_FOUND Then
    
        m_bNoRows = True
    Else
        'increase fetched rows
        m_lFetchedRows = m_lFetchedRows + 1
    End If

    'rc
    fetch = True

    Exit Function

ErrFetch:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      extendedFetch
'    description:   fetch the next row
'    arguments:     [in] fetchtype, type of fetch
'                   [in] irow, number of the row to fetch
'                   [out] row, the number of rows actually fetched
'                   [out] rowstatus(), status of each row
'
'    return value:  true if successfully
'
'=========================================================================================
Public Function extendedFetch(ByVal fetchtype As Integer, _
                              ByVal irow As Long, _
                              ByRef row As Long, _
                              ByRef rowstatus() As Integer) As Boolean
    On Error GoTo errExtendedFetch

    Const FUNCTION_NAME = "extendedFetch"
    
    'rc
    extendedFetch = False
    
    'init
    row = 0
    
    If fetchtype = SQL_FETCH_LAST Or _
       fetchtype = SQL_FETCH_FIRST Or _
       fetchtype = SQL_FETCH_ABSOLUTE _
    Then m_lFetchedRows = 0
    
    If m_oConnection.hDbc = SQL_NULL_HDBC Then
    
        m_bNoRows = True
        Exit Function
    End If
    
    If Not m_oConnection.error.checkRC(SQLExtendedFetch(m_hResult, fetchtype, irow, row, rowstatus()), m_hResult) Then
    
        m_bNoRows = True
        Exit Function
    End If
    
    If m_oConnection.error.rc = SQL_NO_DATA_FOUND Or row = 0 Then
    
        m_bNoRows = True
    Else
        m_bNoRows = False
        m_lFetchedRows = m_lFetchedRows + 1
    End If

    extendedFetch = True

    Exit Function

errExtendedFetch:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      getBookMark
'    description:   get book mark of result
'    arguments:     /
'
'    return value:  the bookmark for the current record number
'
'=========================================================================================
Public Function getBookMark() As Long
    On Error GoTo errGetBookMark

    Const FUNCTION_NAME = "getBookMark"
    
    '=local variables==================================================
    Dim lBookMark      As Long
    Dim lRc            As Integer
    '==================================================================
    
    'rc
    getBookMark = -1
    
    If m_oConnection.hEnv = SQL_NULL_HENV Or _
       m_oConnection.hDbc = SQL_NULL_HDBC Then Exit Function
    
    lRc = SQLGetStmtOption(m_hResult, SQL_GET_BOOKMARK, lBookMark)
    
    If lRc <> SQL_SUCCESS Then
    
        If Not m_oConnection.error.checkRC(lRc, m_hResult) Then Exit Function
     End If

    getBookMark = lBookMark

    Exit Function

errGetBookMark:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      getCursorPos
'    description:   position of the current row within the result set
'    arguments:     /
'
'    return value:  see description
'
'=========================================================================================
Public Function getCursorPos() As Long
    On Error GoTo errGetCursorPos
    
    Const FUNCTION_NAME = "getCursorPos"
    
    '=local variables==================================================
    Dim lCursorPos      As Long
    Dim lRc             As Integer
    '==================================================================
    
    'rc
    getCursorPos = -1
    
    If m_oConnection.hEnv = SQL_NULL_HENV Or m_oConnection.hDbc = SQL_NULL_HDBC Then Exit Function
    
    lRc = SQLGetStmtOption(m_hResult, SQL_ROW_NUMBER, lCursorPos)
    If lRc <> SQL_SUCCESS Then
    
        If Not m_oConnection.error.checkRC(lRc, m_hResult) Then
        
            'invalid cursor state => cursor is behind last or before first row
            If m_oConnection.error.lastSQLStateErrorNumber = "24000" Then
            
                lCursorPos = 0
            Else
                lCursorPos = -1
            End If
        End If
     End If

    getCursorPos = lCursorPos

    Exit Function

errGetCursorPos:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      getData
'    description:   get data of database result row to each column in columns collection
'    arguments:     /
'
'    return value:  true if succesfully
'
'=========================================================================================
Public Function getData() As Boolean
    On Error GoTo ErrGetData

    Const FUNCTION_NAME = "getData"

    '=local variables======================================================
    Dim nRun              As Integer
    '================================================================
    
    'rc
    getData = False
    
    If m_oConnection.hEnv = SQL_NULL_HENV Or _
       m_oConnection.hDbc = SQL_NULL_HDBC Then Exit Function

    'Get the data for the current row
    For nRun = 1 To m_nColCount
        
        getColumnData nRun
    Next

    'rc
    getData = True

    Exit Function

ErrGetData:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      getColumnData
'    description:   get data of a result column into a buffer
'    arguments:     [in] nCol, column
'
'    return value:  true if success
'
'=========================================================================================
Public Function getColumnData(nCol As Integer) As Boolean
    On Error GoTo errGetColumnData

    Const FUNCTION_NAME = "getColumnData"

    '=local variables==================================================
    Dim lBoolean           As Boolean
    Dim lValueLen          As Long
    Dim lGetDataLen        As Long
    Dim lRc                As Integer
    '==================================================================
    
    'rc
    getColumnData = False
    
    'check
    If m_oConnection.hEnv = SQL_NULL_HENV Or _
       m_oConnection.hDbc = SQL_NULL_HDBC Then Exit Function
    
    getColumnData = getColData(nCol, _
                               m_oColumns.Item(nCol))
    Exit Function

errGetColumnData:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function getRawBinaryData(ByVal nCol As Integer, ByVal lSize As Long, ByRef lUsed As Long) As Byte()
    On Error GoTo errGetRawBinaryData

    Const FUNCTION_NAME = "getRawBinaryData"
    
    '=local variables==================================================
    Dim lRc               As Integer
    Dim lValueLen         As Long
    Dim sByteBuffer()     As Byte
    Dim oCurrentCol       As Column
    '==================================================================
       
        
    Set oCurrentCol = m_oColumns(nCol)
    
    If oCurrentCol.odbcColType <> odbcColTypeLongVarChar And _
       oCurrentCol.odbcColType <> odbcColTypeLongVarBinary And _
       oCurrentCol.odbcColType <> odbcColTypeWLongVarChar And _
       oCurrentCol.odbcColType <> odbcColTypeVarBinary _
    Then Exit Function
    
    ReDim sByteBuffer(lSize)
            
    m_oConnection.error.noSQLState = SQLSTATE_DATA_TRUNCATED
    lRc = SQLGetData(m_hResult, nCol, odbcColTypeBinary, sByteBuffer(0), lSize, lUsed)
    If lRc <> SQL_SUCCESS Then
        
        If Not m_oConnection.error.checkRC(lRc, m_hResult) Then
        
            oCurrentCol.colValue = m_oConnection.error.text
            'set back no sql state of error class
            m_oConnection.error.noSQLState = SQLSTATE_SUCCESS
            
            Exit Function
        End If
        'set back no sql state of error class
        m_oConnection.error.noSQLState = SQLSTATE_SUCCESS
    End If
    
    getRawBinaryData = sByteBuffer()
    
    Exit Function

errGetRawBinaryData:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      getLongData
'    description:   get data of a long column into a buffer
'    arguments:     [in/out] Value, buffer to receive data
'                   [in] lAmount, maximum long data in bytes
'                   [in] lCol, column
'
'    return value:  true if success
'
'=========================================================================================
Public Function getLongData(Value As String, lAmount As Long, lColumn As Long, bOneChunk As Boolean) As Boolean
    On Error GoTo errGetLongData

    Const FUNCTION_NAME = "getLongData"
    
    '=local variables==================================================
    Dim lValueLen       As Long
    Dim sBuffer         As String
    Dim oCurrentCol     As Column
    '==================================================================
    
    'rc
    getLongData = False
    
    Set oCurrentCol = m_oColumns(lColumn)
    
    If oCurrentCol.odbcColType = odbcColTypeLongVarChar Or _
       oCurrentCol.odbcColType = odbcColTypeLongVarBinary Or _
       oCurrentCol.odbcColType = odbcColTypeWLongVarChar _
    Then
        Do
            If lAmount = -1 Then
            
              sBuffer = Space$(MX_COLUMN_LONG_VALUE)
            Else
              sBuffer = Space$(lAmount)
            End If
            
            m_oConnection.error.checkRC SQLGetData(m_hResult, lColumn, odbcColTypeBinary, ByVal sBuffer, Len(sBuffer), lValueLen), m_hResult
            
            'check it
            If lValueLen < 0 Then
                
                'if data is trunctated continue
                If Not m_oConnection.error.sqlStateErrorNumber = SQLSTATE_DATA_TRUNCATED Then
                
                    MsgBox LoadResString(113), vbInformation + vbOKOnly
                    Exit Function
                End If
            End If
            
            If m_oConnection.error.sqlStateErrorNumber = SQLSTATE_DATA_TRUNCATED Then
            
                If bOneChunk Then
                    
                    Value = Value + sBuffer
                Else
                    Value = sBuffer
                    Exit Function
                End If
            Else
                If bOneChunk Then
                
                   Value = Value + left$(sBuffer, lValueLen)
                Else
                   Value = left$(sBuffer, lValueLen)
                End If
            
                'set rc
                getLongData = True
                
                Exit Function
            End If
        Loop While m_oConnection.error.sqlStateErrorNumber = SQLSTATE_DATA_TRUNCATED
    End If
       
    getLongData = True

    Exit Function

errGetLongData:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      getColDescriptions
'    description:   columns description of all columns
'    arguments:     /
'
'    return value:  true if success
'
'=========================================================================================
Private Function getColDescriptions() As Boolean
    On Error GoTo errGetColDescriptions

    Const FUNCTION_NAME = "getColDescriptions"

    '=local variables========================
    Dim i               As Integer
    Dim sColName        As String
    Dim nsColNameLen    As Integer
    Dim nColType        As Integer
    Dim nColLength      As Long
    Dim lRc             As Integer
    Dim nColDecimal     As Integer
    Dim nColNullable    As Integer
    Dim newCollection   As New Collection
    Dim bColName()      As Byte
    '=======================================

    'inits
    getColDescriptions = False
    
    If m_oConnection.hEnv = SQL_NULL_HENV Or m_oConnection.hDbc = SQL_NULL_HDBC Then Exit Function

    'get number of columns
    lRc = SQLNumResultCols(m_hResult, m_nColCount)
    If lRc <> SQL_SUCCESS Then
    
        If Not m_oConnection.error.checkRC(lRc, m_hResult) Then Exit Function
    End If
    
    'alloc space
    sColName = Space$(MX_COLUMN_NAME)
    
    'init memory
    m_sValue = Space$(MX_COLUMN_VALUE)
    ReDim m_byUniCodeValue(MX_COLUMN_VALUE * 2)
    m_sValueLong = Space$(MX_COLUMN_LONG_VALUE)
    m_sValueGenericNumber = Space$(MX_COLUMN_GENERIC_NUMERIC)
    
    'Get the column descriptions
    For i = 1 To m_nColCount
    
        Dim onewColumn   As New Column
        
        'init
        ReDim bColName(MX_COLUMN_NAME * 2)
        'Get the individual column description
        lRc = SQLDescribeColW(m_hResult, _
                                i, _
                                bColName(0), _
                                MX_COLUMN_NAME, _
                                nsColNameLen, _
                                nColType, _
                                nColLength, _
                                nColDecimal, _
                                nColNullable)
        If lRc <> SQL_SUCCESS Then
        
            If Not m_oConnection.error.checkRC(lRc, m_hResult) Then Exit Function
        End If
        
        sColName = left$(bColName, nsColNameLen)
        
        'set column description
        If nsColNameLen > 0 Then
        
            onewColumn.colName = sColName
        Else
            onewColumn.colName = ""
        End If
        
        onewColumn.odbcColType = nColType
        onewColumn.colLength = nColLength
        onewColumn.colDecimal = nColDecimal
        
        If nColNullable <> 0 Then
        
            onewColumn.colNullable = True
        Else
            onewColumn.colNullable = False
        End If
                
        'add new column to column collection
        newCollection.Add onewColumn
        Set onewColumn = Nothing
    Next
    
    'clean
    Set m_oColumns = Nothing
    'set new collumns collection
    Set m_oColumns = newCollection

    getColDescriptions = True

    Exit Function

errGetColDescriptions:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      openParamResult
'    description:   open a result of a db procedure
'    arguments:     [in] sCmdStr, sql command (db procedure) string
'                   [in] emSQLMode, sql mode for execute
'
'    return value:  true if succesfully
'
'=========================================================================================
Public Function openParamResult(sCmdStr As String, emSQLMode As sqlMode) As Boolean
    On Error GoTo errOpenParamResult

    Const FUNCTION_NAME = "openParamResult"

    '=local variables================================================
    Dim oParameterDefinitions  As Parameter
    Dim newCollection          As New Collection
    '=================================================================

    'rc
    openParamResult = False
    
    'inits
    m_lastSQLMode = emSQLMode
    m_sStatement = sCmdStr
    
    m_bDBProcedureResult = True
    
    If m_oConnection.hEnv = SQL_NULL_HENV Or _
       m_oConnection.hDbc = SQL_NULL_HDBC Then Exit Function
    
    If m_oFunctions.fullParameterExecute(m_sStatement, emSQLMode) Then
                
        If m_oFunctions.parameterDefinitions.Count < 1 Then
        
            m_lRowCount = 0
            m_nColCount = 0
            m_bNoRows = True
            Exit Function
        End If
    Else
        Exit Function
    End If
                    
    'create a placebo result object
    m_nColCount = 0
    m_bNoRows = False
    m_lRowCount = 1
    
    For Each oParameterDefinitions In m_oFunctions.parameterDefinitions
    
        Dim onewColumn   As New Column
        m_nColCount = m_nColCount + 1
        
        onewColumn.odbcColType = oParameterDefinitions.columnType
        onewColumn.colValue = oParameterDefinitions.Value
        onewColumn.colLength = oParameterDefinitions.valueLength
        
        'build colname
        Select Case oParameterDefinitions.parameterType
            Case ptUnknown
                onewColumn.colName = LoadResString(107)
            Case ptIn
                onewColumn.colName = LoadResString(114)
            Case ptInOut
                onewColumn.colName = LoadResString(115)
            Case ptResultCol
                onewColumn.colName = LoadResString(116)
            Case ptOut
                onewColumn.colName = LoadResString(117)
            Case ptReturnValue
                onewColumn.colName = LoadResString(116)
        End Select
        
        onewColumn.colName = onewColumn.colName + " (" + Trim$(Str$(oParameterDefinitions.parameterNo)) + ")"
        
        onewColumn.colNullable = False
        
        'add new column to column collection
        newCollection.Add onewColumn
        Set onewColumn = Nothing
    Next
    
    'clean
    Set m_oColumns = Nothing
    'set new collumns collection
    Set m_oColumns = newCollection

    'rc
    openParamResult = True

    Exit Function

errOpenParamResult:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Function
Private Function resultRows(ByVal hResult As Long) As Long
    On Error GoTo errResultRows

    Const FUNCTION_NAME = "resultRows"

    Dim Rows           As Long
    Dim lRc            As Integer

    ' Inits
    resultRows = 0
    
    If m_oConnection.hEnv = SQL_NULL_HENV Or m_oConnection.hDbc = SQL_NULL_HDBC Then Exit Function

    ' Try to Get the number of rows
    lRc = SQLRowCount(hResult, Rows)
    If lRc <> SQL_SUCCESS Then
    
        If Not m_oConnection.error.checkRC(lRc, hResult) Then Exit Function
    End If
        
    resultRows = Rows

    Exit Function

errResultRows:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function NumberRowsInResult() As String
    On Error GoTo ErrNumberRowsInResult

    Const FUNCTION_NAME = "NumberRowsInResult"

    If m_lRowCount >= 0 Then
    
        NumberRowsInResult = Trim$(Str$(m_lRowCount))
    Else
        NumberRowsInResult = LoadResString(107)
    End If
       
    Exit Function

ErrNumberRowsInResult:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      getFormattedNumber
'    description:   format a number value to a string due to system settings of windows
'
'    arguments:     [in] CurrentNumber,number as string
'
'    return value:  formatted number
'
'=========================================================================================
Private Function getFormattedNumber(ByVal CurrentNumber As String) As String
    On Error GoTo errGetFormattedNumber

    Const FUNCTION_NAME = "getFormattedNumber"

    '=local variables===================
    Dim NumberStr       As String
    Dim NumberLen       As Integer
    Dim ThousandsLen    As Integer
    Dim ReplacePos      As Integer
    Dim iNegative       As Integer
    Dim i               As Integer
    '===================================

    'inits
    NumberLen = Len(CurrentNumber)
    ThousandsLen = Len(m_oIntSettings.thousandSeparator)
    ReplacePos = 0
    NumberStr = ""

    'Get the replace position for the separator
    ReplacePos = InStr(CurrentNumber, ".")
    If ReplacePos <> 0 Then

        ' Replace the separator
        NumberStr = left$(CurrentNumber, ReplacePos - 1) + m_oIntSettings.decimalSeparator + right$(CurrentNumber, NumberLen - ReplacePos)
    Else
        NumberStr = CurrentNumber
    End If

    ' Search the position to begin setting of thousands
    If ReplacePos = 0 Then

        ReplacePos = NumberLen
    Else
        ReplacePos = ReplacePos - 1
    End If

    'Get the replace position for the separator
    iNegative = InStr(CurrentNumber, "-")
    If iNegative <> 0 And ReplacePos > 1 Then ReplacePos = ReplacePos - 1

    'set leading zero
    If ReplacePos = 0 And m_oIntSettings.leadingZero And Len(CurrentNumber) > 0 Then 'CurrentNumber <> "" Then

        NumberStr = "0" + NumberStr
        NumberLen = NumberLen + 1
    End If

    ' Set the thousands separator
    If ThousandsLen > 0 Then

        For i = ReplacePos To 0 Step -3

            If i - 3 > 0 Then

                If iNegative <> 0 Then

                    NumberStr = left$(NumberStr, i - 2) + m_oIntSettings.thousandSeparator + right$(NumberStr, NumberLen - i + 2)
                Else
                    NumberStr = left$(NumberStr, i - 3) + m_oIntSettings.thousandSeparator + right$(NumberStr, NumberLen - i + 3)
                End If
                NumberLen = NumberLen + ThousandsLen
            Else
                Exit For
            End If
        Next
    End If

    getFormattedNumber = NumberStr

    Exit Function

errGetFormattedNumber:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      class_Initialize
'    description:   Occurs when an application creates an instance of a Form, MDIForm, User control, Property Page, Webclass, DHTML Page Designer, or class.
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Class_Initialize()
    On Error GoTo ErrClass_Initialize

    Const FUNCTION_NAME = "Class_Initialize"
    
    m_hResult = 0
    m_bNoRows = True
    m_lFetchedRows = 0
    m_lRowCount = 0
    m_sAdditionalStatement = ""
    m_lLimitForLong = -1
    m_sRepOfNullValue = cnstQUERY_NULL
    m_lCallingWnd = 0
    m_sResultName = ""
    m_emResultMode = sapdbSimpleMode
    
    m_bDBProcedureResult = False
    
    m_lastSQLMode = Internal
        
    If Not m_oIntSettings Is Nothing Then _
       m_oIntSettings.Refresh
    
    Set m_oColumns = Nothing
        
    Exit Sub
    
ErrClass_Initialize:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      class_Terminate
'    description:   Occurs when all references to an instance of
'                   a Form, User control... or class are removed
'                   from memory by setting all the variables that
'                   refer to the object to Nothing or when the last
'                   reference to the object falls out of scope.
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Class_Terminate()
    On Error GoTo ErrClass_Terminate

    Const FUNCTION_NAME = "Class_Terminate"
    
    'first close result if open
    closeResult
        
    Exit Sub
    
ErrClass_Terminate:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    property:      representationOfNullValue
'    description:   Get the representation of a null value
'    arguments:     /
'
'    return value:  value as string
'
'=========================================================================================
Public Property Get representationOfNullValue() As String
    On Error GoTo ErrGETrepresentationOfNullValue
    
    Const FUNCTION_NAME = "Get representationOfNullValue"
    
    representationOfNullValue = m_sRepOfNullValue
    
    Exit Property
    
ErrGETrepresentationOfNullValue:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      representationOfNullValue
'    description:   Let the representation of a null value
'    arguments:     [in] newRepresentationOfNullValue,new representation of a null value
'
'    return value:  value as string
'
'=========================================================================================
Public Property Let representationOfNullValue(newRepresentationOfNullValue As String)
    On Error GoTo errLETrepresentationOfNullValue
    
    Const FUNCTION_NAME = "Let representationOfNullValue"
    
    m_sRepOfNullValue = newRepresentationOfNullValue
    
    Exit Property
    
errLETrepresentationOfNullValue:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property       CursorName
'    description:   return the cursor name associated with statement or result object.
'    arguments:     /
'
'    return value:  name of cursor as string
'
'=========================================================================================
Public Property Get cursorName() As String
    On Error GoTo errP_Get_CursorName

    Const FUNCTION_NAME = "P_Get cursorName"
    
    '=local variables===================
    Dim sCursorName       As String
    Dim bByteCursorName() As Byte
    Dim lCursorMax        As Integer
    Dim lCursorLen        As Integer
    Dim lPos              As Long
    Dim lRc               As Integer
    '====================================
    
    'rc
    cursorName = ""
    
    If m_oConnection.hDbc = SQL_NULL_HDBC Then Exit Property
    
    'Init
    lCursorMax = 512
    ReDim bByteCursorName(lCursorMax * 2)
        
    lRc = SQLGetCursorNameW(m_hResult, _
                            bByteCursorName(0), _
                            lCursorMax, _
                            lCursorLen)
    If lRc <> SQL_SUCCESS Then
    
        If Not m_oConnection.error.checkRC(lRc, m_hResult) Then sCursorName = ""
    End If
    
    sCursorName = left$(bByteCursorName, lCursorLen \ 2)
    cursorName = Chr$(34) + sCursorName + Chr$(34)
         
    Exit Property
    
errP_Get_CursorName:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    function:      getColData
'    description:   get data of a result column into a a msflexgrid, or column object
'    arguments:     [in] nCol, Column
'
'    return value:  true if success
'
'=========================================================================================
Private Function getColData(nCol As Integer, _
                            oCurrentCol As Column) As Boolean
    On Error GoTo ErrgetColData

    Const FUNCTION_NAME = "getColData"
    
    Dim lBoolean           As Boolean
    Dim lValueLen          As Long
    Dim lGetDataLen        As Long
    Dim lRc                As Integer
    Dim sRepresentData     As String
    
    'rc
    getColData = False
    
    'Get the data for the current col
    Select Case oCurrentCol.odbcColType
        Case odbcColTypeDate:        '<<<<<<---odbcColTypeDate--->>>>>>>>
            
            'Get the current value
            lRc = SQLGetData(m_hResult, nCol, odbcColTypeChar, ByVal m_sValue, MX_DATE_COLUMN_VALUE, lValueLen)
            If lRc <> SQL_SUCCESS Then
            
                If Not m_oConnection.error.checkRC(lRc, m_hResult) Then
                
                     oCurrentCol.colValue = m_oConnection.error.text
                    Exit Function
                End If
            End If
            
            If Not oCurrentCol Is Nothing Then
                'set value
                If lValueLen >= 0 Then
                
                    oCurrentCol.colValue = left$(m_sValue, lValueLen)
                    oCurrentCol.colIsNull = False
                Else
                    oCurrentCol.colValue = m_sRepOfNullValue
                    oCurrentCol.colIsNull = True
                End If
            End If
        Case odbcColTypeTime:      '<<<<<<---odbcColTypeTime--->>>>>>>>
        
            'Get the current value
            lRc = SQLGetData(m_hResult, nCol, odbcColTypeChar, ByVal m_sValue, MX_TIME_COLUMN_VALUE, lValueLen)
            If lRc <> SQL_SUCCESS Then
            
                If Not m_oConnection.error.checkRC(lRc, m_hResult) Then
                
                    oCurrentCol.colValue = m_oConnection.error.text
                    Exit Function
                End If
            End If
            
            If Not oCurrentCol Is Nothing Then
                'set value
                If lValueLen >= 0 Then
                
                    oCurrentCol.colValue = left$(m_sValue, lValueLen)
                    oCurrentCol.colIsNull = False
                Else
                    oCurrentCol.colValue = m_sRepOfNullValue
                    oCurrentCol.colIsNull = True
                End If
            End If
            
        Case odbcColTypeTimeStamp:        '<<<<<<---odbcColTypeTimeStamp--->>>>>>>>
            'Get the current value
            
            lRc = SQLGetData(m_hResult, nCol, odbcColTypeChar, ByVal m_sValue, MX_TIMESTAMP_COLUMN_VALUE, lValueLen)
            If lRc <> SQL_SUCCESS Then
            
                If Not m_oConnection.error.checkRC(lRc, m_hResult) Then
                
                    oCurrentCol.colValue = m_oConnection.error.text
                    Exit Function
                End If
            End If
            
            If Not oCurrentCol Is Nothing Then
                'set value
                If lValueLen >= 0 Then
                
                    oCurrentCol.colValue = left$(m_sValue, lValueLen)
                    oCurrentCol.colIsNull = False
                Else
                    oCurrentCol.colValue = m_sRepOfNullValue
                    oCurrentCol.colIsNull = True
                End If
            End If
            
        Case odbcColTypeLongVarBinary:          '<<<<<<---odbcColTypeLongVarBinary--->>>>>>>>
            
            If m_lLimitForLong >= 0 Then

                 lGetDataLen = m_lLimitForLong
                 
                 If m_lLimitForLong > MX_COLUMN_LONG_VALUE Then _
                    m_sValueLong = Space$(m_lLimitForLong)
            Else
                 lGetDataLen = MX_COLUMN_LONG_VALUE
            End If
            
            m_oConnection.error.noSQLState = SQLSTATE_DATA_TRUNCATED
            lRc = SQLGetData(m_hResult, nCol, odbcColTypeBinary, ByVal m_sValueLong, lGetDataLen, lValueLen)
            If lRc <> SQL_SUCCESS Then
                
                If Not m_oConnection.error.checkRC(lRc, m_hResult) Then
                
                    oCurrentCol.colValue = m_oConnection.error.text
                    'set back no sql state of error class
                    m_oConnection.error.noSQLState = SQLSTATE_SUCCESS
                    
                    Exit Function
                End If
                'set back no sql state of error class
                m_oConnection.error.noSQLState = SQLSTATE_SUCCESS
             End If

            If Not oCurrentCol Is Nothing Then
                'set value
                If lValueLen = SQL_NO_TOTAL Then
                
                    oCurrentCol.colIsNull = False
                    oCurrentCol.colValue = left$(m_sValueLong, lGetDataLen)
                Else
                    If lValueLen >= 0 Then
                
                        oCurrentCol.colValue = left$(m_sValueLong, lValueLen)
                        oCurrentCol.colIsNull = False
                    Else
                        oCurrentCol.colValue = m_sRepOfNullValue
                        oCurrentCol.colIsNull = True
                    End If
                End If
            End If

        Case odbcColTypeDecimal, odbcColTypeNumeric, _
             odbcColTypeReal, odbcColTypeFloat, _
             odbcColTypeDouble, odbcColTypeInteger:     '<<<<<<---odbcColTypeNUMBER--->>>>>>>>
        
            'Get the current value
            lRc = SQLGetData(m_hResult, nCol, odbcColTypeChar, ByVal m_sValueGenericNumber, MX_COLUMN_GENERIC_NUMERIC, lValueLen)
            If lRc <> SQL_SUCCESS Then
            
                If Not m_oConnection.error.checkRC(lRc, m_hResult) Then
                
                    oCurrentCol.colValue = m_oConnection.error.text
                    Exit Function
                End If
            End If
            
            If Not oCurrentCol Is Nothing Then
                'set value
                If lValueLen >= 0 Then
                
                    oCurrentCol.colValue = getFormattedNumber(left$(m_sValueGenericNumber, lValueLen))
                    oCurrentCol.colIsNull = False
                Else
                    oCurrentCol.colValue = m_sRepOfNullValue
                    oCurrentCol.colIsNull = True
                End If
            End If
        Case odbcColTypeBit:                         '<<<<<<---odbcColTypeBit--->>>>>>>>
            'Get the current value
            lRc = SQLGetData(m_hResult, nCol, odbcColTypeBit, lBoolean, 1, lValueLen)
            If lRc <> SQL_SUCCESS Then
            
                If Not m_oConnection.error.checkRC(lRc, m_hResult) Then
                
                    oCurrentCol.colValue = m_oConnection.error.text
                    Exit Function
                End If
            End If
            If Not oCurrentCol Is Nothing Then

                'set value
                If lValueLen > 0 Then
                    If lBoolean Then
                    
                        oCurrentCol.colValue = "TRUE"
                    Else
                        oCurrentCol.colValue = "FALSE"
                    End If
                    
                    oCurrentCol.colIsNull = False
                Else
                    oCurrentCol.colValue = m_sRepOfNullValue
                    oCurrentCol.colIsNull = True
                End If
            End If
        'wide char types are fetched as strings
        Case odbcColTypeWChar, _
             odbcColTypeWVarChar, _
             odbcColTypeWLongVarChar:                '<<<<<<---odbcColTypeUNICODE--->>>>>>>>
            
            If oCurrentCol.odbcColType = odbcColTypeWLongVarChar Then
                lGetDataLen = MX_COLUMN_VALUE * 2
            Else
                'collength is char count so buffer is double size
                'add two bytes for double zero termination
                lGetDataLen = oCurrentCol.colLength * 2 + 2
                If lGetDataLen > MX_COLUMN_VALUE * 2 Then lGetDataLen = MX_COLUMN_VALUE * 2
            End If
            
            lRc = SQLGetData(m_hResult, nCol, odbcColTypeWChar, m_byUniCodeValue(0), lGetDataLen, lValueLen)
            If lRc <> SQL_SUCCESS Then
            
                If Not m_oConnection.error.checkRC(lRc, m_hResult) Then
                
                    oCurrentCol.colValue = m_oConnection.error.text
                    Exit Function
                End If
            End If
            
            If Not oCurrentCol Is Nothing Then

                'set value
                If lValueLen > 0 Then
                
                    oCurrentCol.colValue = left$(m_byUniCodeValue, lValueLen \ 2)
                    oCurrentCol.colIsNull = False
                Else
                    If lValueLen <> SQL_NULL_DATA Then
                    
                        oCurrentCol.colValue = ""
                        oCurrentCol.colIsNull = False
                    Else
                        oCurrentCol.colValue = m_sRepOfNullValue
                        oCurrentCol.colIsNull = True
                    End If
                End If
            End If
        Case Else                           '<<<<<<---odbcColTypeANYTHINGELSE--->>>>>>>>
            'byte representation in database will be converted to string, get double space
            If oCurrentCol.odbcColType = odbcColTypeVarBinary Or oCurrentCol.odbcColType = odbcColTypeBinary Then
            
                lGetDataLen = oCurrentCol.colLength * 2 + 1
            ElseIf oCurrentCol.odbcColType = odbcColTypeLongVarChar Then
            
                lGetDataLen = MX_COLUMN_VALUE * 2
            Else
                lGetDataLen = oCurrentCol.colLength + 1
            End If
                
            lRc = SQLGetData(m_hResult, nCol, odbcColTypeChar, ByVal m_sValue, lGetDataLen, lValueLen)
            If lRc <> SQL_SUCCESS Then
            
                If Not m_oConnection.error.checkRC(lRc, m_hResult) Then
                
                    oCurrentCol.colValue = m_oConnection.error.text
                    Exit Function
                End If
            End If

            If Not oCurrentCol Is Nothing Then

                'set value
                If lValueLen > 0 Then
                
                    oCurrentCol.colValue = left$(m_sValue, lValueLen)
                    oCurrentCol.colIsNull = False
                Else
                    If lValueLen <> SQL_NULL_DATA Then
                    
                        oCurrentCol.colValue = ""
                        oCurrentCol.colIsNull = False
                    Else
                        oCurrentCol.colValue = m_sRepOfNullValue
                        oCurrentCol.colIsNull = True
                    End If
                End If
            End If
    End Select
    
    'rc
    getColData = True
    
   Exit Function
    
ErrgetColData:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      showError
'    description:   display actual error
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Public Function showError()
    On Error GoTo errShowError

    Const FUNCTION_NAME = "showError"
    
    m_oConnection.error.showError
    
    Exit Function
    
errShowError:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      reopen
'    description:   open (execute the sql) a database result again
'    arguments:     reopen
'
'    return value:  true if success
'
'=========================================================================================
Public Function reopen() As Boolean
    On Error GoTo errReOpen

    Const FUNCTION_NAME = "reopen"
    
    Dim oFunctions       As New SQLStudioDBLayer.Functions
        
    'first close old result
    closeResult
    
    If Me.dbProcedureResult Then
    
        reopen = Me.openParamResult(m_sStatement, m_lastSQLMode)
    Else
        
        If Len(Me.additionalStatement) > 0 Then

            Set oFunctions.connection = m_oConnection
            If Not oFunctions Is Nothing Then

                reopen = oFunctions.fullExecDirectStmt(Me.additionalStatement, m_lastSQLMode)
            End If
        Else
            reopen = Me.openResult(m_sStatement, m_lastSQLMode)
        End If
    End If
    
    Exit Function
    
errReOpen:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    property:      connection
'    description:   set a sapdb connection object
'    arguments:     newConnection, connection object
'
'    return value:  /
'
'=========================================================================================
Public Property Set connection(newConnection As SQLStudioDBLayer.connection)
    On Error GoTo errP_SET_Connection

    Const FUNCTION_NAME = "P_SET Connection"
    
    Set m_oConnection = newConnection
    Set m_oFunctions.connection = m_oConnection
    
    Exit Property
    
errP_SET_Connection:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      connection
'    description:   get a sapdb connection object
'    arguments:     /
'
'    return value:  sapdb connection object
'
'=========================================================================================
Public Property Get connection() As SQLStudioDBLayer.connection
    On Error GoTo errP_Get_Connection

    Const FUNCTION_NAME = "P_Get connection"
    
    Set connection = m_oConnection
    
    Exit Property
    
errP_Get_Connection:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property

