VERSION 5.00
Begin VB.Form frmShowDBError 
   Caption         =   "Database Error"
   ClientHeight    =   4530
   ClientLeft      =   60
   ClientTop       =   300
   ClientWidth     =   8070
   Icon            =   "SAPDBShowDBError.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4530
   ScaleWidth      =   8070
   Begin VB.CommandButton cmdOk 
      Caption         =   "&Close"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   3264
      TabIndex        =   1
      Top             =   4068
      Width           =   1200
   End
   Begin DBLayer.DBError ctrDBError 
      Height          =   3840
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   7728
      _ExtentX        =   10398
      _ExtentY        =   6588
   End
End
Attribute VB_Name = "frmShowDBError"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Module:      frmShowDBError
'
'
'-----------------------------------------------------------------------
'
' responsible:  WolfgangA
'
' special area: SAPDBConnection
'
' description:  form to show a error (sql,odbc) message
'
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
'Module Name
'--------------------------------------------------------
Const MODULE_NAME = "SAPDBQP.frmShowDBError"


'=========================================================================================
'    function:      cmdOk_Click
'    description:   the ok button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdOk_Click()
  On Error GoTo ErrcmdOk_Click

    Const FUNCTION_NAME = "cmdOk_Click"
    
    Unload Me
    
    Exit Sub
    
ErrcmdOk_Click:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub ctrDBError_UnloadRequest()
    On Error GoTo ErrctrDBError_UnloadRequest

    Const FUNCTION_NAME = "ctrDBError_UnloadRequest"
    
    Unload Me
    
    Exit Sub
    
ErrctrDBError_UnloadRequest:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._KeyDown
'    description:   key down event of form
'    arguments:     [in] KeyCode, such as vbKeyHome (the HOME key).
'                   [in] Shift, Integer that corresponds to the state of the SHIFT, CTRL, and ALT keys at the time of the event
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrForm_KeyDown

    Const FUNCTION_NAME = "Form_KeyDown"
    
    If KeyCode = vbKeyEscape Then Unload Me
        
    Exit Sub
    
ErrForm_KeyDown:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._Paint
'    description:   Occurs when part or all of an object is exposed after being moved or enlarged, or after a window that was covering the object has been moved
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Paint()
    On Error GoTo ErrForm_Paint

    Const FUNCTION_NAME = "Form_Paint"
    
    resizeControls
    
    ctrDBError.RefreshContext
    
    Exit Sub
    
ErrForm_Paint:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._Resize
'    description:   Occurs when an object is first displayed or when the window state of an object changes.
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Resize()
    On Error GoTo ErrForm_Resize

    Const FUNCTION_NAME = "Form_Resize"
    
    resizeControls
    
    Exit Sub
    
ErrForm_Resize:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      resizeControls
'    description:   place all elements of control due to new size
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub resizeControls()
    On Error GoTo errResizeControls

    Const FUNCTION_NAME = "ResizeControls"
    
    
    Dim lHeight As Long
    Dim lLeft  As Long
    
    ctrDBError.Width = ScaleWidth
    
    lHeight = ScaleHeight - 2 * cmdOk.Height
    lLeft = Width / 2 - cmdOk.Width / 2
    
    If lHeight > 100 Then
        ctrDBError.Height = lHeight
        cmdOk.top = lHeight + cmdOk.Height / 2
    Else
        ctrDBError.Height = 4860
    End If
    
    If lLeft > 0 Then cmdOk.left = lLeft
    
    Exit Sub
    
errResizeControls:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    property:      Connection
'    description:   set a sapdb connection object
'    arguments:     NewConnection, Connection object
'
'    return value:  /
'
'=========================================================================================
Public Property Set Connection(NewConnection As SAPDBConnection.Connection)
    On Error GoTo ErrP_SET_Connection

    Const FUNCTION_NAME = "P_SET Connection"
    
    Set ctrDBError.Connection = NewConnection
    
    Exit Property
    
ErrP_SET_Connection:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property

