VERSION 5.00
Begin VB.Form frmNIString 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Enter NI String ..."
   ClientHeight    =   1170
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6045
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1170
   ScaleWidth      =   6045
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtNiString 
      Height          =   315
      Left            =   105
      TabIndex        =   1
      Top             =   270
      Width           =   5760
   End
   Begin VB.CommandButton cmOK 
      Caption         =   "&Ok"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   360
      Left            =   4755
      TabIndex        =   0
      Top             =   690
      Width           =   1125
   End
End
Attribute VB_Name = "frmNIString"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Form:       frmNIString
'
' responsible:  WolfgangA
'
' special area: SQL Studio DB Layer
'
' description:  form for entering the sap ni connection string
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'module name
Const MODULE_NAME = "SAPDBxFunctions.frmNIString"

Private m_bOk      As Boolean
'=========================================================================================
'    porperty:      NiString
'    description:   Get then NI string entered by user
'
'    arguments:     /
'
'    return value:  see description
'
'=========================================================================================
Public Property Get niString() As String
    On Error GoTo errP_Get_NiString

    Const FUNCTION_NAME = "P_Get niString"

    Let niString = txtNiString.text

    Exit Property

errP_Get_NiString:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    porperty:      Ok
'    description:   if dialog was terminated by pressing ok button porperty is true
'
'    arguments:     /
'
'    return value:  see description
'
'=========================================================================================
Public Property Get Ok() As Boolean
    On Error GoTo errP_Get_Ok

    Const FUNCTION_NAME = "P_GET Ok"

    Let Ok = m_bOk

    Exit Property

errP_Get_Ok:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    function:      cmdOk_Click
'    description:   the ok button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub cmOK_Click()
    On Error GoTo ErrcmOK_Click

    Const FUNCTION_NAME = "cmOK_Click"

    m_bOk = True
    
    Me.Hide
    
    Exit Sub

ErrcmOK_Click:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      Form_Load
'    description:   Occurs when a form is loaded.
'                   For a startup form, occurs when an application starts as
'                   the result of a Load statement or as the result of a
'                   reference to an unloaded form's properties or controls.
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Load()
  On Error GoTo ErrForm_Load

    Const FUNCTION_NAME = "Form_Load"

    m_bOk = False
    
    If txtNiString.Visible Then txtNiString.SetFocus
    
    cmOK.Enabled = False
    
    Exit Sub

ErrForm_Load:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._Change
'    description:   Indicates the contents of a control have changed. How and when this event occurs varies with the control.
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub txtNiString_Change()
    On Error GoTo ErrtxtNiString_Change

    Const FUNCTION_NAME = "txtNiString_Change"

    If Len(txtNiString) > 0 Then
        
        cmOK.Enabled = True
    Else
        cmOK.Enabled = False
    End If
    
    Exit Sub

ErrtxtNiString_Change:
    internalError err, MODULE_NAME, FUNCTION_NAME
End Sub
