VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SQLSTO"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''///////
'
' Class:   SQLSTD
'
'
' mail to:  sapdb-general@sap.com
'
' special area: SQLStudio
'
' description:  class modul for sql studio
'
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
' Module Name
'--------------------------------------------------------
Const MODULE_NAME = "SQLStudio.SQLStudioApp"

'=========================================================================================
'    function:      showSQLStudio
'    description:   starts instance of sql studio
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Public Function showSQLStudio()
    On Error GoTo errShowSQLStudio
    
    Const FUNCTION_NAME = "showSQLStudio"
    
    frmMain.Show
    
    Exit Function

errShowSQLStudio:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      connectDB
'    description:   starts instance of sql studio, and connects to database
'    arguments:     [in] sUser, user id
'                   [in] sPassword, password
'                   [in] sDatabase, database
'                   [in] sdbServer, server of database
'
'    return value:  /
'
'=========================================================================================
Public Function connectDB(Optional sUser As String, Optional sPassWord As String, Optional sDatabase As String, Optional sdbServer As String)
    On Error GoTo errConnectDB
    
    Const FUNCTION_NAME = "connectDB"
        
     'inits
    If m_oGlobalInfo Is Nothing Then
        Set m_oGlobalInfo = New globalInfo
        Set m_oGlobalInfo.excelApplication = m_oExcelApp
    End If
        
    'check
    If m_oGlobalInfo Is Nothing Then
    
        MsgBox LoadResString(350), vbCritical
        End
    End If
    
    m_oGlobalInfo.ConMan.UID = sUser
    m_oGlobalInfo.ConMan.PWD = sPassWord
    m_oGlobalInfo.ConMan.database = sDatabase
    m_oGlobalInfo.ConMan.dbServer = sdbServer
    
    If Len(m_sDriverName) < 1 Then m_sDriverName = instDriver
        
    'instdriver failed just show sqlstudio
    If Len(m_sDriverName) < 1 Then End
    
    m_oGlobalInfo.ConMan.driver = m_sDriverName
    
    Call connect
    
    Exit Function

errConnectDB:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function


