VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CmdLineOpt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Form:       SQLStudio.CmdLine
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
' Module Name
'--------------------------------------------------------
Const MODULE_NAME = "SQLStudio.CmdLineOpt"


Private lPrefix As CmdLinePrefixConstants
Private sName As String
Private bIsOptional As Boolean
Private bMatchCase As Boolean
Private sValueDesc As String
Private sDescription As String
Private sValue As String
Private bInCmdLine As Boolean

Public Property Get Prefix() As CmdLinePrefixConstants
    On Error GoTo ErrGetPrefix
    
    Const FUNCTION_NAME = ""
    
    Prefix = lPrefix

    Exit Property
ErrGetPrefix:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let Prefix(ByVal NewVal As CmdLinePrefixConstants)
    On Error GoTo errLetPrefix
    
    Const FUNCTION_NAME = ""
    
    lPrefix = NewVal

    Exit Property
    
errLetPrefix:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get PrefixString() As String
    On Error GoTo ErrGetPrefixString
    
    Const FUNCTION_NAME = ""
    
    Select Case lPrefix
        Case cmlPrefixSlash: PrefixString = "/"
        Case cmlPrefixMinus: PrefixString = "-"
        Case cmlPrefixPlus:  PrefixString = "+"
    End Select
    

    Exit Property
    
ErrGetPrefixString:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get Name() As String
    On Error GoTo ErrGetName
    
    Const FUNCTION_NAME = ""
    
    Name = sName

    Exit Property
    
ErrGetName:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let Name(NewVal As String)
    On Error GoTo errLetName
    
    Const FUNCTION_NAME = ""
    
    sName = NewVal

    Exit Property
    
errLetName:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get isOptional() As Boolean
    On Error GoTo ErrGetIsOptional
    
    Const FUNCTION_NAME = ""
    
    isOptional = bIsOptional

    Exit Property
    
ErrGetIsOptional:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let isOptional(ByVal NewVal As Boolean)
    On Error GoTo errLetIsOptional
    
    Const FUNCTION_NAME = ""
    
    bIsOptional = NewVal

    Exit Property
    
errLetIsOptional:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get MatchCase() As Boolean
    On Error GoTo ErrGetMatchCase
    
    Const FUNCTION_NAME = ""
    
    MatchCase = bMatchCase

    Exit Property
    
ErrGetMatchCase:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let MatchCase(ByVal NewVal As Boolean)
    On Error GoTo errLetMatchCase
    
    Const FUNCTION_NAME = ""
    
    bMatchCase = NewVal

    Exit Property
    
errLetMatchCase:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get ValueDesc() As String
    On Error GoTo ErrGetValueDesc
    
    Const FUNCTION_NAME = ""
    
    ValueDesc = sValueDesc

    Exit Property
    
ErrGetValueDesc:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let ValueDesc(NewVal As String)
    On Error GoTo errLetValueDesc
    
    Const FUNCTION_NAME = ""
    
    sValueDesc = NewVal

    Exit Property
    
errLetValueDesc:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get description() As String
    On Error GoTo ErrGetDescription
    
    Const FUNCTION_NAME = ""
    
    description = sDescription
    

    Exit Property
    
ErrGetDescription:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let description(NewVal As String)
    On Error GoTo errLetDescription
    
    Const FUNCTION_NAME = ""
    
    sDescription = NewVal

    Exit Property
    
errLetDescription:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get Value() As String
    On Error GoTo ErrGetValue
    
    Const FUNCTION_NAME = ""
    
    Value = sValue
    

    Exit Property
    
ErrGetValue:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let Value(NewVal As String)
    On Error GoTo errLetValue
    
    Const FUNCTION_NAME = ""
    
    sValue = NewVal

    Exit Property
    
errLetValue:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get inCmdLine() As Boolean
    On Error GoTo ErrGetInCmdLine
    
    Const FUNCTION_NAME = ""
    
    inCmdLine = bInCmdLine

    Exit Property
    
ErrGetInCmdLine:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let inCmdLine(ByVal NewVal As Boolean)
    On Error GoTo errLetInCmdLine
    
    Const FUNCTION_NAME = ""
    
    bInCmdLine = NewVal

    Exit Property
    
errLetInCmdLine:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    function:      Class_Initialize
'    description:   Occurs when an application creates an instance of a Form, MDIForm, User control, Property Page, Webclass, DHTML Page Designer, or class.
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Class_Initialize()
    On Error GoTo errClass_Initialize
    
    Const FUNCTION_NAME = ""
    
    lPrefix = cmlPrefixMinus
    sName = ""
    bIsOptional = True
    bMatchCase = False
    sValueDesc = ""
    sDescription = ""
    sValue = ""
    bInCmdLine = False

    Exit Sub
    
errClass_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
