VERSION 5.00
Begin VB.Form frmCmdLineOpt 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "SQL Studio Command Line Options"
   ClientHeight    =   3495
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6495
   Icon            =   "CmdLineOpt.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3495
   ScaleWidth      =   6495
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   5220
      TabIndex        =   5
      Top             =   3000
      Width           =   1155
   End
   Begin VB.Frame fraOptions 
      BackColor       =   &H00000080&
      Caption         =   "Options"
      Height          =   2235
      Left            =   180
      TabIndex        =   2
      Top             =   660
      Width           =   6195
      Begin VB.Label lblDescription 
         Caption         =   "Show command line options."
         Height          =   195
         Index           =   0
         Left            =   2160
         TabIndex        =   4
         Top             =   360
         Width           =   3855
      End
      Begin VB.Label lblName 
         Caption         =   "/?"
         Height          =   195
         Index           =   0
         Left            =   240
         TabIndex        =   3
         Top             =   360
         Width           =   1875
      End
   End
   Begin VB.Label lblCmdLineOpts 
      Caption         =   "[/?]"
      Height          =   435
      Left            =   1440
      TabIndex        =   1
      Top             =   120
      Width           =   4875
   End
   Begin VB.Label lblExeName 
      Caption         =   "ExeName[.exe]"
      Height          =   195
      Left            =   180
      TabIndex        =   0
      Top             =   120
      Width           =   1095
   End
End
Attribute VB_Name = "frmCmdLineOpt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Form:       SQLStudio.frmCmdLineOpt
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
' Module Name
'--------------------------------------------------------
Const MODULE_NAME = "SQLStudio.frmCmdLineOpt"

'=private variables================================================================
'command line object
Private m_oCmdLine As cmdLine
'=============================================================================

Public Property Set cmdLine(NewVal As cmdLine)
    On Error GoTo errSetCmdLine
    
    Const FUNCTION_NAME = "CmdLine"
   
    Set m_oCmdLine = NewVal

    Exit Property
    
errSetCmdLine:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    function:      Form_Load
'    description:   Occurs when a form is loaded.
'                   For a startup form, occurs when an application starts as
'                   the result of a Load statement or as the result of a
'                   reference to an unloaded form's properties or controls.
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Load()
    On Error GoTo errForm_Load
    
    Const FUNCTION_NAME = "Form_Load"
   
    Dim sCmdLineOpts As String
    Dim oCmdLineOpt As CmdLineOpt
    Dim l As Long
    
    fraOptions.BackColor = vbButtonFace

    lblExeName.Caption = App.EXEName & "[.exe]"
    
    sCmdLineOpts = ""
    For Each oCmdLineOpt In m_oCmdLine
        With oCmdLineOpt
            If .isOptional Then sCmdLineOpts = sCmdLineOpts & "["
            sCmdLineOpts = sCmdLineOpts & .PrefixString
            sCmdLineOpts = sCmdLineOpts & .Name
            If .ValueDesc <> "" Then
                sCmdLineOpts = sCmdLineOpts & " "
                sCmdLineOpts = sCmdLineOpts & "<" & .ValueDesc & ">"
            End If
            If .isOptional Then sCmdLineOpts = sCmdLineOpts & "]"
            sCmdLineOpts = sCmdLineOpts & " "
        End With
    Next
            
    For l = 0 To m_oCmdLine.count - 1
        If l > 0 Then
            Load lblName(l)
            lblName(l).Move lblName(l - 1).Left, lblName(l - 1).Top + lblName(l - 1).Height
            lblName(l).Visible = True
            Load lblDescription(l)
            lblDescription(l).Move lblDescription(l - 1).Left, lblDescription(l - 1).Top + lblDescription(l - 1).Height
            lblDescription(l).Visible = True
        End If
        With m_oCmdLine.item(l + 1)
            If .ValueDesc = "" Then
                lblName(l).Caption = .PrefixString & .Name
            Else
                lblName(l).Caption = .PrefixString & .Name & " <" & .ValueDesc & ">"
            End If
            lblDescription(l).Caption = .description
        End With
    Next
            
    lblCmdLineOpts.Caption = sCmdLineOpts

    Exit Sub
    
errForm_Load:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      cmdOk_Click
'    description:   the ok button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdOK_Click()
    On Error GoTo errCmdOK_Click
    
    Const FUNCTION_NAME = "cmdOK_Click"
   
    Unload Me

    Exit Sub
    
errCmdOK_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub




