Attribute VB_Name = "Core"
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Module:      Core - Core Module
'
'
'-----------------------------------------------------------------------
'
' responsible:  WolfgangA
'
' special area: SQLStudio
'
' description:  module for function imports, constants ...
'
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


Option Explicit

'--------------------------------------------------------
' Module Name
'--------------------------------------------------------
Const MODULE_NAME = "SQLStudio.Core"

'=public const=====================================

'const used in funtion RemoveMenu
Public Const MF_BYPOSITION = &H400&
Public Const MF_REMOVE = &H1000&

Public Const SQL_NO_DATA = 100

Public Const SW_SHOWNORMAL = 1

Public Const SAPDB_TRUE = "True"

Public Const ODBC_INSTALL_INQUIRY = 1
Public Const ODBC_INSTALL_COMPLETE = 2

Public Const SQL_MAX_MESSAGE_LENGTH = 512

Public Const SQL_SUCCESS = 0
Public Const SQL_SUCCESS_WITH_INFO = 1

Public Const REMOVEFAILEDCON = "RemFailedCon"

Public Const NOTIMEOUT = "NoTimeOut"
Public Const WINDOWPLACEMENT = "WindowPlacement"

'const path for help urls
Public Const hlpRoot = "00006979"
Public Const hlpMain = ".chm::/9395DC3958923402E10000000A11402F/content.htm"
Public Const hlpDirectSQLMain = ".chm::/AD990075EAF111D4AA2800A0C9430730/content.htm"
Public Const hlpVIQMain = ".chm::/AD99007BEAF111D4AA2800A0C9430730/content.htm"
Public Const hlpQBEMain = ".chm::/AD990078EAF111D4AA2800A0C9430730/content.htm"
Public Const hlpTablesMain = ".chm::/EE1C5BCDEBA711D4AA2800A0C9430730/content.htm"
Public Const hlpUserSettings = ".chm::/AD99006EEAF111D4AA2800A0C9430730/content.htm"
'===========================================================================

'=imported functions=====================================
Declare Function GetSystemMenu Lib "user32" (ByVal hwnd As Long, ByVal bRevert As Long) As Long
Declare Function GetMenuItemCount Lib "user32" (ByVal hMenu As Long) As Long
Declare Function DrawMenuBar Lib "user32" (ByVal hwnd As Long) As Long
Declare Function RemoveMenu Lib "user32" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long) As Long
    
    

''' Parameter Description for Shell Execute
'''
''' hwnd         Identifies the parent window. This window receives any
'''              message boxes an application produces (for example, for error
'''              reporting).
'''
''' lpszOp       Points to a null-terminated string specifying the operation
'''              to perform. This string can be "open" or "print." If this
'''              parameter is NULL, "open" is the default value.
'''
''' lpszFile     Points to a null-terminated string specifying the file
'''              to open.
'''
''' lpszParams   Points to a null-terminated string specifying parameters
'''              passed to the application when the lpszFile parameter
'''              specifies an executable file. If lpszFile points to a string
'''              specifying a document file, this parameter is NULL.
'''
''' LpszDir      Points to a null-terminated string specifying the default
'''              directory.
'''
''' FsShowCmd    Specifies whether the application window is to be shown when
'''              the application is opened.
Declare Function ShellExecuteA Lib "shell32.dll" _
                                            (ByVal hwnd As Long, _
                                             ByVal lpszOp As String, _
                                             ByVal lpszFile As String, _
                                             ByVal lpszParams As String, _
                                             ByVal LpszDir As String, _
                                             ByVal FsShowCmd As Long) _
                                             As Long

Declare Function ShellExecuteW Lib "shell32.dll" _
                                            (ByVal hwnd As Long, _
                                             ByVal lpszOp As String, _
                                             ByVal lpszFile As String, _
                                             ByVal lpszParams As String, _
                                             ByVal LpszDir As String, _
                                             ByVal FsShowCmd As Long) _
                                             As Long
                                            
Declare Function SQLRemoveDriverW Lib "odbccp32" ( _
                                            lpszDriver As Byte, _
                                            ByVal fRemoveDSN As Long, _
                                            ByRef lpdwUsageCount As Long) As Integer


Declare Function SQLInstallDriverEx Lib "odbccp32" ( _
                                            ByVal lpszDriver As String, _
                                            ByVal lpszPathIn As String, _
                                            ByVal lpszPathOut As String, _
                                            ByVal cbPathOutMax As Long, _
                                            ByRef pcbPathOut As Long, _
                                            ByVal fRequest As Long, _
                                            ByRef lpdwUsageCount As Long) As Integer
                                            
Declare Function SQLInstallDriverExW Lib "odbccp32" ( _
                                            lpszDriver As Byte, _
                                            lpszPathIn As Byte, _
                                            lpszPathOut As Byte, _
                                            ByVal cbPathOutMax As Long, _
                                            ByRef pcbPathOut As Long, _
                                            ByVal fRequest As Long, _
                                            ByRef lpdwUsageCount As Long) As Integer
                                            
Declare Function SQLInstallerErrorW Lib "odbccp32" ( _
                                            ByVal iError As Long, _
                                            ByRef pfErrorCode As Long, _
                                            lpszErrorMsg As Byte, _
                                            ByVal cbErrorMsgMax As Long, _
                                            ByRef pcbErrorMsg As Long) As Integer

'The GetWindowThreadProcessId function retrieves the identifier of the
'thread that created the specified window and, optionally,
'the identifier of the process that created the window.
Public Declare Function GetWindowThreadProcessId Lib "user32" _
                            (ByVal hwnd As Long, _
                             lpdwprocessid As Long) As Long

'===========================================================================
