VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "LRUConnection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Class:      LRUConnection
'
'
'-----------------------------------------------------------------------
'
' responsible:  sapdb-general@sap.com
'
' special area: SQLStudio
'
' description:  class representing one LastRecentlyUsed connection
'
' see also:
'
'-----------------------------------------------------------------------
'
'
'    Copyright (C) 2000 SAP AG
'
' This library is free software; you can redistribute it and/or
' modify it under the terms of the GNU Lesser General Public
' License as published by the Free Software Foundation; either
' version 2.1 of the License, or (at your option) any later version.
'
' This library is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
' Lesser General Public License for more details.
'
' You should have received a copy of the GNU Lesser General Public
' License along with this library; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'Module name
Const MODULE_NAME = "SQLStudio.LRUConnection"


'=const=====================================================================
Const LRUConnectionKeyName = "Connection"
'============================================================================


'=private variables================================================================
Private m_sPWD As String
Private m_sUID As String
Private m_sDatabase As String
Private m_sdbServer As String

'object for registry functions
Private m_oRegFunc                  As SQLStudioUtil.Registry

Private m_oCrypt                    As New sqlStudioCt.CTPW
'============================================================================

'=========================================================================================
'    function:      Class_Initialize
'    description:   Occurs when an application creates an instance of a Form, MDIForm, User control, Property Page, Webclass, DHTML Page Designer, or class.
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Class_Initialize()
    On Error GoTo errClassInit
    
    Const FUNCTION_NAME = "Class Init"
    
    m_sPWD = ""
    m_sUID = ""
    m_sDatabase = ""
    m_sdbServer = ""
 
    Exit Sub
    
errClassInit:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      Driver
'    description:   this property is kept just for binary compability !!!!
'                   SQL Studio registers a driver temporary.
'                   Storing the driver name in the registry is not necessary.
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Public Property Get driver() As String
    On Error GoTo ErrGETDriver
    
    Const FUNCTION_NAME = "Get driver"
    
    MsgBox LoadResString(147)
    
    driver = ""
   
    Exit Property
    
ErrGETDriver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    function:      Driver
'    description:   this property is kept just for binary compability !!!!
'                   SQL Studio registers a driver temporary.
'                   Storing the driver name in the registry is not necessary.
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Public Property Let driver(sNewDriver As String)
    On Error GoTo errLETDriver
    
    Const FUNCTION_NAME = "Let driver"

    MsgBox LoadResString(147)
    
    Exit Property
   
errLETDriver:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Get PWD() As String
    On Error GoTo ErrGetPWD
    
    Const FUNCTION_NAME = "GET PWD"

    PWD = m_sPWD
   
    Exit Property
   
ErrGetPWD:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Let PWD(sNewPWD As String)
   On Error GoTo errLETPWD
    
    Const FUNCTION_NAME = "LET PWD"

   m_sPWD = sNewPWD
      
   Exit Property
   
errLETPWD:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Get UID() As String
    On Error GoTo ErrGETUID
    
    Const FUNCTION_NAME = "GET UID"

    UID = m_sUID
    
    Exit Property
    
ErrGETUID:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Let UID(sNewUID As String)
    On Error GoTo errLETUID
    
    Const FUNCTION_NAME = "LET UID"

    m_sUID = sNewUID
    
    Exit Property
    
errLETUID:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get database() As String
    On Error GoTo ErrGETDatabase
    
    Const FUNCTION_NAME = "Get database"

    database = m_sDatabase
   
    Exit Property
   
   
ErrGETDatabase:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let database(sNewDatabase As String)
    On Error GoTo errLETDatabase
    
    Const FUNCTION_NAME = "Let database"

    m_sDatabase = sNewDatabase
   
    Exit Property
   
   
errLETDatabase:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get dbServer() As String
    On Error GoTo ErrGETdbServer
    
    Const FUNCTION_NAME = "Get dbServer"

    dbServer = m_sdbServer
   
    Exit Property
   
   
ErrGETdbServer:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let dbServer(sNewdbServer As String)
    On Error GoTo errLETdbServer
    
    Const FUNCTION_NAME = "Let dbServer"

    m_sdbServer = sNewdbServer
   
    Exit Property
   
errLETdbServer:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Function IsEqual(oConnection As LRUConnection) As Boolean
    On Error GoTo ErrIsEqual
    
    Const FUNCTION_NAME = "Is Equal"
    
    IsEqual = False
    
    IsEqual = False
    If m_sUID = oConnection.UID Then
        If m_sDatabase = oConnection.database Then
            If m_sdbServer = oConnection.dbServer Then
            
                oConnection.PWD = m_sPWD
                IsEqual = True
            End If
        End If
    End If
    
    
    Exit Function
    
ErrIsEqual:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Friend Function ReadConnection(ByVal lKey As Long) As Boolean
    On Error GoTo errReadConnection
    
    Const FUNCTION_NAME = "ReadConnection"
    
    Dim bResult As Boolean
    Dim strKeyValue As String
    Dim lKeyValueLength As Long
    Dim regtypeKeyValueType As RegistryTypeConstants
    
    m_sUID = ""
    m_sPWD = ""
    m_sDatabase = ""
    m_sdbServer = ""
       
    strKeyValue = ""
    lKeyValueLength = 0
    
    bResult = m_oRegFunc.QueryValueNull(lKey, m_cnstKEYNAMEUID, regtypeKeyValueType, lKeyValueLength)
    If bResult And (regtypeKeyValueType = REG_SZ) Then
        bResult = m_oRegFunc.QueryValueString(lKey, m_cnstKEYNAMEUID, strKeyValue, lKeyValueLength)
        If bResult Then
            
            If Trim$(strKeyValue) = "" Then
                
                strKeyValue = ""
                ReadConnection = False
                Exit Function
            Else
                If Asc(Left$(strKeyValue, 1)) = 0 Then
                    strKeyValue = ""
                    ReadConnection = False
                    Exit Function
                End If
                
                m_sUID = strKeyValue
            End If
        End If
    End If
    
    strKeyValue = ""
    lKeyValueLength = 0
        
    bResult = m_oRegFunc.QueryValueNull(lKey, m_cnstKEYSERVERNODE, regtypeKeyValueType, lKeyValueLength)
    If bResult And (regtypeKeyValueType = REG_SZ) Then
        bResult = m_oRegFunc.QueryValueString(lKey, m_cnstKEYSERVERNODE, strKeyValue, lKeyValueLength)
        If bResult Then
            m_sdbServer = strKeyValue
        End If
    End If
    
    strKeyValue = ""
    lKeyValueLength = 0
    
    bResult = m_oRegFunc.QueryValueNull(lKey, m_cnstKEYDATABASE, regtypeKeyValueType, lKeyValueLength)
    If bResult And (regtypeKeyValueType = REG_SZ) Then
        bResult = m_oRegFunc.QueryValueString(lKey, m_cnstKEYDATABASE, strKeyValue, lKeyValueLength)
        If bResult Then
            m_sDatabase = strKeyValue
        End If
    End If
    
    strKeyValue = ""
    lKeyValueLength = 0
    
    bResult = m_oRegFunc.QueryValueNull(lKey, m_cnstKEYNAMEPWD, regtypeKeyValueType, lKeyValueLength)
    If bResult And (regtypeKeyValueType = REG_SZ) Then
        bResult = m_oRegFunc.QueryValueString(lKey, m_cnstKEYNAMEPWD, strKeyValue, lKeyValueLength)
        If bResult Then
            
                If (Len(strKeyValue) <> 0) And (Len(strKeyValue) > 39) Then
                  Call m_oCrypt.sqlStudioDeCt(strKeyValue)
            End If
            m_sPWD = strKeyValue
        End If
    End If
    
    'bug fix !
    'in older versions the function RegSetValueExStringW failed
    'due to a wrong length of the written data,
    'the size did not include the terminating null character
    If ((m_sPWD = m_sUID And _
        m_sPWD = m_sDatabase And _
        m_sPWD = m_sdbServer And _
        m_sUID = m_sDatabase And _
        m_sUID = m_sdbServer And _
        m_sDatabase = m_sdbServer) Or _
        (m_sPWD = m_sUID And _
        m_sdbServer = "" And _
        m_sDatabase = "")) _
    Then
        m_sPWD = ""
        m_sUID = ""
        m_sDatabase = ""
        m_sdbServer = ""
    End If
    
    ReadConnection = True

    Exit Function
errReadConnection:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Friend Function WriteConnection(ByVal lKey As Long) As Boolean
    On Error GoTo ErrWriteConnection
    
    Dim bResult As Boolean
    
    Const FUNCTION_NAME = "Write Connection"
    
    If (Len(m_sPWD) > 0) Then _
        Call m_oCrypt.sqlStudioCt(m_sPWD)
        
    bResult = m_oRegFunc.SetValueString(lKey, m_cnstKEYNAMEPWD, m_sPWD)
    bResult = m_oRegFunc.SetValueString(lKey, m_cnstKEYNAMEUID, m_sUID)
    bResult = m_oRegFunc.SetValueString(lKey, m_cnstKEYDATABASE, m_sDatabase)
    bResult = m_oRegFunc.SetValueString(lKey, m_cnstKEYSERVERNODE, m_sdbServer)
    
        
    If bResult Then
        WriteConnection = True
    Else
        WriteConnection = False
    End If
    
    m_sPWD = ""
    m_sUID = ""
    m_sDatabase = ""
    m_sdbServer = ""

    Exit Function
    
ErrWriteConnection:
        internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'=========================================================================================
'    friend property:      regFunctions
'    description:          sets a registry lib object for doing registry operations
'    arguments:            oNewRegFunctions, new registry object
'
'    return value:  /
'
'=========================================================================================
Friend Property Set regFunctions(oNewRegFunctions As SQLStudioUtil.Registry)
    On Error GoTo errRegFunctions
    
    Const FUNCTION_NAME = "regFunctions"

    Set m_oRegFunc = oNewRegFunctions
    
    Exit Property
    
errRegFunctions:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

