VERSION 5.00
Object = "{7AD30FBF-01AA-11D5-B32A-0050DADF6C37}#1.0#0"; "SQLStudioCV.ocx"
Begin VB.Form frmSaveSO 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Save ..."
   ClientHeight    =   4350
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4605
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   NegotiateMenus  =   0   'False
   ScaleHeight     =   4350
   ScaleWidth      =   4605
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtFileName 
      Height          =   330
      Left            =   300
      MaxLength       =   64
      TabIndex        =   0
      Top             =   3705
      Width           =   2940
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Height          =   315
      Left            =   3315
      TabIndex        =   3
      Top             =   3720
      Width           =   1080
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "&Save"
      Default         =   -1  'True
      Height          =   315
      Left            =   3330
      TabIndex        =   2
      Top             =   3285
      Width           =   1080
   End
   Begin SQLStudioCV.CatalogView ctlCM 
      Height          =   2685
      Left            =   195
      TabIndex        =   1
      Top             =   225
      Width           =   4245
      _ExtentX        =   7488
      _ExtentY        =   4736
   End
   Begin VB.Label lblFileName 
      Caption         =   "File name:"
      Height          =   195
      Left            =   300
      TabIndex        =   4
      Top             =   3360
      Width           =   1110
   End
End
Attribute VB_Name = "frmSaveSO"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---

'
' Form:       SQLStudio.frmSaveSO -   Form for Saving SO

Option Explicit


'=private variables================================================================
'full path without file name
Private m_sPath         As String

'these are the initial values when the dialog starts
Private m_sOrgFileName  As String
Private m_sOrgFilePath  As String

Private m_bReplace      As Boolean

'--------------------------------------------------------
' Module Name
'--------------------------------------------------------
Const MODULE_NAME = "SAPDBSSC.frmDirectSQL"
'=========================================================================================
'    property:      Connection
'    description:   sets a sapdb connection object
'    arguments:     NewConnection, connection object
'
'    return value:  /
'
'=========================================================================================
Public Property Set connection(NewConnection As SQLStudioDBLayer.connection)
    On Error GoTo errP_SET_Connection

    Const FUNCTION_NAME = "P_Set connection"

    Set ctlCM.connection = NewConnection

    Exit Property

errP_SET_Connection:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      globalInfo
'    description:   sets a object of type globalInfo
'    arguments:     newGlobalInfo, a globalcom object
'
'    return value:  /
'
'=========================================================================================
Public Property Set globalInfo(newGlobalInfo As SQLStudioMan.globalInfo)
    On Error GoTo errP_SET_globalInfo

    Const FUNCTION_NAME = "P_SET globalInfo"
    
    Set ctlCM.globalInfo = newGlobalInfo
    
    Exit Property
    
errP_SET_globalInfo:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Function loadFolders()
    On Error GoTo errLoadFolders
    
    Const FUNCTION_NAME = "LoadFolders"
        
    If frmMain.chkTinyMode.Value = vbUnchecked Then
    
        ctlCM.tinyMode = False
    Else
        'disable all features, open the tree with stored (local) folders
        ctlCM.tinyMode = True
    End If
    ctlCM.useLocalFolderInd = m_oGlobalInfo.userProfile.localFolderIndependent
    ctlCM.loadCatalog _
               m_oGlobalInfo.ConMan.UID, _
               frmMain.lstTableFilter.Text, _
               itemStoredObjects
            
    Exit Function
    
errLoadFolders:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      cmdCancel_Click
'    description:   the cancel button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdCancel_Click()
    On Error GoTo errCmdCancel_Click
   
    Const FUNCTION_NAME = "cmdCancel_Click"
    
    ctlCM.clearResults
    
    m_sPath = ""
    txtFileName = ""
    
    Me.Hide
                
    Exit Sub
    
errCmdCancel_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._KeyDown
'    description:   Occurs when the user presses (KeyDown)  a key while an object has the focus.
'    arguments:     [in] KeyCode, a key code, such as vbKeyF1 (the F1 key) or vbKeyHome (the HOME key).
'                   [in] Shift, an integer that corresponds to the state of the SHIFT, CTRL, and ALT keys at the time of the event.
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdCancel_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errCmdCancel_KeyDown
   
    Const FUNCTION_NAME = "cmdCancel_KeyDown"
        
    If KeyCode = vbKeyEscape Then Unload Me
         
    Exit Sub
    
errCmdCancel_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub cmdSave_Click()
    On Error GoTo errCmdSave_Click
   
    Const FUNCTION_NAME = "cmdSave_Click"
    
    Dim sPath As String
    
    If Len(txtFileName) < 1 Then
    
        txtFileName.SetFocus
        Exit Sub
    End If
   
    m_sPath = ctlCM.SelectedSOFolder
    If Len(m_sPath) < 1 Then
    
        ctlCM.SetFocus
        Exit Sub
    End If
    
    ' check for the file if we don't want to replace or the
    ' user changed the orginial filename or orginial file path
    If Not m_bReplace _
       Or m_sOrgFileName <> txtFileName And m_sOrgFilePath <> m_sPath _
    Then
    
        If frmMain.ctlCM.SOFileExists(fullFileName) Then
            
            If MsgBox(LoadResString(614) + vbCrLf + LoadResString(615), vbYesNo) = vbNo Then
            
                txtFileName.SetFocus
                Exit Sub
            Else
                m_bReplace = True
            End If
        End If
    End If
    
    ctlCM.clearResults
    
    Me.Hide
                
    Exit Sub
    
errCmdSave_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._KeyDown
'    description:   Occurs when the user presses (KeyDown)  a key while an object has the focus.
'    arguments:     [in] KeyCode, a key code, such as vbKeyF1 (the F1 key) or vbKeyHome (the HOME key).
'                   [in] Shift, an integer that corresponds to the state of the SHIFT, CTRL, and ALT keys at the time of the event.
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdSave_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errCmdSave_KeyDown
   
    Const FUNCTION_NAME = "cmdSave_KeyDown"
        
    If KeyCode = vbKeyEscape Then Unload Me
         
    Exit Sub
    
errCmdSave_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub ctlCM_SOFileClick(sFilePath As String, sFileName As String, cmType As SQLStudioMan.cvItemType)
    On Error GoTo errCtlCM_SOFileClick
   
    Const FUNCTION_NAME = "ctlCM_SOFileClick"
   
    txtFileName = sFileName
               
    Exit Sub
    
errCtlCM_SOFileClick:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._KeyDown
'    description:   Occurs when the user presses (KeyDown)  a key while an object has the focus.
'    arguments:     [in] KeyCode, a key code, such as vbKeyF1 (the F1 key) or vbKeyHome (the HOME key).
'                   [in] Shift, an integer that corresponds to the state of the SHIFT, CTRL, and ALT keys at the time of the event.
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errForm_KeyDown
   
    Const FUNCTION_NAME = "Form_KeyDown"
        
    If KeyCode = vbKeyEscape Then Unload Me
         
    Exit Sub
    
errForm_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      Form_Load
'    description:   Occurs when a form is loaded.
'                   For a startup form, occurs when an application starts as
'                   the result of a Load statement or as the result of a
'                   reference to an unloaded form's properties or controls.
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Load()
    On Error GoTo errForm_Load
   
    Const FUNCTION_NAME = "Form_Load"
   
    m_sPath = ""
    m_bReplace = False
    
    m_sOrgFileName = ""
    m_sOrgFilePath = ""
                
    Exit Sub
    
errForm_Load:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._Resize
'    description:   Occurs when an object is first displayed or when the window state of an object changes.
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Resize()
  On Error GoTo errForm_Resize

    Const FUNCTION_NAME = "Form_Resize"

    resizeControls

    Exit Sub

errForm_Resize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      resizeControls
'    description:   place all elements of control due to new size
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub resizeControls()
    On Error GoTo errResizeControls

    Const FUNCTION_NAME = "ResizeControls"
    
    
    If ScaleHeight - cmdSave.Height * 2 < 0 Then Exit Sub
    If ctlCM.Width - cmdSave.Width < 0 Then Exit Sub
    
    ctlCM.Left = 20
    ctlCM.Width = ScaleWidth - 20
    ctlCM.Height = ScaleHeight - cmdSave.Height * 3
    
    cmdSave.Top = ScaleHeight - 2 * cmdSave.Height - 40
    cmdCancel.Top = cmdSave.Top + cmdSave.Height + 40
    
    cmdSave.Left = ctlCM.Width - cmdSave.Width
    cmdCancel.Left = cmdSave.Left
    
    txtFileName.Left = ctlCM.Left
    txtFileName.Top = cmdCancel.Top
    txtFileName.Width = cmdCancel.Left - 40
    
    lblFileName.Left = ctlCM.Left
    lblFileName.Top = txtFileName.Top - lblFileName.Height - 40
    
    Exit Sub
    
errResizeControls:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub


Public Property Get fullFileName() As String
    On Error GoTo errP_GET_FullFileName

    Const FUNCTION_NAME = "P_Get fullFileName"
    
    If Len(txtFileName) < 1 Then Exit Property
    
    If m_sPath = "/" Then
    
        fullFileName = m_sPath + txtFileName
    Else
        fullFileName = m_sPath + "/" + txtFileName
    End If
    
    Exit Property

errP_GET_FullFileName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get fileName() As String
    On Error GoTo errP_GET_FileName

    Const FUNCTION_NAME = "P_Get fileName"
    
    If Len(txtFileName) < 1 Then Exit Property
        
    fileName = txtFileName
    
    Exit Property

errP_GET_FileName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let fileName(NewFileName As String)
    On Error GoTo errP_LET_FileName

    Const FUNCTION_NAME = "P_Get fileName"
        
    m_sOrgFileName = NewFileName
    
    txtFileName = NewFileName
    
    Exit Property

errP_LET_FileName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property


Public Property Get filePath() As String
    On Error GoTo errP_GET_FilePath

    Const FUNCTION_NAME = "P_Get filePath"
    
    If Len(txtFileName) < 1 Then Exit Property
        
    filePath = m_sPath
    
    Exit Property

errP_GET_FilePath:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let filePath(NewFilePath As String)
    On Error GoTo errP_LET_FilePath

    Const FUNCTION_NAME = "P_Let filePath"
            
    m_sPath = NewFilePath
    
    m_sOrgFilePath = NewFilePath
    
    Exit Property

errP_LET_FilePath:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get replaceOrUpdate() As Boolean
    On Error GoTo errP_GET_ReplaceOrUpdate

    Const FUNCTION_NAME = "P_Get replaceOrUpdate"
            
    replaceOrUpdate = m_bReplace
    
    Exit Property

errP_GET_ReplaceOrUpdate:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Let replaceOrUpdate(NewReplaceOrUpdate As Boolean)
    On Error GoTo errP_LET_ReplaceOrUpdate

    Const FUNCTION_NAME = "P_Let replaceOrUpdate"
            
    m_bReplace = NewReplaceOrUpdate
    
    Exit Property

errP_LET_ReplaceOrUpdate:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    function:      ..._KeyPress
'    description:   Occurs when the user presses and releases an ANSI key.
'    arguments:     [in] KeyAscii, an integer that returns a standard numeric ANSI keycode. Keyascii is passed by reference;
'                                  changing it sends a different character to the object.
'                                  changing keyascii to 0 cancels the keystroke so the object receives no character.
'
'    return value:  /
'
'=========================================================================================
Private Sub txtFileName_KeyPress(KeyAscii As Integer)
    On Error GoTo ErrtxtFileName_KeyPress
    
    Const FUNCTION_NAME = "txtFileName_KeyPress"
    
        ' /\ : * ?  " < > |
        If KeyAscii = 58 Or _
           KeyAscii = 62 Or _
           KeyAscii = 60 Or _
           KeyAscii = 92 Or _
           KeyAscii = 63 Or _
           KeyAscii = 42 Or _
           KeyAscii = 46 Or _
           KeyAscii = 34 Or _
           KeyAscii = 47 Or _
           KeyAscii = 124 _
        Then
           KeyAscii = 0
        End If
            
    Exit Sub
    
ErrtxtFileName_KeyPress:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
