Attribute VB_Name = "versions"
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Module:      Versions - Versions module
'
'
'-----------------------------------------------------------------------
'
' responsible:  WolfgangA
'
' special area: SQLStudio
'
' description:  module for version specific constants,functions ...
'
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
' Module Name
'--------------------------------------------------------
Const MODULE_NAME = "SQLStudio.Versions"


'Public Const VERSIONSTRING = "7.3"

'application version and sql studio object versions can run different

'SQLStudio/webSQL version which created so object
Public Const APPLICATIONVERSION = 73000

Public Const NOVERSIONDEP = "NoVersionDep"

'version of stored object
Public Const SQLSTOBJECTSVERSION = 72200


Private m_oComFunc As New SQLStudioUtil.Functions
'=========================================================================================
'    function:      copyRegValuesFromVersion73010
'    description:   from version > 73010 sqlstudio will use version independent registry entries
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Public Function copyRegValuesFromVersion73010()
    On Error GoTo errCopyRegValuesFromVersion73010
    
    Const FUNCTION_NAME = "copyRegValuesFromVersion73010"


    '=varibles===================================================================
    Dim bReturn      As Boolean
    Dim lNewKey      As Long
    Dim lOldKey      As Long
    Dim lDisPos      As Long
    Dim sValue       As String
    Dim lValue       As Long
    Dim sNewKey      As String
    Dim sOldKey      As String
    Dim oLRU         As New LRUConnections
    '============================================================================
    
    m_oRegFunc.showErrors = False
    
    sValue = Space$(64)
    
    'copy all values from version 7.3.0.10 to a version independent reg path
    sNewKey = m_oComFunc.getRegBasicKey + REMOVEFAILEDCON + "\" + NOVERSIONDEP
    bReturn = m_oRegFunc.openKey(HKEY_CURRENT_USER, sNewKey, KEY_ALL_ACCESS, lNewKey)
    If bReturn = False Then
        sOldKey = m_oComFunc.getRegBasicKey + REMOVEFAILEDCON + "\" + Trim$(Str(APPLICATIONVERSION))
        bReturn = m_oRegFunc.openKey(HKEY_CURRENT_USER, sOldKey, KEY_ALL_ACCESS, lOldKey)
        If bReturn Then
            bReturn = m_oRegFunc.QueryValueString(lOldKey, REMOVEFAILEDCON, sValue, Len(sValue))
            If bReturn Then
                bReturn = m_oRegFunc.createKey(HKEY_CURRENT_USER, sNewKey, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, lNewKey, lDisPos)
                If bReturn Then
                    bReturn = m_oRegFunc.setValueString(lNewKey, REMOVEFAILEDCON, Trim$(sValue))
                 End If
            End If
        End If
        m_oRegFunc.closeKey sOldKey, lOldKey
    End If
    m_oRegFunc.closeKey sNewKey, lNewKey
    
    sNewKey = m_oComFunc.getRegBasicKey + LOCALFOLDERIND + "\" + NOVERSIONDEP
    bReturn = m_oRegFunc.openKey(HKEY_CURRENT_USER, sNewKey, KEY_ALL_ACCESS, lNewKey)
    If bReturn = False Then
        sOldKey = m_oComFunc.getRegBasicKey + LOCALFOLDERIND + "\" + Trim$(Str(APPLICATIONVERSION))
        bReturn = m_oRegFunc.openKey(HKEY_CURRENT_USER, sOldKey, KEY_ALL_ACCESS, lOldKey)
        If bReturn Then
           bReturn = m_oRegFunc.QueryValueString(lOldKey, LOCALFOLDERIND, sValue, Len(sValue))
            If bReturn Then
                bReturn = m_oRegFunc.createKey(HKEY_CURRENT_USER, sNewKey, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, lNewKey, lDisPos)
                If bReturn Then
                    bReturn = m_oRegFunc.setValueString(lNewKey, LOCALFOLDERIND, Trim$(sValue))
                End If
            End If
        End If
        m_oRegFunc.closeKey sOldKey, lOldKey
    End If
    m_oRegFunc.closeKey sNewKey, lNewKey
    
    sNewKey = m_oComFunc.getRegBasicKey + NOTIMEOUT + "\" + NOVERSIONDEP
    bReturn = m_oRegFunc.openKey(HKEY_CURRENT_USER, sNewKey, KEY_ALL_ACCESS, lNewKey)
    If bReturn = False Then
        sOldKey = m_oComFunc.getRegBasicKey + NOTIMEOUT + "\" + Trim$(Str(APPLICATIONVERSION))
        bReturn = m_oRegFunc.openKey(HKEY_CURRENT_USER, sOldKey, KEY_ALL_ACCESS, lOldKey)
        If bReturn Then
            bReturn = m_oRegFunc.QueryValueString(lOldKey, NOTIMEOUT, sValue, Len(sValue))
            If bReturn Then
                bReturn = m_oRegFunc.createKey(HKEY_CURRENT_USER, sNewKey, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, lNewKey, lDisPos)
                If bReturn Then
                    bReturn = m_oRegFunc.setValueString(lNewKey, NOTIMEOUT, Trim$(sValue))
                End If
            End If
        End If
        m_oRegFunc.closeKey sOldKey, lOldKey
    End If
    m_oRegFunc.closeKey sNewKey, lNewKey
        
    sNewKey = m_oComFunc.getRegBasicKey + WINDOWPLACEMENT + "\" + NOVERSIONDEP
    bReturn = m_oRegFunc.openKey(HKEY_CURRENT_USER, sNewKey, KEY_ALL_ACCESS, lNewKey)
    If bReturn = False Then
        sOldKey = m_oComFunc.getRegBasicKey + WINDOWPLACEMENT + "\" + Trim$(Str(APPLICATIONVERSION))
        bReturn = m_oRegFunc.openKey(HKEY_CURRENT_USER, sOldKey, KEY_ALL_ACCESS, lOldKey)
        If bReturn Then
            bReturn = m_oRegFunc.queryValueLong(lOldKey, "WindowState", lValue)
            If bReturn Then
                bReturn = m_oRegFunc.createKey(HKEY_CURRENT_USER, sNewKey, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, lNewKey, lDisPos)
                If bReturn Then
                    bReturn = m_oRegFunc.setValueLong(lNewKey, "WindowState", lValue)
                End If
            End If
            bReturn = m_oRegFunc.queryValueLong(lOldKey, "Left", lValue)
            If bReturn Then
                bReturn = m_oRegFunc.createKey(HKEY_CURRENT_USER, sNewKey, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, lNewKey, lDisPos)
                If bReturn Then
                    bReturn = m_oRegFunc.setValueLong(lNewKey, "Left", lValue)
                End If
            End If
            bReturn = m_oRegFunc.queryValueLong(lOldKey, "Top", lValue)
            If bReturn Then
                bReturn = m_oRegFunc.createKey(HKEY_CURRENT_USER, sNewKey, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, lNewKey, lDisPos)
                If bReturn Then
                    bReturn = m_oRegFunc.setValueLong(lNewKey, "Top", lValue)
                End If
            End If
            bReturn = m_oRegFunc.queryValueLong(lOldKey, "Height", lValue)
            If bReturn Then
                bReturn = m_oRegFunc.createKey(HKEY_CURRENT_USER, sNewKey, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, lNewKey, lDisPos)
                If bReturn Then
                    bReturn = m_oRegFunc.setValueLong(lNewKey, "Height", lValue)
                End If
            End If
            bReturn = m_oRegFunc.queryValueLong(lOldKey, "Width", lValue)
            If bReturn Then
                bReturn = m_oRegFunc.createKey(HKEY_CURRENT_USER, sNewKey, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, lNewKey, lDisPos)
                If bReturn Then
                    bReturn = m_oRegFunc.setValueLong(lNewKey, "Width", lValue)
                End If
            End If
        End If
        m_oRegFunc.closeKey sOldKey, lOldKey
    End If
    m_oRegFunc.closeKey sNewKey, lNewKey
    
    'check if the version independent connections exist
    sNewKey = m_oComFunc.getRegBasicKey + "LRUConnections" + "\" + NOVERSIONDEP + "\Connection" + Trim(Str(0))
    sOldKey = m_oComFunc.getRegBasicKey + "LRUConnections" + "\" + Trim$(Str(APPLICATIONVERSION)) + "\Connection" + Trim(Str(0))
    
    bReturn = m_oRegFunc.openKey(HKEY_CURRENT_USER, sNewKey, KEY_QUERY_VALUE, lNewKey)
    If (bReturn = False) Then
    
        'check if there are old value to copy
        bReturn = m_oRegFunc.openKey(HKEY_CURRENT_USER, sOldKey, KEY_QUERY_VALUE, lOldKey)
        If (bReturn) Then
        
            Set oLRU.regFunctions = m_oRegFunc
            'first load lru connections with NOVERSIONDEP, this creates all registry keys
            oLRU.AppVersion = NOVERSIONDEP
            oLRU.loadConnections
            
            'now read old values
            oLRU.AppVersion = APPLICATIONVERSION
            oLRU.loadConnections
            
            'now save old values to new keys
            oLRU.AppVersion = NOVERSIONDEP
            oLRU.dirty = True
            oLRU.saveConnections
        End If
        m_oRegFunc.closeKey sOldKey, lOldKey
    End If
    m_oRegFunc.closeKey sNewKey, lNewKey
    
    Exit Function

errCopyRegValuesFromVersion73010:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      showAboutForm
'    description:   shows about form
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Public Function showAboutForm()
    On Error GoTo errShowAboutForm
    
    Const FUNCTION_NAME = "showAboutForm"

    '=varibles===================================================================
    'instance of about form
    Dim oAbout As New SQLStudioCCon.About
    '============================================================================
    
    oAbout.Files.add "SQLSTO.exe", App.Path
    oAbout.Files.add "SQLStudioCDCon.ocx", App.Path
    oAbout.Files.add "SQLStudioCV.ocx", App.Path
    oAbout.Files.add "SQLStudioQCon.ocx", App.Path
    oAbout.Files.add "SQLStudioCCon.ocx", App.Path
    oAbout.Files.add "SQLStudioMan.dll", App.Path
    oAbout.Files.add "SQLStudioDBL.dll", App.Path
    oAbout.Files.add "SQLStudioUtil.dll", App.Path
    oAbout.Files.add "SQLStudioCt.dll", App.Path
    
    oAbout.Files.add "SQLStudioDSQL.dll", App.Path     'Text Editor
    
    'show version from main programm
    If (Len(oAbout.Files.item(1).versionString) > 3) Then
    
        oAbout.version = Left(oAbout.Files.item(1).versionString, 3)
    Else
        oAbout.version = oAbout.Files.item(1).versionString
    End If
    
    oAbout.showAboutForm

    Exit Function

errShowAboutForm:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

