VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AppManagement"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  Class:       AppManagement
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'module name
Const MODULE_NAME = "AppManagement"


'Public enum types
Public Enum appFileType

    AppStatement = 0
    AppQueryByExample = 1
    AppVisualQuery = 2
    AppUserProfile = 3
    AppDrafts = 4
End Enum


'  Copy of properties
Private m_emLastType     As appFileType

Private m_lLeft            As Long
Private m_lTop             As Long
Private m_lWidth           As Long
Private m_lHeight          As Long
Private m_lWindowsState    As Long
Private m_emSQLMode      As SQLStudioDBLayer.sqlMode
Private m_emIsoLevel     As SQLStudioDBLayer.isoLevel

Public Property Let lastType(ByVal NewLastType As appFileType)
    On Error GoTo err_Let_LastType
    
    Const FUNCTION_NAME = "P_LET LastType"
    
    ' this conversion is necessary because of compatibility reasons (em AppfileType)
    If NewLastType = AppDrafts Then
        m_emLastType = AppUserProfile
        Exit Property
    End If
    
    If NewLastType = AppUserProfile Then
        m_emLastType = AppDrafts
        Exit Property
    End If
    
    m_emLastType = NewLastType
    
    Exit Property
    
err_Let_LastType:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get lastType() As appFileType
    On Error GoTo err_Get_LastType
    
    Const FUNCTION_NAME = "P_Get lastType"
    
    ' get property
    lastType = m_emLastType
    
    Exit Property
    
err_Get_LastType:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let windowsState(ByVal NewWindowsState As Long)
    On Error GoTo err_Let_WindowsState
    
    Const FUNCTION_NAME = "P_LET WindowsState"
    
    'set property
    m_lWindowsState = NewWindowsState
    
    Exit Property
    
err_Let_WindowsState:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get windowsState() As Long
    On Error GoTo err_Get_WindowsState
    
    Const FUNCTION_NAME = "P_Get windowsState"
    
    ' get property
    windowsState = m_lWindowsState
    
    Exit Property
    
err_Get_WindowsState:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let left(ByVal NewLeft As Long)
    On Error GoTo err_Let_Left
    
    Const FUNCTION_NAME = "P_LET Left"
    
    'set property
    m_lLeft = NewLeft
    
    Exit Property
    
err_Let_Left:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get left() As Long
    On Error GoTo err_Get_Left
    
    Const FUNCTION_NAME = "P_Get left"
    
    ' get property
    left = m_lLeft
    
    Exit Property
    
err_Get_Left:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let top(ByVal NewTop As Long)
    On Error GoTo err_Let_Top
    
    Const FUNCTION_NAME = "P_LET Top"
    
    'set property
    m_lTop = NewTop
    
    Exit Property
    
err_Let_Top:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get top() As Long
    On Error GoTo err_Get_Top
    
    Const FUNCTION_NAME = "P_Get top"
    
    ' get property
    top = m_lTop
    
    Exit Property
    
err_Get_Top:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let height(ByVal NewHeight As Long)
    On Error GoTo err_Let_Height
    
    Const FUNCTION_NAME = "P_LET Height"
    
    'set property
    m_lHeight = NewHeight
    
    Exit Property
    
err_Let_Height:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get height() As Long
    On Error GoTo err_Get_Height
    
    Const FUNCTION_NAME = "P_Get height"
    
    ' get property
    height = m_lHeight
    
    Exit Property
    
err_Get_Height:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let width(ByVal NewWidth As Long)
    On Error GoTo err_Let_Width
    
    Const FUNCTION_NAME = "P_LET Width"
    
    'set property
    m_lWidth = NewWidth
    
    Exit Property
    
err_Let_Width:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get width() As Long
    On Error GoTo err_Get_Width
    
    Const FUNCTION_NAME = "P_Get width"
    
    ' get property
    width = m_lWidth
    
    Exit Property
    
err_Get_Width:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get isoLevel() As isoLevel
    On Error GoTo errP_Get_IsoLevel

    Const FUNCTION_NAME = "P_GET IsoLevel"
    
    isoLevel = m_emIsoLevel
    
    Exit Property
    
errP_Get_IsoLevel:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let isoLevel(NewIsoLevel As isoLevel)
    On Error GoTo errP_Let_IsoLevel

    Const FUNCTION_NAME = "P_Let isoLevel"
    
    m_emIsoLevel = NewIsoLevel
    
    Exit Property
    
errP_Let_IsoLevel:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get sqlMode() As sqlMode
    On Error GoTo errP_Get_SQLMode

    Const FUNCTION_NAME = "P_Get sQLMode"
    
    sqlMode = m_emSQLMode
    
    Exit Property
    
errP_Get_SQLMode:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let sqlMode(newSQLMode As sqlMode)
    On Error GoTo errP_Let_SQLMode

    Const FUNCTION_NAME = "P_LET SQLMode"
    
    m_emSQLMode = newSQLMode
    
    Exit Property
    
errP_Let_SQLMode:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Function getDescriptionFromStudioObjects(Description As String) As Boolean
    On Error GoTo errGetDescriptionFromStudioObjects
    
    Const FUNCTION_NAME = "GetDescriptionFromStudioObjects"
    
    'inits
    getDescriptionFromStudioObjects = False
    Description = ""
    
    ' Get table types description
    Description = Trim$(Str$(m_emLastType))
    Description = Description + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    
    Description = Description + Trim$(Str$(m_lLeft))
    Description = Description + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    
    Description = Description + Trim$(Str$(m_lTop))
    Description = Description + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    
    Description = Description + Trim$(Str$(m_lWidth))
    Description = Description + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    
    Description = Description + Trim$(Str$(m_lHeight))
    Description = Description + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    
    Description = Description + Trim$(Str$(m_lWindowsState))
    Description = Description + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    
    Description = Description + Trim$(Str$(m_emIsoLevel))
    Description = Description + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    
    Description = Description + Trim$(Str$(m_emSQLMode))
    Description = Description + m_oComFunc.GetTokenSeperator(qplObjectLevel2)

    
    'set rc
    getDescriptionFromStudioObjects = True
    
    Exit Function
    
errGetDescriptionFromStudioObjects:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Friend Function getStudioObjectsFromDescription(Description As String) As Boolean
    On Error GoTo errGetStudioObjectsFromDescription
    
    Const FUNCTION_NAME = "GetStudioObjectsFromDescription"
    
    Dim lType        As Long
    Dim NextToken    As String
    
    'rc
    getStudioObjectsFromDescription = False
    
    'init
    lType = 3
        
    'Get table types
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    If Len(NextToken) > 0 Then lType = CLng(NextToken)
    
    Select Case lType
        Case 0
            m_emLastType = AppStatement
        Case 1
            m_emLastType = AppQueryByExample
        Case 2
            m_emLastType = AppVisualQuery
        Case 3
            m_emLastType = AppUserProfile
        Case 4
            m_emLastType = AppDrafts
        Case Else
            m_emLastType = AppUserProfile
    End Select
    
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    If Len(NextToken) > 0 Then m_lLeft = CLng(NextToken)

    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    If Len(NextToken) > 0 Then m_lTop = CLng(NextToken)
    
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    If Len(NextToken) > 0 Then m_lWidth = CLng(NextToken)
    
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    If Len(NextToken) > 0 Then m_lHeight = CLng(NextToken)
    
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    If Len(NextToken) > 0 Then m_lWindowsState = CLng(NextToken)
    
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    If Len(NextToken) > 0 Then m_emIsoLevel = CLng(NextToken)
    
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    If Len(NextToken) > 0 Then m_emSQLMode = CLng(NextToken)

    'set rc
    getStudioObjectsFromDescription = True
    
    Exit Function
    
errGetStudioObjectsFromDescription:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Private Sub Class_Initialize()
    On Error GoTo ErrClass_Initialize
    
    Const FUNCTION_NAME = "Class_Initialize"
    
    'set default table types
    m_emLastType = AppStatement
    
    m_lLeft = 0
    m_lTop = 0
    m_lWidth = 12000
    m_lHeight = 3000
    
    m_lWindowsState = vbNormal
    
    m_emIsoLevel = Committed
    m_emSQLMode = Internal

    
    Exit Sub
    
ErrClass_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub



