VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "VIQColumn"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  Class:        VIQColumn -  Global Object Column Object
'
'  Description:  Module is used in the context of VisualQuery.
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
'module name
'--------------------------------------------------------
Const MODULE_NAME = "VIQColumn"

'local property copies
Private m_lWnd            As Long
Private m_sTableOwner     As String
Private m_sTableName      As String
Private m_sTableRefName   As String
Private m_sColumnName     As String
Private m_sColumnInfo     As String

Private m_oTable          As Object
Private m_oColumn         As Object

Private m_emFormat      As DBObjectType

Private m_emTableType      As cvItemType
Private m_emSAPDBColType   As SAPDBColumnType




'TableOwner
'm_oComFunc.GetTokenSeperator(qplObjectLevel5)
'TableName
'm_oComFunc.GetTokenSeperator(qplObjectLevel5) +
'TableType is an cvItemType
'm_oComFunc.GetTokenSeperator(qplObjectLevel5) +
'RefName
'm_oComFunc.GetTokenSeperator(qplObjectLevel5) +
'ColumnName
'm_oComFunc.GetTokenSeperator(qplObjectLevel5) +
'ODBCColumnType



Public Property Let hWnd(NewhWnd As Long)
    On Error GoTo errP_Let_hWnd

    Const FUNCTION_NAME = "P_LET hWnd"
    
    m_lWnd = NewhWnd
    
    Exit Property
    
errP_Let_hWnd:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get hWnd() As Long
    On Error GoTo errP_Get_hWnd

    Const FUNCTION_NAME = "P_Get hWnd"
    
    hWnd = m_lWnd
    
    Exit Property
    
errP_Get_hWnd:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Let format(NewFormat As DBObjectType)
    On Error GoTo errP_Let_Format

    Const FUNCTION_NAME = "P_LET Format"
    
    m_emFormat = NewFormat
    
    Exit Property
    
errP_Let_Format:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get format() As DBObjectType
    On Error GoTo errP_Get_Format

    Const FUNCTION_NAME = "P_Get format"
    
    format = m_emFormat
    
    Exit Property
    
errP_Get_Format:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Set table(NewTable As Object)
    On Error GoTo errP_SET_Table

    Const FUNCTION_NAME = "P_SET Table"
    
    Set m_oTable = NewTable
    
    Exit Property
    
errP_SET_Table:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get table() As Object
    On Error GoTo errP_Get_Table

    Const FUNCTION_NAME = "P_Get table"
    
    Set table = m_oTable
    
    Exit Property
    
errP_Get_Table:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get tableOwner() As String
    On Error GoTo errP_Get_TableOwner

    Const FUNCTION_NAME = "P_Get tableOwner"
    
    tableOwner = m_sTableOwner
    
    Exit Property
    
errP_Get_TableOwner:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Private Property Let tableName(NewTableName As String)
    On Error GoTo errP_Let_TableName

    Const FUNCTION_NAME = "P_LET TableName"
    
    m_sTableName = NewTableName
    
    Exit Property
    
errP_Let_TableName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get tableName() As String
    On Error GoTo errP_Get_TableName

    Const FUNCTION_NAME = "P_Get tableName"
    
    tableName = m_sTableName
    
    Exit Property
    
errP_Get_TableName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let columnInfo(NewColumnInfo As String)
    On Error GoTo errP_Let_ColumnInfo

    Const FUNCTION_NAME = "P_LET ColumnInfo"
    
    m_sColumnInfo = NewColumnInfo
    
    splitColumnInfo NewColumnInfo, _
                    m_sTableOwner, _
                    m_sTableName, _
                    m_sTableRefName, _
                    m_emTableType, _
                    m_sColumnName, _
                    m_emSAPDBColType
    
    Exit Property
    
errP_Let_ColumnInfo:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get columnInfo() As String
    On Error GoTo errP_Get_ColumnInfo

    Const FUNCTION_NAME = "P_Get columnInfo"
    
    columnInfo = m_sColumnInfo
    
    Exit Property
    
errP_Get_ColumnInfo:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Set column(NewColumn As Object)
    On Error GoTo errP_SET_Column

    Const FUNCTION_NAME = "P_SET Column"
    
    Set m_oColumn = NewColumn
    
    Exit Property
    
errP_SET_Column:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get column() As Object
    On Error GoTo errP_Get_Column

    Const FUNCTION_NAME = "P_Get column"
    
    Set column = m_oColumn
    
    Exit Property
    
errP_Get_Column:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Private Property Let columnName(NewColumnName As String)
    On Error GoTo errP_Let_ColumnName

    Const FUNCTION_NAME = "P_LET ColumnName"
    
    m_sColumnName = NewColumnName
    
    Exit Property
    
errP_Let_ColumnName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get columnName() As String
    On Error GoTo errP_Get_ColumnName

    Const FUNCTION_NAME = "P_Get columnName"
    
    columnName = m_sColumnName
    
    Exit Property
    
errP_Get_ColumnName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Private Property Let tableRefName(NewTableRefName As String)
    On Error GoTo errP_Let_TableRefName

    Const FUNCTION_NAME = "P_LET TableRefName"
    
    m_sTableRefName = NewTableRefName
    
    Exit Property
    
errP_Let_TableRefName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get tableRefName() As String
    On Error GoTo errP_Get_TableRefName

    Const FUNCTION_NAME = "P_Get tableRefName"
    
    tableRefName = m_sTableRefName
    
    Exit Property
    
errP_Get_TableRefName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get sapdbColType() As SAPDBColumnType
    On Error GoTo errP_Get_SAPDBColType

    Const FUNCTION_NAME = "P_Get sAPDBColType"
    
     sapdbColType = m_emSAPDBColType
    
    Exit Property
    
errP_Get_SAPDBColType:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Private Function splitColumnInfo(ByVal sColInfo As String, _
                                sTableOwner As String, _
                                sTableName As String, _
                                sTableRefName As String, _
                                emTableType As cvItemType, _
                                sColName As String, _
                                emColType As ODBCColumnType) As Boolean
    On Error GoTo errSplitColumnInfo

    Const FUNCTION_NAME = "SplitColumnInfo"
    
    Dim lPos         As Long
    Dim lChildCount  As Long
    Dim sTyp         As String
    Dim sDummy       As String

    'rc
    splitColumnInfo = False
    
    'inits
    sTableOwner = ""
    sTableName = ""
    emTableType = cmUnknown
    sColName = ""
    emColType = odbcColTypeChar
    
    'check table length
    If Len(sColInfo) < 1 Then Exit Function
    
    m_oComFunc.GetNextToken sColInfo, sTableOwner, m_oComFunc.GetTokenSeperator(qplObjectLevel5)
    If Len(sTableOwner) > 1 Then sTableOwner = Mid$(sTableOwner, 2, Len(sTableOwner) - 2)
    
    m_oComFunc.GetNextToken sColInfo, sTableName, m_oComFunc.GetTokenSeperator(qplObjectLevel5)
    If Len(sTableName) > 1 Then sTableName = Mid$(sTableName, 2, Len(sTableName) - 2)
    
    m_oComFunc.GetNextToken sColInfo, sTyp, m_oComFunc.GetTokenSeperator(qplObjectLevel5)
    If IsNumeric(sTyp) Then emTableType = CLng(sTyp)
    
    m_oComFunc.GetNextToken sColInfo, sDummy, m_oComFunc.GetTokenSeperator(qplObjectLevel5)
    
    
    'Child Counter of Table
    m_oComFunc.GetNextToken sColInfo, sDummy, m_oComFunc.GetTokenSeperator(qplObjectLevel5)
    If IsNumeric(sDummy) Then
    
        lChildCount = CLng(sDummy)
        If lChildCount > 1 Then
        
            sTableRefName = sTableOwner + "." + sTableName + "_" + Trim$(Str$(lChildCount - 1))
        Else
            sTableRefName = ""
        End If
    End If
    
    m_oComFunc.GetNextToken sColInfo, sColName, m_oComFunc.GetTokenSeperator(qplObjectLevel5)
    If Len(sColName) > 1 Then sColName = Mid$(sColName, 2, Len(sColName) - 2)
    
    m_oComFunc.GetNextToken sColInfo, sTyp, m_oComFunc.GetTokenSeperator(qplObjectLevel5)
    If IsNumeric(sTyp) Then emColType = CLng(sTyp)


    'set rc
    splitColumnInfo = True

    Exit Function

errSplitColumnInfo:
  '  InternalError Err, MODULE_NAME, FUNCTION_NAME
End Function

