Attribute VB_Name = "Common"
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  Module:     Common
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'--------------------------------------------------------
'module name
'--------------------------------------------------------
Const MODULE_NAME = "Common"

Public Const TABLE_SYSQP_ALL_OBJECTS = "SYSQP_ALL_OBJECTS"
Public Const TABLE_SYSQP_MY_OBJECTS = "SYSQP_MY_OBJECTS"
Public Const TABLE_DOMAIN_SYNONYMS = "DOMAIN.SYNONYMS"

Public Const TABLE_SYSQP_TO_ME_GRANTED_OBJECTS = "SYSQP_TO_ME_GRANTED_OBJECTS"

Public Const COL_DOMAIN_TABLEOWNER = "TABLEOWNER"
Public Const COL_DOMAIN_TABLENAME = "TABLENAME"
Public Const TAB_DOMAIN_SYNONYMS = "DOMAIN.SYNONYMS"
Public Const DBA_COL_DOMAIN_OWNER = "OWNER"
Public Const COL_DOMAIN_SYNONYMNAME = "SYNONYMNAME"

'Global Const SQL_DATA_AT_EXEC = -2
'Global Const SQL_NEED_DATA = 99
'Global Const SQL_NO_DATA_FOUND = 100
'Global Const SQL_SUCCESS = 0
'Global Const SQL_SUCCESS_WITH_INFO = 1
'Global Const SQLSTATE_SUCCESS = "00000"
'Global Const SQLSTATE_DATA_TRUNCATED = "01004"

Public m_oComFunc As New SQLStudioUtil.Functions

Public Sub internalError(ByVal CurrentError As ErrObject, ModulName As String, FunctionName As String)
    MsgBox "Module:" + Chr$(9) + ModulName + Chr$(13) + Chr$(10) + "Function:" + Chr$(9) + FunctionName + Chr$(13) + Chr$(10) + "Error No:" + Chr$(9) + Trim$(Str$(CurrentError.Number)) + Chr$(13) + Chr$(10) + "Error:" + Chr$(9) + CurrentError.Description, vbExclamation, "Unexpected Error:"
End Sub



'=========================================================================================
'    function:      commonGetParameters
'    description:   search for parameters in query e.g. select * from [table:]
'    arguments:     sStatement, statement to be searched
'
'    return value:  true if success
'
'=========================================================================================
Public Function commonGetParameters(sStatement As String) As Boolean
    On Error GoTo errCommonGetParameters
    
    Const FUNCTION_NAME = "commonGetParameters"
    
    '=variables==============================
    Dim StrPos             As Integer
    Dim StartPos           As Integer
    Dim EndPos             As Integer
    Dim nStatementLen      As Integer
    Dim lParamCount        As Long
    Dim StartPosQuote1     As Long
    Dim StartPosQuote2     As Long
    Dim StartPosNew        As Long
    Dim sNewStatement      As String
    Dim sNewParts()        As String
    Dim lRun               As Long
    'are [] inside quotes ?
    Dim bQuoted            As Boolean
    
    Dim oFormParam         As New frmGetParameters
    '=======================================
    
    'rc
    commonGetParameters = True
        
    StartPos = InStr(sStatement, "[")
    If StartPos = 0 Then Exit Function
    
    EndPos = InStr(sStatement, "]")
    If EndPos = 0 Then Exit Function
    
    nStatementLen = Len(sStatement)
    StrPos = 1
    StartPosNew = 1
    lParamCount = 0
        
    While StartPosNew <= nStatementLen And StartPos <> 0
    
        StartPos = InStr(m_oComFunc.Max(StartPosNew, 1), sStatement, "[")
        StartPosQuote1 = InStr(m_oComFunc.Max(StartPosNew, 1), sStatement, Chr$(34))
        If StartPosQuote1 = 0 Then StartPosQuote1 = InStr(m_oComFunc.Max(StartPosNew, 1), sStatement, "'")
        EndPos = InStr(m_oComFunc.Max(StartPosNew, 1), sStatement, "]")
        StartPosQuote2 = InStr(m_oComFunc.Max(EndPos, 1), sStatement, Chr$(34))
        If StartPosQuote2 = 0 Then StartPosQuote2 = InStr(m_oComFunc.Max(EndPos, 1), sStatement, "'")
                
        If StartPos > 0 Then
        
            If StartPosQuote1 <> 0 And _
               StartPos > StartPosQuote1 And _
               EndPos < StartPosQuote2 Then
            
                bQuoted = True
                StartPos = StartPosQuote1
            End If
        
            If EndPos > StartPos Then
            
                If StartPosQuote1 <> 0 And bQuoted Then
                    bQuoted = True
                Else
                    bQuoted = False
                End If
                
                If bQuoted = False Then
                
                    ReDim Preserve sNewParts(lParamCount + 1)
                    sNewParts(lParamCount) = Mid$(sStatement, StrPos, StartPos - StrPos)
            
                    lParamCount = lParamCount + 1
                    Load oFormParam.lblParameter(lParamCount)
                    Load oFormParam.txtParameter(lParamCount)
                    oFormParam.lblParameter(lParamCount).Caption = Mid$(sStatement, StartPos + 1, EndPos - StartPos - 1)
                    
                    'position new objects
                    oFormParam.lblParameter(lParamCount).top = _
                                    (lParamCount - 1) * _
                                    (oFormParam.lblParameter(lParamCount).height + 60 + _
                                     oFormParam.txtParameter(lParamCount).height + 60)
                    oFormParam.txtParameter(lParamCount).top = oFormParam.lblParameter(lParamCount).top + (oFormParam.lblParameter(lParamCount).height + 60)
                    
                    If oFormParam.vsbColumns.Visible Then
                    
                        oFormParam.txtParameter(lParamCount).width = oFormParam.ScaleWidth - oFormParam.txtParameter(lParamCount).left - oFormParam.vsbColumns.width - 120
                    Else
                        oFormParam.txtParameter(lParamCount).width = oFormParam.ScaleWidth - oFormParam.txtParameter(lParamCount).left - 120
                    End If
                    'make visible
                    oFormParam.lblParameter(lParamCount).Visible = True
                    oFormParam.txtParameter(lParamCount).Visible = True
                    
                    StrPos = EndPos + 1
                    StartPosNew = StrPos
                Else
                    StartPosNew = StartPosQuote2 + 1
                End If
            Else
                'if parse error occurred, leave statement unchanged
                commonGetParameters = False
                Exit Function
            End If
        End If
    Wend
    
    If lParamCount < 1 Then
        
        commonGetParameters = True
        Exit Function
    End If
    
    sNewParts(lParamCount) = Right$(sStatement, nStatementLen - StrPos + 1)
    oFormParam.Caption = oFormParam.Caption + " for " + left(sStatement, 10)
    If Len(sStatement) > 9 Then _
       oFormParam.Caption = oFormParam.Caption + "..."
    
    oFormParam.Show vbModal
    
    If oFormParam.OK = False Then
    
        Set oFormParam = Nothing
        commonGetParameters = False
        Exit Function
    End If
    
    sNewStatement = ""
    
    For lRun = 0 To lParamCount
    
        sNewStatement = sNewStatement + sNewParts(lRun) + oFormParam.Parameters(lRun + 1)
    Next
    
    Set oFormParam = Nothing
    sStatement = sNewStatement
    
    commonGetParameters = True

    Exit Function

errCommonGetParameters:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function




