VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PredicateDefault"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  Class:      PredicateDefault - Class for Default Predicates
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
'module name
'--------------------------------------------------------
Const MODULE_NAME = "PredicateDefault"
    
'properties
Private m_emArrange        As predicateArrange
Private m_emComparison     As predicateCompare
Private m_emPredicateTyp   As predicateTyp



Private Property Let predicateTyp(NewPredicateTyp As predicateTyp)
    On Error GoTo errP_Let_PredicateTyp

    Const FUNCTION_NAME = "P_LET PredicateTyp"
    
    m_emPredicateTyp = NewPredicateTyp
    
    Exit Property
    
errP_Let_PredicateTyp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get predicateTyp() As predicateTyp
    On Error GoTo errP_Get_PredicateTyp

    Const FUNCTION_NAME = "P_GET PredicateTyp"
    
    predicateTyp = m_emPredicateTyp
    
    Exit Property
    
errP_Get_PredicateTyp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let arrange(NewArrange As predicateArrange)
    On Error GoTo errP_Let_Arrange

    Const FUNCTION_NAME = "P_Let arrange"
    
    m_emArrange = NewArrange
    
    Exit Property
    
errP_Let_Arrange:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get arrange() As predicateArrange
    On Error GoTo errP_Get_Arrange

    Const FUNCTION_NAME = "P_Get arrange"
    
    arrange = m_emArrange
    
    Exit Property
    
errP_Get_Arrange:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let comparison(NewComparison As predicateCompare)
    On Error GoTo errP_Let_Comparison

    Const FUNCTION_NAME = "P_LET Comparison"
    
    m_emComparison = NewComparison
    
    Exit Property
    
errP_Let_Comparison:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get comparison() As predicateCompare
    On Error GoTo errP_Get_Comparison

    Const FUNCTION_NAME = "P_Get comparison"
    
    comparison = m_emComparison
    
    Exit Property
    
errP_Get_Comparison:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Private Sub Class_Initialize()
    On Error GoTo ErrClass_Initialize

    Const FUNCTION_NAME = "Class_Initialize"
    
    'inits
    m_emArrange = PredicateArrangeAnd
    m_emComparison = PredicateCompareEqual
    
     m_emPredicateTyp = PredicateDefault
    
    Exit Sub
    
ErrClass_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Public Function getDescription(Description As String) As Boolean
    On Error GoTo errGetDescription

    Const FUNCTION_NAME = "GetDescription"
    
    Dim SeparatorValue As Integer
    Dim NewDescription  As String
        
    '  Init
    getDescription = False
    SeparatorValue = 5
    
    'check separator value
    If SeparatorValue > 8 Then
        'separator value can be a printable character
        Exit Function
    End If
    
    'get property PredicateTyp
    NewDescription = Trim$(Str$(m_emPredicateTyp)) + Chr$(SeparatorValue)
    
    'get property Arrange
    NewDescription = NewDescription + Trim$(Str$(m_emArrange)) + Chr$(SeparatorValue)
    
    'get property Comparison
    NewDescription = NewDescription + Trim$(Str$(m_emComparison)) + Chr$(SeparatorValue)
    
    'rc
    Description = NewDescription
    
    getDescription = True
    
    Exit Function

errGetDescription:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Public Function setDescription(Description As String) As Boolean
    On Error GoTo errSetDescription

    Const FUNCTION_NAME = "SetDescription"

    Dim NextToken   As String
    
    '  Init
    setDescription = False
    
    'check description
    If Len(Description) < 1 Then
    
        setDescription = True
        Exit Function
    End If
    
    'set property PredicateTyp
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel6)
    m_emPredicateTyp = Val(NextToken)
    
    'set property Arrange
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel6)
    m_emArrange = Val(NextToken)
    
    'set property Comparison
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel6)
    m_emComparison = Val(NextToken)
    
    'rc
    setDescription = True
    
    Exit Function

errSetDescription:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function getPredicateAsStatement(bFormated As Boolean) As String
    On Error GoTo errGetPredicateAsStatement

    Const FUNCTION_NAME = "GetPredicateAsStatement"

    Dim CurrentClause       As String
    
    'inits
    getPredicateAsStatement = ""
    CurrentClause = ""
    
    Select Case comparison
            Case PredicateCompareSmaller:
                CurrentClause = CurrentClause + " < "
            Case PredicateCompareGreater:
                CurrentClause = CurrentClause + " > "
            Case PredicateCompareEqual:
                CurrentClause = CurrentClause + " = "
            Case PredicateCompareUnequal:
                CurrentClause = CurrentClause + " <> "
            Case PredicateCompareEqualSmaller:
                CurrentClause = CurrentClause + " <= "
            Case PredicateCompareEqualGreater:
                CurrentClause = CurrentClause + " >= "
    End Select

    CurrentClause = CurrentClause + "DEFAULT"
    
    getPredicateAsStatement = getPredicateAsStatement + CurrentClause
    
   
    Exit Function
    
errGetPredicateAsStatement:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Public Function getPredicateArrange() As String
    On Error GoTo errGetPredicateArrange

    Const FUNCTION_NAME = "GetPredicateArrange"

    Dim CurrentClause       As String

    If arrange = PredicateArrangeAnd Then
        getPredicateArrange = "AND"
    Else
        getPredicateArrange = "OR"
    End If
    
    Exit Function
    
errGetPredicateArrange:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Public Function getPredicateArrangeFromDescription(Description As String) As String
    On Error GoTo errGetPredicateArrangeFromDescription

    Const FUNCTION_NAME = "GetPredicateArrangeFromDescription"
    
        
    Dim clsArrange      As predicateArrange
    Dim predicateTyp    As predicateTyp
    Dim CurrentClause   As String
    Dim NextToken       As String

    '  Init
    getPredicateArrangeFromDescription = ""
    
    'check description
    If Len(Description) < 1 Then Exit Function
    
    'set property PredicateTyp
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel6)
    predicateTyp = Val(NextToken)
        
    'set property Arrange
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel6)
    arrange = Val(NextToken)
        

    If arrange = PredicateArrangeAnd Then
        getPredicateArrangeFromDescription = "AND"
    Else
        getPredicateArrangeFromDescription = "OR"
    End If
    
    Exit Function
    
errGetPredicateArrangeFromDescription:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function




