VERSION 5.00
Begin VB.Form frmGetParameters 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Get Parameters"
   ClientHeight    =   3000
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5520
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "GetParameters.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3000
   ScaleWidth      =   5520
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.PictureBox picColumns 
      BorderStyle     =   0  'None
      Height          =   2184
      Left            =   60
      OLEDropMode     =   1  'Manual
      ScaleHeight     =   2190
      ScaleWidth      =   5385
      TabIndex        =   2
      Top             =   108
      Width           =   5388
      Begin VB.TextBox txtParameter 
         Height          =   315
         Index           =   0
         Left            =   36
         TabIndex        =   0
         Top             =   540
         Visible         =   0   'False
         Width           =   5115
      End
      Begin VB.VScrollBar vsbColumns 
         Height          =   2715
         LargeChange     =   5
         Left            =   6540
         Min             =   1
         TabIndex        =   3
         Top             =   480
         Value           =   1
         Width           =   240
      End
      Begin VB.Label lblParameter 
         Caption         =   "SAP"
         Height          =   288
         Index           =   0
         Left            =   36
         TabIndex        =   4
         Top             =   216
         Visible         =   0   'False
         Width           =   5115
      End
   End
   Begin VB.CommandButton cmdOk 
      Caption         =   "&Ok"
      Default         =   -1  'True
      Height          =   375
      Left            =   2160
      TabIndex        =   1
      Top             =   2448
      Width           =   1200
   End
End
Attribute VB_Name = "frmGetParameters"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''/////////
'
' Form:       frmGetParameters - Get Parameters
'
'-----------------------------------------------------------------------
'
' responsible:  WolfgangA
'
' special area: SQLStudio
'
' description:  dialog to get parameters for a statement
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''/////////

Option Explicit

'module name
Const MODULE_NAME = "frmGetParameters"

Dim CurrentColIndex As Long
Dim colParameter    As New Collection

'private copy of properties
Dim m_sParameter  As String

Dim m_bFirstPaint   As Boolean
Dim m_bOK          As Boolean
'=========================================================================================
'    function:      Parameters
'    description:   Get s specific parameter
'    arguments:     [in] lIndex, number of parameter
'
'    return value:  /
'
'=========================================================================================
Public Function Parameters(lIndex As Long) As String
    On Error GoTo errParameters

    Const FUNCTION_NAME = "Parameters"
    
    'Init
    Parameters = ""
    
    If lIndex < 1 Then Exit Function
    If lIndex > colParameter.count Then Exit Function
    
    m_sParameter = colParameter.item(lIndex)
    
    Parameters = m_sParameter
    
    Exit Function
    
errParameters:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      cmdOk_Click
'    description:   the ok button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdOk_Click()
    On Error GoTo ErrcmdOk_Click

    Const FUNCTION_NAME = "cmdOk_Click"
    
    Dim lCount   As Long
    
    For lCount = 1 To colParameter.count
    
        colParameter.remove 1
    Next
    
    For lCount = 1 To txtParameter.count - 1
    
        If Len(txtParameter(lCount).Text) < 1 Then
            'If vsbColumns.Visible = True Then Comment because now each Textfield is scrolled visible
            
                If lCount <= vsbColumns.Max Then vsbColumns.value = lCount
            'End If
            
            txtParameter(lCount).SetFocus
            Exit Sub
        End If
        
        m_sParameter = txtParameter(lCount).Text
        colParameter.add m_sParameter
    Next
    
    m_bOK = True
    
    Unload Me
    
    Exit Sub
    
ErrcmdOk_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._Load
'    description:   Occurs when a form is loaded.
'                   For a startup form, occurs when an application starts as
'                   the result of a Load statement or as the result of a
'                   reference to an unloaded form's properties or controls.
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Load()
 On Error GoTo ErrForm_Load

    Const FUNCTION_NAME = "Form_Load"

    If txtParameter.count >= 1 Then CurrentColIndex = 1
    
    m_bFirstPaint = True
    m_bOK = False
    
    Exit Sub
    
ErrForm_Load:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._Paint
'    description:   Occurs when part or all of an object is exposed after being moved or enlarged, or after a window that was covering the object has been moved.
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Paint()
 On Error GoTo ErrForm_Paint

    Const FUNCTION_NAME = "Form_Paint"
    
    resizeControls
    
    If m_bFirstPaint = True Then
    
        m_bFirstPaint = False
        txtParameter(1).SetFocus
    End If
    
    Exit Sub
    
ErrForm_Paint:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._Resize
'    description:   Occurs when an object is first displayed or when the window state of an object changes.
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Resize()
    On Error GoTo ErrForm_Resize

    Const FUNCTION_NAME = "Form_Resize"
    
    resizeControls
    
    Exit Sub
    
ErrForm_Resize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._GotFocus
'    description:   Occurs when an object receives the focus,
'                   either by user action, such as tabbing to or clicking the object, or by changing the focus in code using the SetFocus method.
'                   A form receives the focus only when all visible controls are disabled.
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub txtParameter_GotFocus(index As Integer)
    On Error GoTo ErrtxtParameter_GotFocus
    
    Const FUNCTION_NAME = "txtParameter_GotFocus"
        
    'set current column index
    CurrentColIndex = index
    
    Exit Sub
    
ErrtxtParameter_GotFocus:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._Change
'    description:   Indicates the contents of a control have changed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub vsbColumns_Change()
    On Error GoTo ErrvsbColumns_Change
    
    Const FUNCTION_NAME = "vsbColumns_Change"
    
    Dim lParamCount   As Long
    
    For lParamCount = 1 To txtParameter.count - 1
        lblParameter(lParamCount).top = (lParamCount - vsbColumns.value) * _
                                        (lblParameter(lParamCount).height + 60 + _
                                         txtParameter(lParamCount).height + 60)
        txtParameter(lParamCount).top = lblParameter(lParamCount).top + (lblParameter(lParamCount).height + 60)
    Next
    
    Exit Sub
    
ErrvsbColumns_Change:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._GotFocus
'    description:   Occurs when an object receives the focus,
'                   either by user action, such as tabbing to or clicking the object, or by changing the focus in code using the SetFocus method.
'                   A form receives the focus only when all visible controls are disabled.
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub vsbColumns_GotFocus()
    On Error GoTo ErrvsbColumns_GotFocus
    
    Const FUNCTION_NAME = "vsbColumns_GotFocus"
    
    txtParameter(CurrentColIndex).SetFocus 'set focus back
    
    Exit Sub
    
ErrvsbColumns_GotFocus:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      calculateScrollbarValue
'    description:   calculate max value of scrollbar
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub calculateScrollbarValue()
    On Error GoTo ErrCalculateScrollbarValue
    
    Const FUNCTION_NAME = "CalculateScrollbarValue"
    
    Dim NewMaxValue  As Integer
    
    NewMaxValue = txtParameter.count - 3
    If NewMaxValue < 1 Then
    
        vsbColumns.Max = 1
    Else
        vsbColumns.Max = NewMaxValue
    End If
    
    Exit Sub
    
ErrCalculateScrollbarValue:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      resizeControls
'    description:   place all elements of control due to new size
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub resizeControls()
    On Error GoTo errResizeControls

    Const FUNCTION_NAME = "resizeControls"
    
    Dim i           As Integer
    Dim lHeight     As Long
        
    If txtParameter.count > 1 Then
        lHeight = txtParameter.count * (txtParameter(1).height + lblParameter(1).height) + 2 * cmdOk.height + 100
        
        If lHeight > 3300 Then
            Me.height = 3300
        Else
            Me.height = lHeight
        End If
    End If
        
    cmdOk.top = Me.height - 2 * cmdOk.height - 100
    picColumns.height = Me.ScaleHeight - 2 * cmdOk.height - 50
       
    'vertical adjustment
    If Me.ScaleHeight > 240 Then
                             
        vsbColumns.top = 60
        If Me.ScaleHeight > 1200 Then
            If txtParameter.count > 1 Then
                If txtParameter(1).top < 0 _
                    Or picColumns.height < _
                       txtParameter(txtParameter.count - 1).top + txtParameter(0).height _
                Then
                    vsbColumns.Visible = True
                    vsbColumns.height = picColumns.height - 60
                Else
                    vsbColumns.Visible = False
                End If
            Else
                vsbColumns.Visible = False
            End If
        Else
            vsbColumns.Visible = False
        End If
    Else
        vsbColumns.Visible = False
    End If
    
    'horizontal adjustment
    If Me.ScaleWidth > 2500 Then
        If vsbColumns.Visible Then
            For i = 1 To txtParameter.count - 1
                txtParameter(i).width = Me.ScaleWidth - txtParameter(i).left - vsbColumns.width - 120
            Next
            vsbColumns.left = picColumns.width - vsbColumns.width - 60
        Else
            For i = 1 To txtParameter.count - 1
                txtParameter(i).width = Me.ScaleWidth - txtParameter(i).left - 120
            Next
        End If
        
        picColumns.width = Me.ScaleWidth
    End If
    
    'calculate scrollbar value
    calculateScrollbarValue

    Exit Sub
    
errResizeControls:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    property:      OK
'    description:   get if ok button was pressed
'
'    arguments:     /
'
'    return value:  true if ok button was pressed
'
'=========================================================================================
Public Property Get OK() As Boolean
    On Error GoTo errP_Get_OK

    Const FUNCTION_NAME = "P_GET OK"
    
    OK = m_bOK
    
    Exit Property
    
errP_Get_OK:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    function:      ..._KeyDown
'    description:   Occurs when the user presses (KeyDown)  a key while an object has the focus.
'    arguments:     [in] KeyCode, a key code, such as vbKeyF1 (the F1 key) or vbKeyHome (the HOME key).
'                   [in] Shift, an integer that corresponds to the state of the SHIFT, CTRL, and ALT keys at the time of the event.
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo ErrForm_KeyDown

    Const FUNCTION_NAME = "Form_KeyDown"
    
    If KeyCode = vbKeyEscape Then Unload Me
    
    Exit Sub
    
ErrForm_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
