VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "GlobalInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.7
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Module:      GlobalInfo
'
'-----------------------------------------------------------------------
'
' responsible:  WolfgangA
'
' special area: SQLStudio
'
' description:  Object to keep information,state... for SQL Studio application
'
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit


'--------------------------------------------------------
'module name
'--------------------------------------------------------
Const MODULE_NAME = "GlobalInfo"

'  Type declaration
Public Enum cvItemType

    cmUnknown = 0
    cmTable = 1
    cmView = 2
    cmResult = 3
    cmSystem = 4
    cmSnapshot = 5
    cmSynonym = 6
    cmUser = 7
    cmUserGroup = 8
    cmTableOwner = 9
    cmWebFolder = 11
    cmWebItem = 12
    cmStoredDSQL = 13
    cmStoredVIQ = 14
    cmStoredQBE = 15
    cmIndex = 16
    cmSequence = 17
    cmSOFolder = 18
    cmStoredDraft = 19
    cmLinkDSQL = 20
    cmLinkVIQ = 21
    cmLinkQBE = 22
    cmLinkDraft = 23
    cmDBProcInt = 24
    cmDBProcExt = 25
    cmDBProcJava = 26
End Enum


'public Declarations
Public Enum DBObjectType

    DBOUnknown = 0
    DBOTable = 1
    DBOColumn = 2
    DBOStoredObject = 3
    DBOUser = 4
    DBOUserGroup = 5
    DBOIndex = 6
    DBOSequence = 7
    DBODBProc = 8
End Enum

Public Enum AggregateTpye

    agMin = 0
    agMax = 1
    agSum = 2
    agAvg = 3
    agCount = 4
    agMinMax = 5
End Enum


Public Enum ColumnHeaders

    ColumnHeadersIncluded = 0
    ColumnHeadersNotIncluded = 1
End Enum

'local property copies
Private m_bDisconnectCanceled   As Boolean
Private m_bSysTablesLoaded      As Boolean
Private m_emAutoCommit        As SQLStudioDBLayer.autoCommit


Private m_colDragObjects                As New Collection
Private m_oConMan                       As New SQLStudioDBLayer.Connections
Private m_oUserProfile                  As New userProfile
Private m_oHourglass                    As New SQLStudioUtil.hourglass

'excel application object
Private m_oExcelApp                     As Object

Public Property Get conMan() As SQLStudioDBLayer.Connections
    On Error GoTo errP_Get_ConMan

    Const FUNCTION_NAME = "P_Get conMan"
    
    Set conMan = m_oConMan
    
    Exit Property
    
errP_Get_ConMan:
   internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get dragObjects() As Collection
    On Error GoTo errP_Get_DragObjects

    Const FUNCTION_NAME = "P_Get dragObjects"
    
    Set dragObjects = m_colDragObjects
    
    Exit Property
    
errP_Get_DragObjects:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get userProfile() As userProfile
    On Error GoTo errP_Get_UserProfile

    Const FUNCTION_NAME = "P_Get userProfile"
    
    Set userProfile = m_oUserProfile
    
    Exit Property
    
errP_Get_UserProfile:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let disconnectCanceled(NewDisconnectCanceled As Boolean)
    On Error GoTo errP_Let_DisconnectCanceled

    Const FUNCTION_NAME = "P_LET DisconnectCanceled"
    
    m_bDisconnectCanceled = NewDisconnectCanceled
    
    Exit Property
    
errP_Let_DisconnectCanceled:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get disconnectCanceled() As Boolean
    On Error GoTo errP_Get_DisconnectCanceled

    Const FUNCTION_NAME = "P_Get disconnectCanceled"
    
    disconnectCanceled = m_bDisconnectCanceled
    
    Exit Property
    
errP_Get_DisconnectCanceled:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let systemtablesLoaded(newSystemtablesLoaded As Boolean)
    On Error GoTo errP_Let_SystemtablesLoaded

    Const FUNCTION_NAME = "P_LET SystemtablesLoaded"
    
    m_bSysTablesLoaded = newSystemtablesLoaded
    
    Exit Property
    
errP_Let_SystemtablesLoaded:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get systemtablesLoaded() As Boolean
    On Error GoTo errP_Get_SystemtablesLoaded

    Const FUNCTION_NAME = "P_Get systemtablesLoaded"
    
    systemtablesLoaded = m_bSysTablesLoaded
    
    Exit Property
    
errP_Get_SystemtablesLoaded:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get hourglass() As SQLStudioUtil.hourglass
    On Error GoTo errP_Get_Hourglass

    Const FUNCTION_NAME = "P_Get hourglass"
    
    Set hourglass = m_oHourglass
    
    Exit Property
    
errP_Get_Hourglass:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get autoCommit() As autoCommit
    On Error GoTo errP_Get_AutoCommit

    Const FUNCTION_NAME = "P_Get autoCommit"
    
    autoCommit = m_emAutoCommit
    
    Exit Property
    
errP_Get_AutoCommit:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Let autoCommit(pNewAutoCommit As autoCommit)
    On Error GoTo errP_Let_AutoCommit

    Const FUNCTION_NAME = "P_Let autoCommit"
    
    m_emAutoCommit = pNewAutoCommit
    
    Exit Property
    
errP_Let_AutoCommit:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Function addTableObject(ByVal hWnd As Long, ByVal tableName As String, objFormat As DBObjectType) As Boolean
    On Error GoTo errAddTableObject

    Const FUNCTION_NAME = "AddTableObject"
    
    Dim TableObject As New TableObject

    'inits
    addTableObject = False

    'set properties
    TableObject.format = objFormat
    TableObject.hWnd = hWnd
    TableObject.objectName = tableName

    'add table object
    m_colDragObjects.add TableObject

    'free table object
    Set TableObject = Nothing
    
    'ret rc
    addTableObject = True
    
    Exit Function
    
errAddTableObject:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Public Function addColumnObject(ByVal hWnd As Long, table As Object, column As Object) As Boolean
    On Error GoTo errAddColumnObject

    Const FUNCTION_NAME = "AddColumnObject"
    
    Dim ColumnObject    As New VIQColumn
    
    'rc
    addColumnObject = False
    
    'set properties
    ColumnObject.format = DBOColumn
    ColumnObject.hWnd = hWnd
    Set ColumnObject.table = table
    Set ColumnObject.column = column
    ColumnObject.columnInfo = column.Tag
    
    'add table object
    m_colDragObjects.add ColumnObject
    
    'free table object
    Set ColumnObject = Nothing
    
    'rc
    addColumnObject = True
    
    Exit Function
    
errAddColumnObject:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function addStoredFileContent(oSFC As StoredFileContent) As Boolean
    On Error GoTo errAddStoredFileContent

    Const FUNCTION_NAME = "addStoredFileContent"
    
    'rc
    addStoredFileContent = False
    
    'add table object
    m_colDragObjects.add oSFC
    
    'rc
    addStoredFileContent = True
    
    Exit Function
    
errAddStoredFileContent:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function


Public Function clearDragObjects() As Boolean
    On Error GoTo ErrClearDragObjects

    Const FUNCTION_NAME = "ClearDragObjects"
    
    Dim ClearObject As Object
    
    'inits
    clearDragObjects = False
    
    '  Clear drag objects
    Set m_colDragObjects = Nothing
    
    '  Create new empty collection
    Set m_colDragObjects = New Collection
    
    'set rc
    clearDragObjects = True
    
    Exit Function
    
ErrClearDragObjects:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      ..._Initialize
'    description:   Occurs when an application creates an instance of a
'                   Form, MDIForm, User control, Property Page, Webclass, DHTML Page Designer, or class.
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Class_Initialize()
    On Error GoTo ErrClass_Initialize

    Const FUNCTION_NAME = "Class_Initialize"
    
    m_bSysTablesLoaded = False
    
    Exit Sub
    
ErrClass_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._Terminate
'    description:   Occurs when all references to an instance of a Form, MDIForm,
'                   User control, Property Page, Webclass, DHTML
'                   Page Designer, or class are removed from memory by setting
'                   all the variables that refer to the object to Nothing or
'                   when the last reference to the object falls out of scope.
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Class_Terminate()
    On Error GoTo ErrClass_Terminate

    Const FUNCTION_NAME = "Class_Terminate"
    
    'release old reference
    If Not m_oExcelApp Is Nothing Then Set m_oExcelApp = Nothing
    
    Exit Sub
    
ErrClass_Terminate:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Public Function addStoredDragObject(ByVal storedObjectKey As String, _
                                    ByVal storedObjectOwner As String, _
                                    ByVal storedObjectName As String, _
                                    ByVal fileType As Long) As Boolean
    On Error GoTo errAddStoredDragObject

    Const FUNCTION_NAME = "AddStoredDragObject"

    Dim oStoredDragObject    As New StoredDragObject

    'inits
    addStoredDragObject = False

    'set properties
    oStoredDragObject.format = DBOStoredObject
    oStoredDragObject.storedObjectKey = storedObjectKey
    oStoredDragObject.storedObjectOwner = storedObjectOwner
    oStoredDragObject.storedObjectName = storedObjectName
    oStoredDragObject.fileType = fileType

    'Add table object
    m_colDragObjects.add oStoredDragObject

    'free table object
    Set oStoredDragObject = Nothing

    'set rc
    addStoredDragObject = True

    Exit Function

errAddStoredDragObject:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function splitCatalogDragInfo(ByVal sTable As String, _
                                    sOwner As String, _
                                    sName As String, _
                                    emTableType As cvItemType) As Boolean
    On Error GoTo errSplitCatalogDragInfo

    Const FUNCTION_NAME = "SplitCatalogDragInfo"
    
    Dim sTableTyp    As String

    'rc
    splitCatalogDragInfo = False
    
    'inits
    sOwner = ""
    sName = ""
    emTableType = cmUnknown
    
    'check table length
    If Len(sTable) < 1 Then Exit Function
    
    m_oComFunc.GetNextToken sTable, sOwner, m_oComFunc.GetTokenSeperator(qplObjectLevel5)
    If Len(sOwner) > 1 Then sOwner = Mid$(sOwner, 2, Len(sOwner) - 2)
    
    m_oComFunc.GetNextToken sTable, sName, m_oComFunc.GetTokenSeperator(qplObjectLevel5)
    If Len(sName) > 1 Then sName = Mid$(sName, 2, Len(sName) - 2)
    
    m_oComFunc.GetNextToken sTable, sTableTyp, m_oComFunc.GetTokenSeperator(qplObjectLevel5)
    If IsNumeric(sTableTyp) Then emTableType = CLng(sTableTyp)
     
    
    'rc
    splitCatalogDragInfo = True

    Exit Function

errSplitCatalogDragInfo:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function getColumnType(ByVal sDBColumn As String) As SAPDBColumnType
    On Error GoTo errGetColumnType

    Const FUNCTION_NAME = "GetColumnType"
    
    
    getColumnType = sapdbColTypeUnknown
    
    'select column type
    Select Case sDBColumn
        Case "CHAR":
            getColumnType = sapdbColTypeChar
        Case "VARCHAR":
            getColumnType = sapdbColTypeVarChar
        Case "LONG":
            getColumnType = sapdbColTypeLong
        Case "BOOLEAN":
            getColumnType = sapdbColTypeBoolean
        Case "FIXED":
            getColumnType = sapdbColTypeFixed
        Case "FLOAT":
            getColumnType = sapdbColTypeFloat
        Case "INT", "INTEGER":
            getColumnType = sapdbColTypeInt
        Case "SMALLINT", "SMALLINTEGER":
            getColumnType = sapdbColTypeSmallInt
        Case "DATE":
            getColumnType = sapdbColTypeDate
        Case "TIME":
            getColumnType = sapdbColTypeTime
        Case "TIMESTAMP":
            getColumnType = sapdbColTypeTimeStamp
        Case "LONGFILE":
            getColumnType = sapdbColTypeLongFile
        Case Else
            getColumnType = sapdbColTypeUnknown
    End Select
    
    Exit Function
    
errGetColumnType:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Public Function getColumnCodeType(ByVal sCodeTypeValue As String) As SAPDBColumnCodeType
    On Error GoTo errGetColumnCodeType

    Const FUNCTION_NAME = "GetColumnCodeType"
        
    getColumnCodeType = sapdbColCodeTypeUnknown
    
    'select column type
    Select Case sCodeTypeValue
        Case "ASCII":
            getColumnCodeType = sapdbColCodeTypeASCII
        Case "BYTE":
            getColumnCodeType = sapdbColCodeTypeBYTE
        Case "EBCDIC":
            getColumnCodeType = sapdbColCodeTypeEBCDIC
        Case Else
            getColumnCodeType = sapdbColCodeTypeUnknown
    End Select
    
    Exit Function
    
errGetColumnCodeType:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    property:      excelApplication
'    description:   set a pointer to an excel application object,intended to be
'                   created in sql studio main
'    arguments:     [in] oExcelApp
'
'    return value:  /
'
'=========================================================================================
Public Property Set excelApplication(oExcelApp As Object)
    On Error GoTo errP_Let_ExcelApplication

    Const FUNCTION_NAME = "P_LET ExcelApplication"
    
    'release old reference
    If Not m_oExcelApp Is Nothing Then Set m_oExcelApp = Nothing
    
    Set m_oExcelApp = oExcelApp
    
    Exit Property
    
errP_Let_ExcelApplication:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      excelApplication
'    description:   get a pointer to an excel application object,intended to be
'                   created in sql studio main
'    arguments:     /
'
'    return value:  an object
'
'=========================================================================================
Public Property Get excelApplication() As Object
    On Error GoTo errP_Get_ExcelApplication

    Const FUNCTION_NAME = "errP_Get_ExcelApplication"
    
    Set excelApplication = m_oExcelApp
    
    Exit Property
    
errP_Get_ExcelApplication:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

