VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PredicateIn"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  Class:      PredicateIn - Class for In Predicates
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
'module name
'--------------------------------------------------------
Const MODULE_NAME = "PredicateIn"

'properties
Private m_emArrange            As predicateArrange
Private m_bIsNot                 As Boolean
Private m_bIncludeEmptyString    As Boolean
Private m_colValueList           As New Collection
Private m_emPredicateTyp       As predicateTyp


Private Property Let predicateTyp(NewPredicateTyp As predicateTyp)
    On Error GoTo errP_Let_PredicateTyp

    Const FUNCTION_NAME = "P_LET PredicateTyp"
    
    m_emPredicateTyp = NewPredicateTyp
    
    Exit Property
    
errP_Let_PredicateTyp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get predicateTyp() As predicateTyp
    On Error GoTo errP_Get_PredicateTyp

    Const FUNCTION_NAME = "P_GET PredicateTyp"
    
    predicateTyp = m_emPredicateTyp
    
    Exit Property
    
errP_Get_PredicateTyp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let arrange(NewArrange As predicateArrange)
    On Error GoTo errP_Let_Arrange

    Const FUNCTION_NAME = "P_Let arrange"
    
    m_emArrange = NewArrange
    
    Exit Property
    
errP_Let_Arrange:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get arrange() As predicateArrange
    On Error GoTo errP_Get_Arrange

    Const FUNCTION_NAME = "P_Get arrange"
    
    arrange = m_emArrange
    
    Exit Property
    
errP_Get_Arrange:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let isNot(NewIsNot As Boolean)
    On Error GoTo errP_Let_IsNot

    Const FUNCTION_NAME = "P_Let isNot"
    
    m_bIsNot = NewIsNot
    
    Exit Property
    
errP_Let_IsNot:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get isNot() As Boolean
    On Error GoTo errP_Get_IsNot

    Const FUNCTION_NAME = "P_GET IsNot"
    
    isNot = m_bIsNot
    
    Exit Property
    
errP_Get_IsNot:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Let includeEmptyString(NewIncludeEmptyString As Boolean)
    On Error GoTo errP_Let_IncludeEmptyString

    Const FUNCTION_NAME = "P_Let includeEmptyString"
    
    m_bIncludeEmptyString = NewIncludeEmptyString
    
    Exit Property
    
errP_Let_IncludeEmptyString:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get includeEmptyString() As Boolean
    On Error GoTo errP_Get_IncludeEmptyString

    Const FUNCTION_NAME = "P_GET IncludeEmptyString"
    
    includeEmptyString = m_bIncludeEmptyString
    
    Exit Property
    
errP_Get_IncludeEmptyString:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get ValueList() As Collection
    On Error GoTo errP_Get_ValueList

    Const FUNCTION_NAME = "P_GET ValueList"
    
    Set ValueList = m_colValueList
    
    Exit Property
    
errP_Get_ValueList:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Function addValue(ByVal NewValue As String) As Boolean
    On Error GoTo errAddValue

    Const FUNCTION_NAME = "AddValue"
    
    Dim value   As Variant
    
    'inits
    addValue = False
    
    '  Value allready exists?
    For Each value In m_colValueList
        If value = NewValue Then
            Exit Function
        End If
    Next
    
    'Add new value
    m_colValueList.add NewValue, NewValue
    
    'rc
    addValue = True
    
    Exit Function
    
errAddValue:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Public Function RemoveValue(ByVal sRemoveValue As String)
    On Error GoTo errRemoveValue

    Const FUNCTION_NAME = "removeValue"
    
    m_colValueList.remove sRemoveValue
    
    Exit Function
    
errRemoveValue:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Private Sub Class_Initialize()
    On Error GoTo ErrClass_Initialize

    Const FUNCTION_NAME = "Class_Initialize"
    
    'inits
    m_emArrange = PredicateArrangeAnd
    m_bIsNot = False
    m_bIncludeEmptyString = False
    m_emPredicateTyp = PredicateIn
    
    Exit Sub
    
ErrClass_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Public Function getDescription(Description As String) As Boolean
    On Error GoTo errGetDescription

    Const FUNCTION_NAME = "GetDescription"
    
    Dim NewDescription      As String
    Dim value               As Variant
    Dim ValueDescription    As String

    Dim SeparatorValue As Integer
        
    '  Init
    getDescription = False
    SeparatorValue = 5
    
    'check separator value
    If SeparatorValue > 7 Then Exit Function 'separator value + 1 can be a printable character
        
    
    'get property PredicateTyp
    NewDescription = Trim$(Str$(m_emPredicateTyp)) + Chr$(SeparatorValue)
    
    'get property Arrange
    NewDescription = NewDescription + Trim$(Str$(m_emArrange)) + Chr$(SeparatorValue)
    
    'get property IsNot
    NewDescription = NewDescription + Trim$(Str$(m_bIsNot)) + Chr$(SeparatorValue)
    
    'get property IncludeEmptyString
    NewDescription = NewDescription + Trim$(Str$(m_bIncludeEmptyString)) + Chr$(SeparatorValue)
    
    'get property ValueList
    For Each value In m_colValueList
        ValueDescription = ValueDescription + value + Chr$(SeparatorValue + 1)
    Next
    NewDescription = NewDescription + ValueDescription + Chr$(SeparatorValue)
    
    'rc
    Description = NewDescription
    
    getDescription = True
    
    Exit Function

errGetDescription:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Public Function setDescription(Description As String) As Boolean
    On Error GoTo errSetDescription

    Const FUNCTION_NAME = "SetDescription"
    
    Dim NextToken   As String
    Dim ValueList   As String
    
    '  Init
    setDescription = False
    
    'check description
    If Len(Description) < 1 Then
    
        setDescription = True
        Exit Function
    End If
    
    'set property PredicateTyp
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel6)
    m_emPredicateTyp = Val(NextToken)
    
    'set property Arrange
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel6)
    m_emArrange = Val(NextToken)
    
    'set property IsNot
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel6)
    m_bIsNot = NextToken
    
    'set property IncludeEmptyString
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel6)
    m_bIncludeEmptyString = NextToken
    
    'set property ValueList
    m_oComFunc.GetNextToken Description, ValueList, m_oComFunc.GetTokenSeperator(qplObjectLevel6)
    
    While Len(ValueList) > 0
    
        m_oComFunc.GetNextToken ValueList, NextToken, Chr$(6)
        If Len(NextToken) > 0 Then addValue NextToken
    Wend
    
    'rc
    setDescription = True
    
    Exit Function

errSetDescription:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function getPredicateAsStatement(bFormated As Boolean) As String
    On Error GoTo errGetPredicateAsStatement

    Const FUNCTION_NAME = "GetPredicateAsStatement"

    Dim oColumn            As New SQLStudioDBLayer.column
    Dim CurrentClause       As String
    Dim CurrentValue        As Variant
    
    'inits
    getPredicateAsStatement = ""
    CurrentClause = ""
    
    If m_bIsNot Then
        CurrentClause = CurrentClause + " NOT IN ("
    Else
        CurrentClause = CurrentClause + " IN ("
    End If

    For Each CurrentValue In ValueList
        CurrentClause = CurrentClause + oColumn.GetFormattedValue(CurrentValue) + ", "
    Next
    
    'Add empty string?
    If m_bIncludeEmptyString Then
        CurrentClause = CurrentClause + "'', "
    End If
    
    '  Reformat current clause
    CurrentClause = left$(CurrentClause, Len(CurrentClause) - 2) + ")"
    
    getPredicateAsStatement = getPredicateAsStatement + CurrentClause
    
   
    Exit Function
    
errGetPredicateAsStatement:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function getPredicateArrange() As String
    On Error GoTo errGetPredicateArrange

    Const FUNCTION_NAME = "GetPredicateArrange"

    Dim CurrentClause       As String

    If arrange = PredicateArrangeAnd Then
        getPredicateArrange = "AND"
    Else
        getPredicateArrange = "OR"
    End If
    
    Exit Function
    
errGetPredicateArrange:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Public Function getPredicateArrangeFromDescription(Description As String) As String
    On Error GoTo errGetPredicateArrangeFromDescription

    Const FUNCTION_NAME = "GetPredicateArrangeFromDescription"

    Dim CurrentClause       As String
    
    
    Dim clsArrange      As predicateArrange
    Dim predicateTyp    As predicateTyp
    Dim NextToken       As String

    '  Init
    getPredicateArrangeFromDescription = ""
    
    'check description
    If Len(Description) < 1 Then Exit Function
         
    
    
    'set property PredicateTyp
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel6)
    predicateTyp = Val(NextToken)
        
    'set property Arrange
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel6)
    arrange = Val(NextToken)
        

    If arrange = PredicateArrangeAnd Then
        getPredicateArrangeFromDescription = "AND"
    Else
        getPredicateArrangeFromDescription = "OR"
    End If
    
    Exit Function
    
errGetPredicateArrangeFromDescription:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function




