VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PredicateOrderCol"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  Class:      PredicateOrderCol - Class for OrderColumn Predicates
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
'module name
'--------------------------------------------------------
Const MODULE_NAME = "PredicateOrderCol"

'properties
Private m_sColumnName        As String
Private m_emDirection      As predicateOrderDirection
Private m_emPredicateTyp   As predicateTyp


Private Property Let predicateTyp(NewPredicateTyp As predicateTyp)
    On Error GoTo errP_Let_PredicateTyp

    Const FUNCTION_NAME = "P_LET PredicateTyp"
    
    m_emPredicateTyp = NewPredicateTyp
    
    Exit Property
    
errP_Let_PredicateTyp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get predicateTyp() As predicateTyp
    On Error GoTo errP_Get_PredicateTyp

    Const FUNCTION_NAME = "P_GET PredicateTyp"
    
    predicateTyp = m_emPredicateTyp
    
    Exit Property
    
errP_Get_PredicateTyp:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Let columnName(NewColumnName As String)
    On Error GoTo errP_Let_ColumnName

    Const FUNCTION_NAME = "P_LET ColumnName"
    
    m_sColumnName = NewColumnName
    
    Exit Property
    
errP_Let_ColumnName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get columnName() As String
    On Error GoTo errP_Get_ColumnName

    Const FUNCTION_NAME = "P_Get columnName"
    
    columnName = m_sColumnName
    
    Exit Property
    
errP_Get_ColumnName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Let direction(NewDirection As predicateOrderDirection)
    On Error GoTo errP_Let_Direction

    Const FUNCTION_NAME = "P_LET Direction"
    
    m_emDirection = NewDirection
    
    Exit Property
    
errP_Let_Direction:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get direction() As predicateOrderDirection
    On Error GoTo errP_Get_Direction

    Const FUNCTION_NAME = "P_Get direction"
    
    direction = m_emDirection
    
    Exit Property
    
errP_Get_Direction:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Private Sub Class_Initialize()
    On Error GoTo ErrClass_Initialize

    Const FUNCTION_NAME = "Class_Initialize"
    
    'inits
    m_sColumnName = ""
    m_emDirection = OrderAscending
    m_emPredicateTyp = PredicateOrderCol
     
    
    Exit Sub
    
ErrClass_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

Public Function getDescription(Description As String) As Boolean
    On Error GoTo errGetDescription

    Const FUNCTION_NAME = "GetDescription"
    
    Dim NewDescription  As String

    Dim SeparatorValue As Integer
        
    '  Init
    getDescription = False
    SeparatorValue = 5
    
    'check separator value
    If SeparatorValue > 7 Then Exit Function 'separator value + 1 can be a printable character
        
    'get property PredicateTyp
    NewDescription = Trim$(Str$(m_emPredicateTyp)) + Chr$(SeparatorValue)
    
    'get property ColumnName
    NewDescription = NewDescription + m_sColumnName + Chr$(SeparatorValue)
    
    'get property Direction
    NewDescription = NewDescription + Trim$(Str$(m_emDirection)) + Chr$(SeparatorValue)
    
    'rc
    Description = NewDescription
    
    getDescription = True
    
    Exit Function

errGetDescription:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Public Function setDescription(Description As String) As Boolean
    On Error GoTo errSetDescription

    Const FUNCTION_NAME = "SetDescription"
    
    Dim NextToken   As String
    
    'rc
    setDescription = False
    
    'check description
    If Len(Description) < 1 Then
    
        setDescription = True
        Exit Function
    End If
    
     'set property PredicateTyp
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel6)
    m_emPredicateTyp = Val(NextToken)
    
    'set property ColumnName
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel6)
    m_sColumnName = NextToken
    
    'set property Direction
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel6)
    m_emDirection = Val(NextToken)
    
    'rc
    setDescription = True
    
    Exit Function

errSetDescription:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function




