VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PasswordOptions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  Class:       PasswordOptions
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'module name
Const MODULE_NAME = "PasswordOptions"



'copy of properties
Private m_oStorePassword     As Boolean




Public Property Let storePassword(ByVal newStorePassword As Boolean)
    On Error GoTo err_Let_StorePassword
    
    Const FUNCTION_NAME = "P_LET StorePassword"
    
    'set property
    m_oStorePassword = newStorePassword
    
    Exit Property
    
err_Let_StorePassword:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get storePassword() As Boolean
    On Error GoTo err_Get_StorePassword
    
    Const FUNCTION_NAME = "P_Get system"
    
    ' get property
    storePassword = m_oStorePassword
    
    Exit Property
    
err_Get_StorePassword:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Function getPasswordOptionsFromDescription(ByVal Description As String) As Boolean
    On Error GoTo errGetPasswordOptionsFromDescription
    
    Const FUNCTION_NAME = "GetTableTypesFromDescription"
    
    Dim NextToken       As String
    
    'inits
    getPasswordOptionsFromDescription = False
    
    ' Get table types
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    
    Select Case NextToken
    
        Case "0":   m_oStorePassword = False
        Case "1":   m_oStorePassword = True
        Case Else:  m_oStorePassword = False
    End Select
    
        'set rc
    getPasswordOptionsFromDescription = True
    
    Exit Function
    
errGetPasswordOptionsFromDescription:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Public Function getDescriptionFromPasswordOptions(Description As String) As Boolean
    On Error GoTo errGetDescriptionFromPasswordOptions
    
    Const FUNCTION_NAME = "GetDescriptionFromPasswordOptions"
    
    'inits
    getDescriptionFromPasswordOptions = False
    Description = ""
    
    ' get
    If m_oStorePassword Then
    
        Description = "1"
    Else
        Description = "0"
    End If
    
    Description = Description + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
        
    'set rc
    getDescriptionFromPasswordOptions = True
    
    Exit Function
    
errGetDescriptionFromPasswordOptions:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Private Sub Class_Initialize()
    On Error GoTo ErrClass_Initialize
    
    Const FUNCTION_NAME = "Class_Initialize"
    
    'set default table types
    m_oStorePassword = False
    
    Exit Sub
    
ErrClass_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub



