VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ResultLevel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Module:      ResultLevel
'
'-----------------------------------------------------------------------
'
' responsible: WolfgangA
'
' special area: SQLStudio
'
' description:  object describes a strutured result level
'
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'module name
Const MODULE_NAME = "ResultLevel"

Private m_lIndex             As Long
Private m_sSynonym           As String
Private m_sOrderBy           As String
Private m_sColumnName        As String
Private m_sTableName         As String
Private m_sTableOwner        As String
Private m_enumSAPDBColType   As SAPDBColumnType
'=========================================================================================
'    property:      sapdbColType
'    description:   set which columntype is represented by resultlevel object
'    arguments:     [in] NewColType, columntype
'
'    return value:  /
'
'=========================================================================================
Public Property Let sapdbColType(NewColType As SAPDBColumnType)
    On Error GoTo errP_Let_SAPDBColType

    Const FUNCTION_NAME = "P_LET sapdbColType"
    
    m_enumSAPDBColType = NewColType
    
    Exit Property
    
errP_Let_SAPDBColType:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      sapdbColType
'    description:   Get which columntype is represented by resultlevel object
'    arguments:     /
'
'    return value:  columntype
'
'=========================================================================================
Public Property Get sapdbColType() As SAPDBColumnType
    On Error GoTo errP_Get_SAPDBColType

    Const FUNCTION_NAME = "P_Get sAPDBColType"
    
    sapdbColType = m_enumSAPDBColType
    
    Exit Property
    
errP_Get_SAPDBColType:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      ColumnName
'    description:   Get columnname of resultlevel object
'    arguments:     /
'
'    return value:  column name as string
'
'=========================================================================================
Public Property Get columnName() As String
    On Error GoTo errP_Get_ColumnName

    Const FUNCTION_NAME = "P_Get columnName"
    
    columnName = m_sColumnName
    
    Exit Property
    
errP_Get_ColumnName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      ColumnName
'    description:   set column name of resultlevel object
'    arguments:     [in] NewColumnName, column name as string
'
'    return value:  /
'
'=========================================================================================
Public Property Let columnName(NewColumnName As String)
    On Error GoTo errP_Let_ColumnName

    Const FUNCTION_NAME = "P_LET ColumnName"
    
    m_sColumnName = NewColumnName
    
    Exit Property
    
errP_Let_ColumnName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      TableName
'    description:   Get tablename of resultlevel object
'    arguments:     /
'
'    return value:  table name as string
'
'=========================================================================================
Public Property Get tableName() As String
    On Error GoTo errP_Get_TableName

    Const FUNCTION_NAME = "P_Get tableName"
    
    tableName = m_sTableName
    
    Exit Property
    
errP_Get_TableName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      TableName
'    description:   set table name of resultlevel object
'    arguments:     [in] NewTableName, table name as string
'
'    return value:  /
'
'=========================================================================================
Public Property Let tableName(NewTableName As String)
    On Error GoTo errP_Let_TableName

    Const FUNCTION_NAME = "P_LET TableName"
    
    m_sTableName = NewTableName
    
    Exit Property
    
errP_Let_TableName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      TableOwner
'    description:   Get table owner of resultlevel object
'    arguments:     /
'
'    return value:  table owner as string
'
'=========================================================================================
Public Property Get tableOwner() As String
    On Error GoTo errP_Get_TableOwner

    Const FUNCTION_NAME = "P_Get tableOwner"
    
    tableOwner = m_sTableOwner
    
    Exit Property
    
errP_Get_TableOwner:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      TableOwner
'    description:   set table owner of resultlevel object
'    arguments:     [in] NewTableOwner, table owner as string
'
'    return value:  /
'
'=========================================================================================
Public Property Let tableOwner(NewTableOwner As String)
    On Error GoTo errP_Let_TableOwner

    Const FUNCTION_NAME = "P_LET TableOwner"
    
    m_sTableOwner = NewTableOwner
    
    Exit Property
    
errP_Let_TableOwner:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      Synonym
'    description:   Get column synonym of resultlevel object
'    arguments:     /
'
'    return value:  column synonym as string
'
'=========================================================================================
Public Property Get synonym() As String
    On Error GoTo errP_Get_Synonym

    Const FUNCTION_NAME = "P_Get synonym"
    
    synonym = m_sSynonym
    
    Exit Property
    
errP_Get_Synonym:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      Synonym
'    description:   set column synonym of resultlevel object
'    arguments:     [in] newSynonym,column synonym as string
'
'    return value:  /
'
'=========================================================================================
Public Property Let synonym(newSynonym As String)
    On Error GoTo errP_Let_Synonym

    Const FUNCTION_NAME = "P_LET Synonym"
    
    m_sSynonym = newSynonym
    
    Exit Property
    
errP_Let_Synonym:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      OrderBy
'    description:   Get sort order of result column described by resultlevel object
'    arguments:     /
'
'    return value:  sort order as string
'
'=========================================================================================
Public Property Get orderBy() As String
    On Error GoTo errP_Get_OrderBy

    Const FUNCTION_NAME = "P_GET OrderBy"
    
    orderBy = m_sOrderBy
    
    Exit Property
    
errP_Get_OrderBy:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      OrderBy
'    description:   set sort order of result column described by resultlevel object
'    arguments:     [in] NewOrderBy, new sort order as string
'
'    return value:  /
'
'=========================================================================================
Public Property Let orderBy(NewOrderBy As String)
    On Error GoTo errP_Let_OrderBy

    Const FUNCTION_NAME = "P_Let orderBy"
    
    Select Case NewOrderBy
    
        Case "Ascending":
              m_sOrderBy = " ASC"
        Case "Descending":
             m_sOrderBy = " DESC"
        Case Else
             m_sOrderBy = ""
    End Select
                
    Exit Property
    
errP_Let_OrderBy:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      index
'    description:   set index of result level object
'    arguments:     [in] NewIndex, index of resultlevel object
'
'    return value:  /
'
'=========================================================================================
Friend Property Let index(ByVal NewIndex As Long)
    On Error GoTo errSetIndex

    Const FUNCTION_NAME = "setIndex"

    m_lIndex = NewIndex

    Exit Property

errSetIndex:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      index
'    description:   get index of result level object
'    arguments:     [in] NewIndex, index of resultlevel object
'
'    return value:  /
'
'=========================================================================================
Public Property Get index() As Long
    On Error GoTo errP_Get_Index

    Const FUNCTION_NAME = "P_GET_Index"
    
    index = m_lIndex
    
    Exit Property
    
errP_Get_Index:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

