VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "StoredDragObject"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  Class:      StoredDragObject - StoredDragObject
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
'module name
'--------------------------------------------------------
Const MODULE_NAME = "StoredDragObject"

'local property copies
Private m_emFormat             As DBObjectType
Private m_sStoredObjectOwner     As String
Private m_sStoredObjectName      As String
Private m_emfileType   As Long
Private m_sStoredObjectKey       As String

Public Property Let format(NewFormat As DBObjectType)
    On Error GoTo errP_Let_Format

    Const FUNCTION_NAME = "P_LET Format"
    
    m_emFormat = NewFormat
    
    Exit Property
    
errP_Let_Format:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get format() As DBObjectType
    On Error GoTo errP_Get_Format

    Const FUNCTION_NAME = "P_Get format"
    
    format = m_emFormat
    
    Exit Property
    
errP_Get_Format:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Let storedObjectOwner(newStoredObjectOwner As String)
    On Error GoTo errP_Let_StoredObjectOwner

    Const FUNCTION_NAME = "P_LET StoredObjectOwner"
    
    m_sStoredObjectOwner = newStoredObjectOwner
    
    Exit Property
    
errP_Let_StoredObjectOwner:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get storedObjectOwner() As String
    On Error GoTo errP_Get_StoredObjectOwner

    Const FUNCTION_NAME = "P_Get storedObjectOwner"
    
    storedObjectOwner = m_sStoredObjectOwner
    
    Exit Property
    
errP_Get_StoredObjectOwner:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Let storedObjectName(newStoredObjectName As String)
    On Error GoTo errP_Let_StoredObjectName

    Const FUNCTION_NAME = "P_LET StoredObjectName"
    
    m_sStoredObjectName = newStoredObjectName
    
    Exit Property
    
errP_Let_StoredObjectName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get storedObjectName() As String
    On Error GoTo errP_Get_StoredObjectName

    Const FUNCTION_NAME = "P_Get storedObjectName"
    
    storedObjectName = m_sStoredObjectName
    
    Exit Property
    
errP_Get_StoredObjectName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let storedObjectKey(newStoredObjectKey As String)
    On Error GoTo errP_Let_StoredObjectKey

    Const FUNCTION_NAME = "P_LET StoredObjectKey"
    
    m_sStoredObjectKey = newStoredObjectKey
    
    Exit Property
    
errP_Let_StoredObjectKey:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get storedObjectKey() As String
    On Error GoTo errP_Get_StoredObjectKey

    Const FUNCTION_NAME = "P_Get storedObjectKey"
    
    storedObjectKey = m_sStoredObjectKey
    
    Exit Property
    
errP_Get_StoredObjectKey:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Let fileType(NewfileType As Long)
    On Error GoTo errP_Let_fileType

    Const FUNCTION_NAME = "P_LET fileType"
    
    m_emfileType = NewfileType
    
    Exit Property
    
errP_Let_fileType:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get fileType() As Long
    On Error GoTo errP_Get_fileType

    Const FUNCTION_NAME = "P_Get fileType"
    
    fileType = m_emfileType
    
    Exit Property
    
errP_Get_fileType:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

