VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TableTypes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  Class:      TableType - Table types (VIEW, TABLE, SYSTEM...)
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'module name
Const MODULE_NAME = "TableTypes"

'  Public enum types

'  Copy of properties
Private m_bSystem     As Boolean
Private m_bTable      As Boolean
Private m_bView       As Boolean
Private m_bSynonym    As Boolean
Private m_bSnapshot   As Boolean
Private m_bResult     As Boolean



Public Property Let system(ByVal newSystem As Boolean)
    On Error GoTo err_Let_System
    
    Const FUNCTION_NAME = "P_LET System"
    
    'set property
    m_bSystem = newSystem
    
    Exit Property
    
err_Let_System:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get system() As Boolean
    On Error GoTo err_Get_System
    
    Const FUNCTION_NAME = "P_Get system"
    
    ' get property
    system = m_bSystem
    
    Exit Property
    
err_Get_System:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Let table(ByVal NewTable As Boolean)
    On Error GoTo err_Let_Table
    
    Const FUNCTION_NAME = "P_LET Table"
    
    'set property
    m_bTable = NewTable
    
    Exit Property
    
err_Let_Table:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get table() As Boolean
    On Error GoTo err_Get_Table
    
    Const FUNCTION_NAME = "P_Get table"
    
    ' get property
    table = m_bTable
    
    Exit Property
    
err_Get_Table:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let view(ByVal NewView As Boolean)
    On Error GoTo err_Let_View
    
    Const FUNCTION_NAME = "P_Let view"
    
    'set property
    m_bView = NewView
    
    Exit Property
    
err_Let_View:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get view() As Boolean
    On Error GoTo err_Get_View
    
    Const FUNCTION_NAME = "P_GET View"
    
    ' get property
    view = m_bView
    
    Exit Property
    
err_Get_View:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Let synonym(ByVal newSynonym As Boolean)
    On Error GoTo err_Let_Synonym
    
    Const FUNCTION_NAME = "P_LET Synonym"
    
    'set property
    m_bSynonym = newSynonym
    
    Exit Property
    
err_Let_Synonym:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get synonym() As Boolean
    On Error GoTo err_Get_Synonym
    
    Const FUNCTION_NAME = "P_Get synonym"
    
    ' get property
    synonym = m_bSynonym
    
    Exit Property
    
err_Get_Synonym:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Let snapshot(ByVal newSnapshot As Boolean)
    On Error GoTo err_Let_Snapshot
    
    Const FUNCTION_NAME = "P_LET Snapshot"
    
    'set property
    m_bSnapshot = newSnapshot
    
    Exit Property
    
err_Let_Snapshot:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get snapshot() As Boolean
    On Error GoTo err_Get_Snapshot
    
    Const FUNCTION_NAME = "P_Get snapshot"
    
    ' get property
    snapshot = m_bSnapshot
    
    Exit Property
    
err_Get_Snapshot:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Let result(ByVal NewResult As Boolean)
    On Error GoTo err_Let_Result
    
    Const FUNCTION_NAME = "P_LET Result"
    
    'set property
    m_bResult = NewResult
    
    Exit Property
    
err_Let_Result:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get result() As Boolean
    On Error GoTo err_Get_Result
    
    Const FUNCTION_NAME = "P_Get result"
    
    ' get property
    result = m_bResult
    
    Exit Property
    
err_Get_Result:
    internalError Err, MODULE_NAME, FUNCTION_NAME

End Property

Public Property Get tableTypeWhereString() As String
    On Error GoTo err_Get_TableTypeWhereString
    
    Const FUNCTION_NAME = "P_Get tableTypeWhereString"
    Dim bPropertyAddedToWhereString As Boolean
    
    
    '  Init
    bPropertyAddedToWhereString = False
    
    
    If (m_bSystem = True And m_bTable = True And m_bView = True And _
        m_bSynonym = True And m_bSnapshot = True And m_bResult = True) Then
     
        tableTypeWhereString = " TYPE LIKE '*'"
        Exit Property
    End If
    
    
    If (m_bSystem = False And m_bTable = False And m_bView = False And _
        m_bSynonym = False And m_bSnapshot = False And m_bResult = False) Then
       tableTypeWhereString = " TYPE = ''"
       Exit Property
   End If
    
   tableTypeWhereString = " ("
   
   If (m_bSystem = True) Then
   
       tableTypeWhereString = tableTypeWhereString + "TYPE = 'SYSTEM'"
       bPropertyAddedToWhereString = True
       
   End If
   
   If (m_bTable = True) Then
       ' Es mu ein OR eingefgt werden
       If (bPropertyAddedToWhereString) Then
            tableTypeWhereString = tableTypeWhereString + " OR "
       End If
       tableTypeWhereString = tableTypeWhereString + "TYPE = 'TABLE'"
       bPropertyAddedToWhereString = True
       
   End If
   
   If (m_bView = True) Then
       ' Es mu ein OR eingefgt werden
       If (bPropertyAddedToWhereString) Then
            tableTypeWhereString = tableTypeWhereString + " OR "
       End If
       tableTypeWhereString = tableTypeWhereString + "TYPE = 'VIEW'"
       bPropertyAddedToWhereString = True
       
   End If
   
   If (m_bSynonym = True) Then
       ' Es mu ein OR eingefgt werden
       If (bPropertyAddedToWhereString) Then
            tableTypeWhereString = tableTypeWhereString + " OR "
       End If
       tableTypeWhereString = tableTypeWhereString + "TYPE = 'SYNONYM'"
       bPropertyAddedToWhereString = True
       
   End If
   
   If (m_bSnapshot = True) Then
       ' Es mu ein OR eingefgt werden
       If (bPropertyAddedToWhereString) Then
            tableTypeWhereString = tableTypeWhereString + " OR "
       End If
       tableTypeWhereString = tableTypeWhereString + "TYPE = 'SNAPSHOT'"
       bPropertyAddedToWhereString = True
   End If
   
   If (m_bResult = True) Then
       ' Es mu ein OR eingefgt werden
       If (bPropertyAddedToWhereString) Then
            tableTypeWhereString = tableTypeWhereString + " OR "
       End If
       tableTypeWhereString = tableTypeWhereString + "TYPE = 'RESULT'"
       bPropertyAddedToWhereString = True
       
   End If
    
   tableTypeWhereString = tableTypeWhereString + ")"
   Exit Property
    
err_Get_TableTypeWhereString:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property


Friend Function getTableTypesFromDescription(ByVal Description As String) As Boolean
    On Error GoTo errGetTableTypesFromDescription
    
    Const FUNCTION_NAME = "GetTableTypesFromDescription"
    
    Dim NextToken       As String
    
    'inits
    getTableTypesFromDescription = False
    
    ' Get table types
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    Select Case NextToken
        Case "0":   m_bSystem = False
        Case "1":   m_bSystem = True
    End Select
    
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    Select Case NextToken
        Case "0":   m_bTable = False
        Case "1":   m_bTable = True
    End Select
    
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    Select Case NextToken
        Case "0":   m_bView = False
        Case "1":   m_bView = True
    End Select
    
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    Select Case NextToken
        Case "0":   m_bSynonym = False
        Case "1":   m_bSynonym = True
    End Select
    
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    Select Case NextToken
        Case "0":   m_bSnapshot = False
        Case "1":   m_bSnapshot = True
    End Select
    
    m_oComFunc.GetNextToken Description, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    Select Case NextToken
        Case "0":   m_bResult = False
        Case "1":   m_bResult = True
    End Select
    
    'set rc
    getTableTypesFromDescription = True
    
    Exit Function
    
errGetTableTypesFromDescription:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Friend Function getDescriptionFromTableTypes(Description As String) As Boolean
    On Error GoTo errGetDescriptionFromTableTypes
    
    Const FUNCTION_NAME = "GetDescriptionFromTableTypes"
    
    'inits
    getDescriptionFromTableTypes = False
    Description = ""
    
    ' Get table types description
    If m_bSystem Then
        Description = "1"
    Else
        Description = "0"
    End If
    Description = Description + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    
    If m_bTable Then
        Description = Description + "1"
    Else
        Description = Description + "0"
    End If
    Description = Description + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    
    If m_bView Then
        Description = Description + "1"
    Else
        Description = Description + "0"
    End If
    Description = Description + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    
    If m_bSynonym Then
        Description = Description + "1"
    Else
        Description = Description + "0"
    End If
    Description = Description + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    
    If m_bSnapshot Then
        Description = Description + "1"
    Else
        Description = Description + "0"
    End If
    Description = Description + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    
    If m_bResult Then
        Description = Description + "1"
    Else
        Description = Description + "0"
    End If
    Description = Description + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    
    'set rc
    getDescriptionFromTableTypes = True
    
    Exit Function
    
errGetDescriptionFromTableTypes:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Private Sub Class_Initialize()
    On Error GoTo ErrClass_Initialize
    
    Const FUNCTION_NAME = "Class_Initialize"
    
    'set default table types
    m_bSystem = True
    m_bTable = True
    m_bView = True
    m_bSynonym = True
    m_bSnapshot = True
    m_bResult = False
    
    Exit Sub
    
ErrClass_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub


