VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "UserProfile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'////////////////////////////////////////////////////////////////////
'//
'// class:      SAPDBUPUserProfile
'//
'//
'//-----------------------------------------------------------------------
'//
'// responsible:  ( @SAP.com)
'//
'// special area: SAPDBUPO
'//
'// description:  class for loading,saving, ... userprofile of sql studio
'//
'// see also:
'//
'//-----------------------------------------------------------------------
'//
'//  copyright:                Copyright by SAP AG, 2000
'//
'//
'////////////////////////////////////////////////////////////////////
Option Explicit

'module name
Const MODULE_NAME = "UserProfile"

Const LOCAL_ROOT = "LocalRoot"
Const NOVERSIONDEP = "NoVersionDep"

Const LOCALFOLDERIND = "LocalFolderInd"

Private Type Font

    Name As String
    FontBold As Boolean
    FontItalic As Boolean
    FontSize As Long
    FontStrikethrough As Boolean
    FontUnderline As Boolean
End Type

Private Const SQL_DATA_AT_EXEC = -2
Private Const SQL_NEED_DATA = 99
Private Const SQL_NO_DATA_FOUND = 100
Private Const SQL_SUCCESS = 0
Private Const SQL_SUCCESS_WITH_INFO = 1
Private Const SQLSTATE_SUCCESS = "00000"
Private Const SQLSTATE_DATA_TRUNCATED = "01004"


'Copy of properties
Private m_oSelectTableTypes             As New TableTypes
Private m_oPasswordOptions              As New PasswordOptions
Private m_oAppManagment                 As New AppManagement
Private m_typeUserFont                  As Font
Private m_typeReportFont                As Font
Private m_bReplaceNonCharsInLongColumn  As Boolean
Private m_bConfirmation                 As Boolean
Private m_bRestoreCatalogState          As Boolean
Private m_bClippedResultView            As Boolean
Private m_lLimitForLongColumn           As Long
Private m_lFetchBlockSize               As Long
Private m_lFetchBufferSize              As Long
Private m_sTableFilter                  As String
Private m_sExpandedNodes                As String
Private m_colTableFilter                As New Collection

Private m_sEscapeCharacter              As String
Private m_sRepOfNullValue               As String

Private m_bQBEReadOnly                  As Boolean

Private m_lVersion                      As Long
Private m_lAppVersion                   As Long

Private m_lForTextColor                 As Long

'this value is kept to be compatible to userprofiles from previous versions which used
'color for protected text
Private m_lProtTextColor                As Long
Private m_lHighlightColor               As Long

Private m_sLocalRoot                    As String

'flag, if input of filter box for the catalog table folder is converted to uppercase
Private m_bCMFilterInputUpper           As Boolean

'if rows are copied in the result dailog, they are seperated with tabs
Private m_bCopyColumsTabSep             As Boolean

'create table dialog, column names are case sensitiv
Private m_bIdentifiersCaseSensitiv As Boolean

'copy a query result with columnheader
Private m_bCopyResultWithHeader As Boolean

Private m_bLocalFolderIndependent As Boolean

'global object for registry functions
Private m_oRegFunc                  As New SQLStudioUtil.Registry

Public Function getUserFont(Name As String, _
                            FontBold As Boolean, _
                            FontItalic As Boolean, _
                            FontSize As Long, _
                            FontStrikethrough As Boolean, _
                            FontUnderline As Boolean) As Boolean
    
    On Error GoTo errGetUserFont
    
    Const FUNCTION_NAME = "GetUserFont"
        
    Name = m_typeUserFont.Name
    FontBold = m_typeUserFont.FontBold
    FontItalic = m_typeUserFont.FontItalic
    FontSize = m_typeUserFont.FontSize
    FontStrikethrough = m_typeUserFont.FontStrikethrough
    FontUnderline = m_typeUserFont.FontUnderline
    
    Exit Function
    
errGetUserFont:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function setUserFont(Name As String, _
                            FontBold As Boolean, _
                            FontItalic As Boolean, _
                            FontSize As Long, _
                            FontStrikethrough As Boolean, _
                            FontUnderline As Boolean) As Boolean
    On Error GoTo errSetUserFont
    
    Const FUNCTION_NAME = "SetUserFont"
    
    m_typeUserFont.Name = Name
    m_typeUserFont.FontBold = FontBold
    m_typeUserFont.FontItalic = FontItalic
    m_typeUserFont.FontSize = FontSize
    m_typeUserFont.FontStrikethrough = FontStrikethrough
    m_typeUserFont.FontUnderline = FontUnderline
    
        
    Exit Function
    
errSetUserFont:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function getReportFont(Name As String, _
                            FontBold As Boolean, _
                            FontItalic As Boolean, _
                            FontSize As Long, _
                            FontStrikethrough As Boolean, _
                            FontUnderline As Boolean) As Boolean
    
    On Error GoTo errGetReportFont
    
    Const FUNCTION_NAME = "GetReportFont"
    
    getReportFont = False
        
    Name = m_typeReportFont.Name
    FontBold = m_typeReportFont.FontBold
    FontItalic = m_typeReportFont.FontItalic
    FontSize = m_typeReportFont.FontSize
    FontStrikethrough = m_typeReportFont.FontStrikethrough
    FontUnderline = m_typeReportFont.FontUnderline
    
    
    getReportFont = True
    
    Exit Function
    
errGetReportFont:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function setReportFont(Name As String, _
                            FontBold As Boolean, _
                            FontItalic As Boolean, _
                            FontSize As Long, _
                            FontStrikethrough As Boolean, _
                            FontUnderline As Boolean) As Boolean
    On Error GoTo errSetReportFont
    
    Const FUNCTION_NAME = "SetReportFont"
    
    m_typeReportFont.Name = Name
    m_typeReportFont.FontBold = FontBold
    m_typeReportFont.FontItalic = FontItalic
    m_typeReportFont.FontSize = FontSize
    m_typeReportFont.FontStrikethrough = FontStrikethrough
    m_typeReportFont.FontUnderline = FontUnderline
    
        
    Exit Function
    
errSetReportFont:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Property Set selectTableTypes(newSelectTableTypes As TableTypes)
    On Error GoTo Err_SET_SelectTableTypes
    
    Const FUNCTION_NAME = "P_SET SelectTableTypes"
    
    'set property
    Set m_oSelectTableTypes = newSelectTableTypes
    
    Exit Property
    
Err_SET_SelectTableTypes:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get selectTableTypes() As TableTypes
    On Error GoTo err_Get_SelectTableTypes
    
    Const FUNCTION_NAME = "P_Get selectTableTypes"
    
    ' get property
    Set selectTableTypes = m_oSelectTableTypes
    
    Exit Property
    
err_Get_SelectTableTypes:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get storePassword() As Boolean
    On Error GoTo err_Get_StorePassword
    
    Const FUNCTION_NAME = "P_Get storePassword"
    
    ' get property
    storePassword = m_oPasswordOptions.storePassword
    
    Exit Property
    
err_Get_StorePassword:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let storePassword(bNewUseStoredPw As Boolean)
    On Error GoTo err_Let_StorePassword
    
    Const FUNCTION_NAME = "P_LET StorePassword"
    
    'let property
    m_oPasswordOptions.storePassword = bNewUseStoredPw
    
    Exit Property
    
err_Let_StorePassword:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get appManagment() As AppManagement
    On Error GoTo err_Get_AppManagment
    
    Const FUNCTION_NAME = "P_Get appManagment"
    
    ' get property
    Set appManagment = m_oAppManagment
    
    Exit Property
    
err_Get_AppManagment:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Set appManagment(NewAppManagment As AppManagement)
    On Error GoTo err_Let_AppManagment
    
    Const FUNCTION_NAME = "P_Let appManagment"
    
    'let property
    Set m_oAppManagment = NewAppManagment
    
    Exit Property
    
err_Let_AppManagment:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get replaceNonCharsInLongColumns() As Boolean
    On Error GoTo err_Get_ReplaceNonCharsInLongColumns
    
    Const FUNCTION_NAME = "P_Get replaceNonCharsInLongColumns"
    
    ' get property
    replaceNonCharsInLongColumns = m_bReplaceNonCharsInLongColumn
    
    Exit Property
    
err_Get_ReplaceNonCharsInLongColumns:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let replaceNonCharsInLongColumns(bNewReplaceNonCharsInLongColumns As Boolean)
    On Error GoTo err_Let_ReplaceNonCharsInLongColumns
    
    Const FUNCTION_NAME = "P_LET ReplaceNonCharsInLongColumns"
    
    'let property
    m_bReplaceNonCharsInLongColumn = bNewReplaceNonCharsInLongColumns
    
    Exit Property
    
err_Let_ReplaceNonCharsInLongColumns:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get confirmation() As Boolean
    On Error GoTo err_Get_Confirmation
    
    Const FUNCTION_NAME = "P_Get confirmation"
    
    ' get property
    confirmation = m_bConfirmation
    
    Exit Property
    
err_Get_Confirmation:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let confirmation(bNewConfirmation As Boolean)
    On Error GoTo err_Let_Confirmation
    
    Const FUNCTION_NAME = "P_LET Confirmation"
    
    'let property
    m_bConfirmation = bNewConfirmation
    
    Exit Property
    
err_Let_Confirmation:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get restoreCatalogState() As Boolean
    On Error GoTo err_Get_RestoreCatalogState
    
    Const FUNCTION_NAME = "P_Get restoreCatalogState"
    
    ' get property
    restoreCatalogState = m_bRestoreCatalogState
    
    Exit Property
    
err_Get_RestoreCatalogState:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let restoreCatalogState(bNewRestoreCatalogState As Boolean)
    On Error GoTo err_Let_RestoreCatalogState
    
    Const FUNCTION_NAME = "P_LET RestoreCatalogState"
    
    'let property
    m_bRestoreCatalogState = bNewRestoreCatalogState
    
    Exit Property
    
err_Let_RestoreCatalogState:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get limitForLongColumn() As Long
    On Error GoTo err_Get_LimitForLongColumn
    
    Const FUNCTION_NAME = "P_Get limitForLongColumn"
    
    ' get property
    limitForLongColumn = m_lLimitForLongColumn
    
    Exit Property
    
err_Get_LimitForLongColumn:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let limitForLongColumn(bNewLimitForLongColumn As Long)
    On Error GoTo err_Let_LimitForLongColumn
    
    Const FUNCTION_NAME = "P_LET LimitForLongColumn"
    
    'let property
    m_lLimitForLongColumn = bNewLimitForLongColumn
    
    Exit Property
    
err_Let_LimitForLongColumn:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get clippedResultView() As Boolean
    On Error GoTo err_Get_ClippedResultView
    
    Const FUNCTION_NAME = "P_Get clippedResultView"
    
    ' get property
    clippedResultView = m_bClippedResultView
    
    Exit Property
    
err_Get_ClippedResultView:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let clippedResultView(bNewClippedResultView As Boolean)
    On Error GoTo err_Let_ClippedResultView
    
    Const FUNCTION_NAME = "P_LET ClippedResultView"
    
    'let property
    m_bClippedResultView = bNewClippedResultView
    
    Exit Property
    
err_Let_ClippedResultView:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Private Property Get fetchBlockSize() As Long
    On Error GoTo err_Get_FetchBlockSize
    
    Const FUNCTION_NAME = "P_Get fetchBlockSize"
    
    ' get property
    fetchBlockSize = m_lFetchBlockSize
    
    Exit Property
    
err_Get_FetchBlockSize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Private Property Let fetchBlockSize(lNewFetchBlockSize As Long)
    On Error GoTo err_Let_FetchBlockSize
    
    Const FUNCTION_NAME = "P_LET FetchBlockSize"
    
    'let property
    m_lFetchBlockSize = lNewFetchBlockSize
    
    Exit Property
    
err_Let_FetchBlockSize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Private Property Get fetchBufferSize() As Long
    On Error GoTo err_Get_FetchBufferSize
    
    Const FUNCTION_NAME = "P_Get fetchBufferSize"
    
    ' get property
    fetchBufferSize = m_lFetchBufferSize
    
    Exit Property
    
err_Get_FetchBufferSize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Private Property Let fetchBufferSize(lNewFetchBufferSize As Long)
    On Error GoTo err_Let_FetchBufferSize
    
    Const FUNCTION_NAME = "P_LET FetchBufferSize"
    
    'let property
    m_lFetchBufferSize = lNewFetchBufferSize
    
    Exit Property
    
err_Let_FetchBufferSize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get tableFilter() As String
    On Error GoTo err_Get_TableFilter
    
    Const FUNCTION_NAME = "P_Get tableFilter"
    
    ' get property
    tableFilter = m_sTableFilter
    
    Exit Property
    
err_Get_TableFilter:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let tableFilter(sNewTableFilter As String)
    On Error GoTo err_Let_TableFilter
    
    Const FUNCTION_NAME = "P_LET TableFilter"
    
    'let property
    m_sTableFilter = sNewTableFilter
    
    Exit Property
    
err_Let_TableFilter:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get expandedNodes() As String
    On Error GoTo err_Get_ExpandedNodes
    
    Const FUNCTION_NAME = "P_Get expandedNodes"
    
    ' get property
    expandedNodes = m_sExpandedNodes
    
    Exit Property
    
err_Get_ExpandedNodes:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let expandedNodes(sNewExpandedNodes As String)
    On Error GoTo err_Let_ExpandedNodes
    
    Const FUNCTION_NAME = "P_LET ExpandedNodes"
    
    'let property
    m_sExpandedNodes = sNewExpandedNodes
    
    Exit Property
    
err_Let_ExpandedNodes:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Function loadUserProfile(connection As SQLStudioDBLayer.connection) As Boolean
    On Error GoTo ErrLoadUserProfile
    
    Const FUNCTION_NAME = "LoadUserProfile"
    
    Dim sUserProfile        As String
    Dim NextToken           As String
    Dim sFont               As String
    Dim sTableFilter        As String
    Dim bTableFilterLoaded  As Boolean
    
    'inits
    loadUserProfile = False
        
    ' Get user profile description
    If Not getUserProfileDescription(connection, sUserProfile) Then Exit Function
    
    'Version
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    If Len(NextToken) > 0 Then
    
       If IsNumeric(NextToken) Then
       
            m_lVersion = CLng(NextToken)
       Else
            m_lVersion = 0
            'Exit because ist an very,very old userprofile
            Exit Function
       End If
    Else
        m_lVersion = 0
        'Exit because ist a very,very old userprofiles
        Exit Function
    End If
        
    ' Get selectTableTypes settings
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_oSelectTableTypes.getTableTypesFromDescription NextToken
    
    ' get Password Options
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_oPasswordOptions.getPasswordOptionsFromDescription NextToken
       
    'Font
    getFont m_typeUserFont, sUserProfile
        
    'ReplaceNonChars
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_bReplaceNonCharsInLongColumn = getBoolValueFromToken(NextToken)
        
    'Confirmation
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_bConfirmation = getBoolValueFromToken(NextToken)
    
    'tableFilter
    bTableFilterLoaded = False
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    If Len(NextToken) > 0 Then
    
        sTableFilter = NextToken
        While Len(sTableFilter) > 0
            m_oComFunc.GetNextToken sTableFilter, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
           
            If bTableFilterLoaded = False Then
            
                bTableFilterLoaded = True
                m_sTableFilter = NextToken
            Else
                m_colTableFilter.add NextToken
            End If
        Wend
    End If
    
    'Font Reports
    getFont m_typeReportFont, sUserProfile
    
    'Limit for Long
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    If Len(NextToken) > 0 Then
    
        m_lLimitForLongColumn = Val(Trim$(NextToken))
    Else
        m_lLimitForLongColumn = 1024
    End If
    
    'Fetch Page Size
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    If Len(NextToken) > 0 Then
    
        m_lFetchBlockSize = Val(Trim$(NextToken))
    Else
        m_lFetchBlockSize = 512
    End If
    
    'Fix Value
    m_lFetchBlockSize = 512
    
    'Fetch Buffersize
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    If Len(NextToken) > 0 Then
    
        m_lFetchBufferSize = Val(Trim$(NextToken))
    Else
        m_lFetchBufferSize = 2048
    End If
    
    'Fix Value
    m_lFetchBufferSize = 2048

    'Expanded Nodes
    m_sExpandedNodes = ""
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    If Len(NextToken) > 0 Then
    
        m_sExpandedNodes = NextToken
    Else
        m_sExpandedNodes = ""
    End If
    
    'RestoreCatalogState
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_bRestoreCatalogState = getBoolValueFromToken(NextToken)
    
    'Get SQLStudioObjects Options
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_oAppManagment.getStudioObjectsFromDescription NextToken
    
   'ClippedResultView
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_bClippedResultView = getBoolValueFromToken(NextToken)
    
    'EscapeCharacter
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    If Len(NextToken) > 0 Then
    
        m_sEscapeCharacter = NextToken
    Else
        m_sEscapeCharacter = "\"
    End If
    
    'RepOfNullValue
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    If Len(NextToken) > 0 Then
    
        m_sRepOfNullValue = NextToken
    Else
        m_sRepOfNullValue = "?"
    End If
    
    'QBEReadOnly
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_bQBEReadOnly = getBoolValueFromToken(NextToken)
    
    'ForTextColor
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    If Len(NextToken) > 0 Then
    
        m_lForTextColor = Val(Trim$(NextToken))
    Else
        m_lForTextColor = 0
    End If
    
    'm_lProtTextColor
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    If Len(NextToken) > 0 Then
    
        m_lProtTextColor = Val(Trim$(NextToken))
    Else
        m_lProtTextColor = 12632256
    End If
    
    'm_lHighlightColor
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    If Len(NextToken) > 0 Then
    
        m_lHighlightColor = Val(Trim$(NextToken))
    Else
        m_lHighlightColor = RGB(0, 0, 255)
    End If
    
    'm_sLocalRoot
    'read the local root from the database userprofile
    'to keep token stream valid, even the value is empty
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    'now read local root from registry
    m_sLocalRoot = readLocalRoot
    'if there is no local root in the registry take the old one of the database, if one exits
    If Len(m_sLocalRoot) < 1 And Len(NextToken) > 0 Then
    
        m_sLocalRoot = NextToken
        'its better to store the local root in the registry and not in the database
        'because if SQL Studio connects to a db from/at two different computers
        'the path for the local folder may not fit on both
        writeLocalRoot m_sLocalRoot
    End If
        
    'flag, if input of filter box for the catalog table folder is converted to uppercase
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_bCMFilterInputUpper = getBoolValueFromToken(NextToken)
    
    'flag, if columns are seperated with tabs when copied to clipboard
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_bCopyColumsTabSep = getBoolValueFromToken(NextToken)
    
    'flag, if identifiers in create dialogs are case sensitiv
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_bIdentifiersCaseSensitiv = getBoolValueFromToken(NextToken)
    
    'flag, if result is copied with column header
    m_oComFunc.GetNextToken sUserProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_bCopyResultWithHeader = getBoolValueFromToken(NextToken)
    
    'read this value from registry
    m_bLocalFolderIndependent = isLocalFolderInd()
    
    'set rc
    loadUserProfile = True
    
    Exit Function
    
ErrLoadUserProfile:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function saveUserProfile(oConnection As SQLStudioDBLayer.connection) As Boolean
    On Error GoTo errSaveUserProfile
    
    Const FUNCTION_NAME = "saveUserProfile"
    
    
    Dim statement                       As String
    Dim userProfile                     As String
    Dim SelectTableTypesDescription     As String
    Dim sPasswordOptions                As String
    Dim sSQLStudioObjects               As String
    Dim lRun                            As Long
    Dim oDBFunctions                     As New SQLStudioDBLayer.Functions
    'rc
    saveUserProfile = False
    
    'init
    sSQLStudioObjects = ""
    
    'Version
    userProfile = userProfile + Trim$(Str$(m_lAppVersion)) + _
                   m_oComFunc.GetTokenSeperator(qplObjectLevel1)
                
    'set SelectTableTypes settings
    m_oSelectTableTypes.getDescriptionFromTableTypes SelectTableTypesDescription
    userProfile = userProfile + SelectTableTypesDescription + m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    
    'set StorePassword settings
    m_oPasswordOptions.getDescriptionFromPasswordOptions sPasswordOptions
    userProfile = userProfile + sPasswordOptions + m_oComFunc.GetTokenSeperator(qplObjectLevel1)
                              
    'Font
    userProfile = userProfile + m_typeUserFont.Name + m_oComFunc.GetTokenSeperator(qplObjectLevel2) _
                              + makeBoolToNumericString(m_typeUserFont.FontBold) + m_oComFunc.GetTokenSeperator(qplObjectLevel2) _
                              + makeBoolToNumericString(m_typeUserFont.FontItalic) + m_oComFunc.GetTokenSeperator(qplObjectLevel2) _
                              + Trim$(Str$(m_typeUserFont.FontSize)) + m_oComFunc.GetTokenSeperator(qplObjectLevel2) _
                              + makeBoolToNumericString(m_typeUserFont.FontStrikethrough) + m_oComFunc.GetTokenSeperator(qplObjectLevel2) _
                              + makeBoolToNumericString(m_typeUserFont.FontUnderline) + m_oComFunc.GetTokenSeperator(qplObjectLevel2) _
                    + m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    
        
    'Replace non chars
    userProfile = userProfile + makeBoolToNumericString(m_bReplaceNonCharsInLongColumn) + _
                   m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    
    'Confirmation
    userProfile = userProfile + makeBoolToNumericString(m_bConfirmation) + _
                   m_oComFunc.GetTokenSeperator(qplObjectLevel1)
                   
    'TableFilter
    userProfile = userProfile + Trim$(m_sTableFilter) + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    For lRun = 1 To m_colTableFilter.count
    
        userProfile = userProfile + Trim$(m_colTableFilter.item(lRun)) + _
                      m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    Next
    userProfile = userProfile + m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    
    
    'Font Report
    userProfile = userProfile + m_typeReportFont.Name + m_oComFunc.GetTokenSeperator(qplObjectLevel2) _
                              + makeBoolToNumericString(m_typeReportFont.FontBold) + m_oComFunc.GetTokenSeperator(qplObjectLevel2) _
                              + makeBoolToNumericString(m_typeReportFont.FontItalic) + m_oComFunc.GetTokenSeperator(qplObjectLevel2) _
                              + Trim$(Str$(m_typeReportFont.FontSize)) + m_oComFunc.GetTokenSeperator(qplObjectLevel2) _
                              + makeBoolToNumericString(m_typeReportFont.FontStrikethrough) + m_oComFunc.GetTokenSeperator(qplObjectLevel2) _
                              + makeBoolToNumericString(m_typeReportFont.FontUnderline) + m_oComFunc.GetTokenSeperator(qplObjectLevel2) _
                    + m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    
    userProfile = userProfile + Trim$(Str$(m_lLimitForLongColumn)) + _
                   m_oComFunc.GetTokenSeperator(qplObjectLevel1)
                   
    'PageSize
    userProfile = userProfile + Trim$(Str$(m_lFetchBlockSize)) + _
                   m_oComFunc.GetTokenSeperator(qplObjectLevel1)
                   
    'Buffersize
    userProfile = userProfile + Trim$(Str$(m_lFetchBufferSize)) + _
                  m_oComFunc.GetTokenSeperator(qplObjectLevel1)
                      
    'Expanded Nodes
    userProfile = userProfile + m_sExpandedNodes + _
                  m_oComFunc.GetTokenSeperator(qplObjectLevel1)
                      
    'RestoreCatalogState
    userProfile = userProfile + makeBoolToNumericString(m_bRestoreCatalogState) + _
                   m_oComFunc.GetTokenSeperator(qplObjectLevel1)
                   
    'set SQLStudio ObjectsSettings
     m_oAppManagment.getDescriptionFromStudioObjects sSQLStudioObjects
    userProfile = userProfile + sSQLStudioObjects + m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    
    
    'ClippedResultView
    userProfile = userProfile + makeBoolToNumericString(m_bClippedResultView) + _
                   m_oComFunc.GetTokenSeperator(qplObjectLevel1)
                   
    'EscapeCharacter
    userProfile = userProfile + m_sEscapeCharacter + _
                   m_oComFunc.GetTokenSeperator(qplObjectLevel1)
                   
    'Representation Of Null Value
    userProfile = userProfile + m_sRepOfNullValue + _
                   m_oComFunc.GetTokenSeperator(qplObjectLevel1)
                   
    'QBEReadOnly
    userProfile = userProfile + makeBoolToNumericString(m_bQBEReadOnly) + _
                   m_oComFunc.GetTokenSeperator(qplObjectLevel1)
                                     
    'ForTextColor
    userProfile = userProfile + Trim$(Str$(m_lForTextColor)) + _
                   m_oComFunc.GetTokenSeperator(qplObjectLevel1)
                   
    'ProtTextColor
    userProfile = userProfile + Trim$(Str$(m_lProtTextColor)) + _
                   m_oComFunc.GetTokenSeperator(qplObjectLevel1)
                                     
    'HighlightColor
    userProfile = userProfile + Trim$(Str$(m_lHighlightColor)) + _
                   m_oComFunc.GetTokenSeperator(qplObjectLevel1)
                   
    'Local Root
    'userProfile = userProfile + m_sLocalRoot + _
    '               m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    'its better to store the local root in the registry and not in the database
    'because if SQL Studio connects to a db from a two different computers
    'the path for the local folder may not fit on both
    writeLocalRoot m_sLocalRoot
    userProfile = userProfile + "" + _
                   m_oComFunc.GetTokenSeperator(qplObjectLevel1)
                   
    'input of filter box for the catalog table folder is converted to uppercase
    userProfile = userProfile + makeBoolToNumericString(m_bCMFilterInputUpper) + _
                   m_oComFunc.GetTokenSeperator(qplObjectLevel1)
                   
    'if rows are copied in the result dailog, they are seperated with tabs
    userProfile = userProfile + makeBoolToNumericString(m_bCopyColumsTabSep) + _
                   m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    
    'if column names in create table dialog are case sensitiv
    userProfile = userProfile + makeBoolToNumericString(m_bIdentifiersCaseSensitiv) + _
                   m_oComFunc.GetTokenSeperator(qplObjectLevel1)
                   
    'if result is copied with column header
    userProfile = userProfile + makeBoolToNumericString(m_bCopyResultWithHeader) + _
                   m_oComFunc.GetTokenSeperator(qplObjectLevel1)
                   
    userProfile = userProfile + m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    
    'save registry value
    saveLocalFolderInd
                   
    'set connection
    Set oDBFunctions.connection = oConnection
    
    'build delete statement
    statement = "DELETE SYSQP_USER_PROFILES WHERE " + Chr$(34) + "UID" + Chr$(34) + " = USERGROUP " '" + Connection.UID + "'"
    
    'execute delete statement
    If Not oDBFunctions.FullExecDirectStmt(statement, Internal) Then Exit Function
    
    'insert new user profile description
    If Not storeUserProfileDescription(oConnection, userProfile) Then Exit Function
    
    'rc
    saveUserProfile = True
    
    Exit Function
    
errSaveUserProfile:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'hidden user profile data is e.g font information
Public Function saveHiddenUserProperties(connection As SQLStudioDBLayer.connection) As Boolean
    On Error GoTo errSaveHiddenUserProperties
    
    Const FUNCTION_NAME = "saveHiddenUserProperties"
    
    Dim userProfile     As String
    Dim NextToken       As String
    Dim sTableFilter    As String
    Dim lRun            As Long
    
    'inits
    saveHiddenUserProperties = False
    
    ' Get user profile description
    If Not getUserProfileDescription(connection, userProfile) Then Exit Function
    
    'Version
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    If Len(NextToken) > 0 Then
    
       If IsNumeric(NextToken) Then
       
            m_lVersion = CLng(NextToken)
       Else
            m_lVersion = 0
            'exit because ist an very,very old userprofile
            Exit Function
       End If
    Else
        m_lVersion = 0
        'exit because ist an very,very old userprofiles
        Exit Function
    End If
        
    ' Get selectTableTypes settings
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_oSelectTableTypes.getTableTypesFromDescription NextToken
    
    ' get Password Options
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_oPasswordOptions.getPasswordOptionsFromDescription NextToken
        
    'Dummy read of User Font
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    
    'ReplaceNonChars
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_bReplaceNonCharsInLongColumn = getBoolValueFromToken(NextToken)
    
    'Confirmation
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_bConfirmation = getBoolValueFromToken(NextToken)
                   
    'Dummy Read of TableFilter
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    If Len(NextToken) > 0 Then

        sTableFilter = NextToken
        While Len(sTableFilter) > 0

            m_oComFunc.GetNextToken sTableFilter, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
        Wend
    End If
    
    'dummy read of Report Font
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    
    'Limit for Long
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    If Len(NextToken) > 0 Then
    
        m_lLimitForLongColumn = Val(Trim$(NextToken))
    Else
        m_lLimitForLongColumn = 1024
    End If
    
    'Fetch Pagesize
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    If Len(NextToken) > 0 Then
    
        m_lFetchBlockSize = Val(Trim$(NextToken))
    Else
        m_lFetchBlockSize = 512
    End If
    
    '''!!!!!!!!!!!!!!!!!!
    m_lFetchBlockSize = 512
    
    'Fetch Buffersize
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    If Len(NextToken) > 0 Then
    
        m_lFetchBufferSize = Val(Trim$(NextToken))
    Else
        m_lFetchBufferSize = 2048
    End If
    
    m_lFetchBufferSize = 2048
    
    'dummy read Expanded Nodes
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    
    'restoreCatalogState
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_bRestoreCatalogState = getBoolValueFromToken(NextToken)
    
    'get appManagment Options
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_oAppManagment.getStudioObjectsFromDescription NextToken
    
    'clippedResultView
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_bClippedResultView = getBoolValueFromToken(NextToken)
    
    'escape character
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    If Len(NextToken) > 0 Then
    
        m_sEscapeCharacter = NextToken
    Else
        m_sEscapeCharacter = "\"
    End If
    
    'RepOfNullValue
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    If Len(NextToken) > 0 Then
    
        m_sRepOfNullValue = NextToken
    Else
        m_sRepOfNullValue = "?"
    End If
    
    'QBEReadOnly
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_bQBEReadOnly = getBoolValueFromToken(NextToken)
    
    'dummy read the three colors
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    
    'dummy read of local root
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    If Len(NextToken) > 0 Then
    
        m_sLocalRoot = NextToken
        'its better to store the local root in the registry and not in the database
        'because if SQL Studio connects to a db from a two different computers
        'the path for the local folder may not fit on both
        writeLocalRoot m_sLocalRoot
    Else
        m_sLocalRoot = readLocalRoot
    End If
        
    'flag, if input of filter box for the catalog table folder is converted to uppercase
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_bCMFilterInputUpper = getBoolValueFromToken(NextToken)
    
    'flag, if columns are seperated with tabs when copied to clipboard
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_bCopyColumsTabSep = getBoolValueFromToken(NextToken)
    
    'flag, if identifiers in create dialogs are case sensitiv
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_bIdentifiersCaseSensitiv = getBoolValueFromToken(NextToken)
    
    'flag, if result is copied with column header
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    m_bCopyResultWithHeader = getBoolValueFromToken(NextToken)
    
    'read this value from registry
    m_bLocalFolderIndependent = isLocalFolderInd()
        
    saveUserProfile connection
        
    'set rc
    saveHiddenUserProperties = True
    
    Exit Function
    
errSaveHiddenUserProperties:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      storeUserProfileDescription
'    description:   stores profile of a sql studio user in database
'    arguments:     [in] oConnection, database connection object pointer
'                   [in] sUserProfile, data to save
'
'    return value:  /
'
'=========================================================================================
Private Function storeUserProfileDescription(oConnection As SQLStudioDBLayer.connection, _
                                             ByVal sUserProfile As String) As Boolean
    On Error GoTo errStoreUserProfileDescription

    Const FUNCTION_NAME = "storeUserProfileDescription"

    '=variables====================================================================
    Dim CmdStr          As String
    Dim hStmt           As Long
    Dim UserProfileLen  As Long
    Dim ParamNo         As Long
    Dim EmptyString     As String
    Dim RC              As Integer
    Dim oDBFunctions     As New SQLStudioDBLayer.Functions
    '===============================================================================

    'rc
    storeUserProfileDescription = False
    
    'init
    EmptyString = ""
    Set oDBFunctions.connection = oConnection
    
    UserProfileLen = Len(sUserProfile)

    'Allocate statement handle
    If Not oDBFunctions.AllocStmt(hStmt) Then Exit Function
        
    '  Insert new user profile
    CmdStr = "INSERT INTO SYSQP_USER_PROFILES ( " + Chr$(34) + "UID" + Chr$(34) + ", PROFILE ) VALUES ( USERGROUP, ?)"
    If Not oDBFunctions.PrepareStmt(hStmt, CmdStr, Internal) Then
    
        Call oDBFunctions.FreeStmt(hStmt)
        Exit Function
    End If
    
    'there is only one param
    ParamNo = 1

    'bind the long parameter
    If Not oDBFunctions.bindBlob(hStmt, ParamNo, 1, UserProfileLen) Then
    
        Call oDBFunctions.FreeStmt(hStmt)
        Exit Function
    End If

    'execute command
    UserProfileLen = SQL_DATA_AT_EXEC
    If Not oDBFunctions.ExecuteStmt(hStmt) Then
    
        Call oDBFunctions.FreeStmt(hStmt)
        Exit Function
    End If

    'fill long column with long value
    RC = oConnection.Error.RC
    While RC = SQL_NEED_DATA
        ' get parameter number
        If Not oDBFunctions.ParamData(hStmt, ParamNo) Then
        
            Call oDBFunctions.FreeStmt(hStmt)
            Exit Function
        End If
        'put data
        RC = oConnection.Error.RC
        If RC = SQL_NEED_DATA Then
            Select Case ParamNo
                Case 1:
                    '  Put long column
                    If Not oDBFunctions.PutBinaryData(hStmt, sUserProfile, Len(sUserProfile)) Then
                    
                        Call oDBFunctions.FreeStmt(hStmt)
                        Exit Function
                    End If

                Case Else
                    '  Put empyt string for the default case
                    If Not oDBFunctions.PutBinaryData(hStmt, EmptyString, Len(EmptyString)) Then
                        Call oDBFunctions.FreeStmt(hStmt)
                        Exit Function
                    End If
            End Select
        End If
    Wend

    'free statement
    Call oDBFunctions.FreeStmt(hStmt)

    'set rc
    storeUserProfileDescription = True

    Exit Function

errStoreUserProfileDescription:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Private Function getUserProfileDescription(oConnection As SQLStudioDBLayer.connection, _
                                           sUserProfile As String) As Boolean
    On Error GoTo errGetUserProfileDescription

    Const FUNCTION_NAME = "GetUserProfileDescription"
    
    '=varibles==========================================
    Dim oResult      As New SQLStudioDBLayer.result
    '===================================================
    
    'rc
    getUserProfileDescription = False
    
    'init
    sUserProfile = ""
       
    Set oResult.connection = oConnection
    
    '  Open result
    If Not oResult.OpenResult("SELECT PROFILE FROM SYSQP_USER_PROFILES WHERE " + Chr$(34) + "UID" + Chr$(34) + " = USERGROUP ", Internal) _
       Then Exit Function
    
    ' get next row
    If Not oResult.Fetch Then Exit Function
    
    If Not oResult.NoRows Then
    
        If Not oResult.GetData() Then Exit Function
        'set user profile
        sUserProfile = oResult.Columns.item(1).ColValue
    End If
        
    getUserProfileDescription = True    'set rc
    
    Exit Function
    
errGetUserProfileDescription:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      Class_Initialize
'    description:   Occurs when an application creates an instance of a Form,
'                   MDIForm, User control, Property Page, Webclass, DHTML Page Designer, or class.
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Class_Initialize()
    On Error GoTo ErrClass_Initialize

    Const FUNCTION_NAME = "Class_Initialize"
    
    Dim lRun          As Long
    
    m_typeUserFont.Name = "MS Sans Serif"
    m_typeUserFont.FontBold = False
    m_typeUserFont.FontItalic = False
    m_typeUserFont.FontSize = 12
    m_typeUserFont.FontStrikethrough = False
    m_typeUserFont.FontUnderline = False
    
    m_typeReportFont.Name = "MS Sans Serif"
    m_typeReportFont.FontBold = False
    m_typeReportFont.FontItalic = False
    m_typeReportFont.FontSize = 9
    m_typeReportFont.FontStrikethrough = False
    m_typeReportFont.FontUnderline = False
        
    m_lLimitForLongColumn = 1024
    m_lFetchBlockSize = 512
    m_lFetchBufferSize = 2048
    m_bRestoreCatalogState = False
    m_bClippedResultView = True
    m_sTableFilter = ""
    m_sExpandedNodes = ""
    
    m_bConfirmation = True
    m_bQBEReadOnly = True
    
    m_sEscapeCharacter = "\"
    m_sRepOfNullValue = "?"
    
    m_lAppVersion = 70200
    m_lVersion = m_lAppVersion
    
    m_bIdentifiersCaseSensitiv = False

    For lRun = 1 To m_colTableFilter.count
    
        m_colTableFilter.remove 1
    Next
    
    m_lForTextColor = 0
    m_lProtTextColor = 12632256
    m_lHighlightColor = RGB(0, 0, 255)
    
    m_sLocalRoot = ""
    
    'input of filter box for the catalog table folder is converted to uppercase
    m_bCMFilterInputUpper = False
    
    m_bCopyColumsTabSep = False
    m_bCopyResultWithHeader = False
    m_bIdentifiersCaseSensitiv = False
    
    Exit Sub
    
ErrClass_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Function getFont(pFont As Font, userProfile As String)
    On Error GoTo errGetFont

    Const FUNCTION_NAME = "GetFont"
    
    Dim NextToken       As String
    Dim sFont           As String


    'Font
    m_oComFunc.GetNextToken userProfile, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel1)
    sFont = NextToken
    
    If Len(sFont) > 0 Then
        m_oComFunc.GetNextToken sFont, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
        pFont.Name = NextToken
    End If
    
    If Len(sFont) > 0 Then
        m_oComFunc.GetNextToken sFont, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
        pFont.FontBold = getBoolValueFromToken(NextToken)
    End If

    If Len(sFont) > 0 Then
        m_oComFunc.GetNextToken sFont, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
        pFont.FontItalic = getBoolValueFromToken(NextToken)
    End If


    If Len(sFont) > 0 Then
        m_oComFunc.GetNextToken sFont, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
        If Len(NextToken) > 0 Then pFont.FontSize = Val(Trim(NextToken))
    End If
    
    If Len(sFont) > 0 Then
        m_oComFunc.GetNextToken sFont, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
        pFont.FontStrikethrough = getBoolValueFromToken(NextToken)
    End If
    
    If Len(sFont) > 0 Then
        m_oComFunc.GetNextToken sFont, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
        pFont.FontUnderline = getBoolValueFromToken(NextToken)
    End If
    
    
    Exit Function
    
errGetFont:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function getTableFilterList(lIndex As Long) As String
    On Error GoTo errGetTableFilterList
    
    Const FUNCTION_NAME = "GetTableFilterList"
    
    
    If lIndex < 1 Or lIndex > m_colTableFilter.count Then
        
        getTableFilterList = ""
        Exit Function
    End If
    
    getTableFilterList = m_colTableFilter.item(lIndex)
        
    Exit Function
    
errGetTableFilterList:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function addTableFilterList(sNewFilter As String)
    On Error GoTo errAddTableFilterList
    
    Const FUNCTION_NAME = "AddTableFilterList"
    
    Dim lRun As Long
    Dim bFound As Boolean
    
    'Init
    bFound = False
    
    While m_colTableFilter.count > 10 And m_colTableFilter.count > 0
    
        m_colTableFilter.remove m_colTableFilter.count
    Wend
    
    For lRun = 1 To m_colTableFilter.count
        If m_colTableFilter.item(lRun) = sNewFilter Then bFound = True
    Next
        
    If bFound = False Then
        
        m_colTableFilter.add sNewFilter
    End If
    
    bFound = True
        
    Exit Function
    
errAddTableFilterList:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Public Function clearFilterList()
    On Error GoTo ErrClearFilterList
    
    Const FUNCTION_NAME = "ClearFilterList"
    
    Dim lRun As Long
      
    While m_colTableFilter.count > 0
    
        m_colTableFilter.remove 1
    Wend
        
    Exit Function
    
ErrClearFilterList:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Property Get escapeCharacter() As String
    On Error GoTo err_Get_EscapeCharacter
    
    Const FUNCTION_NAME = "P_Get escapeCharacter "
    
    ' get property
    escapeCharacter = m_sEscapeCharacter
    
    Exit Property
    
err_Get_EscapeCharacter:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let escapeCharacter(sNewEscapeCharacter As String)
    On Error GoTo err_Let_EscapeCharacter
    
    Const FUNCTION_NAME = "P_LET EscapeCharacter "
    
    'let property
    m_sEscapeCharacter = sNewEscapeCharacter
    
    Exit Property
    
err_Let_EscapeCharacter:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get repOfNullValue() As String
    On Error GoTo err_Get_RepOfNullValue
    
    Const FUNCTION_NAME = "P_Get repOfNullValue "
    
    ' get property
    repOfNullValue = m_sRepOfNullValue
    
    Exit Property
    
err_Get_RepOfNullValue:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let repOfNullValue(sNewRepOfNullValue As String)
    On Error GoTo err_Let_RepOfNullValue
    
    Const FUNCTION_NAME = "P_LET RepOfNullValue "
    
    'let property
    m_sRepOfNullValue = sNewRepOfNullValue
    
    Exit Property
    
err_Let_RepOfNullValue:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get qbeReadOnly() As Boolean
    On Error GoTo err_Get_QBEReadOnly
    
    Const FUNCTION_NAME = "P_Get qbeReadOnly"
    
    ' get property
    qbeReadOnly = m_bQBEReadOnly
    
    Exit Property
    
err_Get_QBEReadOnly:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let qbeReadOnly(bNewQBEReadOnly As Boolean)
    On Error GoTo err_Let_QBEReadOnly
    
    Const FUNCTION_NAME = "P_LET QBEReadOnly"
    
    'let property
    m_bQBEReadOnly = bNewQBEReadOnly
    
    Exit Property
    
err_Let_QBEReadOnly:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Let forTextColor(lNewForTextColor As Long)
    On Error GoTo err_Let_ForTextColor
    
    Const FUNCTION_NAME = "P_LET ForTextColor"
    
    'let property
    m_lForTextColor = lNewForTextColor
    
    Exit Property
    
err_Let_ForTextColor:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get forTextColor() As Long
    On Error GoTo err_Get_ForTextColor
    
    Const FUNCTION_NAME = "P_Get forTextColor"
    
    ' get property
    forTextColor = m_lForTextColor
    
    Exit Property
    
err_Get_ForTextColor:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let highlightColor(lNewHighlightColor As Long)
    On Error GoTo err_Let_HighlightColor
    
    Const FUNCTION_NAME = "P_LET HighlightColor"
    
    'let property
    m_lHighlightColor = lNewHighlightColor
    
    Exit Property
    
err_Let_HighlightColor:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get highlightColor() As Long
    On Error GoTo err_Get_HighlightColor
    
    Const FUNCTION_NAME = "P_Get highlightColor"
    
    ' get property
    highlightColor = m_lHighlightColor
    
    Exit Property
    
err_Get_HighlightColor:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get localRoot() As String
    On Error GoTo err_Get_LocalRoot
    
    Const FUNCTION_NAME = "P_Get localRoot"
    
    ' get property
    localRoot = m_sLocalRoot
    
    Exit Property
    
err_Get_LocalRoot:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let localRoot(sNewLocalRoot As String)
    On Error GoTo err_Let_LocalRoot
    
    Const FUNCTION_NAME = "P_LET LocalRoot"
    
    'let property
    m_sLocalRoot = sNewLocalRoot
    
    Exit Property
    
err_Let_LocalRoot:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      CMFilterInputUpper
'    description:   get if input of filter box for
'                   the catalog table folder is converted to uppercase
'    arguments:     /
'
'    return value:  boolean
'
'=========================================================================================
Public Property Get cmFilterInputUpper() As Boolean
    On Error GoTo err_Get_CMFilterInputUpper
    
    Const FUNCTION_NAME = "P_Get cmFilterInputUpper"
    
    ' get property
    cmFilterInputUpper = m_bCMFilterInputUpper
    
    Exit Property
    
err_Get_CMFilterInputUpper:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      cmFilterInputUpper
'    description:   set if input of filter box for
'                   the catalog table folder is converted to uppercase
'    arguments:     bNewCMFilterInputUpper
'
'    return value:  /
'
'=========================================================================================
Public Property Let cmFilterInputUpper(bNewCMFilterInputUpper As Boolean)
    On Error GoTo err_Let_CMFilterInputUpper
    
    Const FUNCTION_NAME = "P_LET cmFilterInputUpper"
    
    'let property
    m_bCMFilterInputUpper = bNewCMFilterInputUpper
    
    Exit Property
    
err_Let_CMFilterInputUpper:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      copyColumsTabSep
'    description:   if rows are copied in the result dailog, they are seperated with tabs
'    arguments:     /
'
'    return value:  boolean
'
'=========================================================================================
Public Property Get copyColumsTabSep() As Boolean
    On Error GoTo err_Get_CopyColumsTabSep
    
    Const FUNCTION_NAME = "P_Get copyColumsTabSep"
    
    'get property
    copyColumsTabSep = m_bCopyColumsTabSep
    
    Exit Property
    
err_Get_CopyColumsTabSep:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      copyColumsTabSep
'    description:   if rows are copied in the result dailog, they are seperated with tabs'
'    arguments:     bNewCopyColumsTabSep
'
'    return value:  /
'
'=========================================================================================
Public Property Let copyColumsTabSep(bNewCopyColumsTabSep As Boolean)
    On Error GoTo err_Let_CopyColumsTabSep
    
    Const FUNCTION_NAME = "P_LET copyColumsTabSep"
    
    'let property
    m_bCopyColumsTabSep = bNewCopyColumsTabSep
    
    Exit Property
    
err_Let_CopyColumsTabSep:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      createTableColumnsCaseSensitiv
'
'    !!! This property is not valid any more '''
'    !!! Just kept for binary compatibility
'
'    return value:  boolean
'
'=========================================================================================
Public Property Get createTableColumnsCaseSensitiv() As Boolean
    On Error GoTo err_Get_createTableColumnsCaseSensitiv
    
    Const FUNCTION_NAME = "P_Get createTableColumnsCaseSensitiv"
        
    MsgBox LoadResString(416)
    
    Exit Property
    
err_Get_createTableColumnsCaseSensitiv:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let createTableColumnsCaseSensitiv(bNewCreateTableColumnsCaseSensitiv As Boolean)
    On Error GoTo err_Let_createTableColumnsCaseSensitiv
    
    Const FUNCTION_NAME = "P_LET createTableColumnsCaseSensitiv"
    
    MsgBox LoadResString(300)
    
    Exit Property
    
err_Let_createTableColumnsCaseSensitiv:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      identifiersCaseSensitiv
'
'    return value:  boolean
'
'=========================================================================================
Public Property Get identifiersCaseSensitiv() As Boolean
    On Error GoTo err_Get_identifiersCaseSensitiv
    
    Const FUNCTION_NAME = "P_Get identifiersCaseSensitiv"
           
    ' get property
    identifiersCaseSensitiv = m_bIdentifiersCaseSensitiv
    
    Exit Property
    
err_Get_identifiersCaseSensitiv:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let identifiersCaseSensitiv(bNewidentifiersCaseSensitiv As Boolean)
    On Error GoTo err_Let_identifiersCaseSensitiv
    
    Const FUNCTION_NAME = "P_LET identifiersCaseSensitiv"
    
    'let property
    m_bIdentifiersCaseSensitiv = bNewidentifiersCaseSensitiv
    
    Exit Property
    
err_Let_identifiersCaseSensitiv:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get copyResultWithHeader() As Boolean
    On Error GoTo err_Get_copyResultWithHeader
    
    Const FUNCTION_NAME = "P_Get copyResultWithHeader"
    
    ' get property
    copyResultWithHeader = m_bCopyResultWithHeader
    
    Exit Property
    
err_Get_copyResultWithHeader:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let copyResultWithHeader(bNewcopyResultWithHeader As Boolean)
    On Error GoTo err_Let_copyResultWithHeader
    
    Const FUNCTION_NAME = "P_LET copyResultWithHeader"
    
    'let property
    m_bCopyResultWithHeader = bNewcopyResultWithHeader
    
    Exit Property
    
err_Let_copyResultWithHeader:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    function:      readLocalRoot
'    description:   reads the value of local root from the registry
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Function readLocalRoot() As String
    On Error GoTo errReadLocalRoot
    
    Const FUNCTION_NAME = "readLocalRoot"
    
    '=varibles===================================================================
    Dim bReturn      As Boolean
    Dim lKey         As Long
    Dim lDisPos      As Long
    Dim sValue       As String
    Dim sKey         As String
    '============================================================================
    
    sValue = Space$(64)
    sKey = m_oComFunc.getRegBasicKey + LOCAL_ROOT + "\" + NOVERSIONDEP
        
    m_oRegFunc.showErrors = False
    bReturn = m_oRegFunc.openKey(HKEY_CURRENT_USER, sKey, KEY_ALL_ACCESS, lKey)
    
    If bReturn = True Then
    
        bReturn = m_oRegFunc.QueryValueString(lKey, LOCAL_ROOT, sValue, Len(sValue))
        If bReturn Then
            readLocalRoot = Trim(sValue)
        End If
    End If
    
    m_oRegFunc.closeKey sKey, lKey
    
    Exit Function
    
errReadLocalRoot:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      writeLocalRoot
'    description:   writes the value of the local root to the registry
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Function writeLocalRoot(sLocalRoot As String)
    On Error GoTo errWriteLocalRoot
    
    Const FUNCTION_NAME = "writeLocalRoot"
    
    '=varibles===================================================================
    Dim bLOCALROOT   As Boolean
    Dim bReturn      As Boolean
    Dim lKey         As Long
    Dim lDisPos      As Long
    Dim sKey         As String
    Dim oKey         As SQLStudioUtil.Key
    Dim oVal         As SQLStudioUtil.value
    '=============================================================================

    sKey = m_oComFunc.getRegBasicKey + LOCAL_ROOT + "\" + NOVERSIONDEP
        
    m_oRegFunc.showErrors = False
    bReturn = m_oRegFunc.openKey(HKEY_CURRENT_USER, sKey, KEY_ALL_ACCESS, lKey)
        
    If bReturn = False Then _
       bReturn = m_oRegFunc.createKey(HKEY_CURRENT_USER, sKey, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, lKey, lDisPos)
    
    If bReturn = True Then _
       bReturn = m_oRegFunc.setValueString(lKey, LOCAL_ROOT, Trim(sLocalRoot))
    
    m_oRegFunc.closeKey sKey, lKey

    Exit Function
    
errWriteLocalRoot:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function



'=========================================================================================
'    function:      isLocalFolderInd
'    description:   read the value if local folder is db and user independent from the registry
'    arguments:     /
'
'    return value:  true if local folder is db and user independent
'
'=========================================================================================
Private Function isLocalFolderInd() As Boolean
    On Error GoTo errIsLocalFolderInd
    
    Const FUNCTION_NAME = "isLocalFolderInd"
    
    '=varibles===================================================================
    Dim bReturn      As Boolean
    Dim lKey         As Long
    Dim lDisPos      As Long
    Dim sValue       As String
    Dim sKey         As String
    '============================================================================
    
    'rc
    isLocalFolderInd = False
    
    sValue = Space$(64)
    sKey = m_oComFunc.getRegBasicKey + LOCALFOLDERIND + "\" + NOVERSIONDEP
        
    m_oRegFunc.showErrors = False
    bReturn = m_oRegFunc.openKey(HKEY_CURRENT_USER, sKey, KEY_ALL_ACCESS, lKey)
    
    If bReturn = True Then
    
        bReturn = m_oRegFunc.QueryValueString(lKey, LOCALFOLDERIND, sValue, Len(sValue))
        If bReturn Then
            If getBoolValueFromToken(sValue) Then isLocalFolderInd = True
        End If
    End If
    
    m_oRegFunc.closeKey sKey, lKey
    
    Exit Function
    
errIsLocalFolderInd:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Property Get localFolderIndependent() As Boolean
    On Error GoTo err_Get_localFolderIndependent
    
    Const FUNCTION_NAME = "P_Get localFolderIndependent"
    
    ' get property
    localFolderIndependent = m_bLocalFolderIndependent
    
    Exit Property
    
err_Get_localFolderIndependent:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let localFolderIndependent(bLocalFolderIndependent As Boolean)
    On Error GoTo err_Let_localFolderIndependent
    
    Const FUNCTION_NAME = "P_LET localFolderIndependent"
    
    'let property
    m_bLocalFolderIndependent = bLocalFolderIndependent
    
    Exit Property
    
err_Let_localFolderIndependent:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    function:      saveLocalFolderInd
'    description:   writes the value if local folder is db and user independent to the registry
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub saveLocalFolderInd()
    On Error GoTo errsaveLocalFolderInd
    
    Const FUNCTION_NAME = "saveLocalFolderInd"
    
    '=varibles===================================================================
    
    Dim bReturn             As Boolean
    Dim lKey                As Long
    Dim lDisPos             As Long
    Dim sKey                As String
    Dim oKey                As SQLStudioUtil.Key
    Dim oVal                As SQLStudioUtil.value
    '=============================================================================
        
    
    sKey = m_oComFunc.getRegBasicKey + LOCALFOLDERIND + "\" + NOVERSIONDEP
    m_oRegFunc.showErrors = False
    bReturn = m_oRegFunc.openKey(HKEY_CURRENT_USER, sKey, KEY_ALL_ACCESS, lKey)
        
    If bReturn = False Then _
       bReturn = m_oRegFunc.createKey(HKEY_CURRENT_USER, sKey, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, lKey, lDisPos)
    
    If bReturn = True Then _
       bReturn = m_oRegFunc.setValueString(lKey, LOCALFOLDERIND, makeBoolToNumericString(m_bLocalFolderIndependent))
    
    m_oRegFunc.closeKey sKey, lKey

    Exit Sub
    
errsaveLocalFolderInd:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      makeBoolToNumericString
'    description:   helper function to convert a boolean value
'                   to a string with "0" or "1"
'                   boolean values should not be stored with this
'                   expression e.g. Trim$(Str$(m_bRestoreCatalogState))
'                   because on some system convert this value language dependent
'                   Trim$(Str$(m_bRestoreCatalogState)) can be "Wahr" instead of "True"
'                   This will cause a type mismatch error
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Function makeBoolToNumericString(bValue As Boolean) As String
    On Error GoTo errMakeBoolToNumericString
    
    Const FUNCTION_NAME = "makeBoolToNumericString"
    
    If bValue Then
        makeBoolToNumericString = "1"
    Else
        makeBoolToNumericString = "0"
    End If

    Exit Function
    
errMakeBoolToNumericString:
    internalError Err, MODULE_NAME, FUNCTION_NAME

End Function
'=========================================================================================
'    function:      getBoolValueFromToken
'    description:   helper function to get a boolean value from the userprofile
'
'                   boolean values should not be stored with this
'                   expression e.g. Trim$(Str$(m_bRestoreCatalogState))
'                   because on some system convert this value language dependent
'                   Trim$(Str$(m_bRestoreCatalogState)) can be "Wahr" instead of "True"
'                   This will cause a type mismatch error
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Function getBoolValueFromToken(sValue As String) As Boolean
    On Error GoTo errGetBoolValueFromToken
    
    Const FUNCTION_NAME = "getBoolValueFromToken"
    
    'rc
    getBoolValueFromToken = False
    
    If Len(sValue) < 1 Then
        getBoolValueFromToken = False
        Exit Function
    End If
            
    'first check the value from the old userprofile
    If sValue = Trim$(CStr(True)) Then
        getBoolValueFromToken = True
        Exit Function
    End If
    
    If sValue = Trim$(CStr(False)) Then
        getBoolValueFromToken = False
        Exit Function
    End If
    
    'try german
    If sValue = "Wahr" Then
        getBoolValueFromToken = True
        Exit Function
    End If
    
    If sValue = "Falsch" Then
        getBoolValueFromToken = False
        Exit Function
    End If
    
    '!!! other languages may be added !!!
    
    
    'now check then new values
    If sValue = "1" Then
        getBoolValueFromToken = True
        Exit Function
    End If
    
    If sValue = "0" Then
        getBoolValueFromToken = False
        Exit Function
    End If
    
    

    Exit Function
    
    
errGetBoolValueFromToken:
    internalError Err, MODULE_NAME, FUNCTION_NAME

End Function
