Attribute VB_Name = "Core"
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Module:  Core.bas
'
'-----------------------------------------------------------------------
'
' responsible:  WolfgangA
'
' special area: SQL Studio Query Controls
'
' description:  module for Function imports, constants ...
'
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


Option Explicit

'module name
Const MODULE_NAME = "core"

'Structure used for data type conversion
Public Type ConvertData
    iSegmentSize    As Long
    iCurrentPos     As Long
    iLength         As Long
    sInString       As String
    sOutString      As String
End Type


'=public const=====================================
Public Const SPI_GETDEFAULTINPUTLANG = 89

'Segment size for segmented data type conversion
Public Const SEGMENT_SIZE = 4096

Public Const SB_ENDSCROLL = &H8
Public Const SB_BOTTOM = &H7
Public Const WM_VSCROLL = &H115

 'maximum char for a cell
Public Const qpMaxCharsInColumn = 100

Public Const SQL_DATA_AT_EXEC = -2
Public Const SQL_NEED_DATA = 99
Public Const SQL_SUCCESS = 0

Public Const SQL_FETCH_NEXT = 1
Public Const SQL_FETCH_FIRST = 2
Public Const SQL_FETCH_LAST = 3
Public Const SQL_FETCH_PREV = 4
Public Const SQL_FETCH_ABSOLUTE = 5
Public Const SQL_FETCH_RELATIVE = 6

Public Const MX_LONG_COLUMN_VALUE = 4096
Public Const MX_LONG_COLUMN_VALUE_EXPORT = 32786
Public Const MX_LONG_COLUMN_VALUE_CLIPBOARD = 1048576

Public Const VK_ESCAPE = &H1B
Public Const VK_PRIOR = &H21 'page up key
Public Const VK_NEXT = &H22  'page down key
Public Const VK_END = &H23 'end key
Public Const VK_HOME = &H24 'home key
Public Const VK_LEFT = &H25 'left arrow key
Public Const VK_UP = &H26 ' up arrow key
Public Const VK_RIGHT = &H27 ' right arrow key
Public Const VK_DOWN = &H28 ' down arrow key

Public Const MF_BYPOSITION = &H400&
Public Const MF_REMOVE = &H1000&

'=imported functions=====================================================================================================================
Declare Function GetSystemMenu Lib "user32" (ByVal hWnd As Long, ByVal bRevert As Long) As Long
Declare Function GetMenuItemCount Lib "user32" (ByVal hMenu As Long) As Long
Declare Function DrawMenuBar Lib "user32" (ByVal hWnd As Long) As Long
Declare Function RemoveMenu Lib "user32" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long) As Long

Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer

Declare Function SystemParametersInfoA Lib "user32" ( _
                        ByVal uAction As Long, _
                        ByVal uparam As Long, _
                        lpvParam As Any, _
                        ByVal fuWinIni As Long) As Long


Declare Function asciiToHexSegmented Lib "StudioUtil" _
                        (inData As ConvertData) As Long

Declare Function LockWindowUpdate Lib "user32" (ByVal hwndLock As Long) As Long
                               

'================================================================================================================================



