VERSION 5.00
Begin VB.Form frmCustomizeResult 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Customize Result"
   ClientHeight    =   3195
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picMaster 
      Height          =   1590
      Left            =   0
      ScaleHeight     =   1530
      ScaleWidth      =   4575
      TabIndex        =   5
      Top             =   0
      Width           =   4635
      Begin VB.CheckBox chkColVisible 
         Caption         =   "Visible"
         Height          =   315
         Index           =   0
         Left            =   20
         TabIndex        =   1
         Top             =   20
         Visible         =   0   'False
         Width           =   825
      End
      Begin VB.TextBox txtColName 
         Height          =   320
         Index           =   0
         Left            =   945
         MaxLength       =   255
         TabIndex        =   2
         Top             =   0
         Visible         =   0   'False
         Width           =   3210
      End
      Begin VB.VScrollBar vsbColumns 
         Height          =   1500
         LargeChange     =   5
         Left            =   4305
         Min             =   1
         TabIndex        =   6
         TabStop         =   0   'False
         Top             =   0
         Value           =   1
         Width           =   270
      End
      Begin VB.Label lblColumn 
         Height          =   375
         Index           =   0
         Left            =   10
         TabIndex        =   7
         Top             =   0
         Visible         =   0   'False
         Width           =   1215
      End
   End
   Begin VB.TextBox txtFixedColumns 
      Height          =   315
      Left            =   1770
      MaxLength       =   3
      TabIndex        =   0
      Text            =   "0"
      Top             =   2805
      Width           =   750
   End
   Begin VB.CommandButton cmdOk 
      Caption         =   "&Ok"
      Default         =   -1  'True
      Height          =   375
      Left            =   3450
      TabIndex        =   3
      Top             =   2760
      Width           =   1185
   End
   Begin VB.Label lblFixdCols 
      Caption         =   "Fixed Columns:"
      Height          =   210
      Left            =   45
      TabIndex        =   4
      Top             =   2850
      Width           =   1110
   End
End
Attribute VB_Name = "frmCustomizeResult"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Module: frmCustomizeResult.frm
'
'-----------------------------------------------------------------------
'
' responsible:  WolfgangA
'
' special area: SQL Studio Controls
'
' description:  show a dailog to customize result view
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit


'--------------------------------------------------------
'module name
'--------------------------------------------------------
Const MODULE_NAME = "frmCustomizeResult"

Private m_oResult              As SQLStudioDBLayer.result


Private m_bOK                  As Boolean

Private m_nFixedCols           As Integer
'=========================================================================================
'    Property:      OK
'    description:   Get if dialog was terminated by pressing ok button
'    arguments:     /
'
'
'    return value:  see description
'
'=========================================================================================
Public Property Get oK() As Boolean
    On Error GoTo errP_Get_OK

    Const FUNCTION_NAME = "P_Get oK"
    
    oK = m_bOK
    
    Exit Property
    
errP_Get_OK:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    Property:      fixedCols
'    description:   Get the number of fixed cols enterd by user
'    arguments:     /
'
'
'    return value:  see description
'
'=========================================================================================
Public Property Get fixedCols() As Integer
    On Error GoTo errP_Get_fixedCols

    Const FUNCTION_NAME = "P_Get fixedCols"
    
    fixedCols = m_nFixedCols
    
    Exit Property
    
errP_Get_fixedCols:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    function:      chkColVisible_Click
'    description:   the visible check box button was clicked
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub chkColVisible_Click(Index As Integer)
 On Error GoTo errChkColVisible_Click

    Const FUNCTION_NAME = "chkColVisible_Click"
    
    Dim lRun As Long
    Dim bOneIsVisible As Boolean
    
    'init
    bOneIsVisible = False
    
    'if number of items is less the number of columns
    'click event is triggered by loadColumns Function and must be ignored
    If chkColVisible.Count - 1 < m_oResult.colCount Then Exit Sub
    
    If chkColVisible.Item(Index) = vbUnchecked Then
    
        'at least one column has to be visible
        For lRun = 1 To chkColVisible.Count - 1
        
            If chkColVisible.Item(lRun).Value = vbChecked Then
            
                bOneIsVisible = True
                Exit For
            End If
        Next
        If bOneIsVisible = False Then
        
            chkColVisible.Item(Index).Value = vbChecked
            MsgBox LoadResString(102), vbCritical
        End If
    End If
    
    Exit Sub
    
errChkColVisible_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      ..._Load
'    description:   Occurs when a form is loaded.
'                   For a startup form, occurs when an application starts as
'                   the result of a Load statement or as the result of a
'                   reference to an unloaded form's properties or controls.
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Load()
    On Error GoTo errForm_Load

    Const FUNCTION_NAME = "Form_Load"
    
    m_bOK = False
    m_nFixedCols = 0
    
    Exit Sub
    
errForm_Load:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub

'=========================================================================================
'    function:      ..._QueryUnload
'    description:   Occurs before a form or application closes.
'    arguments:     [out] cancel,  setting this argument to any value other than 0 stops the QueryUnload event in all loaded forms and stops the form and application from closing.
'                   [in] unloadmode,a value or constant indicating the cause of the QueryUnload event, as described in Return Values.
'                                   {vbFormControlMenu ,vbFormCode,vbAppWindows,vbAppTaskManager,vbFormMDIForm,vbFormOwner }
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    On Error GoTo errForm_QueryUnload

    Const FUNCTION_NAME = "Form_QueryUnload"
    
    Dim lRun As Long
    
    'unload objects
    For lRun = 1 To txtColName.Count - 1
    
        Unload chkColVisible(lRun)
        Unload txtColName(lRun)
    Next
    
    Exit Sub
    
errForm_QueryUnload:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._Resize
'    description:   Occurs when an object is first displayed or when the window state of an object changes.
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Resize()
    On Error GoTo errForm_Resize

    Const FUNCTION_NAME = "Form_Resize"

    resizeControls

    Exit Sub

errForm_Resize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._KeyDown
'    description:   Occurs when the user presses (KeyDown)  a key while an object has the focus.
'    arguments:     [in] KeyCode, a key code, such as vbKeyF1 (the F1 key) or vbKeyHome (the HOME key).
'                   [in] Shift, an integer that corresponds to the state of the SHIFT, CTRL, and ALT keys at the time of the event.
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errForm_KeyDown

    Const FUNCTION_NAME = "Form_KeyDown"
    
    If KeyCode = vbKeyEscape Then Me.Hide
    
    Exit Sub
    
errForm_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      resizeControls
'    description:   place all elements of control due to new size
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub resizeControls()
    On Error GoTo errResizeControls

    Const FUNCTION_NAME = "resizeControls"
    
    cmdOk.Move Me.Width - 10 * cmdOk.Width / 9, Me.Height - 5 * cmdOk.Height / 2
    lblFixdCols.Move 50, cmdOk.Top + lblFixdCols.Height / 2
    txtFixedColumns.Move lblFixdCols.Left + lblFixdCols.Width, lblFixdCols.Top
    
    picMaster.Move 20, 20, Me.Width - 20, cmdOk.Top - 100
    vsbColumns.Move Me.Width - 3 * vsbColumns.Width \ 2 - 5, 0, vsbColumns.Width - 10, picMaster.Height - 50
    
    If picMaster.Height > 200 Then
    
        If txtColName.Count > 0 Then
        
            If txtColName(1).Top < 0 Or _
               picMaster.Height < txtColName(txtColName.Count - 1).Top + 2 * txtColName(0).Height _
            Then
                vsbColumns.Visible = True
            Else
                vsbColumns.Visible = False
            End If
        Else
            vsbColumns.Visible = False
        End If
    Else
        vsbColumns.Visible = False
    End If
    
    calculateScrollbarValue
    
    Exit Sub
    
errResizeControls:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    property:      result
'    description:   sets a result object
'    arguments:     NewResult
'
'    return value:  /
'
'=========================================================================================
Public Property Set result(ByVal NewResult As SQLStudioDBLayer.result)
    On Error GoTo errP_SET_Result

    Const FUNCTION_NAME = "P_SET Result"
    
    Set m_oResult = NewResult
       
                
    Exit Property
    
errP_SET_Result:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
'=========================================================================================
'    property:      result
'    description:   Get the result object
'    arguments:     /
'
'    return value:  a result object
'
'=========================================================================================
Private Property Get result() As SQLStudioDBLayer.result
    On Error GoTo errP_Get_Result

    Const FUNCTION_NAME = "P_Get result"
    
    result = m_oResult
    
    Exit Property
    
errP_Get_Result:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

'=========================================================================================
'    function:      calculateScrollbarValue
'    description:   calculate scrollbars of detail pane
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub calculateScrollbarValue()
    On Error GoTo errCalculateScrollbarValue
    
    Const FUNCTION_NAME = "calculateScrollbarValue"
    
    Dim VisibleColumns      As Integer
    Dim UnvisibleColumns    As Integer
    Dim NewMaxValue         As Integer
    
    'inits
    NewMaxValue = 2 * txtColName.Count \ 3
    
    If NewMaxValue < 1 Then
    
        vsbColumns.Max = 1
    Else
        vsbColumns.Max = NewMaxValue
    End If
    
    Exit Sub
    
errCalculateScrollbarValue:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._KeyPress
'    description:   Occurs when the user presses and releases an ANSI key.
'    arguments:     [in] KeyAscii, an integer that returns a standard numeric ANSI keycode. Keyascii is passed by reference;
'                                  changing it sends a different character to the object.
'                                  changing keyascii to 0 cancels the keystroke so the object receives no character.
'
'    return value:  /
'
'=========================================================================================
Private Sub txtFixedColumns_KeyPress(KeyAscii As Integer)
    On Error GoTo errTxtFixedColumns_KeyPress
    
    Const FUNCTION_NAME = "txtFixedColumns_KeyPress"
    
    If (KeyAscii > 47 And KeyAscii < 58) Or _
        KeyAscii < 31 Or _
        KeyAscii = 44 Or _
        KeyAscii = 46 _
    Then
       Exit Sub
    End If
    
    KeyAscii = 0
        
    Exit Sub
    
errTxtFixedColumns_KeyPress:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._Change
'    description:   Indicates the contents of a control or
'                   a property value have changed.
'                   How and when this event occurs varies with the control
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub vsbColumns_Change()
    On Error GoTo ErrvsbColumns_Change
    
    Const FUNCTION_NAME = "vsbColumns_Change"
    
    Dim lRun    As Long
    
    For lRun = 1 To txtColName.Count - 1
        
        txtColName(lRun).Top = (lRun - vsbColumns.Value) * _
                                        (chkColVisible(lRun).Height + 60)
        chkColVisible(lRun).Top = txtColName(lRun).Top
    Next
    
    Exit Sub
    
ErrvsbColumns_Change:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      cmdOk_Click
'    description:   the ok button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdOk_Click()
    On Error GoTo errCmdOk_Click
   
    Const FUNCTION_NAME = "cmdOK_Click"
    
    Dim nVisible As Integer
    Dim lRun     As Long
    Dim nMax     As Integer
    
    'value user entered in dialog, my differ from m_nFixedCols
    Dim nFixColDialog As Integer
    
    'init
    m_bOK = True
    
    If (IsNumeric(txtFixedColumns)) Then
        nFixColDialog = CInt(txtFixedColumns)
    Else
        MsgBox LoadResString(100), vbCritical
        txtFixedColumns.SelStart = 0
        txtFixedColumns.SelLength = Len(txtFixedColumns)
        txtFixedColumns.SetFocus
        Exit Sub
    End If
    
    If nFixColDialog < 0 Then
    
        MsgBox LoadResString(100), vbCritical
        txtFixedColumns.SelStart = 0
        txtFixedColumns.SelLength = Len(txtFixedColumns)
        txtFixedColumns.SetFocus
        Exit Sub
    End If
    
    m_nFixedCols = nFixColDialog
    
    'get visible columns
    For lRun = 1 To txtColName.Count - 1
    
        If m_oResult.Columns(lRun).colName <> txtColName(lRun) Then _
            m_oResult.Columns(lRun).colName = txtColName(lRun)
            
        If chkColVisible.Item(lRun).Value = vbChecked Then
        
            nVisible = nVisible + 1
            m_oResult.Columns(lRun).colDisplayVisible = True
        Else
            m_oResult.Columns(lRun).colDisplayVisible = False
            'if ncolumn is not visible, increase m_nFixedCols because
            'flexgrid will count invisble (width = 0) column as valid
            'fix column, but user wants only visible columns to be fixed
            If lRun <= m_nFixedCols Then
                m_nFixedCols = m_oComFunc.Min(m_nFixedCols + 1, m_oResult.colCount - 1)
            End If
        End If
    Next
        
    nMax = m_oComFunc.Min(nVisible - 1, m_oResult.colCount - 1)
    If nFixColDialog > nMax Then
    
        MsgBox LoadResString(101) + Str(nMax), vbCritical
        txtFixedColumns.SelStart = 0
        txtFixedColumns.SelLength = Len(txtFixedColumns)
        txtFixedColumns.SetFocus
        Exit Sub
    End If
            
    Me.Hide
                
    Exit Sub
    
errCmdOk_Click:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      loadColumns
'    description:   load columns of result into dialog
'
'    arguments:     [in] fixedCols, fixed columns of result
'                   the value for fixed columns is a parameter of the function loadColumns
'                   because if set with let property fixedCols the value m_nFixedCols
'                   can be overwritten in onload event of form
'
'    return value:  /
'
'=========================================================================================
Public Function loadColumns(fixedCols As Integer)
    On Error GoTo errLoadColumns
    
    Const FUNCTION_NAME = "loadColumns"
    
    '=local varibles========================
    Dim nCol        As Integer
    Dim nNotVisible As Integer
    '=======================================
    
    If m_oResult Is Nothing Then Exit Function
    
    'init
    nNotVisible = 0
    For nCol = 1 To m_oResult.colCount
        
        'may trigger on load event
        Load chkColVisible(nCol)
        Load txtColName(nCol)
        chkColVisible.Item(nCol).Value = vbChecked
        txtColName.Item(nCol).Text = m_oResult.Columns.Item(nCol).colName
        
        'position new objects
        chkColVisible(nCol).Top = _
                        (nCol - 1) * _
                        (chkColVisible(nCol - 1).Height + 60)
        txtColName(nCol).Top = chkColVisible(nCol).Top
        
        txtColName.Item(nCol).Visible = True
        chkColVisible.Item(nCol).Visible = True
        
        If m_oResult.Columns(nCol).colDisplayVisible = True Then
            
            chkColVisible.Item(nCol).Value = vbChecked
        Else
            chkColVisible.Item(nCol).Value = vbUnchecked
        End If
    Next
    
    'result needs at least 2 columns to fix one of them
    If m_oResult.colCount < 2 Then
    
        txtFixedColumns.Enabled = False
        chkColVisible.Item(1) = vbChecked
        chkColVisible.Item(1).Enabled = False
    End If
    
    m_nFixedCols = fixedCols
    'get visible columns see cmdOK_Click
    For nCol = 1 To m_oResult.colCount
            
        If nCol < m_nFixedCols And m_oResult.Columns(nCol).colDisplayVisible = False Then
            nNotVisible = nNotVisible + 1
        End If
    Next
    'remove one more column for row count column which is fixed too
    m_nFixedCols = m_nFixedCols - nNotVisible - 1
    
    txtFixedColumns = Trim(Str(m_nFixedCols))
    txtFixedColumns.SelStart = Len(txtFixedColumns)
    txtFixedColumns.SelLength = Len(txtFixedColumns)
    
    calculateScrollbarValue
    
    Exit Function
    
errLoadColumns:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

