VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Join"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Friend License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Friend License for more details.
'
' You should have received a copy of the GNU General Friend License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  Class:      Join
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'module name
Const MODULE_NAME = "Join"

'  Friend enum definitions
Public Enum joinType

    JoinTypeNormal = 0
    JoinTypeLeftOuter = 1
    JoinTypeRightOuter = 2
    JoinTypeBothOuter = 3
End Enum

'  Private properties
Private m_enumJoinType        As joinType
Private m_sCompareOperator    As String
Private m_sLeftTableOwner     As String
Private m_sLeftTableName      As String
Private m_sLeftRefTableName   As String
Private m_sLeftColumnName     As String
Private m_sRightTableOwner    As String
Private m_sRightRefTableName  As String
Private m_sRightTableName     As String
Private m_sRightColumnName    As String
Private m_oLeftTable          As SQLStudioCCon.QTable
Private m_oLeftColumn         As SQLStudioCCon.Column
Private m_oRightTable         As SQLStudioCCon.QTable
Private m_oRightColumn        As SQLStudioCCon.Column
Private m_oJoinLine           As Line
Private m_oLeftConnector      As Shape
Private m_oRightConnector     As Shape
Private m_nIndex              As Integer

Friend Property Let compareOperator(ByVal NewCompareOperator As String)
    On Error GoTo Err_LET_CompareOperator
    
    Const FUNCTION_NAME = "P_LET CompareOperator"
    
    
    'set property
    m_sCompareOperator = NewCompareOperator
    
    Exit Property
    
Err_LET_CompareOperator:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Property Get compareOperator() As String
    On Error GoTo Err_GET_CompareOperator
    
    Const FUNCTION_NAME = "P_Get compareOperator"
    
    ' Get property
    compareOperator = m_sCompareOperator
    
    Exit Property
    
Err_GET_CompareOperator:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Let joinType(ByVal NewJoinType As joinType)
    On Error GoTo Err_LET_JoinType
    
    Const FUNCTION_NAME = "P_LET JoinType"
    
    'set property
    m_enumJoinType = NewJoinType
    
    Exit Property
    
Err_LET_JoinType:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Get joinType() As joinType
    On Error GoTo Err_GET_JoinType
    
    Const FUNCTION_NAME = "P_Get JoinType"
    
    ' Get property
    joinType = m_enumJoinType
    
    Exit Property
    
Err_GET_JoinType:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Let leftTableName(ByVal NewLeftTableName As String)
    On Error GoTo Err_LET_LeftTableName
    
    Const FUNCTION_NAME = "P_LET LeftTableName"
    
    'set property
    m_sLeftTableName = NewLeftTableName
    
    Exit Property
    
Err_LET_LeftTableName:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Get leftTableName() As String
    On Error GoTo Err_GET_LeftTableName
    
    Const FUNCTION_NAME = "P_Get leftTableName"
    
    ' Get property
    leftTableName = m_sLeftTableName
    
    Exit Property
    
Err_GET_LeftTableName:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Let leftTableOwner(ByVal NewLeftTableOwner As String)
    On Error GoTo Err_LET_LeftTableOwner
    
    Const FUNCTION_NAME = "P_LET LeftTableOwner"
    
    'set property
    m_sLeftTableOwner = NewLeftTableOwner
    
    Exit Property
    
Err_LET_LeftTableOwner:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Get leftTableOwner() As String
    On Error GoTo Err_GET_LeftTableOwner
    
    Const FUNCTION_NAME = "P_Get leftTableOwner"
    
    ' Get property
    leftTableOwner = m_sLeftTableOwner
    
    Exit Property
    
Err_GET_LeftTableOwner:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Let leftColumnName(ByVal NewLeftColumnName As String)
    On Error GoTo Err_LET_LeftColumnName
    
    Const FUNCTION_NAME = "P_LET LeftColumnName"
    
    'set property
    m_sLeftColumnName = NewLeftColumnName
    
    Exit Property
    
Err_LET_LeftColumnName:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Property Get leftColumnName() As String
    On Error GoTo Err_GET_LeftColumnName
    
    Const FUNCTION_NAME = "P_Get leftColumnName"
    
    ' Get property
    leftColumnName = m_sLeftColumnName
    
    Exit Property
    
Err_GET_LeftColumnName:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Let rightTableName(ByVal NewRightTableName As String)
    On Error GoTo Err_LET_RightTableName
    
    Const FUNCTION_NAME = "P_Let rightTableName"
    
    'set property
    m_sRightTableName = NewRightTableName
    
    Exit Property
    
Err_LET_RightTableName:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Property Get rightRefTableName() As String
    On Error GoTo Err_GET_RightRefTableName
    
    Const FUNCTION_NAME = "P_Get rightRefTableName"
    
    ' Get property
    rightRefTableName = m_sRightRefTableName
    
    Exit Property
    
Err_GET_RightRefTableName:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Let rightRefTableName(ByVal NewRightRefTableName As String)
    On Error GoTo Err_LET_RightTableName
    
    Const FUNCTION_NAME = "P_Let rightRefTableName"
    
    'set property
    m_sRightRefTableName = NewRightRefTableName
    
    Exit Property
    
Err_LET_RightTableName:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Get rightTableName() As String
    On Error GoTo Err_GET_RightTableName
    
    Const FUNCTION_NAME = "P_Get rightTableName"
    
    ' Get property
    rightTableName = m_sRightTableName
    
    Exit Property
    
Err_GET_RightTableName:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Property Let rightTableOwner(ByVal NewRightTableOwner As String)
    On Error GoTo Err_LET_RightTableOwner
    
    Const FUNCTION_NAME = "P_Let rightTableOwner"
    
    'set property
    m_sRightTableOwner = NewRightTableOwner
    
    Exit Property
    
Err_LET_RightTableOwner:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Property Get rightTableOwner() As String
    On Error GoTo Err_GET_RightTableOwner
    
    Const FUNCTION_NAME = "P_Get rightTableOwner"
    
    ' Get property
    rightTableOwner = m_sRightTableOwner
    
    Exit Property
    
Err_GET_RightTableOwner:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Let rightColumnName(ByVal NewRightColumnName As String)
    On Error GoTo Err_LET_RightColumnName
    
    Const FUNCTION_NAME = "P_Let rightColumnName"
    
    'set property
    m_sRightColumnName = NewRightColumnName
    
    Exit Property
    
Err_LET_RightColumnName:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Get rightColumnName() As String
    On Error GoTo Err_GET_RightColumnName
    
    Const FUNCTION_NAME = "P_Get rightColumnName"
    
    ' Get property
    rightColumnName = m_sRightColumnName
    
    Exit Property
    
Err_GET_RightColumnName:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Get leftRefTableName() As String
    On Error GoTo Err_GET_LeftRefTableName
    
    Const FUNCTION_NAME = "P_Get leftRefTableName"
    
    ' Get property
    leftRefTableName = m_sLeftRefTableName
    
    Exit Property
    
Err_GET_LeftRefTableName:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Let leftRefTableName(ByVal NewLeftRefTableName As String)
    On Error GoTo Err_LET_LeftTableName
    
    Const FUNCTION_NAME = "P_LET LeftRefTableName"
    
    'set property
    m_sLeftRefTableName = NewLeftRefTableName
    
    Exit Property
    
Err_LET_LeftTableName:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Property Set leftTable(NewLeftTable As SQLStudioCCon.QTable)
    On Error GoTo err_SET_LeftTable
    
    Const FUNCTION_NAME = "P_SET LeftTable"
    
    'set property
    Set m_oLeftTable = NewLeftTable
    
    Exit Property
    
err_SET_LeftTable:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Get leftTable() As SQLStudioCCon.QTable
    On Error GoTo Err_GET_LeftTable
    
    Const FUNCTION_NAME = "P_Get leftTable"
    
    'Get property
    Set leftTable = m_oLeftTable
    
    Exit Property
    
Err_GET_LeftTable:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Set leftColumn(NewLeftColumn As SQLStudioCCon.Column)
    On Error GoTo err_SET_LeftColumn
    
    Const FUNCTION_NAME = "P_SET LeftColumn"
    
    'set property
    Set m_oLeftColumn = NewLeftColumn
    
    Exit Property
    
err_SET_LeftColumn:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Get leftColumn() As SQLStudioCCon.Column
    On Error GoTo Err_GET_LeftColumn
    
    Const FUNCTION_NAME = "P_Get leftColumn"
    
    ' Get property
    Set leftColumn = m_oLeftColumn
    
    Exit Property
    
Err_GET_LeftColumn:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Set rightTable(NewRightTable As SQLStudioCCon.QTable)
    On Error GoTo err_SET_RightTable
    
    Const FUNCTION_NAME = "P_SET RightTable"
    
    'set property
    Set m_oRightTable = NewRightTable
    
    Exit Property
    
err_SET_RightTable:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Property Get rightTable() As SQLStudioCCon.QTable
    On Error GoTo Err_GET_RightTable
    
    Const FUNCTION_NAME = "P_Get rightTable"
    
    ' Get property
    Set rightTable = m_oRightTable
    
    Exit Property
    
Err_GET_RightTable:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Set rightColumn(NewRightColumn As SQLStudioCCon.Column)
    On Error GoTo err_SET_RightColumn
    
    Const FUNCTION_NAME = "P_SET RightColumn"
    
    'set property
    Set m_oRightColumn = NewRightColumn
    
    Exit Property
    
err_SET_RightColumn:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Property Get rightColumn() As Object
    On Error GoTo Err_GET_RightColumn
    
    Const FUNCTION_NAME = "P_Get rightColumn"
    
    ' Get property
    Set rightColumn = m_oRightColumn
    
    Exit Property
    
Err_GET_RightColumn:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Set joinLine(NewJoinLine As Object)
    On Error GoTo err_SET_JoinLine
    
    Const FUNCTION_NAME = "P_Set joinLine"
    
    'set property
    Set m_oJoinLine = NewJoinLine
    
    Exit Property
    
err_SET_JoinLine:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Get joinLine() As Object
    On Error GoTo Err_GET_JoinLine
    
    Const FUNCTION_NAME = "P_Get JoinLine"
    
    ' Get property
    Set joinLine = m_oJoinLine
    
    Exit Property
    
Err_GET_JoinLine:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Property Set leftConnector(NewLeftConnector As Object)
    On Error GoTo err_SET_LeftConnector
    
    Const FUNCTION_NAME = "P_SET LeftConnector"
    
    'set property
    Set m_oLeftConnector = NewLeftConnector
    
    Exit Property
    
err_SET_LeftConnector:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Get leftConnector() As Object
    On Error GoTo Err_GET_LeftConnector
    
    Const FUNCTION_NAME = "P_Get leftConnector"
    
    ' Get property
    Set leftConnector = m_oLeftConnector
    
    Exit Property
    
Err_GET_LeftConnector:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Set rightConnector(NewRightConnector As Object)
    On Error GoTo err_SET_RightConnector
    
    Const FUNCTION_NAME = "P_SET RightConnector"
    
    'set property
    Set m_oRightConnector = NewRightConnector
    
    Exit Property
    
err_SET_RightConnector:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Get rightConnector() As Object
    On Error GoTo Err_GET_RightConnector
    
    Const FUNCTION_NAME = "P_Get rightConnector"
    
    ' Get property
    Set rightConnector = m_oRightConnector
    
    Exit Property
    
Err_GET_RightConnector:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Let Index(ByVal NewIndex As Integer)
    On Error GoTo Err_LET_Index
    
    Const FUNCTION_NAME = "P_LET Index"
    
    'set property
    m_nIndex = NewIndex
    
    Exit Property
    
Err_LET_Index:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Get Index() As Integer
    On Error GoTo Err_GET_Index
    
    Const FUNCTION_NAME = "P_Get index"
    
    ' Get property
    Index = m_nIndex
    
    Exit Property
    
Err_GET_Index:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Function draw() As Boolean
    On Error GoTo errDraw
    
    Const FUNCTION_NAME = "Draw"
    
    Dim LeftColumnPosX  As Single
    Dim LeftColumnPosY  As Single
    Dim RightColumnPosX As Single
    Dim RightColumnPosY As Single
    
    Dim clsColumnTemp         As SQLStudioCCon.Column
    Dim clsTableTemp          As SQLStudioCCon.QTable
    
    'inits
    draw = False
   
    If m_oLeftTable.Left > m_oRightTable.Left Then
        Set clsColumnTemp = m_oRightColumn
        Set m_oRightColumn = m_oLeftColumn
        Set m_oLeftColumn = clsColumnTemp

        Set clsTableTemp = m_oRightTable
        Set m_oRightTable = m_oLeftTable
        Set m_oLeftTable = clsTableTemp
    End If

    'set left column positions
    m_oLeftColumn.GetRightPos LeftColumnPosX, LeftColumnPosY
    'set right column positions
    m_oRightColumn.GetLeftPos RightColumnPosX, RightColumnPosY

    'set position of join connectors
    m_oLeftConnector.Left = LeftColumnPosX
    If LeftColumnPosY - (m_oLeftConnector.Height \ 2) <= m_oLeftTable.Top Then
        m_oLeftConnector.Top = m_oLeftTable.Top
    ElseIf LeftColumnPosY + (m_oLeftConnector.Height \ 2) >= m_oLeftTable.Top + m_oLeftTable.Height Then
        m_oLeftConnector.Top = m_oLeftTable.Top + m_oLeftTable.Height - m_oLeftConnector.Height
    Else
        m_oLeftConnector.Top = LeftColumnPosY - (m_oLeftConnector.Height \ 2)
    End If

    m_oRightConnector.Left = RightColumnPosX - m_oRightConnector.Width
    If RightColumnPosY - (m_oRightConnector.Height \ 2) <= m_oRightTable.Top Then
        m_oRightConnector.Top = m_oRightTable.Top
    ElseIf RightColumnPosY + (m_oRightConnector.Height \ 2) >= m_oRightTable.Top + m_oRightTable.Height Then
        m_oRightConnector.Top = m_oRightTable.Top + m_oRightTable.Height - m_oRightConnector.Height
    Else
        m_oRightConnector.Top = RightColumnPosY - (m_oRightConnector.Height \ 2)
    End If

    'set position of join line
    m_oJoinLine.X1 = LeftColumnPosX + m_oLeftConnector.Width
    m_oJoinLine.Y1 = m_oLeftConnector.Top + (m_oLeftConnector.Height \ 2)

    m_oJoinLine.X2 = RightColumnPosX - m_oRightConnector.Width
    m_oJoinLine.Y2 = m_oRightConnector.Top + (m_oRightConnector.Height \ 2)

    '  Make visible
    m_oJoinLine.Visible = True
    m_oLeftConnector.Visible = True
    m_oRightConnector.Visible = True
    
    'set rc
    draw = True
    
    Exit Function
    
errDraw:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Function
Private Sub Class_Initialize()
    On Error GoTo errClass_Initialize
    
    Const FUNCTION_NAME = "Class_Initialize"
    
    'inits
    m_enumJoinType = JoinTypeNormal
    m_sCompareOperator = "="
    
    Exit Sub
    
errClass_Initialize:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub
