VERSION 5.00
Begin VB.Form frmPredicateComparison 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Comparison Predicate"
   ClientHeight    =   1815
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3555
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "PredicateComparison.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1815
   ScaleWidth      =   3555
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdOk 
      Caption         =   "&Ok"
      Default         =   -1  'True
      Height          =   375
      Left            =   2280
      TabIndex        =   4
      Top             =   180
      Width           =   1200
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   2280
      TabIndex        =   3
      Top             =   600
      Width           =   1200
   End
   Begin VB.Frame fraPredicate 
      Caption         =   "Comparison Predicate"
      Height          =   1470
      Left            =   90
      TabIndex        =   0
      Top             =   165
      Width           =   2130
      Begin VB.CheckBox chkDefault 
         Caption         =   "&Default"
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   1005
         Width           =   1785
      End
      Begin VB.TextBox txtExpression 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   315
         Left            =   120
         TabIndex        =   1
         Top             =   525
         Width           =   1935
      End
      Begin VB.Label lblExpression 
         Caption         =   "Expression"
         Height          =   255
         Left            =   135
         TabIndex        =   2
         Top             =   255
         Width           =   1200
      End
   End
End
Attribute VB_Name = "frmPredicateComparison"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  Form:       frmPredicateComparison - Form for Comparison Predicates
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
'module name
'--------------------------------------------------------
Const MODULE_NAME = "frmPredicateComparison"

Private Const CompareSmaller = 0
Private Const CompareGreater = 1
Private Const CompareEqual = 2
Private Const CompareUnequal = 3
Private Const CompareEqualSmaller = 4
Private Const CompareEqualGreater = 5


Private m_oPredicateComparison        As SQLStudioMan.PredicateComp
 

Private m_oPredicateComparisonCopy    As New SQLStudioMan.PredicateComp

Private m_oPredicateDefault        As SQLStudioMan.predicateDefault


Private m_oPredicateDefaultCopy    As New SQLStudioMan.predicateDefault

Private m_oColDef           As SQLStudioDBLayer.Column

'flag which contains value of default checkbox/property
Private m_bDefault          As Boolean

Public Property Set columnDefinition(NewColumnDefinition As SQLStudioDBLayer.Column)
    On Error GoTo errP_SET_ColumnDefinition

    Const FUNCTION_NAME = "P_SET ColumnDefinition"
    
    Set m_oColDef = NewColumnDefinition
    
    Exit Property
    
errP_SET_ColumnDefinition:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Private Function copyPredicateComp(DestPredicate As SQLStudioMan.PredicateComp, SrcPredicate As SQLStudioMan.PredicateComp)
    On Error GoTo errCopyPredicateComp

    Const FUNCTION_NAME = "copyPredicateComp"
    
    '  Copy predicate
    DestPredicate.arrange = SrcPredicate.arrange
    DestPredicate.Comparison = SrcPredicate.Comparison
    DestPredicate.Value = SrcPredicate.Value
    
    Exit Function
    
errCopyPredicateComp:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Function

Public Property Set predicateComparison(NewPredicateComparison As SQLStudioMan.PredicateComp)
    On Error GoTo errP_SET_PredicateComparison

    Const FUNCTION_NAME = "P_SET PredicateComparison"
    
    If NewPredicateComparison Is Nothing Then Exit Property
    
    Set m_oPredicateComparison = NewPredicateComparison
    
    '  Copy predicate
    copyPredicateComp m_oPredicateComparisonCopy, NewPredicateComparison
    
    'just set value, if default property is false
    If m_bDefault = False Then _
       txtExpression.Text = m_oPredicateComparison.Value
    
    Exit Property
    
errP_SET_PredicateComparison:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Private Function copyPredicateDefault(DestPredicate As SQLStudioMan.predicateDefault, SrcPredicate As SQLStudioMan.predicateDefault)
    On Error GoTo errCopyPredicateDefault

    Const FUNCTION_NAME = "copyPredicateDefault"
    
    '  Copy predicate
    DestPredicate.arrange = SrcPredicate.arrange
    DestPredicate.Comparison = SrcPredicate.Comparison
    
    Exit Function
    
errCopyPredicateDefault:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Function

Public Property Set predicateDefault(NewPredicateDefault As SQLStudioMan.predicateDefault)
    On Error GoTo errP_SET_PredicateDefault

    Const FUNCTION_NAME = "P_SET PredicateDefault"
    
    If NewPredicateDefault Is Nothing Then Exit Property
    
    Set m_oPredicateDefault = NewPredicateDefault
    
    '  Copy predicate
    copyPredicateDefault m_oPredicateDefaultCopy, NewPredicateDefault
    
    Exit Property
    
errP_SET_PredicateDefault:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Get predicateComparison() As SQLStudioMan.PredicateComp
    On Error GoTo errP_Get_PredicateComparison

    Const FUNCTION_NAME = "P_Get predicateComparison"
    
    Set predicateComparison = m_oPredicateComparison
    
    Exit Property
    
errP_Get_PredicateComparison:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Private Sub chkDefault_Click()
    On Error GoTo errChkDefault_Click
    
    Const FUNCTION_NAME = "chkDefault_Click"
    
    If chkDefault.Value = vbChecked Then
    
        txtExpression.Enabled = False
        m_bDefault = True
    Else
        txtExpression.Enabled = True
        m_bDefault = False
    End If
    
    Exit Sub
    
errChkDefault_Click:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      cmdCancel_Click
'    description:   the cancel button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdCancel_Click()
    On Error GoTo errCmdCancel_Click

    Const FUNCTION_NAME = "cmdCancel_Click"
    
    'set old predicate values
    copyPredicateComp m_oPredicateComparison, m_oPredicateComparisonCopy
    
    copyPredicateDefault m_oPredicateDefault, m_oPredicateDefaultCopy
    
    Err.Number = cdlCancel
    
    'unload form
    Unload Me
    
    Exit Sub
    
errCmdCancel_Click:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      cmdOk_Click
'    description:   the ok button was pressed
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub cmdOk_Click()
    On Error GoTo errCmdOk_Click
    
    Const FUNCTION_NAME = "cmdOk_Click"
    
    'Unload form
    Unload Me
    
    Err.Number = 0
     
    Exit Sub
    
errCmdOk_Click:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub
Private Sub txtExpression_Change()
    On Error GoTo errTxtExpression_Change

    Const FUNCTION_NAME = "txtExpression_Change"
    
    m_oPredicateComparison.Value = txtExpression.Text
    
    Exit Sub
    
errTxtExpression_Change:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub

Private Sub Form_Unload(Cancel As Integer)
    On Error GoTo errForm_Unload

    Const FUNCTION_NAME = "Form_Unload"

    Err.Number = cdlCancel
    
    Exit Sub
    
errForm_Unload:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Sub
Public Property Get default() As Boolean
    On Error GoTo errP_Get_Default

    Const FUNCTION_NAME = "P_Get default"
    
    default = m_bDefault
    
    Exit Property
    
errP_Get_Default:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Let default(NewDefault As Boolean)
    On Error GoTo errP_LET_Default

    Const FUNCTION_NAME = "P_LET Default"
    
    If NewDefault = True Then
    
        chkDefault.Value = vbChecked
    Else
        chkDefault.Value = vbUnchecked
    End If
    
    m_bDefault = NewDefault
    
    Exit Property
    
errP_LET_Default:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property

