VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "QBEColumn"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Friend License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Friend License for more details.
'
' You should have received a copy of the GNU General Friend License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  Class:      QBE ColumnManagement
'
'  Description:
'  Module is used in the context of QueryByExample.
'  Especially for Import of Long Data
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'module name
Const MODULE_NAME = "QBEColumn"

Private m_lValueLength           As Long
Private m_sColumnFileReferenz    As String
Private m_sColumnValue           As String
Private m_bDirty                 As Boolean

Private m_emSAPDBColType       As SAPDBColumnType

Friend Property Get columnValue() As String
    On Error GoTo errP_Get_ColumnValue

    Const FUNCTION_NAME = "P_Get columnValue"
    
    columnValue = m_sColumnValue
    
    Exit Property
    
errP_Get_ColumnValue:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Let columnValue(NewColumnValue As String)
    On Error GoTo errP_LET_ColumnValue

    Const FUNCTION_NAME = "P_LET ColumnValue"
    
    m_sColumnValue = NewColumnValue
    
    Exit Property
    
errP_LET_ColumnValue:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get dirty() As Boolean
    On Error GoTo errP_Get_Dirty

    Const FUNCTION_NAME = "P_Get dirty"
    
    dirty = m_bDirty
    
    Exit Property
    
errP_Get_Dirty:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Let dirty(NewDirty As Boolean)
    On Error GoTo errP_LET_Dirty

    Const FUNCTION_NAME = "P_LET Dirty"
    
    m_bDirty = NewDirty
    
    Exit Property
    
errP_LET_Dirty:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get sapdbColType() As SAPDBColumnType
    On Error GoTo errP_Get_SAPDBColType

    Const FUNCTION_NAME = "P_Get sapdbColType"
    
    sapdbColType = m_emSAPDBColType
    
    Exit Property
    
errP_Get_SAPDBColType:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let sapdbColType(NewSAPDBColType As SAPDBColumnType)
    On Error GoTo errP_LET_SAPDBColType

    Const FUNCTION_NAME = "P_Let sAPDBColType"
    
    m_emSAPDBColType = NewSAPDBColType
    
    Exit Property
    
errP_LET_SAPDBColType:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Get fileReferenz() As String
    On Error GoTo errP_Get_FileReferenz

    Const FUNCTION_NAME = "P_Get fileReferenz"
    
    fileReferenz = m_sColumnFileReferenz
    
    Exit Property
    
errP_Get_FileReferenz:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Let fileReferenz(NewFileReferenz As String)
    On Error GoTo errP_LET_FileReferenz

    Const FUNCTION_NAME = "P_let fileReferenz"
    
    m_sColumnFileReferenz = NewFileReferenz
    
    Exit Property
    
errP_LET_FileReferenz:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Get valueLength() As Long
    On Error GoTo errP_Get_ValueLength

    Const FUNCTION_NAME = "P_Get valueLength"
    
    valueLength = m_lValueLength
    
    Exit Property
    
errP_Get_ValueLength:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Let valueLength(NewValueLength As Long)
    On Error GoTo errP_LET_ValueLength

    Const FUNCTION_NAME = "P_LET ValueLength"
    
    m_lValueLength = NewValueLength
    
    Exit Property
    
errP_LET_ValueLength:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property


Private Sub Class_Initialize()
    On Error GoTo errClass_Initialize

    Const FUNCTION_NAME = "Class_Initialize"

    m_sColumnFileReferenz = ""
    m_sColumnValue = ""
    m_bDirty = False
    
    Exit Sub
    
errClass_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME

End Sub

