VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "QBEColumnFilter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Friend License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Friend License for more details.
'
' You should have received a copy of the GNU General Friend License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  Class:      ColumnFilter - Class for Column Filter
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
'module name
'--------------------------------------------------------
Const MODULE_NAME = "QBEColumnFilter"



'properties
Private m_emArrange                    As SQLStudioMan.PredicateArrange
Private m_oColDef                        As SQLStudioDBLayer.Column
Private m_oPredicateBetween              As predicateBetween
Private m_oPredicateBool                 As predicateBool
Private m_oPredicateComparison           As PredicateComp
Private m_oPredicateDefault              As predicateDefault
Private m_oPredicateIn                   As predicateIn
Private m_oPredicateLike                 As predicateLike
Private m_oPredicateNull                 As predicateNull
Private m_oPredicateQuantified           As predicateQuantified

Private m_ActivePredicateType             As SQLStudioMan.PredicateTyp

Public Property Get activePredicateType() As SQLStudioMan.PredicateTyp
    On Error GoTo errP_Get_ActivePredicateType

    Const FUNCTION_NAME = "P_Get arrange"
    
    activePredicateType = m_ActivePredicateType
    
    Exit Property
    
errP_Get_ActivePredicateType:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let arrange(NewArrange As SQLStudioMan.PredicateArrange)
    On Error GoTo errP_LET_Arrange

    Const FUNCTION_NAME = "P_LET Arrange"
    
    m_emArrange = NewArrange
    
    If Not m_oPredicateBool Is Nothing Then m_oPredicateBool.arrange = m_emArrange
    If Not m_oPredicateBetween Is Nothing Then m_oPredicateBetween.arrange = m_emArrange
    If Not m_oPredicateComparison Is Nothing Then m_oPredicateComparison.arrange = m_emArrange
    If Not m_oPredicateDefault Is Nothing Then m_oPredicateDefault.arrange = m_emArrange
    If Not m_oPredicateIn Is Nothing Then m_oPredicateIn.arrange = m_emArrange
    If Not m_oPredicateLike Is Nothing Then m_oPredicateLike.arrange = m_emArrange
    If Not m_oPredicateNull Is Nothing Then m_oPredicateNull.arrange = m_emArrange
    If Not m_oPredicateQuantified Is Nothing Then m_oPredicateQuantified.arrange = m_emArrange
        
    Exit Property
    
errP_LET_Arrange:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get arrange() As SQLStudioMan.PredicateArrange
    On Error GoTo errP_Get_Arrange

    Const FUNCTION_NAME = "P_Get arrange"
    
    arrange = m_emArrange
    
    Exit Property
    
errP_Get_Arrange:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Set columnDefinition(NewColumnDefinition As SQLStudioDBLayer.Column)
    On Error GoTo errP_SET_ColumnDefinition

    Const FUNCTION_NAME = "P_SET ColumnDefinition"
    
    Set m_oColDef = NewColumnDefinition
    
    Exit Property
    
errP_SET_ColumnDefinition:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get columnDefinition() As SQLStudioDBLayer.Column
    On Error GoTo errP_Get_ColumnDefinition

    Const FUNCTION_NAME = "P_Get columnDefinition"
    
    Set columnDefinition = m_oColDef
    
    Exit Property
    
errP_Get_ColumnDefinition:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Set predicateBetween(NewPredicateBetween As SQLStudioMan.predicateBetween)
    On Error GoTo errSetPredicateBetween

    Const FUNCTION_NAME = "Set predicateBetween"
        
    'force all predictes to nothing, so just one predicate is valid
    clearAll
    
    Set m_oPredicateBetween = NewPredicateBetween
    
    m_ActivePredicateType = SQLStudioMan.predicateBetween
    
    Exit Property
    
errSetPredicateBetween:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get predicateBetween() As SQLStudioMan.predicateBetween
    On Error GoTo errGetPredicateBetween

    Const FUNCTION_NAME = "Get predicateBetween"
    
    Set predicateBetween = m_oPredicateBetween
    
    Exit Property
    
errGetPredicateBetween:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Set predicateBool(NewPredicateBool As SQLStudioMan.predicateBool)
    On Error GoTo errSetPredicateBool

    Const FUNCTION_NAME = "Set predicateBool"
        
    'force all predictes to nothing, so just one predicate is valid
    clearAll
    
    Set m_oPredicateBool = NewPredicateBool
    
    m_ActivePredicateType = SQLStudioMan.predicateBool
    
    Exit Property
    
errSetPredicateBool:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get predicateBool() As SQLStudioMan.predicateBool
    On Error GoTo errGetPredicateBool

    Const FUNCTION_NAME = "Get predicateBool"
    
    Set predicateBool = m_oPredicateBool
    
    Exit Property
    
errGetPredicateBool:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Set predicateComparison(NewPredicateComparsion As SQLStudioMan.PredicateComp)
    On Error GoTo errSetPredicateComparison

    Const FUNCTION_NAME = "Set predicateComparison"
    
    'force all predictes to nothing, so just one predicate is valid
    clearAll
    
    Set m_oPredicateComparison = NewPredicateComparsion
    
    m_ActivePredicateType = SQLStudioMan.PredicateComparsion
    
    Exit Property
    
errSetPredicateComparison:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get predicateComparison() As SQLStudioMan.PredicateComp
    On Error GoTo errGetPredicateComparison

    Const FUNCTION_NAME = "Get predicateComparison"
    
    Set predicateComparison = m_oPredicateComparison
    
    Exit Property
    
errGetPredicateComparison:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Set predicateDefault(NewPredicateDefault As SQLStudioMan.predicateDefault)
    On Error GoTo errSetPredicateDefault

    Const FUNCTION_NAME = "Set predicateDefault"
    
    'force all predictes to nothing, so just one predicate is valid
    clearAll
    
    Set m_oPredicateDefault = NewPredicateDefault
    
    m_ActivePredicateType = SQLStudioMan.predicateDefault
    
    Exit Property
    
errSetPredicateDefault:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get predicateDefault() As SQLStudioMan.predicateDefault
    On Error GoTo errGetPredicateDefault

    Const FUNCTION_NAME = "Get predicateDefault"
    
    Set predicateDefault = m_oPredicateDefault
    
    Exit Property
    
errGetPredicateDefault:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Public Property Set predicateIn(NewPredicateIn As SQLStudioMan.predicateIn)
    On Error GoTo errSetPredicateIn

    Const FUNCTION_NAME = "Set predicateIn"
    
    'force all predictes to nothing, so just one predicate is valid
    clearAll
    
    Set m_oPredicateIn = NewPredicateIn
    m_ActivePredicateType = SQLStudioMan.predicateIn
    
    Exit Property
    
errSetPredicateIn:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get predicateIn() As SQLStudioMan.predicateIn
    On Error GoTo errGetPredicateIn

    Const FUNCTION_NAME = "Get predicateIn"
    
    Set predicateIn = m_oPredicateIn
            
    Exit Property
    
errGetPredicateIn:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Set predicateLike(NewPredicateLike As SQLStudioMan.predicateLike)
    On Error GoTo errSetPredicateLike

    Const FUNCTION_NAME = "Set predicateLike"
    
    'force all predictes to nothing, so just one predicate is valid
    clearAll
        
    Set m_oPredicateLike = NewPredicateLike
    m_ActivePredicateType = SQLStudioMan.predicateLike
    
    Exit Property
    
errSetPredicateLike:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get predicateLike() As SQLStudioMan.predicateLike
    On Error GoTo errGetPredicateLike

    Const FUNCTION_NAME = "Get predicateLike"
    
    Set predicateLike = m_oPredicateLike
    
    Exit Property
    
errGetPredicateLike:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Set predicateNull(NewPredicateNull As SQLStudioMan.predicateNull)
    On Error GoTo errSetPredicateNull

    Const FUNCTION_NAME = "Set predicateNull"
    
    'force all predictes to nothing, so just one predicate is valid
    clearAll
    
    Set m_oPredicateNull = NewPredicateNull
    m_ActivePredicateType = SQLStudioMan.predicateNull
    
    Exit Property
    
errSetPredicateNull:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get predicateNull() As SQLStudioMan.predicateNull
    On Error GoTo errGetPredicateNull

    Const FUNCTION_NAME = "Get predicateNull"
    
    Set predicateNull = m_oPredicateNull
    
    Exit Property
    
errGetPredicateNull:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Set predicateQuantified(NewPredicateQuantified As SQLStudioMan.predicateQuantified)
    On Error GoTo errSetPredicateQuantified

    Const FUNCTION_NAME = "Set predicateQuantified"
    
    'force all predictes to nothing, so just one predicate is valid
    clearAll
    
    Set m_oPredicateQuantified = NewPredicateQuantified
    m_ActivePredicateType = SQLStudioMan.predicateQuantified
    
    Exit Property
    
errSetPredicateQuantified:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get predicateQuantified() As SQLStudioMan.predicateQuantified
    On Error GoTo errGetPredicateQuantified

    Const FUNCTION_NAME = "Get predicateQuantified"
    
    Set predicateQuantified = m_oPredicateQuantified
    
    Exit Property
    
errGetPredicateQuantified:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Function getPredicateAsStatement(bFormated As Boolean) As String
    On Error GoTo errGetPredicateAsStatement

    Const FUNCTION_NAME = "Get predicateAsStatement"

    Dim bPredicateInFront       As Boolean
    Dim CurrentClause           As String
    Dim TempClause              As String
    Dim CurrentValue            As Variant
    

    'rc
    getPredicateAsStatement = ""
        
    'inits
    bPredicateInFront = False
    CurrentClause = ""
    TempClause = ""
    
    ' BETWEEN predicate
     If Not m_oPredicateBetween Is Nothing Then
         TempClause = ""
         If (Len(m_oColDef.GetFormattedValue(m_oPredicateBetween.Value1)) > 0 And _
             Len(m_oColDef.GetFormattedValue(m_oPredicateBetween.Value2)) > 0) Or _
             (m_oColDef.sapdbColType = sapdbColTypeChar And _
              m_oColDef.SAPDBColCodeType = sapdbColCodeTypeASCII _
             ) _
         Then
             If m_oPredicateBetween.IsNot Then
                 TempClause = LTrim$(Chr$(34) + m_oColDef.ColName + Chr$(34) + " NOT BETWEEN ")
             Else
                 TempClause = LTrim$(Chr$(34) + m_oColDef.ColName + Chr$(34) + " BETWEEN ")
             End If
     
             TempClause = TempClause + m_oColDef.GetFormattedValue(m_oPredicateBetween.Value1) + " AND " + m_oColDef.GetFormattedValue(m_oPredicateBetween.Value2)
         End If
         
         If bPredicateInFront Then
              CurrentClause = CurrentClause + " " + m_oPredicateBetween.GetPredicateArrange
              If bFormated Then CurrentClause = CurrentClause + vbCrLf
              CurrentClause = CurrentClause + " " + TempClause
         Else
             CurrentClause = CurrentClause + " " + TempClause
         End If
         
         bPredicateInFront = True
    End If

    
    
    getPredicateAsStatement = getPredicateAsStatement + CurrentClause
    'If bFormated And Len(CurrentClause) > 0 Then GetPredicateAsStatement = GetPredicateAsStatement + vbCrLf
    
    CurrentClause = ""
    TempClause = ""

    'set BOOL predicate
     If Not m_oPredicateBool Is Nothing Then
         TempClause = ""
         If m_oPredicateBool.IsNot Then
            TempClause = LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " IS NOT ")
         Else
            TempClause = LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " IS ")
         End If
         
         If m_oPredicateBool.Value Then
             TempClause = TempClause + "TRUE"
         Else
             TempClause = TempClause + "FALSE"
         End If
         
         If bPredicateInFront Then
             CurrentClause = CurrentClause + " " + m_oPredicateBool.GetPredicateArrange
             If bFormated Then CurrentClause = CurrentClause + vbCrLf
             CurrentClause = CurrentClause + " " + TempClause
         Else
            CurrentClause = CurrentClause + " " + TempClause
         End If
         
         bPredicateInFront = True
    End If
    
    getPredicateAsStatement = getPredicateAsStatement + CurrentClause
    'If bFormated And Len(CurrentClause) > 0 Then GetPredicateAsStatement = GetPredicateAsStatement + vbCrLf
    
    CurrentClause = ""
    TempClause = ""

    'set Comparsion predicate
     If Not m_oPredicateComparison Is Nothing Then
         TempClause = ""
         If (Len(m_oColDef.GetFormattedValue(m_oPredicateComparison.Value))) Or (m_oColDef.sapdbColType = sapdbColTypeChar And m_oColDef.SAPDBColCodeType = sapdbColCodeTypeASCII) Then
             Select Case m_oPredicateComparison.Comparison
                 Case SQLStudioMan.PredicateCompareSmaller:
                     TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " < ")
                 Case SQLStudioMan.PredicateCompareGreater:
                     TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " > ")
                 Case SQLStudioMan.PredicateCompareEqual:
                     TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " = ")
                 Case SQLStudioMan.PredicateCompareUnequal:
                     TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " <> ")
                 Case SQLStudioMan.PredicateCompareEqualSmaller:
                     TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " <= ")
                 Case SQLStudioMan.PredicateCompareEqualGreater:
                     TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " >= ")
             End Select
         
             TempClause = TempClause + m_oColDef.GetFormattedValue(m_oPredicateComparison.Value)
                         
             
             If bPredicateInFront Then
                 CurrentClause = CurrentClause + " " + m_oPredicateComparison.GetPredicateArrange
                 If bFormated Then CurrentClause = CurrentClause + vbCrLf
                 CurrentClause = CurrentClause + " " + TempClause
             Else
                CurrentClause = CurrentClause + " " + TempClause
             End If
         
             bPredicateInFront = True
        End If
    End If
    
    getPredicateAsStatement = getPredicateAsStatement + CurrentClause
    'If bFormated And Len(CurrentClause) > 0 Then GetPredicateAsStatement = GetPredicateAsStatement + vbCrLf
    
    CurrentClause = ""
    TempClause = ""

    'set  Defaultpredicate
     If Not m_oPredicateDefault Is Nothing Then
         TempClause = ""
         Select Case m_oPredicateDefault.Comparison
             Case SQLStudioMan.PredicateCompareSmaller:
                 TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " < ")
             Case SQLStudioMan.PredicateCompareGreater:
                 TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " > ")
             Case SQLStudioMan.PredicateCompareEqual:
                 TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " = ")
             Case SQLStudioMan.PredicateCompareUnequal:
                 TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " <> ")
             Case SQLStudioMan.PredicateCompareEqualSmaller:
                 TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " <= ")
             Case SQLStudioMan.PredicateCompareEqualGreater:
                 TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " >= ")
         End Select

         TempClause = TempClause + "DEFAULT"
         
         If bPredicateInFront Then
             
             CurrentClause = CurrentClause + " " + m_oPredicateDefault.GetPredicateArrange
             If bFormated Then CurrentClause = CurrentClause + vbCrLf
             CurrentClause = CurrentClause + " " + TempClause
         Else
            CurrentClause = CurrentClause + " " + TempClause
         End If
         
         bPredicateInFront = True
    End If
    
    getPredicateAsStatement = getPredicateAsStatement + CurrentClause
    'If bFormated And Len(CurrentClause) > 0 Then GetPredicateAsStatement = GetPredicateAsStatement + vbCrLf
    
    CurrentClause = ""
    TempClause = ""

    'set In predicate
     If Not m_oPredicateIn Is Nothing Then
         TempClause = ""
         If m_oPredicateIn.ValueList.Count > 0 Or (m_oColDef.sapdbColType = sapdbColTypeChar And m_oColDef.SAPDBColCodeType = sapdbColCodeTypeASCII And m_oPredicateIn.IncludeEmptyString) Then
                 
             If m_oPredicateIn.IsNot Then
                 TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " NOT IN (")
             Else
                 TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " IN (")
             End If
         
             For Each CurrentValue In m_oPredicateIn.ValueList
                 TempClause = TempClause + m_oColDef.GetFormattedValue(CurrentValue) + ", "
             Next
             
             'Add empty string?
             If m_oPredicateIn.IncludeEmptyString Then
                 TempClause = TempClause + "'', "
             End If
             
             If bPredicateInFront Then
                CurrentClause = CurrentClause + " " + m_oPredicateIn.GetPredicateArrange
                If bFormated Then CurrentClause = CurrentClause + vbCrLf
                CurrentClause = CurrentClause + " " + TempClause
             Else
                CurrentClause = CurrentClause + " " + TempClause
             End If
             
             bPredicateInFront = True
         End If
    End If
       
    '  Reformat current clause
    If Not m_oPredicateIn Is Nothing Then
    
        If m_oPredicateIn.ValueList.Count > 0 Then _
           CurrentClause = Left$(CurrentClause, Len(CurrentClause) - 2) + ")"
     End If
    
    getPredicateAsStatement = getPredicateAsStatement + CurrentClause
    'If bFormated And Len(CurrentClause) > 0 Then GetPredicateAsStatement = GetPredicateAsStatement + vbCrLf
    
    CurrentClause = ""
    TempClause = ""

    'set Like predicate
     TempClause = ""
     If Not m_oPredicateLike Is Nothing Then
         TempClause = ""
         If ( _
             Len(m_oColDef.GetFormattedValue(m_oPredicateLike.LikeValue)) Or _
             ( _
                 m_oColDef.sapdbColType = sapdbColTypeChar And _
                 m_oColDef.SAPDBColCodeType = sapdbColCodeTypeASCII)) And _
                 ( _
                   (Not m_oPredicateLike.Escape Or _
                   (m_oPredicateLike.Escape And Len(m_oPredicateLike.EscapeValue) > 0)) Or _
                   (m_oColDef.sapdbColType = sapdbColTypeChar And m_oColDef.SAPDBColCodeType = sapdbColCodeTypeASCII) _
                 ) _
         Then
             
             If m_oPredicateLike.IsNot Then
                 If m_oPredicateLike.SoundsLike Then
                     TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " NOT SOUNDS LIKE ")
                 Else
                     TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " NOT LIKE ")
                 End If
             Else
                 If m_oPredicateLike.SoundsLike Then
                     TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " SOUNDS LIKE ")
                 Else
                     TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " LIKE ")
                 End If
             End If
     
             TempClause = TempClause + m_oColDef.GetCodeTypePrefix + "'" + m_oPredicateLike.LikeValue + "'"
     
             If Not m_oPredicateLike.SoundsLike And m_oPredicateLike.Escape Then
                 TempClause = TempClause + " ESCAPE "  'LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " ESCAPE ")
                 TempClause = TempClause + m_oColDef.GetCodeTypePrefix + "'" + m_oPredicateLike.EscapeValue + "'"
             End If
                         
             
             If bPredicateInFront Then
                 CurrentClause = CurrentClause + " " + m_oPredicateLike.GetPredicateArrange
                 If bFormated Then CurrentClause = CurrentClause + vbCrLf
                 CurrentClause = CurrentClause + " " + TempClause
             Else
                 CurrentClause = CurrentClause + " " + TempClause
             End If
             
             bPredicateInFront = True
        End If
    End If
    
    getPredicateAsStatement = getPredicateAsStatement + CurrentClause
    'If bFormated And Len(CurrentClause) > 0 Then GetPredicateAsStatement = GetPredicateAsStatement + vbCrLf
    
    CurrentClause = ""
    TempClause = ""

    'set Null predicate
     If Not m_oPredicateNull Is Nothing Then
         TempClause = ""
         If m_oPredicateNull.IsNot Then
             TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " IS NOT NULL")
          Else
             TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " IS NULL")
          End If
          
         
         If bPredicateInFront Then
             CurrentClause = CurrentClause + " " + m_oPredicateNull.GetPredicateArrange
             If bFormated Then CurrentClause = CurrentClause + vbCrLf
             CurrentClause = CurrentClause + " " + TempClause
         Else
            CurrentClause = CurrentClause + " " + TempClause
         End If
         
         bPredicateInFront = True
    End If
        
    
    getPredicateAsStatement = getPredicateAsStatement + CurrentClause
    'If bFormated And Len(CurrentClause) > 0 Then GetPredicateAsStatement = GetPredicateAsStatement + vbCrLf
    
    CurrentClause = ""
    TempClause = ""
    
    'set Quantified predicate
    If Not m_oPredicateQuantified Is Nothing Then
        TempClause = ""
        If m_oPredicateQuantified.ValueList.Count > 0 Or _
           (m_oColDef.sapdbColType = sapdbColTypeChar And _
            m_oColDef.SAPDBColCodeType = sapdbColCodeTypeASCII And _
            m_oPredicateQuantified.IncludeEmptyString) _
        Then
        
            Select Case m_oPredicateQuantified.Comparison
                Case SQLStudioMan.PredicateCompareSmaller:
                    TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " < ")
                Case SQLStudioMan.PredicateCompareGreater:
                    TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " > ")
                Case SQLStudioMan.PredicateCompareEqual:
                    TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " = ")
                Case SQLStudioMan.PredicateCompareUnequal:
                    TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " <> ")
                Case SQLStudioMan.PredicateCompareEqualSmaller:
                    TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " <= ")
                Case SQLStudioMan.PredicateCompareEqualGreater:
                    TempClause = TempClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " >= ")
            End Select
    
            Select Case m_oPredicateQuantified.Quantifier
                Case SQLStudioMan.PredicateQuantifierAll:
                    TempClause = TempClause + "ALL "
                Case SQLStudioMan.PredicateQuantifierSome:
                    TempClause = TempClause + "SOME "
            End Select
            TempClause = TempClause + "( "
    
            For Each CurrentValue In m_oPredicateQuantified.ValueList
                TempClause = TempClause + m_oColDef.GetFormattedValue(CurrentValue) + ", "
            Next
            
            'Add empty string?
            If m_oPredicateQuantified.IncludeEmptyString Then _
               TempClause = TempClause + "'', "
               
            '  Reformat current clause
            If m_oPredicateQuantified.ValueList.Count > 0 Then _
                TempClause = Left$(TempClause, Len(TempClause) - 2)

            TempClause = TempClause + ")"
                         
                        
            If bPredicateInFront Then
                CurrentClause = CurrentClause + " " + m_oPredicateQuantified.GetPredicateArrange
                If bFormated Then CurrentClause = CurrentClause + vbCrLf
                CurrentClause = CurrentClause + " " + TempClause
            Else
               CurrentClause = CurrentClause + " " + TempClause
            End If
            
            bPredicateInFront = True
       End If
   End If
    
    getPredicateAsStatement = getPredicateAsStatement + CurrentClause
    'If bFormated And Len(CurrentClause) > 0 Then GetPredicateAsStatement = GetPredicateAsStatement + vbCrLf

    Exit Function
    
errGetPredicateAsStatement:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Friend Function getDescription(Description As String, ByVal SeparatorValue As Integer) As Boolean
    On Error GoTo errGetDescription

    Const FUNCTION_NAME = "getDescription"
    
    Dim newDescription                  As String
    Dim ColumnDefinitionDescription     As String
    Dim PredicateBetweenDescription     As String
    Dim PredicateBoolDescription        As String
    Dim PredicateComparisonDescription  As String
    Dim PredicateDefaultDescription     As String
    Dim PredicateInDescription          As String
    Dim PredicateLikeDescription        As String
    Dim PredicateNullDescription        As String
    Dim PredicateQuantifiedDescription  As String
        
    'rc
    getDescription = False
    
    '  Check separator value
    If SeparatorValue > 7 Then Exit Function 'separator value + 1 can be a printable character
    
    'Name
    newDescription = newDescription + m_oColDef.ColName + Chr$(SeparatorValue)
       
    'GetColumnArrange
    newDescription = newDescription + Trim$(Str$(m_emArrange)) + Chr$(SeparatorValue)
    
    If Not m_oPredicateBetween Is Nothing Then
    
        If Not m_oPredicateBetween.getDescription(PredicateBetweenDescription) Then
           Exit Function
        Else
            newDescription = newDescription + PredicateBetweenDescription + Chr$(SeparatorValue)
        End If
    End If
            
    If Not m_oPredicateBool Is Nothing Then
    
        If Not m_oPredicateBool.getDescription(PredicateBoolDescription) Then
           Exit Function
        Else
            newDescription = newDescription + PredicateBoolDescription + Chr$(SeparatorValue)
        End If
    End If
    
    'Comparison
    If Not m_oPredicateComparison Is Nothing Then
    
        If Not m_oPredicateComparison.getDescription(PredicateComparisonDescription) Then
           Exit Function
        Else
            newDescription = newDescription + PredicateComparisonDescription + Chr$(SeparatorValue)
        End If
    End If
    
    If Not m_oPredicateDefault Is Nothing Then
    
        If Not m_oPredicateDefault.getDescription(PredicateDefaultDescription) Then
           Exit Function
        Else
            newDescription = newDescription + PredicateDefaultDescription + Chr$(SeparatorValue)
        End If
    End If
    
    If Not m_oPredicateIn Is Nothing Then
    
        If Not m_oPredicateIn.getDescription(PredicateInDescription) Then
           Exit Function
        Else
            newDescription = newDescription + PredicateInDescription + Chr$(SeparatorValue)
        End If
    End If
    
    If Not m_oPredicateLike Is Nothing Then
    
        If Not m_oPredicateLike.getDescription(PredicateLikeDescription) Then
           Exit Function
        Else
            newDescription = newDescription + PredicateLikeDescription + Chr$(SeparatorValue)
        End If
    End If
    
    If Not m_oPredicateNull Is Nothing Then
    
        If Not m_oPredicateNull.getDescription(PredicateNullDescription) Then
           Exit Function
        Else
            newDescription = newDescription + PredicateNullDescription + Chr$(SeparatorValue)
        End If
    End If
    
    If Not m_oPredicateQuantified Is Nothing Then
    
        If Not m_oPredicateQuantified.getDescription(PredicateQuantifiedDescription) Then
           Exit Function
        Else
            newDescription = newDescription + PredicateQuantifiedDescription + Chr$(SeparatorValue)
        End If
    End If
    
    'set rc
    Description = newDescription
    
    getDescription = True
    
    Exit Function

errGetDescription:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function setDescription(Description As String) As Boolean
    On Error GoTo errSetDescription

    Const FUNCTION_NAME = "SetDescription"
    
    Dim PredicateDescription            As String
    Dim sCopyOfDescription              As String
    Dim sCopyCopyOfDescription          As String
    Dim NextToken                       As String
    
    'rc
    setDescription = False
    
    '  Check description
    If Len(Description) < 1 Then
    
        setDescription = True
        Exit Function
    End If
    
    ' Get predicate ColumnValue
    m_oComFunc.getNextToken Description, NextToken, Chr$(4)
    m_emArrange = Val(NextToken)
    
    sCopyOfDescription = Description
    
    ' Get one predicate
    Do While Len(sCopyOfDescription)
        m_oComFunc.getNextToken sCopyOfDescription, PredicateDescription, m_oComFunc.GetTokenSeperator(qplObjectLevel5)
        If Len(PredicateDescription) Then
            
            sCopyCopyOfDescription = PredicateDescription
            m_oComFunc.getNextToken sCopyCopyOfDescription, NextToken, Chr$(5)
            If Val(NextToken) = SQLStudioMan.predicateBetween Then
            
                If m_oPredicateBetween Is Nothing Then Set m_oPredicateBetween = New predicateBetween
                m_ActivePredicateType = SQLStudioMan.predicateBetween
                If Not m_oPredicateBetween.setDescription(PredicateDescription) Then Exit Function
            End If
            
            If Val(NextToken) = SQLStudioMan.predicateBool Then
            
                If m_oPredicateBool Is Nothing Then Set m_oPredicateBool = New predicateBool
                m_ActivePredicateType = SQLStudioMan.predicateBool
                If Not m_oPredicateBool.setDescription(PredicateDescription) Then Exit Function
            End If
            
            If Val(NextToken) = SQLStudioMan.PredicateComparsion Then
            
                If m_oPredicateComparison Is Nothing Then Set m_oPredicateComparison = New PredicateComp
                m_ActivePredicateType = PredicateComparsion
                If Not m_oPredicateComparison.setDescription(PredicateDescription) Then Exit Function
            End If
            
            If Val(NextToken) = SQLStudioMan.predicateDefault Then
            
                If m_oPredicateDefault Is Nothing Then Set m_oPredicateDefault = New SQLStudioMan.predicateDefault
                m_ActivePredicateType = SQLStudioMan.predicateDefault
                If Not m_oPredicateDefault.setDescription(PredicateDescription) Then Exit Function
            End If
            
            If Val(NextToken) = SQLStudioMan.predicateIn Then
            
                If m_oPredicateIn Is Nothing Then Set m_oPredicateIn = New predicateIn
                m_ActivePredicateType = SQLStudioMan.predicateIn
                If Not m_oPredicateIn.setDescription(PredicateDescription) Then Exit Function
            End If
            
            If Val(NextToken) = SQLStudioMan.predicateNull Then
            
                If m_oPredicateNull Is Nothing Then Set m_oPredicateNull = New SQLStudioMan.predicateNull
                m_ActivePredicateType = SQLStudioMan.predicateNull
                If Not m_oPredicateNull.setDescription(PredicateDescription) Then Exit Function
            End If
            
            If Val(NextToken) = SQLStudioMan.predicateLike Then
                 
                If m_oPredicateLike Is Nothing Then Set m_oPredicateLike = New SQLStudioMan.predicateLike
                m_ActivePredicateType = SQLStudioMan.predicateLike
                If Not m_oPredicateLike.setDescription(PredicateDescription) Then Exit Function
            End If
            
            If Val(NextToken) = SQLStudioMan.predicateQuantified Then
            
                If m_oPredicateQuantified Is Nothing Then Set m_oPredicateQuantified = New SQLStudioMan.predicateQuantified
                m_ActivePredicateType = SQLStudioMan.predicateQuantified
                If Not m_oPredicateQuantified.setDescription(PredicateDescription) Then Exit Function
            End If
        End If
    Loop
    
    'set rc
    setDescription = True
    
    Exit Function

errSetDescription:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Friend Function getColumnArrange() As String
    On Error GoTo errGetColumnArrange

    Const FUNCTION_NAME = "GetColumnArrange"

    Dim CurrentClause       As String

    If arrange = SQLStudioMan.PredicateArrangeAnd Then
        getColumnArrange = "AND"
    Else
        getColumnArrange = "OR"
    End If
    
    Exit Function
    
errGetColumnArrange:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Private Sub Class_Initialize()
    On Error GoTo errClass_Initialize

    Const FUNCTION_NAME = "Class_Initialize"
    
    m_emArrange = -1
    
    m_ActivePredicateType = -1

    Exit Sub

errClass_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Public Function clearAll() As Boolean
    On Error GoTo errClearAll

    Const FUNCTION_NAME = "clearAll"
    
    clearAll = False

    Set m_oPredicateBetween = Nothing
    Set m_oPredicateBool = Nothing
    Set m_oPredicateComparison = Nothing
    Set m_oPredicateDefault = Nothing
    Set m_oPredicateIn = Nothing
    Set m_oPredicateLike = Nothing
    Set m_oPredicateNull = Nothing
    Set m_oPredicateQuantified = Nothing

    clearAll = True
    
    Exit Function

errClearAll:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function getPredicateValues() As String
    On Error GoTo errGetPredicateValues

    Const FUNCTION_NAME = "Get predicateValues"

    Dim CurrentClause           As String
    Dim CurrentValue            As Variant
    Dim bPredicateValueExists   As Boolean
    

    'rc
    getPredicateValues = ""
        
    'inits
    CurrentClause = ""
    
    ' BETWEEN predicate
     If Not m_oPredicateBetween Is Nothing Then
         
         If (Len(m_oColDef.GetFormattedValue(m_oPredicateBetween.Value1)) > 0 And _
             Len(m_oColDef.GetFormattedValue(m_oPredicateBetween.Value2)) > 0) Or _
             (m_oColDef.sapdbColType = sapdbColTypeChar And _
              m_oColDef.SAPDBColCodeType = sapdbColCodeTypeASCII _
             ) _
         Then
             CurrentClause = CurrentClause + m_oColDef.GetFormattedValue(m_oPredicateBetween.Value1) + " AND " + m_oColDef.GetFormattedValue(m_oPredicateBetween.Value2)
         End If
    End If
    
    getPredicateValues = getPredicateValues + CurrentClause
    CurrentClause = ""

    'set BOOL predicate
     If Not m_oPredicateBool Is Nothing Then
         
         If m_oPredicateBool.Value Then
             CurrentClause = CurrentClause + "TRUE"
         Else
             CurrentClause = CurrentClause + "FALSE"
         End If
    End If
    
    getPredicateValues = getPredicateValues + CurrentClause
    'If bFormated And Len(CurrentClause) > 0 Then GetPredicateValues = GetPredicateValues + vbCrLf
    
    CurrentClause = ""

    'set Comparsion predicate
     If Not m_oPredicateComparison Is Nothing Then
         
         If (Len(m_oColDef.GetFormattedValue(m_oPredicateComparison.Value))) Or (m_oColDef.sapdbColType = sapdbColTypeChar And m_oColDef.SAPDBColCodeType = sapdbColCodeTypeASCII) Then
         
             CurrentClause = CurrentClause + m_oColDef.GetFormattedValue(m_oPredicateComparison.Value)
        End If
    End If
    
    getPredicateValues = getPredicateValues + CurrentClause
    'If bFormated And Len(CurrentClause) > 0 Then GetPredicateValues = GetPredicateValues + vbCrLf
    
    CurrentClause = ""

    'set  Defaultpredicate
     If Not m_oPredicateDefault Is Nothing Then CurrentClause = CurrentClause + "DEFAULT"
    
    getPredicateValues = getPredicateValues + CurrentClause
    'If bFormated And Len(CurrentClause) > 0 Then GetPredicateValues = GetPredicateValues + vbCrLf
    
    CurrentClause = ""
    
    'set In predicate
     If Not m_oPredicateIn Is Nothing Then
        
         CurrentClause = CurrentClause + " ("
         
         If m_oPredicateIn.ValueList.Count > 0 Or (m_oColDef.sapdbColType = sapdbColTypeChar And m_oColDef.SAPDBColCodeType = sapdbColCodeTypeASCII And m_oPredicateIn.IncludeEmptyString) Then
             
             For Each CurrentValue In m_oPredicateIn.ValueList
                 CurrentClause = CurrentClause + m_oColDef.GetFormattedValue(CurrentValue) + ", "
             Next
             
             'Add empty string?
             If m_oPredicateIn.IncludeEmptyString Then
                 CurrentClause = CurrentClause + "'', "
             End If
         End If
    
        If m_oPredicateIn.ValueList.Count > 0 Then _
           CurrentClause = Left$(CurrentClause, Len(CurrentClause) - 2) + ")"
     End If
    
    getPredicateValues = getPredicateValues + CurrentClause
    
    CurrentClause = ""
    
    'set Like predicate
     If Not m_oPredicateLike Is Nothing Then
         
         If ( _
             Len(m_oColDef.GetFormattedValue(m_oPredicateLike.LikeValue)) Or _
             ( _
                 m_oColDef.sapdbColType = sapdbColTypeChar And _
                 m_oColDef.SAPDBColCodeType = sapdbColCodeTypeASCII)) And _
                 ( _
                   (Not m_oPredicateLike.Escape Or _
                   (m_oPredicateLike.Escape And Len(m_oPredicateLike.EscapeValue) > 0)) Or _
                   (m_oColDef.sapdbColType = sapdbColTypeChar And m_oColDef.SAPDBColCodeType = sapdbColCodeTypeASCII) _
                 ) _
         Then
             
              If m_oPredicateLike.SoundsLike Then CurrentClause = " SOUNDS  "
             
             CurrentClause = CurrentClause + m_oColDef.GetCodeTypePrefix + "'" + m_oPredicateLike.LikeValue + "'"
     
             If Not m_oPredicateLike.SoundsLike And m_oPredicateLike.Escape Then
                 CurrentClause = CurrentClause + " ESCAPE "  'LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " ESCAPE ")
                 CurrentClause = CurrentClause + m_oColDef.GetCodeTypePrefix + "'" + m_oPredicateLike.EscapeValue + "'"
             End If
        End If
    End If
    
    getPredicateValues = getPredicateValues + CurrentClause
    
    CurrentClause = ""

    'set Null predicate
     If Not m_oPredicateNull Is Nothing Then
         
         If m_oPredicateNull.IsNot Then
             CurrentClause = CurrentClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " IS NOT NULL")
          Else
             CurrentClause = CurrentClause + LTrim$(Chr$(34) + (m_oColDef.ColName) + Chr$(34) + " IS NULL")
          End If
    End If
        
    
    getPredicateValues = getPredicateValues + CurrentClause
    'If bFormated And Len(CurrentClause) > 0 Then GetPredicateValues = GetPredicateValues + vbCrLf
    
    CurrentClause = ""
    
    'set Quantified predicate
    If Not m_oPredicateQuantified Is Nothing Then
        
        If m_oPredicateQuantified.ValueList.Count > 0 Or _
           (m_oColDef.sapdbColType = sapdbColTypeChar And _
            m_oColDef.SAPDBColCodeType = sapdbColCodeTypeASCII And _
            m_oPredicateQuantified.IncludeEmptyString) _
        Then
            CurrentClause = ""
    
            Select Case m_oPredicateQuantified.Comparison
                Case PredicateCompareSmaller:
                    CurrentClause = CurrentClause + " < "
                Case PredicateCompareGreater:
                    CurrentClause = CurrentClause + " > "
                Case PredicateCompareEqual:
                    CurrentClause = CurrentClause + " = "
                Case PredicateCompareUnequal:
                    CurrentClause = CurrentClause + " <> "
                Case PredicateCompareEqualSmaller:
                    CurrentClause = CurrentClause + " <= "
                Case PredicateCompareEqualGreater:
                    CurrentClause = CurrentClause + " >= "
            End Select

            Select Case m_oPredicateQuantified.Quantifier
                Case SQLStudioMan.PredicateQuantifierAll:
                    CurrentClause = CurrentClause + "ALL "
                Case SQLStudioMan.PredicateQuantifierSome:
                    CurrentClause = CurrentClause + "SOME "
            End Select
            CurrentClause = CurrentClause + "( "
    
            For Each CurrentValue In m_oPredicateQuantified.ValueList
                CurrentClause = CurrentClause + m_oColDef.GetFormattedValue(CurrentValue) + ", "
            Next
            
            'Add empty string?
            If m_oPredicateQuantified.IncludeEmptyString Then _
               CurrentClause = CurrentClause + "'', "
               
            'reformat current clause
            If m_oPredicateQuantified.ValueList.Count > 0 Then _
                CurrentClause = Left$(CurrentClause, Len(CurrentClause) - 2)

            CurrentClause = CurrentClause + ")"
       End If
   End If
   
   getPredicateValues = getPredicateValues + CurrentClause

   Exit Function
    
errGetPredicateValues:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'============================================================================
' returns the predicate that is not null
'============================================================================
Public Property Get activePredicate() As Object
    On Error GoTo errActivePredicate

    Const FUNCTION_NAME = "ActivePredicate"
    
    If Not m_oPredicateBetween Is Nothing Then
    
        Set activePredicate = m_oPredicateBetween
        Exit Property
    End If
    If Not m_oPredicateBool Is Nothing Then
    
        Set activePredicate = m_oPredicateBool
        Exit Property
    End If
    If Not m_oPredicateComparison Is Nothing Then
    
        Set activePredicate = m_oPredicateComparison
        Exit Property
    End If
    If Not m_oPredicateDefault Is Nothing Then
    
        Set activePredicate = m_oPredicateDefault
        Exit Property
    End If
    If Not m_oPredicateIn Is Nothing Then
    
        Set activePredicate = m_oPredicateIn
        Exit Property
    End If
    If Not m_oPredicateLike Is Nothing Then
    
        Set activePredicate = m_oPredicateLike
        Exit Property
    End If
    If Not m_oPredicateNull Is Nothing Then
    
        Set activePredicate = m_oPredicateNull
        Exit Property
    End If
    If Not m_oPredicateQuantified Is Nothing Then
    
        Set activePredicate = m_oPredicateQuantified
        Exit Property
    End If
    
    Exit Property
    
errActivePredicate:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
