VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "QBEObject"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Friend  License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Friend  License for more details.
'
' You should have received a copy of the GNU General Friend  License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
'  Class:      QBEObject - Quick QueryByExample Object Description
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'module name
Const MODULE_NAME = "QBEObject"

Const TABLE_DOMAIN_COLUMNS = "DOMAIN.COLUMNS"

Const COLUMN_DOMAIm_oWNER = "OWNER"
Const COLUMN_DOMAIN_TABLENAME = "TABLENAME"
Const COLUMN_DOMAIN_COLUMNS_MODE = "MODE"
Const COLUMN_DOMAIN_COLUMNS_COLUMNPRIVILEGES = "cOLUMNPRIVILEGES"
Const COLUMN_DOMAIN_COLUMNS_COLUMNNAME = "cOLUMNNAME"
Const COLUMN_DOMAIN_COLUMNS_DATATYPE = "DATATYPE"
Const COLUMN_DOMAIN_COLUMNS_CODETYPE = "cODETYPE"
Const COLUMN_DOMAIN_COLUMNS_LEN = "LEN"
Const COLUMN_DOMAIN_COLUMNS_DEC = "DEC"



'  Private properties
Private m_oConnection         As SQLStudioDBLayer.connection

Private m_emTableType         As cvItemType
Private m_sTableOwner         As String
Private m_sTableName          As String
Private m_sOriginTableOwner   As String
Private m_sOriginTableName    As String
Private m_sRepOfNullValue     As String
Private m_bUseFilter          As Boolean

Private m_colTableDefinition    As Collection
Private m_oQBEObjectFilter      As New QBEObjectFilter
Private m_oIntSettings          As New SQLStudioUtil.International
Friend Property Set connection(NewConnection As SQLStudioDBLayer.connection)
    On Error GoTo errP_SET_Connection

    Const FUNCTION_NAME = "P_SET Connection"

    Set m_oConnection = NewConnection

    Exit Property
    
errP_SET_Connection:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Get connection() As SQLStudioDBLayer.connection
    On Error GoTo errP_SET_Connection

    Const FUNCTION_NAME = "P_SET Connection"

    Set connection = m_oConnection

    Exit Property
    
errP_SET_Connection:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Let repOfNullValue(NewRepOfNullValue As String)
    On Error GoTo errP_LET_RepOfNullValue
    
    Const FUNCTION_NAME = "P_Let repOfNullValue"
    
    m_sRepOfNullValue = NewRepOfNullValue
    
    Exit Property
    
errP_LET_RepOfNullValue:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Let tableOwner(NewTableOwner As String)
    On Error GoTo errP_LET_TableOwner
    
    Const FUNCTION_NAME = "P_LET TableOwner"
    
    m_sTableOwner = NewTableOwner
    
    Exit Property
    
errP_LET_TableOwner:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Get tableOwner() As String
    On Error GoTo errP_Get_TableOwner
    
    Const FUNCTION_NAME = "P_Get tableOwner"
    
    tableOwner = m_sTableOwner
    
    Exit Property
    
errP_Get_TableOwner:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Property Let tableName(NewTableName As String)
    On Error GoTo errP_LET_TableName
    
    Const FUNCTION_NAME = "P_LET TableName"
    
    m_sTableName = NewTableName
    
    Exit Property
    
errP_LET_TableName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Property Get tableName() As String
    On Error GoTo errP_Get_TableName
    
    Const FUNCTION_NAME = "P_Get tableName"
    
    tableName = m_sTableName
    
    Exit Property
    
errP_Get_TableName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Property Let originTableOwner(NewOriginTableOwner As String)
    On Error GoTo errP_LET_OriginTableOwner
    
    Const FUNCTION_NAME = "P_LET OriginTableOwner"
    
    m_sOriginTableOwner = NewOriginTableOwner
    
    Exit Property
    
errP_LET_OriginTableOwner:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Property Get originTableOwner() As String
    On Error GoTo errP_Get_OriginTableOwner
    
    Const FUNCTION_NAME = "P_Get originTableOwner"
    
    originTableOwner = m_sOriginTableOwner
    
    Exit Property
    
errP_Get_OriginTableOwner:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Property Let originTableName(NewOriginTableName As String)
    On Error GoTo errP_LET_OriginTableName
    
    Const FUNCTION_NAME = "P_LET OriginTableName"
    
    m_sOriginTableName = NewOriginTableName
    
    Exit Property
    
errP_LET_OriginTableName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Property Get originTableName() As String
    On Error GoTo errP_Get_OriginTableName
    
    Const FUNCTION_NAME = "P_Get originTableName"
    
    originTableName = m_sOriginTableName
    
    Exit Property
    
errP_Get_OriginTableName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Property Let useFilter(NewUseFilter As Boolean)
    On Error GoTo errP_LET_UseFilter
    
    Const FUNCTION_NAME = "P_LET UseFilter"
    
    m_bUseFilter = NewUseFilter
    
    Exit Property
    
errP_LET_UseFilter:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Property Get useFilter() As Boolean
    On Error GoTo errP_Get_UseFilter
    
    Const FUNCTION_NAME = "P_Get useFilter"
    
    useFilter = m_bUseFilter
    
    Exit Property
    
errP_Get_UseFilter:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Let tableType(NewTableType As cvItemType)
    On Error GoTo errP_LET_TableType
    
    Const FUNCTION_NAME = "P_LET TableType"
    
    m_emTableType = NewTableType
    
    Exit Property
    
errP_LET_TableType:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Get tableType() As cvItemType
    On Error GoTo errP_Get_TableType
    
    Const FUNCTION_NAME = "P_Get tableType"
    
    tableType = m_emTableType
    
    Exit Property
    
errP_Get_TableType:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Property Get filter() As QBEObjectFilter
    On Error GoTo errP_Get_Filter
    
    Const FUNCTION_NAME = "P_Get filter"
    
    Set filter = m_oQBEObjectFilter
    
    Exit Property
    
errP_Get_Filter:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Private Property Set filter(NewFilter As QBEObjectFilter)
    On Error GoTo errP_SET_Filter
    
    Const FUNCTION_NAME = "P_SET Filter"
    
    Set m_oQBEObjectFilter = NewFilter
    
    Exit Property
    
errP_SET_Filter:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Property Get tableDefinition() As Collection
    On Error GoTo errP_Get_TableDefinition
    
    Const FUNCTION_NAME = "P_Get tableDefinition"
    
    Set tableDefinition = m_colTableDefinition
    
    Exit Property
    
errP_Get_TableDefinition:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Friend Function getTableDefinition(emItemType As cvItemType) As Boolean
    On Error GoTo errGetTableDefinition

    Const FUNCTION_NAME = "getTableDefinition"
        
    If m_oConnection Is Nothing Then Exit Function
    
    'rc
    getTableDefinition = False
    
    If emItemType = cmSynonym Then
    
        ' Get synonym
        If Not getSynonym(m_oConnection, m_sTableOwner, m_sTableName, m_sOriginTableOwner, m_sOriginTableName) _
           Then Exit Function
    Else
        m_sOriginTableOwner = m_sTableOwner
        m_sOriginTableName = m_sTableName
    End If
    
    ' Get column definitions
    If Not getColumns(m_colTableDefinition, _
                      m_sOriginTableOwner, _
                      m_sOriginTableName) _
    Then Exit Function
    
        
    'rc
    getTableDefinition = True

    Exit Function

errGetTableDefinition:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Friend Function getQueryByExampleDescription(qbeFile As storedFileContent) As Boolean
    On Error GoTo errGetQueryByExampleDescription

    Const FUNCTION_NAME = "getQueryByExampleDescription"
    
    Dim newFile             As New storedFileContent
    Dim FilterDescription   As String
    
    'inits
    getQueryByExampleDescription = False
        
    ' Connection Properties
    newFile.AutoCommit = m_oConnection.AutoCommit
    newFile.SQLMode = m_oConnection.SQLMode
    newFile.IsoLevel = m_oConnection.IsoLevel
    'save old file name
    newFile.FileName = qbeFile.FileName
    newFile.fileType = fileTypeQueryByExample
    
    ' Get sQL for the QueryByExample
    newFile.sqlData = getQueryByExampleSQL()
    
    ' get QueryByExample description
    newFile.ViewData = m_sTableOwner + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    newFile.ViewData = newFile.ViewData + m_sTableName + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    newFile.ViewData = newFile.ViewData + Trim$(Str$(m_emTableType)) + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    newFile.ViewData = newFile.ViewData + m_sOriginTableOwner + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    newFile.ViewData = newFile.ViewData + m_sOriginTableName + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    newFile.ViewData = newFile.ViewData + Trim$(Str$(m_bUseFilter)) + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    
    ' get filter description
    If Not m_oQBEObjectFilter.getDescription(FilterDescription, 2) Then Exit Function
    
    newFile.ViewData = newFile.ViewData + FilterDescription + m_oComFunc.GetTokenSeperator(qplObjectLevel2)
    
    'set rc
    If Not qbeFile Is Nothing Then Set qbeFile = Nothing
    
    Set qbeFile = newFile
    
    getQueryByExampleDescription = True

    Exit Function

errGetQueryByExampleDescription:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Friend Function setQueryByExample(qbeFile As storedFileContent) As Boolean
    On Error GoTo errSetQueryByExample

    Const FUNCTION_NAME = "setQueryByExample"
    
    Dim ViewData            As String
    Dim NextToken           As String
    Dim FilterDescription   As String
    
    'inits
    setQueryByExample = False
    
    ViewData = qbeFile.ViewData
    If Len(ViewData) > 0 Then
        ' Get table owner
        m_oComFunc.getNextToken ViewData, m_sTableOwner, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
        
        ' Get table name
        m_oComFunc.getNextToken ViewData, m_sTableName, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
        
        ' Get table type
        m_oComFunc.getNextToken ViewData, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
        If Len(NextToken) > 0 Then m_emTableType = CLng(NextToken)
        
        ' Get origin table owner
        m_oComFunc.getNextToken ViewData, m_sOriginTableOwner, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
        
        ' Get origin table name
        m_oComFunc.getNextToken ViewData, m_sOriginTableName, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
        
        ' Get use filter flag
        m_oComFunc.getNextToken ViewData, NextToken, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
        
        m_bUseFilter = NextToken
        
        ' get filter description
        m_oComFunc.getNextToken ViewData, FilterDescription, m_oComFunc.GetTokenSeperator(qplObjectLevel2)
        
        '  If there's a filter description
        If Len(FilterDescription) > 0 Then
        
            'set filter
            If Not m_oQBEObjectFilter.setDescription(FilterDescription) Then Exit Function
        End If
    End If
       
    
    'set rc
    setQueryByExample = True
    
    Exit Function

errSetQueryByExample:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Friend Function getQueryByExampleSQL() As String
    On Error GoTo errGetQueryByExampleSQL

    Const FUNCTION_NAME = "GetQueryByExampleSQL"
    
    Dim SQLStatement    As String
    
    'inits
    SQLStatement = ""
    
    ' Get sQL for the QueryByExample
    SQLStatement = "SELECT * FROM " + Chr$(34) + m_sTableOwner + Chr$(34) + "." + Chr$(34) + m_sTableName + Chr$(34)
    
    If m_bUseFilter Then SQLStatement = SQLStatement + m_oQBEObjectFilter.getFilterAsStatement(False)
            
    getQueryByExampleSQL = SQLStatement  'set rc

    Exit Function

errGetQueryByExampleSQL:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Private Sub Class_Initialize()
    On Error GoTo errClass_Initialize

    Const FUNCTION_NAME = "Class_Initialize"
    
    m_bUseFilter = False
    
    m_oIntSettings.refresh
    
    m_sRepOfNullValue = "?"

    Exit Sub

errClass_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
Friend Function getColumns(tableDefinition As Collection, ByVal tableOwner As String, ByVal tableName As String) As Boolean
    On Error GoTo errGetColumns

    Const FUNCTION_NAME = "GetColumns"

    Dim oResult             As New SQLStudioDBLayer.result
    Dim NewTableDefinition  As New Collection
    
    Set oResult.connection = m_oConnection
    'rc
    getColumns = False
    
    'get key information
    If Not oResult.OpenResult("SELECT " + _
                                COLUMN_DOMAIN_COLUMNS_MODE + ", " + _
                                COLUMN_DOMAIN_COLUMNS_COLUMNPRIVILEGES + ", " + _
                                COLUMN_DOMAIN_COLUMNS_COLUMNNAME + ", " + _
                                COLUMN_DOMAIN_COLUMNS_DATATYPE + ", " + _
                                COLUMN_DOMAIN_COLUMNS_CODETYPE + ", " + _
                                COLUMN_DOMAIN_COLUMNS_LEN + ", " + _
                                COLUMN_DOMAIN_COLUMNS_DEC + _
                                " FROM " + TABLE_DOMAIN_COLUMNS + _
                                " WHERE " + COLUMN_DOMAIm_oWNER + " = '" + tableOwner + "' AND " + _
                                COLUMN_DOMAIN_TABLENAME + " = '" + tableName + "'", Internal) _
    Then Exit Function
    
    If oResult.NoRows Then Exit Function
    
    'fetch
    If Not oResult.Fetch() Then Exit Function
    
    While Not oResult.NoRows
            
        If Not oResult.GetData() Then Exit Function
        
        'allocate new table definition object
        Dim NewColumn As New SQLStudioDBLayer.Column
        
        NewColumn.ThousandSeparator = m_oIntSettings.ThousandSeparator
        NewColumn.DecimalSeparator = m_oIntSettings.DecimalSeparator
            
        'set key info
        If oResult.Columns(1).ColValue = "KEY" Then
        
            NewColumn.ColIsKey = True
        Else
            NewColumn.ColIsKey = False
        End If
        
        'set nullable info
        If oResult.Columns(1).ColValue = "MAN" Then
        
            NewColumn.ColNullable = 0
        Else
            NewColumn.ColNullable = 1
        End If
        
        'is column updatable?
        If (InStr(oResult.Columns(2).ColValue, "UPD")) Then ' And (oResult.Columns(4).ColValue <> "LONG")) Then
            NewColumn.ColIsUpdatable = True
        Else
            NewColumn.ColIsUpdatable = False
        End If

        'set column name
        NewColumn.ColName = oResult.Columns(3).ColValue
        'set column type
        NewColumn.SetSapDBColumnType oResult.Columns(4).ColValue
        'set code type
        NewColumn.SetSapDBColumnCodeType oResult.Columns(5).ColValue
        
        'not init the odbc columntype from the sapdb types
        NewColumn.initODBCColTypeFromSAPDBTypes

        'set length
        If oResult.Columns(6).ColValue <> oResult.representationOfNullValue Then
        
            NewColumn.ColLength = oResult.Columns(6).ColValue
        Else
            NewColumn.ColLength = 0
        End If

        'set decimal
        If oResult.Columns(7).ColValue <> oResult.representationOfNullValue Then
        
            NewColumn.ColDecimal = oResult.Columns(7).ColValue
        Else
            NewColumn.ColDecimal = 0
        End If
        
        NewColumn.representationOfNullValue = m_sRepOfNullValue
        
        'add new table definition
        NewTableDefinition.Add NewColumn, NewColumn.ColName
        
        'free new table definition
        Set NewColumn = Nothing
        
        'fetch next row
        If Not oResult.Fetch() Then Exit Function
    Wend
    
    'rc
    Set tableDefinition = Nothing
    Set tableDefinition = NewTableDefinition
    
    getColumns = True

    Exit Function

errGetColumns:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

