VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "QBEObjectFilter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Friend License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Friend License for more details.
'
' You should have received a copy of the GNU General Friend License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''//////
'
'  Class:      QBEObjectFilter
'
' responsible:  WolfgangA
'
' special area: QBE
'
' description:  Class for QBE Filter
'
' see also:
'
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''//////


Option Explicit

'--------------------------------------------------------
'module name
'--------------------------------------------------------
Const MODULE_NAME = "QBEObjectFilter"

'properties
Private m_colColFilterList        As New Collection
Private m_oPredicateRowNo         As SQLStudioMan.predicateRowno
Private m_oPredicateOrderCols     As SQLStudioMan.predicateOrderCols

Public Property Get columnFilterList() As Collection
    On Error GoTo errP_Get_ColumnFilterList

    Const FUNCTION_NAME = "P_Get columnFilterList"
    
    Set columnFilterList = m_colColFilterList
    
    Exit Property
    
errP_Get_ColumnFilterList:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Set predicateRowno(NewPredicateRowno As SQLStudioMan.predicateRowno)
    On Error GoTo errP_SET_PredicateRowno

    Const FUNCTION_NAME = "P_SET PredicateRowno"
    
    Set m_oPredicateRowNo = NewPredicateRowno
    
    Exit Property
    
errP_SET_PredicateRowno:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get predicateRowno() As SQLStudioMan.predicateRowno
    On Error GoTo errP_Get_PredicateRowno

    Const FUNCTION_NAME = "P_Get predicateRowno"
    
    Set predicateRowno = m_oPredicateRowNo
    
    Exit Property
    
errP_Get_PredicateRowno:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Set predicateOrderCols(NewPredicateOrderCols As SQLStudioMan.predicateOrderCols)
    On Error GoTo errP_SET_PredicateOrderCols

    Const FUNCTION_NAME = "P_SET PredicateOrderCols"
    
    Set m_oPredicateOrderCols = NewPredicateOrderCols
    
    Exit Property
    
errP_SET_PredicateOrderCols:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get predicateOrderCols() As SQLStudioMan.predicateOrderCols
    On Error GoTo errP_Get_PredicateOrderCols

    Const FUNCTION_NAME = "P_Get predicateOrderCols"
    
    Set predicateOrderCols = m_oPredicateOrderCols
    
    Exit Property
    
errP_Get_PredicateOrderCols:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Property

Friend Function addColumnFilter(columnDefinition As SQLStudioDBLayer.Column)
    On Error GoTo errAddColumnFilter

    Const FUNCTION_NAME = "AddColumnFilter"
    
    Dim sKey            As String
    Dim NewColumnFilter As New QBEColumnFilter
    
    Set NewColumnFilter.columnDefinition = columnDefinition
    
    sKey = NewColumnFilter.columnDefinition.ColName
    m_colColFilterList.Add NewColumnFilter, sKey
    
    Set NewColumnFilter = Nothing
    
    Exit Function
    
errAddColumnFilter:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Function

Friend Function removeColumnFilter(ByVal Key As String)
    On Error GoTo errRemoveColumnFilter

    Const FUNCTION_NAME = "RemoveColumnFilter"
    
    m_colColFilterList.Remove Key
    
    Exit Function
    
errRemoveColumnFilter:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Function

Friend Function getFilterAsStatement(bFormated As Boolean) As String
    On Error GoTo errGetFilterAsStatement

    Const FUNCTION_NAME = "GetFilterAsStatement"

    Dim PredicateStatement  As String
    Dim CurrentColumnClause As String
    Dim sColumnFilter       As String
    Dim oColumnFilter       As QBEColumnFilter
    Dim OrderColumn         As SQLStudioMan.PredicateOrderCol
    Dim bFirst              As Boolean
    
    'remember the arrange expression of the previous item
    Dim sLastArrange        As String

    'inits
    getFilterAsStatement = ""
    
    bFirst = True
    
    'scan columns
    For Each oColumnFilter In m_colColFilterList
        CurrentColumnClause = ""
        
        sColumnFilter = oColumnFilter.getPredicateAsStatement(bFormated)
        If Len(sColumnFilter) > 0 Then
            If bFirst Then
                bFirst = False
                CurrentColumnClause = " WHERE "
            Else
                CurrentColumnClause = sLastArrange
            End If
            
            sLastArrange = " " + oColumnFilter.getColumnArrange() + " "
            
            CurrentColumnClause = CurrentColumnClause + " ("
            If bFormated Then CurrentColumnClause = CurrentColumnClause + vbCrLf
            
            CurrentColumnClause = CurrentColumnClause + sColumnFilter
            CurrentColumnClause = CurrentColumnClause + ")"
            If bFormated Then CurrentColumnClause = CurrentColumnClause + vbCrLf
        
            PredicateStatement = PredicateStatement + CurrentColumnClause
        End If
    Next

    If Not m_oPredicateRowNo Is Nothing Then 'set ROWNO predicate
    
        If Len(PredicateStatement) < 1 Then
        
            PredicateStatement = " WHERE "
        Else
            PredicateStatement = PredicateStatement + " AND "
        End If
        PredicateStatement = PredicateStatement + m_oPredicateRowNo.getPredicateAsStatement(bFormated)
   End If

    
    'scan columns for order by predicates
    bFirst = True
    If Not m_oPredicateOrderCols Is Nothing Then
        For Each OrderColumn In m_oPredicateOrderCols.OrderColumns
        
            CurrentColumnClause = ""
            If bFirst Then
            
                bFirst = False
                
                If bFormated And Len(PredicateStatement) > 0 Then CurrentColumnClause = vbCrLf
                CurrentColumnClause = CurrentColumnClause + " ORDER BY "
            Else
                CurrentColumnClause = CurrentColumnClause + ", "
            End If
            
            If OrderColumn.Direction = SQLStudioMan.OrderAscending Then
                CurrentColumnClause = CurrentColumnClause + OrderColumn.ColumnName + " ASC"
            Else
                CurrentColumnClause = CurrentColumnClause + OrderColumn.ColumnName + " DESC"
            End If
            PredicateStatement = PredicateStatement + CurrentColumnClause
        Next
'        If bFormated And Len(PredicateStatement) > 0 Then PredicateStatement = PredicateStatement + vbCrLf
    End If
    
    'set rc
    getFilterAsStatement = PredicateStatement

    Exit Function
    
errGetFilterAsStatement:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Function

Friend Function getDescription(Description As String, ByVal SeparatorValue As Integer) As Boolean
    On Error GoTo errGetDescription

    Const FUNCTION_NAME = "GetDescription"
    
    
    Dim newFile                      As String
    Dim ColumnFilterDescription             As String
    Dim PredicateRownoDescription           As String
    Dim PredicateOrderColsDescription    As String
    Dim ColumnFilter                        As QBEColumnFilter
    
    
    'rc
    getDescription = False
    
    '  Check separator value
    If SeparatorValue > 6 Then Exit Function     'separator value + 2 can be a printable character
    
    
    ' Get column filters
    For Each ColumnFilter In m_colColFilterList
    
        If Not ColumnFilter Is Nothing Then
        
            If ColumnFilter.getDescription(ColumnFilterDescription, SeparatorValue + 2) Then
            
               newFile = newFile + ColumnFilterDescription + Chr$(SeparatorValue + 1)
            Else
               Exit Function
            End If
        End If
    Next
    
    'add separator
    newFile = newFile + Chr$(SeparatorValue)
    
    'Get predicate rowno description
    If Not m_oPredicateRowNo Is Nothing Then
    
        If m_oPredicateRowNo.getDescription(PredicateRownoDescription) Then
           
            newFile = newFile + PredicateRownoDescription
        Else
            Exit Function
        End If
    End If
    
    'add separator
    newFile = newFile + Chr$(SeparatorValue)
    
    'Get predicate order columns description
    If Not m_oPredicateOrderCols Is Nothing Then
    
        If m_oPredicateOrderCols.getDescription(PredicateOrderColsDescription) Then
        
           newFile = newFile + PredicateOrderColsDescription
        Else
           Exit Function
        End If
    End If
    
    'sdd separator
    newFile = newFile + Chr$(SeparatorValue)
    
    'set rc
    Description = newFile
    getDescription = True
    
    Exit Function

errGetDescription:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Function
Friend Function setDescription(Description As String) As Boolean
    On Error GoTo errSetDescription

    Const FUNCTION_NAME = "setDescription"
    
    Dim objNewColumnFilter                  As QBEColumnFilter
    Dim bKeyFound                           As Boolean
    Dim ColumnFiltersDescription            As String
    Dim ColumnFilterDescription             As String
    Dim PredicateRownoDescription           As String
    Dim PredicateOrderColsDescription       As String
    Dim sKey                                As String
    Dim lRun                                As Long
    
    'rc
    setDescription = False
    '  Check description
    If Len(Description) < 1 Then
    
        setDescription = True
        Exit Function
    End If
    
    ' Get column filters
    lRun = 1
    m_oComFunc.getNextToken Description, ColumnFiltersDescription, m_oComFunc.GetTokenSeperator(qplObjectLevel3)
    
    While Len(ColumnFiltersDescription) > 0 'And lRun <= m_colColFilterList.Count
    
        m_oComFunc.getNextToken ColumnFiltersDescription, ColumnFilterDescription, m_oComFunc.GetTokenSeperator(qplObjectLevel4)
        If Len(ColumnFilterDescription) > 0 Then
            
            m_oComFunc.getNextToken ColumnFilterDescription, sKey, m_oComFunc.GetTokenSeperator(qplObjectLevel5)
            
            If Len(sKey) > 0 Then
            
                bKeyFound = False
                For Each objNewColumnFilter In m_colColFilterList
                
                    If sKey = objNewColumnFilter.columnDefinition.ColName Then
                    
                        bKeyFound = True
                        Exit For
                    End If
                Next
                If bKeyFound Then
                
                    If Not m_colColFilterList.Item(sKey).setDescription(ColumnFilterDescription) Then Exit Function
                End If
            End If
        End If
        lRun = lRun + 1
    Wend
    
    ' Get rowno predicate
    m_oComFunc.getNextToken Description, PredicateRownoDescription, m_oComFunc.GetTokenSeperator(qplObjectLevel3)
    
    If Len(PredicateRownoDescription) > 0 Then
    
        If m_oPredicateRowNo Is Nothing Then
        
            Set m_oPredicateRowNo = New SQLStudioMan.predicateRowno
            m_oPredicateRowNo.setDescription (PredicateRownoDescription)
        End If
    End If
    
    ' Get order by predicate
    m_oComFunc.getNextToken Description, PredicateOrderColsDescription, Chr$(2)
    If Len(PredicateOrderColsDescription) > 0 Then
    
        If m_oPredicateOrderCols Is Nothing Then
        
            Set m_oPredicateOrderCols = New SQLStudioMan.predicateOrderCols
            m_oPredicateOrderCols.setDescription (PredicateOrderColsDescription)
        End If
    End If
    
    'set rc
    setDescription = True
    
    Exit Function

errSetDescription:
    internalerrOr Err, MODULE_NAME, FUNCTION_NAME
End Function


