VERSION 5.00
Begin VB.Form frmZoom 
   Caption         =   "Zoom"
   ClientHeight    =   5220
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6885
   Icon            =   "Zoom.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5220
   ScaleWidth      =   6885
   StartUpPosition =   1  'CenterOwner
   Begin SQLStudioQCon.Zoom ctlZoom 
      Height          =   5220
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   6870
      _ExtentX        =   12118
      _ExtentY        =   9208
   End
End
Attribute VB_Name = "frmZoom"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Form: frmZoom.frm
'
'-----------------------------------------------------------------------
'
' responsible:  WolfgangA
'
' special area: SQL Studio Controls
'
' description:  Form for zooming of result values
'
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
'module name
'--------------------------------------------------------
Const MODULE_NAME = "SAPDB.frmZoom"
'=========================================================================================
'    function:      setZoomText
'    description:   set the buffer in zoom control
'    arguments:     [in] sZoomText, buffer to be shown in zoom control
'                   ByRef is used to prevent a copy of the string
'                   String can be very large
'
'    return value:  /
'
'=========================================================================================
Public Function setZoomText(ByRef sZoomText As String)
    On Error GoTo errSetZoomText

    Const FUNCTION_NAME = "setZoomText"
    
    'set caption
    Me.Caption = "Zoom into " + m_oComFunc.MakeCaption(sZoomText, 50)
        
    'set buffer in zoom control
    ctlZoom.zoomText = sZoomText
    
    Exit Function
    
errSetZoomText:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      _CloseMe
'    description:   message from zoom control
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub ctlZoom_CloseMe()
    On Error GoTo errCtlZoom_CloseMe

    Const FUNCTION_NAME = "ctlZoom_CloseMe"
    
    Unload Me
    
    Exit Sub
    
errCtlZoom_CloseMe:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._KeyDown
'    description:   Occurs when the user presses (KeyDown)  a key while an object has the focus.
'    arguments:     [in] KeyCode, a key code, such as vbKeyF1 (the F1 key) or vbKeyHome (the HOME key).
'                   [in] Shift, an integer that corresponds to the state of the SHIFT, CTRL, and ALT keys at the time of the event.
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    On Error GoTo errForm_KeyDown

    Const FUNCTION_NAME = "Form_KeyDown"
    
    If KeyCode = vbKeyEscape Then Unload Me
    
    Exit Sub
    
errForm_KeyDown:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._Load
'    description:   Occurs when a form is loaded.
'                   For a startup form, occurs when an application starts as
'                   the result of a Load statement or as the result of a
'                   reference to an unloaded form's properties or controls.
'
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Load()
    On Error GoTo errForm_Load

    Const FUNCTION_NAME = "Form_Load"
    
    '=variables====================================================================
    Dim hSysMenu As Long
    Dim lMenu    As Long
    '==============================================================================
    
    'disable some system menus
    'get handle to form's system menu (Restore, Maximize, Move, close etc.)
    hSysMenu = GetSystemMenu(Me.hWnd, False)
    If hSysMenu Then
        'Get system menu's menu count
        lMenu = GetMenuItemCount(hSysMenu)
        If lMenu Then
            'menu count is based on 0
            RemoveMenu hSysMenu, lMenu - 1, MF_BYPOSITION Or MF_REMOVE
            RemoveMenu hSysMenu, lMenu - 2, MF_BYPOSITION Or MF_REMOVE ' Remove the seperator

            'force caption bar's refresh. disabling close button
            DrawMenuBar Me.hWnd
        End If
    End If

    Exit Sub
    
errForm_Load:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
'=========================================================================================
'    function:      ..._Resize
'    description:   Occurs when an object is first displayed or when the window state of an object changes.
'    arguments:     /
'
'    return value:  /
'
'=========================================================================================
Private Sub Form_Resize()
    On Error GoTo errForm_Resize

    Const FUNCTION_NAME = "Form_Resize"
    
    'resize control
    ctlZoom.Width = Me.ScaleWidth
    ctlZoom.Height = Me.ScaleHeight
    
    Exit Sub
    
errForm_Resize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
