Attribute VB_Name = "Common"
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Module:      Common Module
'
'
'-----------------------------------------------------------------------
'
' responsible:  WolfgangA
'
' special area: SQLStudioUtil
'
' description:  module for common functions
'
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

Public Const const_sQPKEY = "Software\SAP\SAP DBTech\Applications\QP\"
'path for LRU-entries
Public Const const_sKEYNAMEDSN = "DSN"
Public Const const_sKEYNAMEUID = "UID"
Public Const const_sKEYNAMEPWD = "PWD"
Public Const const_sKEYNAMESERVERDB = "SERVERDB"
Public Const const_sKEYNAMESERVERNODE = "SERVERNODE"

'=========================================================================================
'    function:      internalError
'    description:   shows message box with error
'    arguments:     [in] CurrentError, vb error Object
'                   [in] Modulname, name of source modul
'                   [in] FunctionName, name of used function
'    return value:  /
'
'=========================================================================================
Public Function internalError(ByVal CurrentError As ErrObject, ModulName As String, FunctionName As String)
    MsgBox "Module:" + Chr$(9) + ModulName + Chr$(13) + Chr$(10) + "Function:" + Chr$(9) + FunctionName + Chr$(13) + Chr$(10) + "Error No:" + Chr$(9) + Trim$(str$(CurrentError.Number)) + Chr$(13) + Chr$(10) + "Error:" + Chr$(9) + CurrentError.Description, vbExclamation, "Unexpected Error:"
End Function

Public Function bytesToString(bValue As ByteValue) As String
    Dim s As String
    Dim i As Integer
    s = StrConv(bValue.b(), vbUnicode)
    i = InStr(s, Chr(0)) - 1
    bytesToString = Left(s, i)
End Function
Public Function bytesToLong(bValue As ByteValue) As Long
    Dim lValue As LongValue
    LSet lValue = bValue
    bytesToLong = lValue.l
End Function
'=========================================================================================
'    function:      getVersion
'    description:   return the OS as String
'    arguments:     /
'    return value:  OS as string
'
'=========================================================================================
'Public Function getVersion() As String
'    Dim osInfo As OSVERSIONINFO
'    Dim retvalue As Integer
'
'    osInfo.dwOSVersionInfoSize = 148
'    osInfo.szCSDVersion = Space$(128)
'    retvalue = GetVersionExA(osInfo)
'
'    With osInfo
'    Select Case .dwPlatformId
'       Case 1
'          If .dwMinorVersion = 0 Then
'             getVersion = "Windows 95"
'          ElseIf .dwMinorVersion = 10 Then
'             getVersion = "Windows 98"
'          End If
'       Case 2
'          If .dwMajorVersion = 3 Then
'             getVersion = "Windows NT 3.51"
'          ElseIf .dwMajorVersion = 4 Then
'             getVersion = "Windows NT 4.0"
'          ElseIf .dwMajorVersion = 5 Then
'             getVersion = "Windows 2000"
'          End If
'       Case Else
'          getVersion = "Failed"
'    End Select
'    End With
' End Function
'=========================================================================================
'    function:      getInstancecount
'    description:   returns current number of SQL studio instances
'    arguments:     /
'    return value:  number as integer
'
'=========================================================================================

'Public Function getInstancecount() As Integer
'
'      Dim retval As Integer
'
'      retval = 0
'      Select Case getPlatformID()
'
'      Case 1 'Windows 95/98
'
'         Dim f As Long, sname As String
'         Dim hSnap As Long, proc As PROCESSENTRY32
'         hSnap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0)
'         If hSnap = hNull Then Exit Function
'         proc.dwSize = Len(proc)
'         ' Iterate through the processes
'         f = Process32First(hSnap, proc)
'         Do While f
'           sname = StrZToStr(proc.szExeFile)
'           retval = retval + 1
'           f = Process32Next(hSnap, proc)
'         Loop
'
'      Case 2 'Windows NT
'
'         Dim cb As Long
'         Dim cbNeeded As Long
'         Dim NumElements As Long
'         Dim ProcessIDs() As Long
'         Dim cbNeeded2 As Long
'         Dim NumElements2 As Long
'         Dim Modules(1 To 200) As Long
'         Dim lRet As Long
'         Dim ModuleName As String
'         Dim nSize As Long
'         Dim hProcess As Long
'         Dim i As Long
'         'Get the array containing the process id's for each process object
'         cb = 8
'         cbNeeded = 96
'         Do While cb <= cbNeeded
'            cb = cb * 2
'            ReDim ProcessIDs(cb / 4) As Long
'            lRet = EnumProcesses(ProcessIDs(1), cb, cbNeeded)
'         Loop
'         NumElements = cbNeeded / 4
'
'         For i = 1 To NumElements
'            'Get a handle to the Process
'            hProcess = OpenProcess(PROCESS_QUERY_INFORMATION _
'               Or PROCESS_VM_READ, 0, ProcessIDs(i))
'            'Got a Process handle
'            If hProcess <> 0 Then
'                'Get an array of the module handles for the specified
'                'process
'                lRet = EnumProcessModules(hProcess, Modules(1), 200, _
'                                             cbNeeded2)
'                'If the Module Array is retrieved, Get the ModuleFileName
'                If lRet <> 0 Then
'                   ModuleName = Space(MAX_PATH)
'                   nSize = 500
'                   lRet = GetModuleFileNameExA(hProcess, Modules(1), _
'                                   ModuleName, nSize)
'                   List1.AddItem Left(ModuleName, lRet)
'                End If
'            End If
'          'Close the handle to the process
'         lRet = CloseHandle(hProcess)
'         Next
'
'      End Select
'End Function


 
 
'=========================================================================================
'    function:      getPlatformID
'    description:   return the OS as enum
'    arguments:     /
'
'    return value:  OS as enum
'
'=========================================================================================
'Public Function getPlatformID() As platformId
'
'    Dim osInfo As OSVERSIONINFO
'    Dim retvalue As Integer
'
'    osInfo.dwOSVersionInfoSize = 148
'    osInfo.szCSDVersion = Space$(128)
'    retvalue = GetVersionExA(osInfo)
'
'    getPlatformID = osInfo.dwPlatformId
'
' End Function
'



