Attribute VB_Name = "Core"
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Module:      Core Module
'
'
'-----------------------------------------------------------------------
'
' responsible:  WolfgangA
'
' special area: SQLStudioUtil
'
' description:  module for Function imports, constants ...
'
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit


Public Type ByteValue
    b(1024) As Byte
End Type

Public Type LongValue
    l As Long
End Type

'Structures Needed For Registry Prototypes
Public Type SECURITY_ATTRIBUTES
    nLength As Long
    lpSecurityDescriptor As Long
    bInheritHandle As Boolean
End Type

Public Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type


' Types
Type SystemTime
        wYear       As Integer
        wMonth      As Integer
        wDayOfWeek  As Integer
        wDay        As Integer
        wHour       As Integer
        wMinute     As Integer
        wSecond     As Integer
        wMilliseconds As Integer
End Type

'   These characters aren't supported by Microsoft Windows.
'* * Values 8, 9, 10, and 13 convert to backspace, tab, linefeed, and carriage return characters, respectively. They have no graphical representation but, depending on the

'''                   Win95     Win98     WinNT 3.51     WinNT 4.0   Win2000
'''                  -------------------------------------------------------
'''dwPlatFormID         1         1            2            2        2
'''
'''dwMajorVersion       4         4            3            4        5
'''
'''dwMinorVersion       0        10           51            0        0


Public Type OSVERSIONINFO

   dwOSVersionInfoSize As Long
   dwMajorVersion As Long
   dwMinorVersion As Long
   dwBuildNumber As Long
   dwPlatformId As Long
   szCSDVersion As String * 128
End Type

Public Type PROCESSENTRY32
   dwSize As Long
   cntUsage As Long
   th32ProcessID As Long           ' This process
   th32DefaultHeapID As Long
   th32ModuleID As Long            ' Associated exe
   cntThreads As Long
   th32ParentProcessID As Long     ' This process's parent process
   pcPriClassBase As Long          ' Base priority of process threads
   dwFlags As Long
   szExeFile As String * 260       ' MAX_PATH
End Type




'=imported functions=====================================
Declare Sub GetLocalTime Lib "kernel32" (lpSystemTime As SystemTime)

Declare Function SystemParametersInfoA Lib "User32" ( _
                ByVal uAction As Long, _
                ByVal uparam As Long, _
                lpvParam As Any, _
                ByVal fuWinIni As Long) As Long
                
Declare Function GetProfileString _
        Lib "kernel32" Alias "GetProfileStringA" (ByVal lpAppName As String, _
                                                  ByVal lpKeyName As String, _
                                                  ByVal lpDefault As String, _
                                                  ByVal lpReturnedString As String, _
                                                  ByVal nSize As Long) As Long


Public Declare Function GetVersionExA Lib "kernel32" _
                        (lpVersionInformation As OSVERSIONINFO) As Integer

Public Declare Function RegOpenKeyExA Lib "advapi32" ( _
                    ByVal hKey As Long, _
                    ByVal lpSubKey As String, _
                    ByVal ulOptions As Long, _
                    ByVal samDesired As Long, _
                    phkResult As Long) As Long
    
Public Declare Function RegOpenKeyExW Lib "advapi32" ( _
    ByVal hKey As Long, _
    lpSubKey As Byte, _
    ByVal ulOptions As Long, _
    ByVal samDesired As Long, _
    phkResult As Long) As Long

Public Declare Function RegCreateKeyExA Lib "advapi32" ( _
    ByVal hKey As Long, _
    ByVal lpSubKey As String, _
    ByVal Reserved As Long, _
    ByVal lpClass As String, _
    ByVal dwOptions As Long, _
    ByVal samDesired As Long, _
    lpSecurityAttributes As SECURITY_ATTRIBUTES, _
    phkResult As Long, _
    lpdwDisposition As Long) As Long

Public Declare Function RegCreateKeyExW Lib "advapi32" ( _
    ByVal hKey As Long, _
    lpSubKey As Byte, _
    ByVal Reserved As Long, _
    lpClass As Byte, _
    ByVal dwOptions As Long, _
    ByVal samDesired As Long, _
    lpSecurityAttributes As SECURITY_ATTRIBUTES, _
    phkResult As Long, _
    lpdwDisposition As Long) As Long
    
Public Declare Function RegQueryValueExNullA Lib "advapi32.dll" Alias "RegQueryValueExA" ( _
    ByVal hKey As Long, _
    ByVal lpValueName As String, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    ByVal lpData As Long, _
    lpcbData As Long) As Long

Public Declare Function RegQueryValueExNullW Lib "advapi32.dll" Alias "RegQueryValueExW" ( _
    ByVal hKey As Long, _
    lpValueName As Byte, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    ByVal lpData As Long, _
    lpcbData As Long) As Long

Public Declare Function RegQueryValueExStringA Lib "advapi32.dll" Alias "RegQueryValueExA" ( _
    ByVal hKey As Long, _
    ByVal lpValueName As String, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    ByVal lpData As String, _
    lpcbData As Long) As Long
    
Public Declare Function RegQueryValueExStringW Lib "advapi32.dll" Alias "RegQueryValueExW" ( _
    ByVal hKey As Long, _
    lpValueName As Byte, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    lpData As Byte, _
    lpcbData As Long) As Long
    
Public Declare Function RegQueryValueExLongA Lib "advapi32.dll" Alias "RegQueryValueExA" ( _
    ByVal hKey As Long, _
    ByVal lpValueName As String, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    lpData As Long, _
    lpcbData As Long) As Long
    
Public Declare Function RegQueryValueExLongW Lib "advapi32.dll" Alias "RegQueryValueExW" ( _
    ByVal hKey As Long, _
    lpValueName As Byte, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    lpData As Long, _
    lpcbData As Long) As Long


Public Declare Function RegSetValueExStringA Lib "advapi32.dll" Alias "RegSetValueExA" ( _
    ByVal hKey As Long, _
    ByVal lpValueName As String, _
    ByVal Reserved As Long, _
    ByVal dwType As Long, _
    ByVal lpValue As String, _
    ByVal cbData As Long) As Long
    
Public Declare Function RegSetValueExStringW Lib "advapi32.dll" Alias "RegSetValueExW" ( _
    ByVal hKey As Long, _
    lpValueName As Byte, _
    ByVal Reserved As Long, _
    ByVal dwType As Long, _
    lpValue As Byte, _
    ByVal cbData As Long) As Long

    
Public Declare Function RegSetValueExLongA Lib "advapi32.dll" Alias "RegSetValueExA" ( _
    ByVal hKey As Long, _
    ByVal lpValueName As String, _
    ByVal Reserved As Long, _
    ByVal dwType As Long, _
    lpValue As Long, _
    ByVal cbData As Long) As Long
    
Public Declare Function RegSetValueExLongW Lib "advapi32.dll" Alias "RegSetValueExW" ( _
    ByVal hKey As Long, _
    lpValueName As Byte, _
    ByVal Reserved As Long, _
    ByVal dwType As Long, _
    lpValue As Long, _
    ByVal cbData As Long) As Long


Public Declare Function RegEnumKeyExA Lib "advapi32.dll" ( _
    ByVal hKey As Long, _
    ByVal dwIndex As Long, _
    ByVal lpName As String, _
    lpcbName As Long, _
    ByVal lpReserved As Long, _
    ByVal lpClass As String, _
    lpcbClass As Long, _
    lpftLastWriteTime As FILETIME) As Long

Public Declare Function RegEnumKeyExW Lib "advapi32.dll" ( _
    ByVal hKey As Long, _
    ByVal dwIndex As Long, _
    lpName As Byte, _
    lpcbName As Long, _
    ByVal lpReserved As Long, _
    lpClass As Byte, _
    lpcbClass As Long, _
    lpftLastWriteTime As FILETIME) As Long

Public Declare Function RegEnumValueA Lib "advapi32.dll" ( _
    ByVal hKey As Long, _
    ByVal dwIndex As Long, _
    ByVal lpValueName As String, _
    lpcbValueName As Long, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    lpData As Any, _
    lpcbData As Long) As Long
    
Public Declare Function RegEnumValueW Lib "advapi32.dll" ( _
    ByVal hKey As Long, _
    ByVal dwIndex As Long, _
    lpValueName As Byte, _
    lpcbValueName As Long, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    lpData As Any, _
    lpcbData As Long) As Long

Public Declare Function RegDeleteKeyA Lib "advapi32.dll" ( _
    ByVal hKey As Long, _
    ByVal lpSubKey As String) As Long
    
Public Declare Function RegDeleteKeyW Lib "advapi32.dll" ( _
    ByVal hKey As Long, _
    lpSubKey As Byte) As Long

Public Declare Function RegDeleteValueA Lib "advapi32.dll" ( _
    ByVal hKey As Long, _
    ByVal lpValueName As String) As Long

Public Declare Function RegDeleteValueW Lib "advapi32.dll" ( _
                                                ByVal hKey As Long, _
                                                lpValueName As Byte) As Long
    
Public Declare Function RegCloseKey Lib "advapi32" (ByVal hKey As Long) As Long

Declare Function convertVB_UCS2ToUTF8 Lib "StudioUtil.dll" _
        (srcBeg As Byte, _
        ByVal srcSize As Long, _
        destBeg As Byte, _
        ByVal destSize As Long, _
        destUsed As Long) As Byte


Declare Function convertUTF8ToVB_UCS2 Lib "StudioUtil.dll" _
        (srcBeg As Byte, _
        ByVal srcSize As Long, _
        destBeg As Byte, _
        ByVal destSize As Long, _
        destUsed As Long) As Byte
        
Public Declare Function CreateToolhelp32Snapshot Lib "kernel32" ( _
         ByVal dwFlags As Long, ByVal th32ProcessID As Long) As Long

Public Declare Function Process32First Lib "kernel32" ( _
   ByVal hSnapshot As Long, lppe As PROCESSENTRY32) As Long

Public Declare Function Process32Next Lib "kernel32" ( _
   ByVal hSnapshot As Long, lppe As PROCESSENTRY32) As Long

Public Declare Function EnumProcesses Lib "psapi.dll" _
   (ByRef lpidProcess As Long, ByVal cb As Long, _
      ByRef cbNeeded As Long) As Long

Public Declare Function OpenProcess Lib "Kernel32.dll" _
  (ByVal dwDesiredAccessas As Long, ByVal bInheritHandle As Long, _
      ByVal dwProcId As Long) As Long

Public Declare Function EnumProcessModules Lib "psapi.dll" _
   (ByVal hProcess As Long, ByRef lphModule As Long, _
      ByVal cb As Long, ByRef cbNeeded As Long) As Long

Public Declare Function GetModuleFileNameExA Lib "psapi.dll" _
   (ByVal hProcess As Long, ByVal hModule As Long, _
      ByVal ModuleName As String, ByVal nSize As Long) As Long
      
Public Declare Function CloseHandle Lib "Kernel32.dll" _
   (ByVal Handle As Long) As Long


Public Const TH32CS_SNAPPROCESS = &H2&
Public Const hNull = 0
Public Const PROCESS_QUERY_INFORMATION = 1024
Public Const PROCESS_VM_READ = 16
Public Const MAX_PATH = 260


'===========================================================================

