VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FreeList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Class:      SQLStudioUtil.FreeList - Freelist Management
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

' Module name
Const MODULE_NAME = "SQLStudioUtil.FreeList"

' Private copy of properties
Private pRangeFrom  As Long
Private pRangeTo    As Long
Private pFreeCount  As Long

' Other local variables
Private pArray()    As Boolean
Private pIsCreated  As Boolean
Public Property Get freeCount() As Long
    On Error GoTo Err_GET_FreeCount
    
    Const FUNCTION_NAME = "P_GET freeCount"
    
    freeCount = pFreeCount
    
    Exit Property
    
Err_GET_FreeCount:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get isFree(ByVal Index As Long) As Boolean
    On Error GoTo err_GET_IsFree
    
    Const FUNCTION_NAME = "P_get isFree"
    
    ' Is array item free
    If pIsCreated And Index >= pRangeFrom And Index <= pRangeTo Then
        isFree = Not pArray(Index - pRangeFrom)
    Else
        isFree = True
    End If
    
    Exit Property
    
err_GET_IsFree:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get rangeFrom() As Long
    On Error GoTo err_GET_RangeFrom
    
    Const FUNCTION_NAME = "P_Get rangeFrom"
    
    rangeFrom = pRangeFrom
    
    Exit Property
    
err_GET_RangeFrom:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get rangeTo() As Long
    On Error GoTo err_GET_RangeFrom
    
    Const FUNCTION_NAME = "P_Get rangeFrom"
    
    rangeTo = pRangeTo
    
    Exit Property
    
err_GET_RangeFrom:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Function getNextFreeIndex(freeIndex As Long) As Boolean
    On Error GoTo errGetNextFreeIndex
    
    Const FUNCTION_NAME = "getNextFreeIndex"
    
    Dim i   As Long
    Dim j   As Long
    
    ' Inits
    getNextFreeIndex = False
    j = 0
    
    For i = pRangeFrom To pRangeTo
        If Not pArray(j) Then
            pArray(j) = True    ' Used now
            pFreeCount = pFreeCount - 1
            
            ' Set rc
            freeIndex = i
            getNextFreeIndex = True
            
            Exit Function
        End If
        ' Increment array index
        j = j + 1
    Next
    
    Exit Function
    
errGetNextFreeIndex:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function freeIndex(ByVal IndexToFree As Long) As Boolean
    On Error GoTo errFreeIndex
    
    Const FUNCTION_NAME = "freeIndex"
    
    ' Inits
    freeIndex = False
    
    pArray(IndexToFree - pRangeFrom) = False  ' Free now
    pFreeCount = pFreeCount + 1
    
    ' Set rc
    freeIndex = True
    
    Exit Function
    
errFreeIndex:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Friend Function createList(ByVal rangeFrom As Long, ByVal rangeTo As Long) As Boolean
    On Error GoTo errCreateList
    
    Const FUNCTION_NAME = "createList"
    
    ' Inits
    createList = False
    
    ' Check
    If rangeTo - rangeFrom < 1 Then
        Exit Function
    End If
    
    ' Set properties
    pRangeFrom = rangeFrom
    pRangeTo = rangeTo
    pFreeCount = rangeTo - rangeFrom + 1
    
    ReDim pArray(pFreeCount)
    
    ' Set created flag
    pIsCreated = True
    
    ' Set rc
    createList = True
    
    Exit Function
    
errCreateList:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

