VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Hourglass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Class:      SQLStudioUtil.Hourglass - Hourglass
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

'--------------------------------------------------------
' Module Name
'--------------------------------------------------------
Const MODULE_NAME = "SQLStudioUtil.Hourglass"

' Public enumerations
Public Enum hourGlassState
    qpHourglassOff = 0
    qpHourglassOn = 1
    qpArrowHourglassOn = 2
    qpArrowHourglassOff = 3
    qpArrowWEOn = 4
    qpArrowWEOff = 5
    qpArrowNSOn = 6
    qpArrowNSOff = 7
    qpIBeam = 8
End Enum


' Local property copies
Private pAppliedObject  As Object
Private pState          As hourGlassState

' Other private variables
Dim HourglassCounter    As Long
Public Property Set appliedObject(NewAppliedObject As Object)
    On Error GoTo errP_SET_AppliedObject

    Const FUNCTION_NAME = "P_Set appliedObject"
    
    Set pAppliedObject = NewAppliedObject
    
    Exit Property
    
errP_SET_AppliedObject:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Let state(NewState As hourGlassState)
    On Error GoTo errP_LET_State

    Const FUNCTION_NAME = "P_LET State"
    
    Dim ArrowHourglassCounter   As Long
    
    pState = NewState
    
    ' Switch hourglass
    Select Case pState
        Case qpHourglassOn:
        
            HourglassCounter = HourglassCounter + 1
            pAppliedObject.MousePointer = vbHourglass
        Case qpHourglassOff:
        
            HourglassCounter = HourglassCounter - 1
            If HourglassCounter < 1 Then
            
                HourglassCounter = 0
                If ArrowHourglassCounter < 1 Then
                
                   pAppliedObject.MousePointer = vbDefault
                   pState = qpHourglassOff
                End If
            End If
        Case qpArrowHourglassOn:
            ArrowHourglassCounter = ArrowHourglassCounter + 1
            pAppliedObject.MousePointer = vbArrowHourglass
        Case qpArrowHourglassOff
            ArrowHourglassCounter = ArrowHourglassCounter - 1
            
            If ArrowHourglassCounter < 1 Then
            
                ArrowHourglassCounter = 0
                If HourglassCounter < 1 Then
                
                    pAppliedObject.MousePointer = vbDefault
                    pState = qpHourglassOff
                Else
                    pAppliedObject.MousePointer = vbHourglass
                End If
            End If
        Case qpIBeam:
            If HourglassCounter < 1 And ArrowHourglassCounter < 1 _
            Then pAppliedObject.MousePointer = vbIbeam
        Case qpArrowWEOn:
            If HourglassCounter < 1 And ArrowHourglassCounter < 1 _
            Then pAppliedObject.MousePointer = vbSizeWE
        Case qpArrowWEOff:
            If HourglassCounter < 1 And ArrowHourglassCounter < 1 Then _
            
                pAppliedObject.MousePointer = vbDefault
                pState = qpHourglassOff
            Else
                If ArrowHourglassCounter < 1 Then
            
                    ArrowHourglassCounter = 0
                    If HourglassCounter < 1 Then
                    
                        pAppliedObject.MousePointer = vbDefault
                        pState = qpHourglassOff
                    Else
                        pAppliedObject.MousePointer = vbHourglass
                    End If
                End If
                If HourglassCounter < 1 Then
            
                    HourglassCounter = 0
                    If ArrowHourglassCounter < 1 Then
                    
                       pAppliedObject.MousePointer = vbDefault
                       pState = qpHourglassOff
                    Else
                       pAppliedObject.MousePointer = vbArrowHourglass
                    End If
                End If
            End If
    End Select
    
    Exit Property
    
errP_LET_State:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get state() As hourGlassState
    On Error GoTo errP_GET_State

    Const FUNCTION_NAME = "P_Get state"
    
    state = pState
    
    
    Exit Property
    
errP_GET_State:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property

Private Sub Class_Initialize()
    On Error GoTo ErrClass_Initialize

    Const FUNCTION_NAME = "Class_Initialize"
    
    ' Inits
    Set pAppliedObject = Screen
    pState = qpHourglassOff
    
    HourglassCounter = 0
    
    Exit Sub
    
ErrClass_Initialize:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Sub
