VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "International"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Class:      International - International Setings
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

' Module name
Const MODULE_NAME = "International"

' Local constants
Const cnstCountry = "iCountry"
Const cnstCurrDigits = "iCurrDigits"
Const cnstCurrencyType = "iCurrency"
Const cnstDateType = "iDate"
Const cnstDigitsType = "iDigits"
Const cnstLeadingZero = "iLZero"
Const cnstMeasure = "iMeasure"
Const cnstNegCurr = "iNegCurr"
Const cnstTimeType = "iTime"
Const cnstTimeLeadingZero = "iTLZero"
Const cnstLocale = "Locale"
Const cnstTime1159 = "s1159"
Const cnstTime2359 = "s2359"
Const cnstCountryName = "sCountry"
Const cnstCurrencyName = "sCurrency"
Const cnstDateSeparator = "sDate"
Const cnstDecimalSeparator = "sDecimal"
Const cnstLanguage = "sLanguage"
Const cnstListSeparator = "sList"
Const cnstLongDate = "sLongDate"
Const cnstShortDate = "sShortDate"
Const cnstThousandSeparator = "sThousand"
Const cnstTimeSeparator = "sTime"

'private property variables
Private pCountry            As String
Private pCurrDigits         As String
Private pCurrencyType       As String
Private pDateType           As String
Private pDigitsType         As String
Private pLeadingZero        As String
Private pMeasure            As String
Private pNegCurr            As String
Private pTimeType           As String
Private pTimeLeadingZero    As String
Private pLocale             As String
Private pTime1159           As String
Private pTime2359           As String
Private pCountryName        As String
Private pCurrencyName       As String
Private pDateSeparator      As String
Private pDecimalSeparator   As String
Private pLanguage           As String
Private pListSeparator      As String
Private pLongDate           As String
Private pShortDate          As String
Private pThousandSeparator  As String
Private pTimeSeparator      As String

Public Property Get country() As String
    On Error GoTo errP_GET_Country

    Const FUNCTION_NAME = "P_get country"
    
    country = pCountry
    
    Exit Property
    
errP_GET_Country:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get currDigits() As String
    On Error GoTo errP_GET_CurrDigits

    Const FUNCTION_NAME = "P_get currDigits"
    
    currDigits = pCurrDigits
    
    Exit Property
    
errP_GET_CurrDigits:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get currencyType() As String
    On Error GoTo errP_GET_CurrencyType

    Const FUNCTION_NAME = "P_get currencyType"
    
    currencyType = pCurrencyType
    
    Exit Property
    
errP_GET_CurrencyType:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get dateType() As String
    On Error GoTo errP_GET_DateType

    Const FUNCTION_NAME = "P_Get dateType"
    
    dateType = pDateType
    
    Exit Property
    
errP_GET_DateType:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get digitsType() As String
    On Error GoTo errP_GET_DigitsType

    Const FUNCTION_NAME = "P_Get digitsType"
    
    digitsType = pDigitsType
    
    Exit Property
    
errP_GET_DigitsType:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get leadingZero() As String
    On Error GoTo errP_GET_LeadingZero

    Const FUNCTION_NAME = "P_Get leadingZero"
    
    leadingZero = pLeadingZero
    
    Exit Property
    
errP_GET_LeadingZero:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get measure() As String
    On Error GoTo errP_GET_Measure

    Const FUNCTION_NAME = "P_Get measure"
    
    measure = pMeasure
    
    Exit Property
    
errP_GET_Measure:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get negCurr() As String
    On Error GoTo errP_GET_NegCurr

    Const FUNCTION_NAME = "P_get negCurr"
    
    negCurr = pNegCurr
    
    Exit Property
    
errP_GET_NegCurr:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get timeType() As String
    On Error GoTo errP_GET_TimeType

    Const FUNCTION_NAME = "P_Get timeType"
    
    timeType = pTimeType
    
    Exit Property
    
errP_GET_TimeType:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get timeLeadingZero() As String
    On Error GoTo errP_GET_TimeLeadingZero

    Const FUNCTION_NAME = "P_Get timeLeadingZero"
    
    timeLeadingZero = pTimeLeadingZero
    
    Exit Property
    
errP_GET_TimeLeadingZero:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get locale() As String
    On Error GoTo errP_GET_Locale

    Const FUNCTION_NAME = "P_Get locale"
    
    locale = pLocale
    
    Exit Property
    
errP_GET_Locale:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get time1159() As String
    On Error GoTo errP_GET_Time1159

    Const FUNCTION_NAME = "P_Get time1159"
    
    time1159 = pTime1159
    
    Exit Property
    
errP_GET_Time1159:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get time2359() As String
    On Error GoTo errP_GET_Time2359

    Const FUNCTION_NAME = "P_Get time2359"
    
    time2359 = pTime2359
    
    Exit Property
    
errP_GET_Time2359:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get countryName() As String
    On Error GoTo errP_GET_CountryName

    Const FUNCTION_NAME = "P_get countryName"
    
    countryName = pCountryName
    
    Exit Property
    
errP_GET_CountryName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get currencyName() As String
    On Error GoTo errP_GET_CurrencyName

    Const FUNCTION_NAME = "P_get currencyName"
    
    currencyName = pCurrencyName
    
    Exit Property
    
errP_GET_CurrencyName:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get dateSeparator() As String
    On Error GoTo errP_GET_DateSeparator

    Const FUNCTION_NAME = "P_Get dateSeparator"
    
    dateSeparator = pDateSeparator
    
    Exit Property
    
errP_GET_DateSeparator:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get decimalSeparator() As String
    On Error GoTo errP_GET_DecimalSeparator

    Const FUNCTION_NAME = "P_Get decimalSeparator"
    
    decimalSeparator = pDecimalSeparator
    
    Exit Property
    
errP_GET_DecimalSeparator:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get language() As String
    On Error GoTo errP_GET_Language

    Const FUNCTION_NAME = "P_Get language"
    
    language = pLanguage
    
    Exit Property
    
errP_GET_Language:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get listSeparator() As String
    On Error GoTo errP_GET_ListSeparator

    Const FUNCTION_NAME = "P_Get listSeparator"
    
    listSeparator = pListSeparator
    
    Exit Property
    
errP_GET_ListSeparator:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get longDate() As String
    On Error GoTo errP_GET_LongDate

    Const FUNCTION_NAME = "P_Get longDate"
    
    longDate = pLongDate
    
    Exit Property
    
errP_GET_LongDate:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get shortDate() As String
    On Error GoTo errP_GET_ShortDate

    Const FUNCTION_NAME = "P_Get shortDate"
    
    shortDate = pShortDate
    
    Exit Property
    
errP_GET_ShortDate:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get thousandSeparator() As String
    On Error GoTo errP_GET_ThousandSeparator

    Const FUNCTION_NAME = "P_Get thousandSeparator"
    
    thousandSeparator = pThousandSeparator
    
    Exit Property
    
errP_GET_ThousandSeparator:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Public Property Get timeSeparator() As String
    On Error GoTo errP_GET_TimeSeparator

    Const FUNCTION_NAME = "P_Get timeSeparator"
    
    timeSeparator = pTimeSeparator
    
    Exit Property
    
errP_GET_TimeSeparator:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Property
Private Function getSettings() As Boolean
    On Error GoTo errGetSettings

    Const FUNCTION_NAME = "GetSettings"
    
    Const MX_KEY_VALUE = 64
    
    Dim KeyValue        As String
    Dim RC              As Long
    
    ' Inits
    getSettings = False
    
    'get country
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstCountry, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pCountry = ""
    Else
        pCountry = nullTrim(KeyValue)
    End If
    
    'get currDigits
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstCurrDigits, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pCurrDigits = ""
    Else
        pCurrDigits = nullTrim(KeyValue)
    End If
    
    'get currencyType
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstCurrencyType, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pCurrencyType = ""
    Else
        pCurrencyType = nullTrim(KeyValue)
    End If
    
    'Get dateType
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstDateType, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pDateType = ""
    Else
        pDateType = nullTrim(KeyValue)
    End If
    
    'Get digitsType
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstDigitsType, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pDigitsType = ""
    Else
        pDigitsType = nullTrim(KeyValue)
    End If
    
    'get LeadingZero
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstLeadingZero, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pLeadingZero = ""
    Else
        pLeadingZero = nullTrim(KeyValue)
    End If
    
    'Get measure
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstMeasure, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pMeasure = ""
    Else
        pMeasure = nullTrim(KeyValue)
    End If
    
    'get negCurr
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstNegCurr, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pNegCurr = ""
    Else
        pNegCurr = nullTrim(KeyValue)
    End If
    
    'Get timeType
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstTimeType, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pTimeType = ""
    Else
        pTimeType = nullTrim(KeyValue)
    End If
    
    'Get timeLeadingZero
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstTimeLeadingZero, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pTimeLeadingZero = ""
    Else
        pTimeLeadingZero = nullTrim(KeyValue)
    End If
    
    'get Locale
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstLocale, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pLocale = ""
    Else
        pLocale = nullTrim(KeyValue)
    End If
    
    'Get time1159
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstTime1159, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pTime1159 = ""
    Else
        pTime1159 = nullTrim(KeyValue)
    End If
    
    'Get time2359
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstTime2359, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pTime2359 = ""
    Else
        pTime2359 = nullTrim(KeyValue)
    End If
    
    'get countryName
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstCountryName, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pCountryName = ""
    Else
        pCountryName = nullTrim(KeyValue)
    End If
    
    'get currencyName
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstCurrencyName, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pCurrencyName = ""
    Else
        pCurrencyName = nullTrim(KeyValue)
    End If
    
    'Get dateSeparator
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstDateSeparator, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pDateSeparator = ""
    Else
        pDateSeparator = nullTrim(KeyValue)
    End If
    
    'Get decimalSeparator
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstDecimalSeparator, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pDecimalSeparator = ""
    Else
        pDecimalSeparator = nullTrim(KeyValue)
    End If
    
    'get Language
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstLanguage, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pLanguage = ""
    Else
        pLanguage = nullTrim(KeyValue)
    End If
    
    'get ListSeparator
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstListSeparator, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pListSeparator = ""
    Else
        pListSeparator = nullTrim(KeyValue)
    End If
    
    'get LongDate
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstLongDate, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pLongDate = ""
    Else
        pLongDate = nullTrim(KeyValue)
    End If
    
    'Get shortDate
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstShortDate, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pShortDate = ""
    Else
        pShortDate = nullTrim(KeyValue)
    End If
    
    'Get thousandSeparator
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstThousandSeparator, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pThousandSeparator = ""
    Else
        pThousandSeparator = nullTrim(KeyValue)
    End If
    
    'Get timeSeparator
    KeyValue = Space(MX_KEY_VALUE)
    RC = getProfileString("INTL", cnstTimeSeparator, "", KeyValue, MX_KEY_VALUE)
    If RC = 0 Then
        pTimeSeparator = ""
    Else
        pTimeSeparator = nullTrim(KeyValue)
    End If
    
    'rc
    getSettings = True
    
    Exit Function
    
errGetSettings:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Public Function refresh() As Boolean
    On Error GoTo errRefresh

    Const FUNCTION_NAME = "Refresh"
    
    'Get settings
    getSettings
    
    Exit Function
    
errRefresh:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Private Function nullTrim(ByVal Src As String) As String
    On Error GoTo errNullTrim

    Const FUNCTION_NAME = "nullTrim"

    Dim i       As Long
    Dim ch      As Integer
    Dim lSrcLen As Long
    Dim lCount  As Long

    'rc
    nullTrim = ""
    
    'init
    lCount = 0
    
    lSrcLen = Len(Src)
    For i = lSrcLen To 1 Step -1
        ch = Asc(Mid$(Src, i, 1))
        If ch = 32 Or ch = 0 Then
            
            lCount = lCount + 1
        Else
            Exit For
        End If
    Next
    
    If lSrcLen >= lCount Then nullTrim = Left(Src, lSrcLen - lCount)

    Exit Function

errNullTrim:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

