VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Functions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Class:      SQLStudioUtil.Functions -  Public Functions
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

' Module name
Const MODULE_NAME = "SQLStudioUtil.Functions"

Public Enum qplTokenSeperator

    qplSaveObjectLevel1 = 1
    qplSaveObjectLevel2 = 2
    qplObjectLevel1 = 3
    qplObjectLevel2 = 4
    qplObjectLevel3 = 5
    qplObjectLevel4 = 6
    qplObjectLevel5 = 7
    qplObjectLevel6 = 8
    qplObjectLevel7 = 9
End Enum

'  0     32 [space]  64 @     96    `
'  1     33 !        65 A     97    a
'  2     34 "        66 B     98    b
'  3     35 #        67 C     99    c
'  4     36 $        68 D    100    d
'  5     37 %        69 E    101    e
'  6     38 &        70 F    102    f
'  7     39 '        71 G    103    g
'  8 * *  40 (        72 H    104    h
'  9 * *  41 )        73 I    105    i
' 10 * *  42 *        74 J    106    j
' 11     43 +        75 K    107    k
' 12     44 ,        76 L    108    l
' 13 * *  45 -        77 M    109    m
' 14     46 .        78 N    110    n
' 15     47 /        79 O    111    o
' 16     48 0        80 P    112    p
' 17     49 1        81 Q    113    q
' 18     50 2        82 R    114    r
' 19     51 3        83 S    115    s
' 20     52 4        84 T    116    t
' 21     53 5        85 U    117    u
' 22     54 6        86 V    118    v
' 23     55 7        87 W    119    w
' 24     56 8        88 X    120    x
' 25     57 9        89 Y    121    y
' 26     58 :        90 Z    122    z
' 27     59 ;        91 [    123    {
' 28     60 <        92 \    124    |
' 29     61 =        93 ]    125    }
' 30     62 >        94 ^    126    ~
' 31     63 ?        95 _    127    



Public Enum platformId

    Win95_98 = 1
    WinNT351_40_2000 = 2
End Enum

Public Function convertStringForCharCol(ByVal StringToConvert As String, ByVal bConvertWholeString As Boolean) As String
    On Error GoTo errConvertStringForCharCol

    Const FUNCTION_NAME = "convertStringForCharCol"
    
    Dim i           As Integer
    Dim ch          As String
    Dim StrLen      As Integer
    Dim NewCharCol  As String

    convertStringForCharCol = ""

    If Len(StringToConvert) = 0 Or InStr(StringToConvert, "'") = 0 Then '= 0
    
        convertStringForCharCol = StringToConvert
        Exit Function
    End If

    StrLen = Len(StringToConvert)
    For i = 1 To StrLen
        ch = Mid$(StringToConvert, i, 1)
        If (ch = "'" And i > 1 And i < StrLen) Or (ch = "'" And bConvertWholeString) Then
            NewCharCol = NewCharCol + "''"
        ElseIf ch <> "'" Then
            NewCharCol = NewCharCol + ch
        End If
    Next
    
    convertStringForCharCol = NewCharCol

    Exit Function

errConvertStringForCharCol:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function replaceTabAndCR(Text As String)
    On Error GoTo errReplaceTabAndCR

    Const FUNCTION_NAME = "replaceTabAndCR"

    ' Replace tabulators
    Call replace(Text, Chr$(9), " ")
    
    ' Replace CR/LF
    Call replace(Text, Chr$(13) + Chr$(10), " ")
    
    ' Replace LF/CR
    Call replace(Text, Chr$(10) + Chr$(13), " ")
    
    ' Replace LF
    Call replace(Text, Chr$(10), " ")
    
    ' Replace CR
    Call replace(Text, Chr$(13), " ")

    Exit Function

errReplaceTabAndCR:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function replaceNonChars(Text As String)
    On Error GoTo errReplaceNonChars

    Const FUNCTION_NAME = "replaceNonChars"
    
    Dim i   As Integer
    
    ' 9 = Replace tabulators
    For i = 0 To 9
        Call replace(Text, Chr$(i), " ")
    Next i
    
    ' Replace tabulators
    Call replace(Text, Chr$(11), " ")
    Call replace(Text, Chr$(12), " ")
    
    For i = 14 To 31
        Call replace(Text, Chr$(i), " ")
    Next i
    
    ' Replace CR/LF
    Call replace(Text, Chr$(13) + Chr$(10), " ")
    
    ' Replace LF/CR
    Call replace(Text, Chr$(10) + Chr$(13), " ")
    
    ' Replace LF
    Call replace(Text, Chr$(10), " ")
    
    ' Replace CR
    Call replace(Text, Chr$(13), " ")
        
    Exit Function

errReplaceNonChars:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    property:      replace
'    description:   replace non chars in sText
'    arguments:     [in] Text, string to be cleaned
'                   [in] ReplaceOf, partial string to be replaced
'                   [in] ReplaceTo, partial string to be set
'
'    return value:  /
'
'=========================================================================================
Public Function replace(Text As String, ByVal ReplaceOf As String, ByVal ReplaceTo As String)
    On Error GoTo errReplace

    Const FUNCTION_NAME = "replace"

    Dim ReplacePos      As Long
    Dim ReplaceOfLen    As Long
    Dim ReplaceToLen    As Long
    Dim TextLen         As Long

    ReplacePos = InStr(Text, ReplaceOf)
    If ReplacePos = 0 Then Exit Function

    ReplaceOfLen = Len(ReplaceOf)
    TextLen = Len(Text)

    While ReplacePos > 0
        Mid$(Text, ReplacePos, ReplaceOfLen) = ReplaceTo
        ReplaceToLen = Len(ReplaceTo)
        TextLen = TextLen + ReplaceToLen - ReplaceOfLen
        If ReplacePos + ReplaceToLen <= TextLen Then
            ReplacePos = InStr(ReplacePos + ReplaceToLen, Text, ReplaceOf)
        Else
            Exit Function
        End If
    Wend

    Exit Function

errReplace:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function createFreeList(ByVal rangeFrom As Long, ByVal rangeTo As Long) As SQLStudioUtil.FreeList
    On Error GoTo errCreateFreeList

    Const FUNCTION_NAME = "createFreeList"

    ' Inits
    Set createFreeList = Nothing
    
    ' Create new free list
    Dim NewFreeList As New SQLStudioUtil.FreeList
    If Not NewFreeList.createList(rangeFrom, rangeTo) Then Exit Function
    
    ' Set rc
    Set createFreeList = NewFreeList
    
    Exit Function

errCreateFreeList:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function createHistory(ByVal dimension As Long) As SQLStudioUtil.History
    On Error GoTo errCreateHistory

    Const FUNCTION_NAME = "createHistory"

    ' Inits
    Set createHistory = Nothing
    
    ' Create new history
    Dim NewHistory As New SQLStudioUtil.History
    If Not NewHistory.createHistory(dimension) Then
        Exit Function
    End If
    
    ' Set rc
    Set createHistory = NewHistory
    
    Exit Function

errCreateHistory:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function getNextToken(TokenList As String, NextToken As String, ByVal TokenSeparator As String) As Boolean
    On Error GoTo errGetNextToken

    Const FUNCTION_NAME = "getNextToken"
    
    Dim FoundPos As Long
    
    'rc
    getNextToken = False
    
    If Len(TokenList) < 1 Then
        NextToken = ""
        Exit Function
    End If
        
    ' Find separator after token
    FoundPos = InStr(TokenList, TokenSeparator)
    If FoundPos > 0 Then
        NextToken = Left$(TokenList, FoundPos - 1)
        TokenList = Right$(TokenList, Len(TokenList) - FoundPos - Len(TokenSeparator) + 1)
    Else
        NextToken = TokenList
        TokenList = ""
    End If
    
    ' Set rc
    getNextToken = True
    
    Exit Function
    
errGetNextToken:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function getLastToken(TokenList As String, NextToken As String, ByVal TokenSeparator As String) As Boolean
    On Error GoTo errGetLastToken

    Const FUNCTION_NAME = "getLastToken"
    
    Dim FoundPos As Long
    Dim lLen     As Long
    Dim lRun     As Long
    
    'rc
    getLastToken = False
    
    If Len(TokenList) < 1 Then Exit Function
        
    'init
    NextToken = ""
    FoundPos = 0
    lRun = 0
    lLen = Len(TokenList)
    
    Do While FoundPos < 1 And lRun < lLen
    
        FoundPos = InStr(lLen - lRun, TokenList, TokenSeparator)
        
        lRun = lRun + 1
        If FoundPos > 0 Then
            
            NextToken = Right$(TokenList, Len(TokenList) - FoundPos - Len(TokenSeparator) + 1)
            TokenList = Left$(TokenList, FoundPos - 1)
            Exit Do
        End If
    Loop
    
    'rc
    getLastToken = True
    
    Exit Function
    
errGetLastToken:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function getTokenSeperator(Sep As qplTokenSeperator) As String
    On Error GoTo errGetTokenSeperator

    Const FUNCTION_NAME = "getTokenSeperator"
    
    getTokenSeperator = ""
    
    Select Case Sep
        Case qplSaveObjectLevel1
            getTokenSeperator = Chr$(30)
                
        Case qplSaveObjectLevel2
            getTokenSeperator = Chr$(31)
            
        Case qplObjectLevel1
            getTokenSeperator = Chr$(0)
            
        Case qplObjectLevel2
            getTokenSeperator = Chr$(1)
            
        Case qplObjectLevel3
            getTokenSeperator = Chr$(2)
            
        Case qplObjectLevel4
            getTokenSeperator = Chr$(3)
            
        Case qplObjectLevel5
            getTokenSeperator = Chr$(4)
            
       Case qplObjectLevel6
            getTokenSeperator = Chr$(5)
            
       Case qplObjectLevel7
            getTokenSeperator = Chr$(6)
            
        Case Else
            getTokenSeperator = Chr$(0)
            
    End Select
    
    Exit Function
    
errGetTokenSeperator:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'''Public Function hexToAsc(ByVal HexStr As String) As String
'''    On Error GoTo ErrHexToAsc
'''
'''    Const FUNCTION_NAME = "HexToAsc"
'''
'''    Dim i       As Long
'''    Dim AscStr  As String
'''
'''    For i = 1 To Len(HexStr) Step 2
'''        AscStr = AscStr + Chr$("&H" + Mid$(HexStr, i, 2))
'''    Next
'''
'''    HexToAsc = AscStr
'''
'''    Exit Function
'''
'''ErrHexToAsc:
'''    internalError Err, MODULE_NAME, FUNCTION_NAME
'''End Function
Public Function makeCaption(ByVal NewCaption As String, ByVal MaxLen As Long) As String
    On Error GoTo errMakeCaption

    Const FUNCTION_NAME = "makeCaption"
    
    ' Skip leading new lines, tabs, blanks
    While Left$(NewCaption, 1) = vbTab Or Left$(NewCaption, 1) = " " Or Left$(NewCaption, 2) = vbCr + vbLf
        NewCaption = skip(NewCaption, vbTab)
        NewCaption = skip(NewCaption, " ")
        NewCaption = skip(NewCaption, vbCr + vbLf)
    Wend
    
    ' Search new line
    replaceTabAndCR NewCaption
    
    If Len(NewCaption) > MaxLen Then NewCaption = Left(NewCaption, (MaxLen - 3)) + "..."
    
    ' Set rc
    makeCaption = NewCaption
    
    Exit Function
    
errMakeCaption:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function skip(ByVal SrcText As String, ByVal SkipText As String) As String
    On Error GoTo ErrSkip

    Const FUNCTION_NAME = "skip"
    
    Dim SkipTextLen As Long
    
    ' Inits
    SkipTextLen = Len(SkipText)
    
    ' Scan text
    While Mid$(SrcText, 1, SkipTextLen) = SkipText
        SrcText = Right$(SrcText, Len(SrcText) - SkipTextLen)
    Wend
    
    ' Set rc
    skip = SrcText
    
    Exit Function
    
ErrSkip:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function loWord(lWert As Long) As Integer
    On Error GoTo errloWord

    Const FUNCTION_NAME = "loWord"
    
    If lWert < 1 Then
    
        loWord = 0
        Exit Function
    End If
    
    If (lWert And &H8000&) = 0 Then
        loWord = lWert And &HFFFF&
    Else
        loWord = &H8000 And (lWert Or &HFFFF&)
    End If
    
    Exit Function
    
errloWord:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function hiWord(lWert As Long) As Integer
    On Error GoTo errHiWord

    Const FUNCTION_NAME = "hiWord"
    
    If lWert < 1 Then
    
        hiWord = 0
        Exit Function
    End If
    
    If (lWert And &H8000&) = 0 Then
        hiWord = lWert / &H10000
    Else
        hiWord = (lWert And &H7FFF&) / &H10000
    End If
    
    Exit Function
    
errHiWord:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'''Public Function bin(ByVal lWert As Long) As String
'''    On Error GoTo ErrBin
'''
'''    Const FUNCTION_NAME = "Bin"
'''
'''    Dim bDigit  As Byte
'''    Dim n       As Integer
'''    Dim sTemp   As String
'''
'''    For n = 31 To 0 Step -1
'''        bDigit = Int(lWert / 2 ^ n)
'''        sTemp = sTemp & bDigit
'''        lWert = lWert - bDigit * 2 ^ n
'''    Next n
'''
'''
'''    ' Cut zero Bits
'''    For n = 0 To Len(sTemp) - 1
'''        If Left(sTemp, 1) = "0" Then
'''            sTemp = Right(sTemp, Len(sTemp) - 1)
'''        End If
'''    Next n
'''
'''    Bin = sTemp
'''
'''    Exit Function
'''
'''ErrBin:
'''    internalError Err, MODULE_NAME, FUNCTION_NAME
'''End Function
''Public Function binToLong(ByVal sWert As String) As Long
''    On Error GoTo ErrBinToLong
''
''    Const FUNCTION_NAME = "BinToLong"
''
''    Dim bDigit  As Byte
''    Dim bLen    As Byte
''    Dim n       As Integer
''    Dim lTemp   As Long
''
''    BinToLong = 0
''
''    bLen = Len(sWert)
''
''    If bLen > 32 Then Exit Function
''
''    For n = 1 To bLen
''        bDigit = Val(Mid(sWert, n, 1))
''        lTemp = lTemp + bDigit * 2 ^ (bLen - n)
''        BinToLong = lTemp
''    Next n
''
''
''    Exit Function
''
''ErrBinToLong:
''    internalError Err, MODULE_NAME, FUNCTION_NAME
''End Function
''Public Function binToInteger(ByVal sWert As String) As Integer
''    On Error GoTo ErrBinToInteger
''
''    Const FUNCTION_NAME = "BinToInteger"
''
''    Dim bDigit  As Byte
''    Dim bLen    As Byte
''    Dim n       As Integer
''    Dim nTemp   As Integer
''
''    BinToInteger = 0
''
''    bLen = Len(sWert)
''
''    If bLen > 16 Then Exit Function
''
''    For n = 1 To bLen
''        bDigit = Val(Mid(sWert, n, 1))
''        nTemp = nTemp + bDigit * 2 ^ (bLen - n)
''        BinToInteger = nTemp
''    Next n
''
''
''    Exit Function
''
''ErrBinToInteger:
''    internalError Err, MODULE_NAME, FUNCTION_NAME
''End Function
'''Function nullTrim(ByVal Src As String) As String
'''    On Error GoTo errNullTrim
'''
'''    Const FUNCTION_NAME = "NullTrim"
'''
'''    Dim i       As Long
'''    Dim ch      As Integer
'''    Dim dest    As String
'''    Dim SrcLen  As Long
'''
'''    NullTrim = ""
'''
'''    SrcLen = Len(Src)
'''    For i = SrcLen To 1 Step -1
'''        ch = Asc(Mid$(Src, i, 1))
'''        If ch <> 32 And ch <> 0 Then
'''            NullTrim = LTrim$(Left$(Src, i))
'''            Exit Function
'''        End If
'''    Next
'''
'''    Exit Function
'''
'''errNullTrim:
'''    internalError Err, MODULE_NAME, FUNCTION_NAME
'''End Function
Public Function getRegBasicKey() As String
    On Error GoTo errGetRegBasicKey
    
    Const FUNCTION_NAME = "getRegBasicKey"

    getRegBasicKey = const_sQPKEY
    
    Exit Function

errGetRegBasicKey:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function isStatementSupported(ByVal Statement As String) As Boolean
    On Error GoTo errIsStatementSupported
    
    Const FUNCTION_NAME = "isStatementSupported"
    
    Dim TokenList       As String
    Dim NextToken       As String
    
    ' Inits
    isStatementSupported = False
    
    ' Check statement
    If Len(Trim(Statement)) = 0 Then Exit Function
    
    ' Check statement
    If UCase(Left$(Statement, 7)) = "CONNECT" Then
        MsgBox LoadResString(166)
        Exit Function
    End If
    
    TokenList = Statement
    replaceTabAndCR TokenList
    Do
        getNextToken TokenList, NextToken, " "
    Loop While Len(NextToken) = 0 And Len(Trim$(TokenList)) > 0
    
    If UCase(NextToken) = "COMMIT" Then
        Do
            getNextToken TokenList, NextToken, " "
        Loop While Len(NextToken) = 0 And Len(Trim$(TokenList)) > 0
        
        If UCase(NextToken) = "RELEASE" Then
            MsgBox LoadResString(165)
            Exit Function
        End If
        
        If UCase(NextToken) = "WORK" Then
            Do
                getNextToken TokenList, NextToken, " "
            Loop While Len(NextToken) = 0 And Len(Trim$(TokenList)) > 0
            
            If UCase(NextToken) = "RELEASE" Then
                MsgBox LoadResString(165)
                Exit Function
            End If
        End If
    End If
    
    ' Set rc
    isStatementSupported = True
    
    Exit Function
    
errIsStatementSupported:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function max(ByVal Value1 As Long, ByVal Value2 As Long) As Long
    On Error GoTo errMax

    Const FUNCTION_NAME = "max"

    If Value1 > Value2 Then
        
        max = Value1
    Else
        max = Value2
    End If
    
    Exit Function

errMax:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function min(ByVal Value1 As Long, ByVal Value2 As Long) As Long
    On Error GoTo errMin

    Const FUNCTION_NAME = "min"

    If Value1 < Value2 Then
        
        min = Value1
    Else
        min = Value2
    End If
    
    Exit Function

errMin:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function getTime() As String
    On Error GoTo errGetTime

    Const FUNCTION_NAME = "getTime"

    Dim SystemTime      As SystemTime
    
    GetLocalTime SystemTime
    
    getTime = Format$(SystemTime.wHour, "00") + ":" + _
              Format$(SystemTime.wMinute, "00") + ":" + _
              Format$(SystemTime.wSecond, "00") + "." + _
              Format$(SystemTime.wMilliseconds, "000")
    
    Exit Function

errGetTime:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      getVersion
'    description:   return the OS as String
'    arguments:     /
'    return value:  OS as string
'
'=========================================================================================
Public Function getVersion() As String

    Dim osInfo As OSVERSIONINFO
    Dim retvalue As Integer

    osInfo.dwOSVersionInfoSize = 148
    osInfo.szCSDVersion = Space$(128)
    retvalue = GetVersionExA(osInfo)

    With osInfo
    Select Case .dwPlatformId
       Case 1
          If .dwMinorVersion = 0 Then
             getVersion = "Windows 95"
          ElseIf .dwMinorVersion = 10 Then
             getVersion = "Windows 98"
          End If
       Case 2
          If .dwMajorVersion = 3 Then
             getVersion = "Windows NT 3.51"
          ElseIf .dwMajorVersion = 4 Then
             getVersion = "Windows NT 4.0"
          ElseIf .dwMajorVersion = 5 Then
             getVersion = "Windows 2000"
          End If
       Case Else
          getVersion = "Failed"
    End Select
    End With
 End Function
'=========================================================================================
'    function:      getPlatformID
'    description:   return the OS as enum
'    arguments:     /
'
'    return value:  OS as enum
'
'=========================================================================================
Public Function getPlatformID() As platformId

    Dim osInfo As OSVERSIONINFO
    Dim retvalue As Integer

    osInfo.dwOSVersionInfoSize = 148
    osInfo.szCSDVersion = Space$(128)
    retvalue = GetVersionExA(osInfo)
    
    getPlatformID = osInfo.dwPlatformId
    
 End Function
'=========================================================================================
'    function:      stripWs
'    description:   Remove all whitespace characters from the given string.
'    arguments:     str - string to be manipulated
'
'    return value:  converted string
'
'=========================================================================================
Public Function stripWS(ByVal str As String) As String
    On Error GoTo ErrStripWS

    Const FUNCTION_NAME = "StripWS"

    Dim iStart  As Integer
    Dim char    As String
        
    iStart = 1
    While (iStart < LenB(str))
        char = Mid(str, iStart, 1)
        If char <> " " And char <> vbCr And char <> vbLf And char <> vbTab Then _
            stripWS = stripWS + char
        iStart = iStart + 1
    Wend
    
    Exit Function

ErrStripWS:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      simplifyWS
'    description:   Replace all multiple whitespace characters by a single space character.
'    arguments:     str - string to be manipulated
'
'    return value:  converted string
'
'=========================================================================================
Public Function simplifyWS(ByVal str As String) As String
    On Error GoTo ErrSimplifyWS

    Const FUNCTION_NAME = "simplifyWS"

    Dim iStart    As Integer
    Dim char      As String
    Dim bSimplify As Boolean
        
    bSimplify = False
        
    iStart = 1
    While (iStart < LenB(str))
        char = Mid(str, iStart, 1)
        If Mid(str, iStart + 1, 1) = vbLf Then char = char + Mid(str, iStart + 1, 1)
        
        If char = " " Or char = vbCr Or char = vbCrLf Or char = vbTab Then
            If bSimplify = False Then
                simplifyWS = simplifyWS + " "
                bSimplify = True
            End If
        Else
            simplifyWS = simplifyWS + char
            bSimplify = False
        End If
        
        If char = vbCrLf Then
            iStart = iStart + 2
        Else
            iStart = iStart + 1
        End If
    Wend
    
    Exit Function

ErrSimplifyWS:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
Public Function loByte(nValue As Integer) As Byte
    On Error GoTo errLoByte

    Const FUNCTION_NAME = "LoByte"
    
    If nValue < 1 Then
    
        loByte = 0
        Exit Function
    End If
    
    If (nValue And &H80&) = 0 Then
        loByte = nValue And &HFF&
    Else
        loByte = &H80 And (nValue Or &HFF&)
    End If
    
    Exit Function
    
errLoByte:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

'=========================================================================================
'    function:      getStringFromUtf8
'    description:   get an vb string from a utf8 buffer
'    arguments:     [in]  bStartUtf8, utf8 buffer
'
'    return value:  string
'
'=========================================================================================
Public Function getStringFromUtf8(bStartUtf8() As Byte) As String
    On Error GoTo errGetStringFromUtf8
    
    Const FUNCTION_NAME = "getStringFromUtf8"

    Dim sBuffer      As String
    Dim bStartUcs2() As Byte
    Dim lUsed        As Long
    Dim bRet         As Byte
    Dim lLen         As Long
    
    If Len(bStartUtf8(0)) < 1 Then Exit Function
    
    lLen = InStrB(bStartUtf8(), Chr$(0)) - 1
    'if there is no null termination take length of buffer
    If lLen < 0 Then
        lLen = Len(bStartUtf8(0)) + 1
    End If
    
    '=convert from utf8 to ucs2==============================================
    ReDim bStartUcs2((lLen * 2))
    bRet = convertUTF8ToVB_UCS2(bStartUtf8(0), _
                             lLen, _
                             bStartUcs2(0), _
                             lLen * 2, _
                             lUsed)
                             
    sBuffer = Left(bStartUcs2, lUsed \ 2)
    '=========================================================================
        
    getStringFromUtf8 = sBuffer
    
    Exit Function
    
errGetStringFromUtf8:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function
'=========================================================================================
'    function:      getUtf8FromString
'    description:   get an utf8 buffer from a vb String
'    arguments:     [in]  sData as string
'
'    return value:  utf8 byte array
'
'=========================================================================================
Public Function getUtf8FromString(sData As String) As Byte()
    On Error GoTo errGetUtf8FromString
    
    Const FUNCTION_NAME = "getUtf8FromString"
    
    '=variables=====================================================
    Dim bStartUcs2() As Byte
    Dim bStartUtf8() As Byte
    Dim lUsed        As Long
    Dim bRet         As Byte
    '===============================================================
    
    bStartUcs2 = sData + vbNullChar
    ReDim bStartUtf8(Len(sData) * 6)
    
    bRet = convertVB_UCS2ToUTF8(bStartUcs2(0), _
                         Len(sData) * 2, _
                         bStartUtf8(0), _
                         Len(sData) * 6, _
                         lUsed)
        
    getUtf8FromString = bStartUtf8()
    
    Exit Function
    
errGetUtf8FromString:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function



'=========================================================================================
'    function:      getInstancecount
'    description:   returns current number of SQL studio instances
'    arguments:     /
'    return value:  number as integer
'
'=========================================================================================

Public Function getInstancecount(mypath As String) As Integer
    On Error GoTo errGetInstancecount
    
    Const FUNCTION_NAME = "getInstancecount"

      Dim retval As Integer
      
      retval = 0
      Select Case getPlatformID()
      
      Case 1 'Windows 95/98

         Dim f As Long, sName As String
         Dim hSnap As Long, proc As PROCESSENTRY32
         hSnap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0)
         If hSnap = hNull Then Exit Function
         proc.dwSize = Len(proc)
         ' Iterate through the processes
         f = Process32First(hSnap, proc)
         Do While f
           sName = StrZToStr(proc.szExeFile)
            If sName = mypath Then
                 retval = retval + 1
            End If
           f = Process32Next(hSnap, proc)
         Loop

      Case 2 'Windows NT

         Dim cb As Long
         Dim cbNeeded As Long
         Dim NumElements As Long
         Dim ProcessIDs() As Long
         Dim cbNeeded2 As Long
         Dim NumElements2 As Long
         Dim Modules(1 To 200) As Long
         Dim lRet As Long
         Dim ModuleName As String
         Dim nSize As Long
         Dim hProcess As Long
         Dim i As Long
         'Get the array containing the process id's for each process object
         cb = 8
         cbNeeded = 96
         Do While cb <= cbNeeded
            cb = cb * 2
            ReDim ProcessIDs(cb / 4) As Long
            lRet = EnumProcesses(ProcessIDs(1), cb, cbNeeded)
         Loop
         NumElements = cbNeeded / 4

         For i = 1 To NumElements
            'Get a handle to the Process
            hProcess = OpenProcess(PROCESS_QUERY_INFORMATION _
               Or PROCESS_VM_READ, 0, ProcessIDs(i))
            'Got a Process handle
            If hProcess <> 0 Then
                'Get an array of the module handles for the specified
                'process
                lRet = EnumProcessModules(hProcess, Modules(1), 200, _
                                             cbNeeded2)
                'If the Module Array is retrieved, Get the ModuleFileName
                If lRet <> 0 Then
                   ModuleName = Space(MAX_PATH)
                   nSize = 500
                   lRet = GetModuleFileNameExA(hProcess, Modules(1), _
                                   ModuleName, nSize)
                   If Left(ModuleName, lRet) = mypath Then
                        retval = retval + 1
                   End If
                End If
            End If
          'Close the handle to the process
         lRet = CloseHandle(hProcess)
         Next

      End Select
      
      getInstancecount = retval
      
      Exit Function
      
errGetInstancecount:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

Private Function StrZToStr(s As String) As String
    On Error GoTo errStrZToStr
    
    Const FUNCTION_NAME = "StrZToStr"
    
         StrZToStr = Left$(s, Len(s) - 1)
         
         Exit Function
         
errStrZToStr:
    internalError Err, MODULE_NAME, FUNCTION_NAME
End Function

