VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Value"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oRegistry As registry

Public name As String
Public Value As Variant
Public ValueType As RegistryTypeConstants
'
' Public Properties
'
Friend Property Get registry() As registry
    Set registry = oRegistry
End Property
Friend Property Set registry(ByVal newVal As registry)
    Set oRegistry = newVal
End Property
'
' Public Sub/Function
'
Public Function checkValue(ByVal lKey As Long) As Boolean
    Dim bShowError As Boolean
    Dim bRaiseError As Boolean
    
    Dim lType As RegistryTypeConstants
    Dim lValueLen As Long
        
    bShowError = oRegistry.showErrors
    bRaiseError = oRegistry.raiseErrors
    oRegistry.showErrors = False
    oRegistry.raiseErrors = False
        
    checkValue = oRegistry.queryValueNull(lKey, name, lType, lValueLen)

    oRegistry.showErrors = bShowError
    oRegistry.raiseErrors = bRaiseError
End Function

Public Function createValue(ByVal lKey As Long) As Boolean
    createValue = setValue(lKey)
End Function

Public Function queryValue(ByVal lKey As Long) As Boolean
    Dim lValueLen As Long
    Dim sValue As String
    Dim lValue As Long
    
    queryValue = False
    
    If oRegistry.queryValueNull(lKey, name, ValueType, lValueLen) Then
        Select Case ValueType
            Case REG_SZ:
                If oRegistry.queryValueString(lKey, name, sValue, lValueLen) Then
                    Value = sValue
                    queryValue = True
                Else
                    Value = Empty
                End If
        
            Case REG_DWORD:
                If oRegistry.queryValueLong(lKey, name, lValue) Then
                    Value = lValue
                    queryValue = True
                Else
                    Value = Empty
                End If
        End Select
    End If
End Function
Public Function setValue(ByVal lKey As Long) As Boolean
    setValue = False
    
    Select Case ValueType
        Case REG_SZ:
            If oRegistry.setValueString(lKey, name, CStr(Value)) Then
                setValue = True
            End If
        Case REG_DWORD:
            If oRegistry.setValueLong(lKey, name, CLng(Value)) Then
                setValue = True
            End If
    End Select
End Function

Public Function deleteValue(ByVal lKey As Long) As Boolean
    deleteValue = oRegistry.deleteValue(lKey, name)
End Function


